﻿// Decompiled with JetBrains decompiler
// Type: Terraria.Item
// Assembly: Terraria, Version=1.4.0.5, Culture=neutral, PublicKeyToken=null
// MVID: 67F9E73E-0A81-4937-A22C-5515CD405A83
// Assembly location: C:\Users\mikeyisbaeyt\Downloads\depotdownloader-2.4.5\depots\105601\6707058\Terraria.exe

using Microsoft.Xna.Framework;
using System;
using System.IO;
using Terraria.Audio;
using Terraria.Enums;
using Terraria.GameContent;
using Terraria.GameContent.Events;
using Terraria.GameContent.UI;
using Terraria.Graphics.Shaders;
using Terraria.ID;
using Terraria.UI;
using Terraria.Utilities;

namespace Terraria
{
  public class Item : Entity
  {
    private string _nameOverride;
    public const int luckPotionDuration1 = 10800;
    public const int luckPotionDuration2 = 18000;
    public const int luckPotionDuration3 = 36000;
    public const int flaskTime = 72000;
    public const int copper = 1;
    public const int silver = 100;
    public const int gold = 10000;
    public const int platinum = 1000000;
    public const int goldCritterRarityColor = 3;
    private readonly int shadowOrbPrice = Item.sellPrice(gold: 1, silver: 50);
    private readonly int dungeonPrice = Item.sellPrice(gold: 1, silver: 75);
    private readonly int queenBeePrice = Item.sellPrice(gold: 2);
    private readonly int hellPrice = Item.sellPrice(gold: 2, silver: 50);
    private readonly int eclipsePrice = Item.sellPrice(gold: 7, silver: 50);
    private readonly int eclipsePostPlanteraPrice = Item.sellPrice(gold: 10);
    private readonly int eclipseMothronPrice = Item.sellPrice(gold: 12, silver: 50);
    public static int[] cachedItemSpawnsByType = ItemID.Sets.Factory.CreateIntSet(-1);
    public static int potionDelay = 3600;
    public static int restorationDelay = 2700;
    public bool questItem;
    public static int[] headType = new int[266];
    public static int[] bodyType = new int[235];
    public static int[] legType = new int[218];
    public static bool[] staff = new bool[5045];
    public static bool[] claw = new bool[5045];
    public bool flame;
    public bool mech;
    public int noGrabDelay;
    public bool beingGrabbed;
    public int timeSinceItemSpawned;
    public int tileWand = -1;
    public bool wornArmor;
    public int tooltipContext = -1;
    public byte dye;
    public int fishingPole = 1;
    public int bait;
    public static int coinGrabRange = 350;
    public static int manaGrabRange = 300;
    public static int lifeGrabRange = 250;
    public static int treasureGrabRange = 150;
    public short makeNPC;
    public bool expertOnly;
    public bool expert;
    public bool isAShopItem;
    public short hairDye = -1;
    public byte paint;
    public bool instanced;
    public int ownIgnore = -1;
    public int ownTime;
    public int keepTime;
    public int type;
    public bool favorited;
    public int holdStyle;
    public int useStyle;
    public bool channel;
    public bool accessory;
    public int useAnimation;
    public int useTime;
    public int stack;
    public int maxStack;
    public int pick;
    public int axe;
    public int hammer;
    public int tileBoost;
    public int createTile = -1;
    public int createWall = -1;
    public int placeStyle;
    public int damage;
    public float knockBack;
    public int healLife;
    public int healMana;
    public bool potion;
    public bool consumable;
    public bool autoReuse;
    public bool useTurn;
    public Color color;
    public int alpha;
    public short glowMask;
    public float scale = 1f;
    public LegacySoundStyle UseSound;
    public int defense;
    public int headSlot = -1;
    public int bodySlot = -1;
    public int legSlot = -1;
    public sbyte handOnSlot = -1;
    public sbyte handOffSlot = -1;
    public sbyte backSlot = -1;
    public sbyte frontSlot = -1;
    public sbyte shoeSlot = -1;
    public sbyte waistSlot = -1;
    public sbyte wingSlot = -1;
    public sbyte shieldSlot = -1;
    public sbyte neckSlot = -1;
    public sbyte faceSlot = -1;
    public sbyte balloonSlot = -1;
    public int stringColor;
    public ItemTooltip ToolTip;
    public string BestiaryNotes;
    public int playerIndexTheItemIsReservedFor = (int) byte.MaxValue;
    public int rare;
    public int shoot;
    public float shootSpeed;
    public int ammo = AmmoID.None;
    public bool notAmmo;
    public int useAmmo = AmmoID.None;
    public int lifeRegen;
    public int manaIncrease;
    public bool buyOnce;
    public int mana;
    public bool noUseGraphic;
    public bool noMelee;
    public int timeSinceTheItemHasBeenReservedForSomeone;
    public int value;
    public bool buy;
    public bool social;
    public bool vanity;
    public bool material;
    public bool noWet;
    public int buffType;
    public int buffTime;
    public int mountType = -1;
    public bool cartTrack;
    public bool uniqueStack;
    public int shopSpecialCurrency = -1;
    public int? shopCustomPrice;
    public bool DD2Summon;
    public int netID;
    public int crit;
    public byte prefix;
    public bool melee;
    public bool magic;
    public bool ranged;
    public bool summon;
    public bool sentry;
    public int reuseDelay;
    public bool newAndShiny;
    public bool canBePlacedInVanityRegardlessOfConditions;
    public const int WALL_PLACEMENT_USETIME = 7;
    public static int numberOfNewItems = 0;

    public string Name => this._nameOverride ?? Lang.GetItemNameValue(this.type);

    public string HoverName
    {
      get
      {
        string str = this.AffixName();
        if (this.stack > 1)
          str = str + " (" + (object) this.stack + ")";
        return str;
      }
    }

    public static void StartCachingType(int t)
    {
      if (Item.cachedItemSpawnsByType[t] != -1)
        return;
      Item.cachedItemSpawnsByType[t] = 0;
    }

    public static void DropCache(Vector2 pos, Vector2 spread, int t, bool stopCaching = true)
    {
      if (Item.cachedItemSpawnsByType[t] == -1)
        return;
      int num = Item.cachedItemSpawnsByType[t];
      Item.cachedItemSpawnsByType[t] = stopCaching ? -1 : 0;
      Item obj = new Item();
      obj.SetDefaults(t);
      int Stack;
      for (; num > 0; num -= Stack)
      {
        Stack = obj.maxStack;
        if (num < Stack)
          Stack = num;
        Item.NewItem((int) pos.X, (int) pos.Y, (int) spread.X, (int) spread.Y, t, Stack);
      }
    }

    public bool FitsAccessoryVanitySlot => this.canBePlacedInVanityRegardlessOfConditions || this.handOnSlot != (sbyte) -1 || this.handOffSlot != (sbyte) -1 || this.backSlot != (sbyte) -1 || this.frontSlot != (sbyte) -1 || this.shoeSlot != (sbyte) -1 || this.waistSlot != (sbyte) -1 || this.wingSlot != (sbyte) -1 || this.shieldSlot != (sbyte) -1 || this.neckSlot != (sbyte) -1 || this.faceSlot != (sbyte) -1 || this.balloonSlot != (sbyte) -1;

    public int OriginalRarity => ContentSamples.ItemsByType[this.type].rare;

    public int OriginalDamage => ContentSamples.ItemsByType[this.type].damage;

    public int OriginalDefense => ContentSamples.ItemsByType[this.type].defense;

    public override string ToString() => string.Format("{{Name: \"{0}\" NetID: {1} Stack: {2}", (object) this.Name, (object) this.netID, (object) this.stack);

    public bool Prefix(int pre)
    {
      if (!WorldGen.gen && Main.rand == null)
        Main.rand = new UnifiedRandom();
      if (pre == 0 || this.type == 0)
        return false;
      UnifiedRandom unifiedRandom = WorldGen.gen ? WorldGen.genRand : Main.rand;
      int num1 = pre;
      float num2 = 1f;
      float num3 = 1f;
      float num4 = 1f;
      float num5 = 1f;
      float num6 = 1f;
      float num7 = 1f;
      int num8 = 0;
      bool flag = true;
      while (flag)
      {
        num2 = 1f;
        num3 = 1f;
        num4 = 1f;
        num5 = 1f;
        num6 = 1f;
        num7 = 1f;
        num8 = 0;
        flag = false;
        if (num1 == -1 && unifiedRandom.Next(4) == 0)
          num1 = 0;
        if (pre < -1)
          num1 = -1;
        if (num1 == -1 || num1 == -2 || num1 == -3)
        {
          if (this.type == 1 || this.type == 4 || this.type == 6 || this.type == 7 || this.type == 10 || this.type == 24 || this.type == 45 || this.type == 46 || this.type == 65 || this.type == 103 || this.type == 104 || this.type == 121 || this.type == 122 || this.type == 155 || this.type == 190 || this.type == 196 || this.type == 198 || this.type == 199 || this.type == 200 || this.type == 201 || this.type == 202 || this.type == 203 || this.type == 4258 || this.type == 204 || this.type == 213 || this.type == 217 || this.type == 273 || this.type == 367 || this.type == 368 || this.type == 426 || this.type == 482 || this.type == 483 || this.type == 484 || this.type == 653 || this.type == 654 || this.type == 656 || this.type == 657 || this.type == 659 || this.type == 660 || this.type == 671 || this.type == 672 || this.type == 674 || this.type == 675 || this.type == 676 || this.type == 723 || this.type == 724 || this.type == 757 || this.type == 776 || this.type == 777 || this.type == 778 || this.type == 787 || this.type == 795 || this.type == 797 || this.type == 798 || this.type == 799 || this.type == 881 || this.type == 882 || this.type == 921 || this.type == 922 || this.type == 989 || this.type == 990 || this.type == 991 || this.type == 992 || this.type == 993 || this.type == 1123 || this.type == 1166 || this.type == 1185 || this.type == 1188 || this.type == 1192 || this.type == 1195 || this.type == 1199 || this.type == 1202 || this.type == 1222 || this.type == 1223 || this.type == 1224 || this.type == 1226 || this.type == 1227 || this.type == 1230 || this.type == 1233 || this.type == 1234 || this.type == 1294 || this.type == 1304 || this.type == 1305 || this.type == 1306 || this.type == 1320 || this.type == 1327 || this.type == 1506 || this.type == 1507 || this.type == 1786 || this.type == 1826 || this.type == 1827 || this.type == 1909 || this.type == 1917 || this.type == 1928 || this.type == 2176 || this.type == 2273 || this.type == 2608 || this.type == 2341 || this.type == 2330 || this.type == 2320 || this.type == 2516 || this.type == 2517 || this.type == 2746 || this.type == 2745 || this.type == 3063 || this.type == 3018 || this.type == 3211 || this.type == 3013 || this.type == 3258 || this.type == 3106 || this.type == 3065 || this.type == 2880 || this.type == 3481 || this.type == 3482 || this.type == 3483 || this.type == 3484 || this.type == 3485 || this.type == 3487 || this.type == 3488 || this.type == 3489 || this.type == 3490 || this.type == 3491 || this.type == 3493 || this.type == 3494 || this.type == 3495 || this.type == 3496 || this.type == 3497 || this.type == 3499 || this.type == 3500 || this.type == 3501 || this.type == 3502 || this.type == 3503 || this.type == 3505 || this.type == 3506 || this.type == 3507 || this.type == 3508 || this.type == 3509 || this.type == 3511 || this.type == 3512 || this.type == 3513 || this.type == 3514 || this.type == 3515 || this.type == 3517 || this.type == 3518 || this.type == 3519 || this.type == 3520 || this.type == 3521 || this.type == 3522 || this.type == 3523 || this.type == 3524 || this.type == 3525 || this.type >= 3462 && this.type <= 3466 || this.type >= 2772 && this.type <= 2786 || this.type == 3349 || this.type == 3352 || this.type == 3351 || this.type >= 3764 && this.type <= 3769 || this.type == 4259 || this.type == 3772 || this.type == 3823 || this.type == 3827 || this.type == 186 || this.type == 946 || this.type == 4059 || this.type == 4317 || this.type == 4463 || this.type == 486 || this.type == 4707 || this.type == 4711 || this.type == 4956 || this.type == 4923 || this.type == 4788 || this.type == 4790 || this.type == 4789 || this.type == 4672 || this.type == 4913 || this.type == 4912 || this.type == 4911 || this.type == 4678 || this.type == 4679 || this.type == 4680 || this.type == 4914)
          {
            int num9 = unifiedRandom.Next(40);
            if (num9 == 0)
              num1 = 1;
            if (num9 == 1)
              num1 = 2;
            if (num9 == 2)
              num1 = 3;
            if (num9 == 3)
              num1 = 4;
            if (num9 == 4)
              num1 = 5;
            if (num9 == 5)
              num1 = 6;
            if (num9 == 6)
              num1 = 7;
            if (num9 == 7)
              num1 = 8;
            if (num9 == 8)
              num1 = 9;
            if (num9 == 9)
              num1 = 10;
            if (num9 == 10)
              num1 = 11;
            if (num9 == 11)
              num1 = 12;
            if (num9 == 12)
              num1 = 13;
            if (num9 == 13)
              num1 = 14;
            if (num9 == 14)
              num1 = 15;
            if (num9 == 15)
              num1 = 36;
            if (num9 == 16)
              num1 = 37;
            if (num9 == 17)
              num1 = 38;
            if (num9 == 18)
              num1 = 53;
            if (num9 == 19)
              num1 = 54;
            if (num9 == 20)
              num1 = 55;
            if (num9 == 21)
              num1 = 39;
            if (num9 == 22)
              num1 = 40;
            if (num9 == 23)
              num1 = 56;
            if (num9 == 24)
              num1 = 41;
            if (num9 == 25)
              num1 = 57;
            if (num9 == 26)
              num1 = 42;
            if (num9 == 27)
              num1 = 43;
            if (num9 == 28)
              num1 = 44;
            if (num9 == 29)
              num1 = 45;
            if (num9 == 30)
              num1 = 46;
            if (num9 == 31)
              num1 = 47;
            if (num9 == 32)
              num1 = 48;
            if (num9 == 33)
              num1 = 49;
            if (num9 == 34)
              num1 = 50;
            if (num9 == 35)
              num1 = 51;
            if (num9 == 36)
              num1 = 59;
            if (num9 == 37)
              num1 = 60;
            if (num9 == 38)
              num1 = 61;
            if (num9 == 39)
              num1 = 81;
          }
          else if (this.type == 162 || this.type == 5011 || this.type == 5012 || this.type == 160 || this.type == 163 || this.type == 220 || this.type == 274 || this.type == 277 || this.type == 280 || this.type == 383 || this.type == 384 || this.type == 385 || this.type == 386 || this.type == 387 || this.type == 388 || this.type == 389 || this.type == 390 || this.type == 406 || this.type == 537 || this.type == 550 || this.type == 579 || this.type == 756 || this.type == 759 || this.type == 801 || this.type == 802 || this.type == 1186 || this.type == 1189 || this.type == 1190 || this.type == 1193 || this.type == 1196 || this.type == 1197 || this.type == 1200 || this.type == 1203 || this.type == 1204 || this.type == 1228 || this.type == 1231 || this.type == 1232 || this.type == 1259 || this.type == 1262 || this.type == 1297 || this.type == 1314 || this.type == 1325 || this.type == 1947 || this.type == 2332 || this.type == 2331 || this.type == 2342 || this.type == 2424 || this.type == 2611 || this.type == 2798 || this.type == 3012 || this.type == 3473 || this.type == 3098 || this.type == 3368 || this.type == 3835 || this.type == 3836 || this.type == 3858 || this.type == 4061 || this.type == 4144 || this.type == 4272 || this.type == 2774 || this.type == 2773 || this.type == 2779 || this.type == 2778 || this.type == 2784 || this.type == 2783 || this.type == 3464 || this.type == 3463)
          {
            int num10 = unifiedRandom.Next(14);
            if (num10 == 0)
              num1 = 36;
            if (num10 == 1)
              num1 = 37;
            if (num10 == 2)
              num1 = 38;
            if (num10 == 3)
              num1 = 53;
            if (num10 == 4)
              num1 = 54;
            if (num10 == 5)
              num1 = 55;
            if (num10 == 6)
              num1 = 39;
            if (num10 == 7)
              num1 = 40;
            if (num10 == 8)
              num1 = 56;
            if (num10 == 9)
              num1 = 41;
            if (num10 == 10)
              num1 = 57;
            if (num10 == 11)
              num1 = 59;
            if (num10 == 12)
              num1 = 60;
            if (num10 == 13)
              num1 = 61;
          }
          else if (this.type == 39 || this.type == 44 || this.type == 95 || this.type == 96 || this.type == 98 || this.type == 99 || this.type == 120 || this.type == 164 || this.type == 197 || this.type == 219 || this.type == 266 || this.type == 281 || this.type == 434 || this.type == 435 || this.type == 436 || this.type == 481 || this.type == 506 || this.type == 533 || this.type == 534 || this.type == 578 || this.type == 655 || this.type == 658 || this.type == 661 || this.type == 679 || this.type == 682 || this.type == 725 || this.type == 758 || this.type == 759 || this.type == 760 || this.type == 796 || this.type == 800 || this.type == 905 || this.type == 923 || this.type == 964 || this.type == 986 || this.type == 1156 || this.type == 1187 || this.type == 1194 || this.type == 1201 || this.type == 1229 || this.type == 1254 || this.type == 1255 || this.type == 1258 || this.type == 1265 || this.type == 1319 || this.type == 1553 || this.type == 1782 || this.type == 1784 || this.type == 1835 || this.type == 1870 || this.type == 1910 || this.type == 1929 || this.type == 1946 || this.type == 2223 || this.type == 2269 || this.type == 2270 || this.type == 2624 || this.type == 2515 || this.type == 2747 || this.type == 2796 || this.type == 2797 || this.type == 3052 || this.type == 2888 || this.type == 3019 || this.type == 3029 || this.type == 3007 || this.type == 3008 || this.type == 3210 || this.type == 3107 || this.type == 3245 || this.type == 3475 || this.type == 3540 || this.type == 3854 || this.type == 3859 || this.type == 3821 || this.type == 3930 || this.type == 3480 || this.type == 3486 || this.type == 3492 || this.type == 3498 || this.type == 3504 || this.type == 3510 || this.type == 3516 || this.type == 3350 || this.type == 3546 || this.type == 3788 || this.type == 4058 || this.type == 4060 || this.type == 4381 || this.type == 4703 || this.type == 4953)
          {
            int num11 = unifiedRandom.Next(35);
            if (num11 == 0)
              num1 = 16;
            if (num11 == 1)
              num1 = 17;
            if (num11 == 2)
              num1 = 18;
            if (num11 == 3)
              num1 = 19;
            if (num11 == 4)
              num1 = 20;
            if (num11 == 5)
              num1 = 21;
            if (num11 == 6)
              num1 = 22;
            if (num11 == 7)
              num1 = 23;
            if (num11 == 8)
              num1 = 24;
            if (num11 == 9)
              num1 = 25;
            if (num11 == 10)
              num1 = 58;
            if (num11 == 11)
              num1 = 36;
            if (num11 == 12)
              num1 = 37;
            if (num11 == 13)
              num1 = 38;
            if (num11 == 14)
              num1 = 53;
            if (num11 == 15)
              num1 = 54;
            if (num11 == 16)
              num1 = 55;
            if (num11 == 17)
              num1 = 39;
            if (num11 == 18)
              num1 = 40;
            if (num11 == 19)
              num1 = 56;
            if (num11 == 20)
              num1 = 41;
            if (num11 == 21)
              num1 = 57;
            if (num11 == 22)
              num1 = 43;
            if (num11 == 23)
              num1 = 44;
            if (num11 == 24)
              num1 = 45;
            if (num11 == 25)
              num1 = 46;
            if (num11 == 26)
              num1 = 47;
            if (num11 == 27)
              num1 = 48;
            if (num11 == 28)
              num1 = 49;
            if (num11 == 29)
              num1 = 50;
            if (num11 == 30)
              num1 = 51;
            if (num11 == 31)
              num1 = 59;
            if (num11 == 32)
              num1 = 60;
            if (num11 == 33)
              num1 = 61;
            if (num11 == 34)
              num1 = 82;
          }
          else if (this.type == 64 || this.type == 112 || this.type == 113 || this.type == (int) sbyte.MaxValue || this.type == 157 || this.type == 165 || this.type == 218 || this.type == 272 || this.type == 494 || this.type == 495 || this.type == 496 || this.type == 514 || this.type == 517 || this.type == 518 || this.type == 519 || this.type == 683 || this.type == 726 || this.type == 739 || this.type == 740 || this.type == 741 || this.type == 742 || this.type == 743 || this.type == 744 || this.type == 788 || this.type == 1121 || this.type == 1155 || this.type == 1157 || this.type == 1178 || this.type == 1244 || this.type == 1256 || this.type == 1260 || this.type == 1264 || this.type == 1266 || this.type == 1295 || this.type == 1296 || this.type == 1308 || this.type == 1309 || this.type == 1313 || this.type == 1336 || this.type == 1444 || this.type == 1445 || this.type == 1446 || this.type == 1572 || this.type == 1801 || this.type == 1802 || this.type == 1930 || this.type == 1931 || this.type == 2188 || this.type == 2622 || this.type == 2621 || this.type == 2584 || this.type == 2551 || this.type == 2366 || this.type == 2535 || this.type == 2365 || this.type == 2364 || this.type == 2623 || this.type == 2750 || this.type == 2795 || this.type == 3053 || this.type == 3051 || this.type == 3209 || this.type == 3014 || this.type == 3105 || this.type == 2882 || this.type == 3269 || this.type == 3006 || this.type == 3377 || this.type == 3069 || this.type == 2749 || this.type == 3249 || this.type == 3476 || this.type == 3474 || this.type == 3531 || this.type == 3541 || this.type == 3542 || this.type == 3569 || this.type == 3570 || this.type == 3571 || this.type == 3779 || this.type == 3787 || this.type == 3531 || this.type == 3852 || this.type == 3870 || this.type == 4269 || this.type == 4273 || this.type == 4281 || this.type == 4347 || this.type == 4348 || this.type == 4270 || this.type == 4758 || this.type == 4715 || this.type == 4952 || this.type == 4607 || this.type == 5005 || this.type == 3824 || this.type == 3818 || this.type == 3829 || this.type == 3832 || this.type == 3825 || this.type == 3819 || this.type == 3830 || this.type == 3833 || this.type == 3826 || this.type == 3820 || this.type == 3831 || this.type == 3834 || this.type == 4062)
          {
            int num12 = unifiedRandom.Next(36);
            if (num12 == 0)
              num1 = 26;
            if (num12 == 1)
              num1 = 27;
            if (num12 == 2)
              num1 = 28;
            if (num12 == 3)
              num1 = 29;
            if (num12 == 4)
              num1 = 30;
            if (num12 == 5)
              num1 = 31;
            if (num12 == 6)
              num1 = 32;
            if (num12 == 7)
              num1 = 33;
            if (num12 == 8)
              num1 = 34;
            if (num12 == 9)
              num1 = 35;
            if (num12 == 10)
              num1 = 52;
            if (num12 == 11)
              num1 = 36;
            if (num12 == 12)
              num1 = 37;
            if (num12 == 13)
              num1 = 38;
            if (num12 == 14)
              num1 = 53;
            if (num12 == 15)
              num1 = 54;
            if (num12 == 16)
              num1 = 55;
            if (num12 == 17)
              num1 = 39;
            if (num12 == 18)
              num1 = 40;
            if (num12 == 19)
              num1 = 56;
            if (num12 == 20)
              num1 = 41;
            if (num12 == 21)
              num1 = 57;
            if (num12 == 22)
              num1 = 42;
            if (num12 == 23)
              num1 = 43;
            if (num12 == 24)
              num1 = 44;
            if (num12 == 25)
              num1 = 45;
            if (num12 == 26)
              num1 = 46;
            if (num12 == 27)
              num1 = 47;
            if (num12 == 28)
              num1 = 48;
            if (num12 == 29)
              num1 = 49;
            if (num12 == 30)
              num1 = 50;
            if (num12 == 31)
              num1 = 51;
            if (num12 == 32)
              num1 = 59;
            if (num12 == 33)
              num1 = 60;
            if (num12 == 34)
              num1 = 61;
            if (num12 == 35)
              num1 = 83;
          }
          else if (this.type == 55 || this.type == 119 || this.type == 191 || this.type == 284 || this.type == 670 || this.type == 1122 || this.type == 1513 || this.type == 1569 || this.type == 1571 || this.type == 1825 || this.type == 1918 || this.type == 3054 || this.type == 3262 || this.type >= 3278 && this.type <= 3292 || this.type >= 3315 && this.type <= 3317 || this.type == 3389 || this.type == 3030 || this.type == 3543 || this.type == 4764 || this.type == 4818 || this.type == 4760)
          {
            int num13 = unifiedRandom.Next(14);
            if (this.type == 3389)
              num13 = unifiedRandom.Next(15);
            if (num13 == 0)
              num1 = 36;
            if (num13 == 1)
              num1 = 37;
            if (num13 == 2)
              num1 = 38;
            if (num13 == 3)
              num1 = 53;
            if (num13 == 4)
              num1 = 54;
            if (num13 == 5)
              num1 = 55;
            if (num13 == 6)
              num1 = 39;
            if (num13 == 7)
              num1 = 40;
            if (num13 == 8)
              num1 = 56;
            if (num13 == 9)
              num1 = 41;
            if (num13 == 10)
              num1 = 57;
            if (num13 == 11)
              num1 = 59;
            if (num13 == 12)
              num1 = 60;
            if (num13 == 13)
              num1 = 61;
            if (num13 == 14)
              num1 = 84;
          }
          else
          {
            if (!this.IsAPrefixableAccessory())
              return false;
            num1 = unifiedRandom.Next(62, 81);
          }
        }
        switch (pre)
        {
          case -3:
            return true;
          case -1:
            if ((num1 == 7 || num1 == 8 || num1 == 9 || num1 == 10 || num1 == 11 || num1 == 22 || num1 == 23 || num1 == 24 || num1 == 29 || num1 == 30 || num1 == 31 || num1 == 39 || num1 == 40 || num1 == 56 || num1 == 41 || num1 == 47 || num1 == 48 || num1 == 49) && unifiedRandom.Next(3) != 0)
            {
              num1 = 0;
              break;
            }
            break;
        }
        switch (num1)
        {
          case 1:
            num5 = 1.12f;
            break;
          case 2:
            num5 = 1.18f;
            break;
          case 3:
            num2 = 1.05f;
            num8 = 2;
            num5 = 1.05f;
            break;
          case 4:
            num2 = 1.1f;
            num5 = 1.1f;
            num3 = 1.1f;
            break;
          case 5:
            num2 = 1.15f;
            break;
          case 6:
            num2 = 1.1f;
            break;
          case 7:
            num5 = 0.82f;
            break;
          case 8:
            num3 = 0.85f;
            num2 = 0.85f;
            num5 = 0.87f;
            break;
          case 9:
            num5 = 0.9f;
            break;
          case 10:
            num2 = 0.85f;
            break;
          case 11:
            num4 = 1.1f;
            num3 = 0.9f;
            num5 = 0.9f;
            break;
          case 12:
            num3 = 1.1f;
            num2 = 1.05f;
            num5 = 1.1f;
            num4 = 1.15f;
            break;
          case 13:
            num3 = 0.8f;
            num2 = 0.9f;
            num5 = 1.1f;
            break;
          case 14:
            num3 = 1.15f;
            num4 = 1.1f;
            break;
          case 15:
            num3 = 0.9f;
            num4 = 0.85f;
            break;
          case 16:
            num2 = 1.1f;
            num8 = 3;
            break;
          case 17:
            num4 = 0.85f;
            num6 = 1.1f;
            break;
          case 18:
            num4 = 0.9f;
            num6 = 1.15f;
            break;
          case 19:
            num3 = 1.15f;
            num6 = 1.05f;
            break;
          case 20:
            num3 = 1.05f;
            num6 = 1.05f;
            num2 = 1.1f;
            num4 = 0.95f;
            num8 = 2;
            break;
          case 21:
            num3 = 1.15f;
            num2 = 1.1f;
            break;
          case 22:
            num3 = 0.9f;
            num6 = 0.9f;
            num2 = 0.85f;
            break;
          case 23:
            num4 = 1.15f;
            num6 = 0.9f;
            break;
          case 24:
            num4 = 1.1f;
            num3 = 0.8f;
            break;
          case 25:
            num4 = 1.1f;
            num2 = 1.15f;
            num8 = 1;
            break;
          case 26:
            num7 = 0.85f;
            num2 = 1.1f;
            break;
          case 27:
            num7 = 0.85f;
            break;
          case 28:
            num7 = 0.85f;
            num2 = 1.15f;
            num3 = 1.05f;
            break;
          case 29:
            num7 = 1.1f;
            break;
          case 30:
            num7 = 1.2f;
            num2 = 0.9f;
            break;
          case 31:
            num3 = 0.9f;
            num2 = 0.9f;
            break;
          case 32:
            num7 = 1.15f;
            num2 = 1.1f;
            break;
          case 33:
            num7 = 1.1f;
            num3 = 1.1f;
            num4 = 0.9f;
            break;
          case 34:
            num7 = 0.9f;
            num3 = 1.1f;
            num4 = 1.1f;
            num2 = 1.1f;
            break;
          case 35:
            num7 = 1.2f;
            num2 = 1.15f;
            num3 = 1.15f;
            break;
          case 36:
            num8 = 3;
            break;
          case 37:
            num2 = 1.1f;
            num8 = 3;
            num3 = 1.1f;
            break;
          case 38:
            num3 = 1.15f;
            break;
          case 39:
            num2 = 0.7f;
            num3 = 0.8f;
            break;
          case 40:
            num2 = 0.85f;
            break;
          case 41:
            num3 = 0.85f;
            num2 = 0.9f;
            break;
          case 42:
            num4 = 0.9f;
            break;
          case 43:
            num2 = 1.1f;
            num4 = 0.9f;
            break;
          case 44:
            num4 = 0.9f;
            num8 = 3;
            break;
          case 45:
            num4 = 0.95f;
            break;
          case 46:
            num8 = 3;
            num4 = 0.94f;
            num2 = 1.07f;
            break;
          case 47:
            num4 = 1.15f;
            break;
          case 48:
            num4 = 1.2f;
            break;
          case 49:
            num4 = 1.08f;
            break;
          case 50:
            num2 = 0.8f;
            num4 = 1.15f;
            break;
          case 51:
            num3 = 0.9f;
            num4 = 0.9f;
            num2 = 1.05f;
            num8 = 2;
            break;
          case 52:
            num7 = 0.9f;
            num2 = 0.9f;
            num4 = 0.9f;
            break;
          case 53:
            num2 = 1.1f;
            break;
          case 54:
            num3 = 1.15f;
            break;
          case 55:
            num3 = 1.15f;
            num2 = 1.05f;
            break;
          case 56:
            num3 = 0.8f;
            break;
          case 57:
            num3 = 0.9f;
            num2 = 1.18f;
            break;
          case 58:
            num4 = 0.85f;
            num2 = 0.85f;
            break;
          case 59:
            num3 = 1.15f;
            num2 = 1.15f;
            num8 = 5;
            break;
          case 60:
            num2 = 1.15f;
            num8 = 5;
            break;
          case 61:
            num8 = 5;
            break;
          case 81:
            num3 = 1.15f;
            num2 = 1.15f;
            num8 = 5;
            num4 = 0.9f;
            num5 = 1.1f;
            break;
          case 82:
            num3 = 1.15f;
            num2 = 1.15f;
            num8 = 5;
            num4 = 0.9f;
            num6 = 1.1f;
            break;
          case 83:
            num3 = 1.15f;
            num2 = 1.15f;
            num8 = 5;
            num4 = 0.9f;
            num7 = 0.9f;
            break;
          case 84:
            num3 = 1.17f;
            num2 = 1.17f;
            num8 = 8;
            break;
        }
        if ((double) num2 != 1.0 && Math.Round((double) this.damage * (double) num2) == (double) this.damage)
        {
          flag = true;
          num1 = -1;
        }
        if ((double) num4 != 1.0 && Math.Round((double) this.useAnimation * (double) num4) == (double) this.useAnimation)
        {
          flag = true;
          num1 = -1;
        }
        if ((double) num7 != 1.0 && Math.Round((double) this.mana * (double) num7) == (double) this.mana)
        {
          flag = true;
          num1 = -1;
        }
        if ((double) num3 != 1.0 && (double) this.knockBack == 0.0)
        {
          flag = true;
          num1 = -1;
        }
        if (pre == -2 && num1 == 0)
        {
          num1 = -1;
          flag = true;
        }
      }
      this.damage = (int) Math.Round((double) this.damage * (double) num2);
      this.useAnimation = (int) Math.Round((double) this.useAnimation * (double) num4);
      this.useTime = (int) Math.Round((double) this.useTime * (double) num4);
      this.reuseDelay = (int) Math.Round((double) this.reuseDelay * (double) num4);
      this.mana = (int) Math.Round((double) this.mana * (double) num7);
      this.knockBack *= num3;
      this.scale *= num5;
      this.shootSpeed *= num6;
      this.crit += num8;
      float num14 = (float) (1.0 * (double) num2 * (2.0 - (double) num4) * (2.0 - (double) num7) * (double) num5 * (double) num3 * (double) num6 * (1.0 + (double) num8 * 0.0199999995529652));
      if (num1 == 62 || num1 == 69 || num1 == 73 || num1 == 77)
        num14 *= 1.05f;
      if (num1 == 63 || num1 == 70 || num1 == 74 || num1 == 78 || num1 == 67)
        num14 *= 1.1f;
      if (num1 == 64 || num1 == 71 || num1 == 75 || num1 == 79 || num1 == 66)
        num14 *= 1.15f;
      if (num1 == 65 || num1 == 72 || num1 == 76 || num1 == 80 || num1 == 68)
        num14 *= 1.2f;
      if ((double) num14 >= 1.2)
        this.rare += 2;
      else if ((double) num14 >= 1.05)
        ++this.rare;
      else if ((double) num14 <= 0.8)
        this.rare -= 2;
      else if ((double) num14 <= 0.95)
        --this.rare;
      if (this.rare > -11)
      {
        if (this.rare < -1)
          this.rare = -1;
        if (this.rare > 11)
          this.rare = 11;
      }
      this.value = (int) ((double) this.value * (double) (num14 * num14));
      this.prefix = (byte) num1;
      return true;
    }

    private bool IsAPrefixableAccessory() => this.accessory && !this.vanity && ItemID.Sets.CanGetPrefixes[this.type];

    public string AffixName()
    {
      if (this.prefix < (byte) 0 || (int) this.prefix >= Lang.prefix.Length)
        return this.Name;
      string str = Lang.prefix[(int) this.prefix].Value;
      if (str == "")
        return this.Name;
      return str.StartsWith("(") ? this.Name + " " + str : str + " " + this.Name;
    }

    public void RebuildTooltip()
    {
      if (this.type < 0)
        return;
      this.ToolTip = Lang.GetTooltip(this.netID);
    }

    public Rectangle getRect() => new Rectangle((int) this.position.X, (int) this.position.Y, this.width, this.height);

    public bool checkMat()
    {
      if (this.type >= 71 && this.type <= 74)
      {
        this.material = false;
        return false;
      }
      switch (this.type)
      {
        case 529:
        case 541:
        case 542:
        case 543:
        case 852:
        case 853:
        case 1151:
        case 3272:
        case 3274:
        case 3275:
        case 3338:
        case 4261:
        case 4282:
        case 4286:
        case 4290:
        case 4295:
          this.material = true;
          return true;
        case 4076:
        case 4131:
          this.material = false;
          return false;
        default:
          for (int index1 = 0; index1 < Recipe.numRecipes; ++index1)
          {
            for (int index2 = 0; Main.recipe[index1].requiredItem[index2].type > 0; ++index2)
            {
              if (this.netID == Main.recipe[index1].requiredItem[index2].netID)
              {
                this.material = true;
                return true;
              }
            }
          }
          this.material = false;
          return false;
      }
    }

    public void netDefaults(int type)
    {
      if (type < 0)
      {
        switch (type)
        {
          case -48:
            this.SetDefaults(3480);
            break;
          case -47:
            this.SetDefaults(3481);
            break;
          case -46:
            this.SetDefaults(3482);
            break;
          case -45:
            this.SetDefaults(3483);
            break;
          case -44:
            this.SetDefaults(3484);
            break;
          case -43:
            this.SetDefaults(3485);
            break;
          case -42:
            this.SetDefaults(3486);
            break;
          case -41:
            this.SetDefaults(3487);
            break;
          case -40:
            this.SetDefaults(3488);
            break;
          case -39:
            this.SetDefaults(3489);
            break;
          case -38:
            this.SetDefaults(3490);
            break;
          case -37:
            this.SetDefaults(3491);
            break;
          case -36:
            this.SetDefaults(3492);
            break;
          case -35:
            this.SetDefaults(3493);
            break;
          case -34:
            this.SetDefaults(3494);
            break;
          case -33:
            this.SetDefaults(3495);
            break;
          case -32:
            this.SetDefaults(3496);
            break;
          case -31:
            this.SetDefaults(3497);
            break;
          case -30:
            this.SetDefaults(3498);
            break;
          case -29:
            this.SetDefaults(3499);
            break;
          case -28:
            this.SetDefaults(3500);
            break;
          case -27:
            this.SetDefaults(3501);
            break;
          case -26:
            this.SetDefaults(3502);
            break;
          case -25:
            this.SetDefaults(3503);
            break;
          case -24:
            this.SetDefaults(3769);
            break;
          case -23:
            this.SetDefaults(3768);
            break;
          case -22:
            this.SetDefaults(3767);
            break;
          case -21:
            this.SetDefaults(3766);
            break;
          case -20:
            this.SetDefaults(3765);
            break;
          case -19:
            this.SetDefaults(3764);
            break;
          case -18:
            this.SetDefaults(3504);
            break;
          case -17:
            this.SetDefaults(3505);
            break;
          case -16:
            this.SetDefaults(3506);
            break;
          case -15:
            this.SetDefaults(3507);
            break;
          case -14:
            this.SetDefaults(3508);
            break;
          case -13:
            this.SetDefaults(3509);
            break;
          case -12:
            this.SetDefaults(3510);
            break;
          case -11:
            this.SetDefaults(3511);
            break;
          case -10:
            this.SetDefaults(3512);
            break;
          case -9:
            this.SetDefaults(3513);
            break;
          case -8:
            this.SetDefaults(3514);
            break;
          case -7:
            this.SetDefaults(3515);
            break;
          case -6:
            this.SetDefaults(3516);
            break;
          case -5:
            this.SetDefaults(3517);
            break;
          case -4:
            this.SetDefaults(3518);
            break;
          case -3:
            this.SetDefaults(3519);
            break;
          case -2:
            this.SetDefaults(3520);
            break;
          case -1:
            this.SetDefaults(3521);
            break;
        }
      }
      else
        this.SetDefaults(type);
    }

    public static int BannerToItem(int banner) => banner < 276 ? (banner < 274 ? (banner != 273 ? (banner < 267 ? (banner < 257 ? (banner < 252 ? (banner != 251 ? (banner < 249 ? (banner < 186 ? (banner < 88 ? 1615 + banner - 1 : 2897 + banner - 88) : 3390 + banner - 186) : 3593 + banner - 249) : 3780) : 3789 + banner - 252) : 3837 + banner - 257) : 4541 + banner - 267) : 4602) : 4687 + banner - 274) : 4965 + banner - 276;

    public static int NPCtoBanner(int i)
    {
      switch (i)
      {
        case -10:
          return 131;
        case -9:
          return 183;
        case -8:
          return 159;
        case -7:
          return 155;
        case -6:
          return 90;
        case -5:
        case 16:
          return 146;
        case -4:
          return 151;
        case -3:
          return 119;
        case -2:
        case 121:
          return 167;
        case -1:
        case 81:
          return 99;
        case 1:
        case 302:
        case 333:
        case 334:
        case 335:
        case 336:
          return 69;
        case 2:
        case 190:
        case 191:
        case 192:
        case 193:
        case 194:
        case 317:
        case 318:
          return 25;
        case 3:
        case 132:
        case 186:
        case 187:
        case 188:
        case 189:
        case 200:
        case 319:
        case 320:
        case 321:
        case 331:
        case 332:
        case 430:
        case 432:
        case 433:
        case 434:
        case 435:
        case 436:
        case 590:
        case 591:
        case 632:
          return 87;
        case 6:
          return 27;
        case 7:
          return 104;
        case 10:
        case 11:
        case 12:
        case 95:
        case 96:
        case 97:
          return 84;
        case 21:
        case 201:
        case 202:
        case 203:
        case 449:
        case 450:
        case 451:
        case 452:
          return 67;
        case 23:
          return 55;
        case 24:
          return 50;
        case 26:
          return 40;
        case 27:
          return 38;
        case 28:
          return 42;
        case 29:
          return 39;
        case 31:
        case 294:
        case 295:
        case 296:
          return 247;
        case 32:
          return 68;
        case 34:
          return 102;
        case 39:
        case 40:
        case 41:
          return 13;
        case 42:
        case 231:
        case 232:
        case 233:
        case 234:
        case 235:
          return 47;
        case 43:
          return 54;
        case 44:
          return 178;
        case 45:
          return 177;
        case 46:
        case 303:
        case 337:
        case 540:
          return 14;
        case 47:
          return 18;
        case 48:
          return 44;
        case 49:
          return 7;
        case 51:
          return 130;
        case 52:
          return 106;
        case 53:
          return 176;
        case 55:
        case 230:
          return 43;
        case 56:
          return 168;
        case 57:
          return 19;
        case 58:
          return 61;
        case 59:
          return 135;
        case 60:
          return 45;
        case 61:
          return 79;
        case 62:
        case 66:
          return 24;
        case 63:
          return 51;
        case 64:
          return 243;
        case 65:
          return 66;
        case 67:
          return 20;
        case 69:
          return 4;
        case 71:
          return 107;
        case 73:
          return 41;
        case 74:
          return 8;
        case 75:
          return 63;
        case 77:
          return 6;
        case 78:
          return 57;
        case 79:
          return 245;
        case 80:
          return 246;
        case 82:
          return 85;
        case 83:
          return 23;
        case 84:
          return 28;
        case 85:
        case 629:
          return 16;
        case 86:
          return 77;
        case 87:
        case 88:
        case 89:
        case 90:
        case 91:
        case 92:
          return 86;
        case 93:
          return 114;
        case 94:
          return 100;
        case 98:
        case 99:
        case 100:
          return 83;
        case 101:
          return 96;
        case 102:
          return 1;
        case 103:
          return 244;
        case 104:
          return 81;
        case 109:
          return 17;
        case 110:
          return 164;
        case 111:
          return 118;
        case 120:
          return 15;
        case 122:
          return 37;
        case 133:
          return 288;
        case 137:
          return 128;
        case 138:
          return 129;
        case 140:
          return 153;
        case 141:
          return 75;
        case 143:
          return 170;
        case 144:
          return 145;
        case 145:
          return 169;
        case 147:
          return 126;
        case 148:
        case 149:
          return 150;
        case 150:
          return 124;
        case 151:
          return 134;
        case 152:
          return 116;
        case 153:
          return 74;
        case 154:
          return 248;
        case 155:
          return 82;
        case 156:
          return 242;
        case 157:
          return 5;
        case 158:
        case 159:
          return 78;
        case 161:
        case 431:
          return 29;
        case 162:
          return 34;
        case 163:
        case 238:
          return 9;
        case 164:
        case 165:
          return 71;
        case 166:
          return 73;
        case 167:
          return 179;
        case 168:
          return 98;
        case 169:
          return 48;
        case 170:
        case 171:
        case 180:
          return 60;
        case 172:
          return 160;
        case 173:
          return 21;
        case 174:
          return 46;
        case 175:
          return 88;
        case 176:
          return 287;
        case 177:
          return 26;
        case 179:
          return 22;
        case 181:
          return 30;
        case 182:
          return 31;
        case 183:
          return 101;
        case 184:
          return 171;
        case 185:
          return 70;
        case 195:
        case 196:
          return 80;
        case 197:
          return 89;
        case 198:
        case 199:
          return 53;
        case 204:
          return 172;
        case 205:
          return 56;
        case 206:
          return 49;
        case 212:
          return 62;
        case 213:
          return 239;
        case 214:
          return 238;
        case 215:
          return 240;
        case 216:
          return 237;
        case 217:
          return 97;
        case 218:
          return 103;
        case 219:
          return 133;
        case 220:
          return 250;
        case 221:
          return 174;
        case 223:
          return 64;
        case 224:
          return 32;
        case 225:
          return 76;
        case 226:
          return 33;
        case 236:
        case 237:
          return 52;
        case 239:
        case 240:
          return 12;
        case 241:
          return 10;
        case 242:
          return 11;
        case 243:
          return 125;
        case 244:
          return 157;
        case 250:
          return 2;
        case 251:
          return 111;
        case 252:
          return 59;
        case 253:
          return 65;
        case 254:
        case (int) byte.MaxValue:
          return 72;
        case 256:
          return 36;
        case 257:
          return 3;
        case 258:
          return 58;
        case 259:
        case 260:
          return 35;
        case 268:
          return (int) sbyte.MaxValue;
        case 269:
        case 270:
        case 271:
        case 272:
          return 161;
        case 273:
        case 274:
        case 275:
        case 276:
          return 91;
        case 277:
        case 278:
        case 279:
        case 280:
          return 121;
        case 281:
        case 282:
          return 156;
        case 283:
        case 284:
          return 147;
        case 285:
        case 286:
          return 105;
        case 287:
          return 95;
        case 288:
          return 108;
        case 289:
          return 115;
        case 290:
          return 149;
        case 291:
          return 166;
        case 292:
          return 175;
        case 293:
          return 165;
        case 301:
          return 158;
        case 304:
          return 123;
        case 305:
        case 306:
        case 307:
        case 308:
        case 309:
        case 310:
        case 311:
        case 312:
        case 313:
        case 314:
          return 162;
        case 315:
          return 120;
        case 316:
          return 113;
        case 326:
          return 173;
        case 329:
          return 122;
        case 330:
          return 152;
        case 338:
        case 339:
        case 340:
          return 185;
        case 341:
          return 154;
        case 342:
          return 117;
        case 343:
          return 184;
        case 347:
          return 110;
        case 348:
        case 349:
          return 148;
        case 350:
          return 109;
        case 351:
          return 132;
        case 352:
          return 112;
        case 379:
          return 92;
        case 380:
          return 180;
        case 381:
          return 136;
        case 382:
          return 142;
        case 383:
        case 384:
          return 141;
        case 385:
          return 140;
        case 386:
          return 138;
        case 387:
          return 144;
        case 388:
          return 137;
        case 389:
          return 139;
        case 390:
          return 143;
        case 391:
          return 163;
        case 402:
        case 403:
        case 404:
          return 217;
        case 405:
        case 406:
          return 221;
        case 407:
        case 408:
          return 218;
        case 409:
        case 410:
          return 219;
        case 411:
          return 216;
        case 412:
        case 413:
        case 414:
          return 224;
        case 415:
          return 226;
        case 416:
        case 518:
          return 225;
        case 417:
          return 223;
        case 418:
          return 222;
        case 419:
          return 227;
        case 420:
          return 230;
        case 421:
          return 229;
        case 423:
          return 231;
        case 424:
          return 228;
        case 425:
          return 236;
        case 426:
          return 233;
        case 427:
          return 234;
        case 428:
          return 232;
        case 429:
          return 235;
        case 438:
          return 93;
        case 460:
          return 196;
        case 461:
          return 191;
        case 462:
          return 190;
        case 463:
          return 199;
        case 464:
          return 281;
        case 465:
          return 282;
        case 466:
          return 197;
        case 467:
          return 198;
        case 468:
          return 192;
        case 469:
          return 195;
        case 470:
          return 283;
        case 471:
          return 186;
        case 473:
          return 284;
        case 474:
          return 285;
        case 475:
          return 286;
        case 477:
        case 478:
        case 479:
          return 193;
        case 480:
          return 201;
        case 481:
          return 202;
        case 482:
          return 204;
        case 483:
          return 203;
        case 489:
          return 205;
        case 490:
          return 206;
        case 494:
        case 495:
          return 189;
        case 496:
        case 497:
          return 188;
        case 498:
        case 499:
        case 500:
        case 501:
        case 502:
        case 503:
        case 504:
        case 505:
        case 506:
          return 187;
        case 508:
        case 580:
          return 210;
        case 509:
        case 581:
          return 209;
        case 510:
        case 511:
        case 512:
          return 208;
        case 513:
        case 514:
        case 515:
          return 207;
        case 520:
          return 241;
        case 524:
        case 525:
        case 526:
        case 527:
          return 211;
        case 528:
        case 529:
          return 212;
        case 530:
        case 531:
          return 215;
        case 532:
          return 214;
        case 533:
          return 213;
        case 536:
          return 267;
        case 537:
          return 249;
        case 541:
          return 251;
        case 542:
          return 252;
        case 543:
          return 253;
        case 544:
          return 254;
        case 545:
          return (int) byte.MaxValue;
        case 546:
          return 256;
        case 552:
        case 553:
        case 554:
          return 258;
        case 555:
        case 556:
        case 557:
          return 257;
        case 558:
        case 559:
        case 560:
          return 264;
        case 561:
        case 562:
        case 563:
          return 265;
        case 566:
        case 567:
          return 259;
        case 568:
        case 569:
          return 263;
        case 570:
        case 571:
          return 260;
        case 572:
        case 573:
          return 262;
        case 574:
        case 575:
          return 261;
        case 578:
          return 266;
        case 582:
          return 280;
        case 586:
          return 268;
        case 587:
          return 269;
        case 618:
          return 273;
        case 619:
          return 270;
        case 620:
          return 272;
        case 621:
        case 622:
        case 623:
          return 271;
        case 624:
          return 275;
        case 628:
          return 274;
        case 630:
          return 277;
        case 631:
          return 276;
        case 634:
          return 279;
        case 635:
          return 278;
        default:
          return 0;
      }
    }

    public static int BannerToNPC(int i)
    {
      switch (i)
      {
        case 1:
          return 102;
        case 2:
          return 250;
        case 3:
          return 257;
        case 4:
          return 69;
        case 5:
          return 157;
        case 6:
          return 77;
        case 7:
          return 49;
        case 8:
          return 74;
        case 9:
          return 163;
        case 10:
          return 241;
        case 11:
          return 242;
        case 12:
          return 239;
        case 13:
          return 39;
        case 14:
          return 46;
        case 15:
          return 120;
        case 16:
          return 85;
        case 17:
          return 109;
        case 18:
          return 47;
        case 19:
          return 57;
        case 20:
          return 67;
        case 21:
          return 173;
        case 22:
          return 179;
        case 23:
          return 83;
        case 24:
          return 62;
        case 25:
          return 2;
        case 26:
          return 177;
        case 27:
          return 6;
        case 28:
          return 84;
        case 29:
          return 161;
        case 30:
          return 181;
        case 31:
          return 182;
        case 32:
          return 224;
        case 33:
          return 226;
        case 34:
          return 162;
        case 35:
          return 259;
        case 36:
          return 256;
        case 37:
          return 122;
        case 38:
          return 27;
        case 39:
          return 29;
        case 40:
          return 26;
        case 41:
          return 73;
        case 42:
          return 28;
        case 43:
          return 55;
        case 44:
          return 48;
        case 45:
          return 60;
        case 46:
          return 174;
        case 47:
          return 42;
        case 48:
          return 169;
        case 49:
          return 206;
        case 50:
          return 24;
        case 51:
          return 63;
        case 52:
          return 236;
        case 53:
          return 199;
        case 54:
          return 43;
        case 55:
          return 23;
        case 56:
          return 205;
        case 57:
          return 78;
        case 58:
          return 258;
        case 59:
          return 252;
        case 60:
          return 170;
        case 61:
          return 58;
        case 62:
          return 212;
        case 63:
          return 75;
        case 64:
          return 223;
        case 65:
          return 253;
        case 66:
          return 65;
        case 67:
          return 21;
        case 68:
          return 32;
        case 69:
          return 1;
        case 70:
          return 185;
        case 71:
          return 164;
        case 72:
          return 254;
        case 73:
          return 166;
        case 74:
          return 153;
        case 75:
          return 141;
        case 76:
          return 225;
        case 77:
          return 86;
        case 78:
          return 158;
        case 79:
          return 61;
        case 80:
          return 196;
        case 81:
          return 104;
        case 82:
          return 155;
        case 83:
          return 98;
        case 84:
          return 10;
        case 85:
          return 82;
        case 86:
          return 87;
        case 87:
          return 3;
        case 88:
          return 175;
        case 89:
          return 197;
        case 90:
          return -6;
        case 91:
          return 273;
        case 92:
          return 379;
        case 93:
          return 438;
        case 95:
          return 287;
        case 96:
          return 101;
        case 97:
          return 217;
        case 98:
          return 168;
        case 99:
          return 81;
        case 100:
          return 94;
        case 101:
          return 183;
        case 102:
          return 34;
        case 103:
          return 218;
        case 104:
          return 7;
        case 105:
          return 285;
        case 106:
          return 52;
        case 107:
          return 71;
        case 108:
          return 288;
        case 109:
          return 350;
        case 110:
          return 347;
        case 111:
          return 251;
        case 112:
          return 352;
        case 113:
          return 316;
        case 114:
          return 93;
        case 115:
          return 289;
        case 116:
          return 152;
        case 117:
          return 342;
        case 118:
          return 111;
        case 119:
          return -3;
        case 120:
          return 315;
        case 121:
          return 277;
        case 122:
          return 329;
        case 123:
          return 304;
        case 124:
          return 150;
        case 125:
          return 243;
        case 126:
          return 147;
        case (int) sbyte.MaxValue:
          return 268;
        case 128:
          return 137;
        case 129:
          return 138;
        case 130:
          return 51;
        case 131:
          return -10;
        case 132:
          return 351;
        case 133:
          return 219;
        case 134:
          return 151;
        case 135:
          return 59;
        case 136:
          return 381;
        case 137:
          return 388;
        case 138:
          return 386;
        case 139:
          return 389;
        case 140:
          return 385;
        case 141:
          return 383;
        case 142:
          return 382;
        case 143:
          return 390;
        case 144:
          return 387;
        case 145:
          return 144;
        case 146:
          return 16;
        case 147:
          return 283;
        case 148:
          return 348;
        case 149:
          return 290;
        case 150:
          return 148;
        case 151:
          return -4;
        case 152:
          return 330;
        case 153:
          return 140;
        case 154:
          return 341;
        case 155:
          return -7;
        case 156:
          return 281;
        case 157:
          return 244;
        case 158:
          return 301;
        case 159:
          return -8;
        case 160:
          return 172;
        case 161:
          return 269;
        case 162:
          return 305;
        case 163:
          return 391;
        case 164:
          return 110;
        case 165:
          return 293;
        case 166:
          return 291;
        case 167:
          return 121;
        case 168:
          return 56;
        case 169:
          return 145;
        case 170:
          return 143;
        case 171:
          return 184;
        case 172:
          return 204;
        case 173:
          return 326;
        case 174:
          return 221;
        case 175:
          return 292;
        case 176:
          return 53;
        case 177:
          return 45;
        case 178:
          return 44;
        case 179:
          return 167;
        case 180:
          return 380;
        case 183:
          return -9;
        case 184:
          return 343;
        case 185:
          return 338;
        case 186:
          return 471;
        case 187:
          return 498;
        case 188:
          return 496;
        case 189:
          return 494;
        case 190:
          return 462;
        case 191:
          return 461;
        case 192:
          return 468;
        case 193:
          return 477;
        case 195:
          return 469;
        case 196:
          return 460;
        case 197:
          return 466;
        case 198:
          return 467;
        case 199:
          return 463;
        case 201:
          return 480;
        case 202:
          return 481;
        case 203:
          return 483;
        case 204:
          return 482;
        case 205:
          return 489;
        case 206:
          return 490;
        case 207:
          return 513;
        case 208:
          return 510;
        case 209:
          return 581;
        case 210:
          return 580;
        case 211:
          return 524;
        case 212:
          return 529;
        case 213:
          return 533;
        case 214:
          return 532;
        case 215:
          return 530;
        case 216:
          return 411;
        case 217:
          return 402;
        case 218:
          return 407;
        case 219:
          return 409;
        case 221:
          return 405;
        case 222:
          return 418;
        case 223:
          return 417;
        case 224:
          return 412;
        case 225:
          return 416;
        case 226:
          return 415;
        case 227:
          return 419;
        case 228:
          return 424;
        case 229:
          return 421;
        case 230:
          return 420;
        case 231:
          return 423;
        case 232:
          return 428;
        case 233:
          return 426;
        case 234:
          return 427;
        case 235:
          return 429;
        case 236:
          return 425;
        case 237:
          return 216;
        case 238:
          return 214;
        case 239:
          return 213;
        case 240:
          return 215;
        case 241:
          return 520;
        case 242:
          return 156;
        case 243:
          return 64;
        case 244:
          return 103;
        case 245:
          return 79;
        case 246:
          return 80;
        case 247:
          return 31;
        case 248:
          return 154;
        case 249:
          return 537;
        case 250:
          return 220;
        case 251:
          return 541;
        case 252:
          return 542;
        case 253:
          return 543;
        case 254:
          return 544;
        case (int) byte.MaxValue:
          return 545;
        case 256:
          return 546;
        case 257:
          return 555;
        case 258:
          return 552;
        case 259:
          return 566;
        case 260:
          return 570;
        case 261:
          return 574;
        case 262:
          return 572;
        case 263:
          return 568;
        case 264:
          return 558;
        case 265:
          return 561;
        case 266:
          return 578;
        case 267:
          return 536;
        case 268:
          return 586;
        case 269:
          return 587;
        case 270:
          return 619;
        case 271:
          return 621;
        case 272:
          return 620;
        case 273:
          return 618;
        case 274:
          return 628;
        case 275:
          return 624;
        case 276:
          return 631;
        case 277:
          return 630;
        case 278:
          return 635;
        case 279:
          return 634;
        case 280:
          return 582;
        case 281:
          return 464;
        case 282:
          return 465;
        case 283:
          return 470;
        case 284:
          return 473;
        case 285:
          return 474;
        case 286:
          return 475;
        case 287:
          return 176;
        case 288:
          return 133;
        default:
          return 0;
      }
    }

    public bool FitsAmmoSlot() => (this.type == 0 || this.ammo > 0 || this.bait > 0 || this.type == 530 || this.type == 849 || this.paint > (byte) 0) && !this.notAmmo || this.type == 353;

    public bool CanFillEmptyAmmoSlot() => this.bait <= 0 && this.paint == (byte) 0 && this.type != 353 && this.type != 849 && this.type != 169 && this.type != 75 && this.type != 23 && this.type != 408 && this.type != 370 && this.type != 1246 && this.type != 154 && !this.notAmmo;

    public void SetDefaults1(int type)
    {
      if (type == 1)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 20;
        this.useTime = 13;
        this.autoReuse = true;
        this.width = 24;
        this.height = 28;
        this.damage = 5;
        this.pick = 40;
        this.UseSound = SoundID.Item1;
        this.knockBack = 2f;
        this.value = 2000;
        this.melee = true;
      }
      else if (type == 2)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 0;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 3)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 1;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 4)
      {
        this.useStyle = 1;
        this.useTurn = false;
        this.useAnimation = 21;
        this.useTime = 21;
        this.width = 24;
        this.height = 28;
        this.damage = 10;
        this.knockBack = 5f;
        this.UseSound = SoundID.Item1;
        this.scale = 1f;
        this.value = 1800;
        this.melee = true;
      }
      else if (type == 5)
      {
        this.useStyle = 2;
        this.UseSound = SoundID.Item2;
        this.useTurn = false;
        this.useAnimation = 17;
        this.useTime = 17;
        this.width = 16;
        this.height = 18;
        this.healLife = 15;
        this.maxStack = 99;
        this.consumable = true;
        this.potion = true;
        this.value = Item.sellPrice(silver: 2, copper: 50);
      }
      else if (type == 6)
      {
        this.autoReuse = false;
        this.useStyle = 13;
        this.useAnimation = 12;
        this.useTime = 12;
        this.width = 50;
        this.height = 18;
        this.shoot = 940;
        this.UseSound = SoundID.Item1;
        this.damage = 8;
        this.knockBack = 4f;
        this.shootSpeed = 2.1f;
        this.noMelee = true;
        this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 2, copper: 80));
        this.melee = true;
        this.noUseGraphic = true;
      }
      else if (type == 7)
      {
        this.autoReuse = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 30;
        this.useTime = 20;
        this.hammer = 40;
        this.width = 24;
        this.height = 28;
        this.damage = 7;
        this.knockBack = 5.5f;
        this.scale = 1.2f;
        this.UseSound = SoundID.Item1;
        this.value = 1600;
        this.melee = true;
      }
      else if (type == 8)
      {
        this.flame = true;
        this.noWet = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.holdStyle = 1;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 4;
        this.width = 10;
        this.height = 12;
        this.value = 50;
      }
      else if (type == 9)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 30;
        this.width = 8;
        this.height = 10;
      }
      else if (type == 10)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 27;
        this.knockBack = 4.5f;
        this.useTime = 19;
        this.autoReuse = true;
        this.width = 24;
        this.height = 28;
        this.damage = 5;
        this.axe = 9;
        this.scale = 1.1f;
        this.UseSound = SoundID.Item1;
        this.value = 1600;
        this.melee = true;
      }
      else if (type == 11)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 6;
        this.width = 12;
        this.height = 12;
        this.value = 500;
      }
      else if (type == 12)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 7;
        this.width = 12;
        this.height = 12;
        this.value = 250;
      }
      else if (type == 13)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 8;
        this.width = 12;
        this.height = 12;
        this.value = Item.sellPrice(silver: 3);
      }
      else if (type == 14)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 9;
        this.width = 12;
        this.height = 12;
        this.value = Item.sellPrice(silver: 1, copper: 50);
      }
      else if (type == 15)
      {
        this.width = 24;
        this.height = 28;
        this.accessory = true;
        this.value = 1000;
        this.waistSlot = (sbyte) 2;
      }
      else if (type == 16)
      {
        this.width = 24;
        this.height = 28;
        this.accessory = true;
        this.value = 5000;
        this.waistSlot = (sbyte) 7;
      }
      else if (type == 17)
      {
        this.width = 24;
        this.height = 28;
        this.accessory = true;
        this.rare = 1;
        this.value = 10000;
        this.waistSlot = (sbyte) 3;
      }
      else if (type == 18)
      {
        this.width = 24;
        this.height = 18;
        this.accessory = true;
        this.rare = 1;
        this.value = Item.sellPrice(silver: 25);
      }
      else if (type == 19)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.value = 6000;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 6;
      }
      else if (type == 20)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.value = 750;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 0;
      }
      else if (type == 21)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.value = 3000;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 4;
      }
      else if (type == 22)
      {
        this.color = new Color(160, 145, 130, 110);
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.value = 1500;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 2;
      }
      else if (type == 23)
      {
        this.width = 10;
        this.height = 12;
        this.maxStack = 999;
        this.alpha = 175;
        this.ammo = AmmoID.Gel;
        this.color = new Color(0, 80, (int) byte.MaxValue, 100);
        this.value = 5;
        this.consumable = true;
      }
      else if (type == 24)
      {
        this.useStyle = 1;
        this.useTurn = false;
        this.useAnimation = 25;
        this.width = 24;
        this.height = 28;
        this.damage = 7;
        this.knockBack = 4f;
        this.scale = 0.95f;
        this.UseSound = SoundID.Item1;
        this.value = 100;
        this.melee = true;
      }
      else if (type == 25)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 10;
        this.width = 14;
        this.height = 28;
        this.value = 200;
      }
      else if (type == 26)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 1;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 27)
      {
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.autoReuse = true;
        this.createTile = 20;
        this.width = 18;
        this.height = 18;
        this.value = 10;
      }
      else if (type == 28)
      {
        this.UseSound = SoundID.Item3;
        this.healLife = 50;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 30;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.potion = true;
        this.value = 300;
      }
      else if (type == 29)
      {
        this.maxStack = 99;
        this.consumable = true;
        this.width = 18;
        this.height = 18;
        this.useStyle = 4;
        this.useTime = 30;
        this.UseSound = SoundID.Item4;
        this.useAnimation = 30;
        this.rare = 2;
        this.value = 75000;
      }
      else if (type == 30)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 16;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 31)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 13;
        this.width = 16;
        this.height = 24;
        this.value = 20;
      }
      else if (type == 32)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 14;
        this.width = 26;
        this.height = 20;
        this.value = 300;
      }
      else if (type == 33)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 17;
        this.width = 26;
        this.height = 24;
        this.value = 300;
      }
      else if (type == 34)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 15;
        this.width = 12;
        this.height = 30;
        this.value = 150;
      }
      else if (type == 35)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 16;
        this.width = 28;
        this.height = 14;
        this.value = 5000;
      }
      else if (type == 36)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 18;
        this.width = 28;
        this.height = 14;
        this.value = 150;
      }
      else if (type == 37)
      {
        this.width = 28;
        this.height = 12;
        this.defense = 1;
        this.headSlot = 10;
        this.value = 1000;
      }
      else if (type == 38)
      {
        this.width = 12;
        this.height = 20;
        this.maxStack = 99;
        this.value = 500;
      }
      else if (type == 39)
      {
        this.useStyle = 5;
        this.useAnimation = 30;
        this.useTime = 30;
        this.width = 12;
        this.height = 28;
        this.shoot = 1;
        this.useAmmo = AmmoID.Arrow;
        this.UseSound = SoundID.Item5;
        this.damage = 4;
        this.shootSpeed = 6.1f;
        this.noMelee = true;
        this.value = 100;
        this.ranged = true;
      }
      else if (type == 40)
      {
        this.shootSpeed = 3f;
        this.shoot = 1;
        this.damage = 5;
        this.width = 10;
        this.height = 28;
        this.maxStack = 999;
        this.consumable = true;
        this.ammo = AmmoID.Arrow;
        this.knockBack = 2f;
        this.value = 5;
        this.ranged = true;
      }
      else if (type == 41)
      {
        this.shootSpeed = 3.5f;
        this.shoot = 2;
        this.damage = 7;
        this.width = 10;
        this.height = 28;
        this.maxStack = 999;
        this.consumable = true;
        this.ammo = AmmoID.Arrow;
        this.knockBack = 2f;
        this.value = 10;
        this.ranged = true;
      }
      else if (type == 42)
      {
        this.useStyle = 1;
        this.shootSpeed = 9f;
        this.shoot = 3;
        this.damage = 10;
        this.width = 18;
        this.height = 20;
        this.maxStack = 999;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.value = 15;
        this.ranged = true;
      }
      else if (type == 43)
      {
        this.useStyle = 4;
        this.width = 22;
        this.height = 14;
        this.consumable = true;
        this.useAnimation = 45;
        this.useTime = 45;
        this.maxStack = 20;
        this.rare = 1;
      }
      else if (type == 44)
      {
        this.useStyle = 5;
        this.useAnimation = 25;
        this.useTime = 25;
        this.width = 12;
        this.height = 28;
        this.shoot = 1;
        this.useAmmo = AmmoID.Arrow;
        this.UseSound = SoundID.Item5;
        this.damage = 14;
        this.shootSpeed = 6.7f;
        this.knockBack = 1f;
        this.alpha = 30;
        this.rare = 1;
        this.noMelee = true;
        this.value = 18000;
        this.ranged = true;
      }
      else if (type == 45)
      {
        this.autoReuse = true;
        this.useStyle = 1;
        this.useAnimation = 30;
        this.knockBack = 6f;
        this.useTime = 15;
        this.width = 24;
        this.height = 28;
        this.damage = 20;
        this.axe = 15;
        this.scale = 1.2f;
        this.UseSound = SoundID.Item1;
        this.rare = 1;
        this.value = 13500;
        this.melee = true;
      }
      else if (type == 46)
      {
        this.useStyle = 1;
        this.useAnimation = 20;
        this.knockBack = 5f;
        this.width = 24;
        this.height = 28;
        this.damage = 17;
        this.scale = 1.4f;
        this.UseSound = SoundID.Item1;
        this.rare = 1;
        this.value = 13500;
        this.melee = true;
      }
      else if (type == 47)
      {
        this.shootSpeed = 3.4f;
        this.shoot = 4;
        this.damage = 12;
        this.width = 10;
        this.height = 28;
        this.maxStack = 999;
        this.consumable = true;
        this.ammo = AmmoID.Arrow;
        this.knockBack = 3f;
        this.alpha = 30;
        this.rare = 1;
        this.value = 40;
        this.ranged = true;
      }
      else if (type == 48)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 21;
        this.width = 26;
        this.height = 22;
        this.value = 500;
      }
      else if (type == 49)
      {
        this.width = 22;
        this.height = 22;
        this.accessory = true;
        this.lifeRegen = 1;
        this.rare = 1;
        this.value = 50000;
        this.handOnSlot = (sbyte) 2;
      }
      else if (type == 50)
      {
        this.useTurn = true;
        this.width = 20;
        this.height = 20;
        this.useStyle = 4;
        this.useTime = 90;
        this.UseSound = SoundID.Item6;
        this.useAnimation = 90;
        this.rare = 1;
        this.value = 50000;
      }
      else if (type == 51)
      {
        this.shootSpeed = 0.5f;
        this.shoot = 5;
        this.damage = 10;
        this.width = 10;
        this.height = 28;
        this.maxStack = 999;
        this.consumable = true;
        this.ammo = AmmoID.Arrow;
        this.knockBack = 4f;
        this.rare = 1;
        this.value = 100;
        this.ranged = true;
      }
      else if (type == 52)
      {
        type = 52;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 105;
        this.width = 20;
        this.height = 20;
        this.value = 300;
        this.placeStyle = 1;
      }
      else if (type == 53)
      {
        this.width = 16;
        this.height = 24;
        this.accessory = true;
        this.rare = 1;
        this.value = 50000;
        this.waistSlot = (sbyte) 1;
      }
      else if (type == 54)
      {
        this.width = 28;
        this.height = 24;
        this.accessory = true;
        this.rare = 1;
        this.value = 50000;
        this.shoeSlot = (sbyte) 6;
      }
      else if (type == 55)
      {
        this.noMelee = true;
        this.useStyle = 1;
        this.shootSpeed = 10f;
        this.shoot = 6;
        this.damage = 13;
        this.knockBack = 8f;
        this.width = 14;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noUseGraphic = true;
        this.rare = 1;
        this.value = 50000;
        this.melee = true;
      }
      else if (type == 56)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 22;
        this.width = 12;
        this.height = 12;
        this.rare = 1;
        this.value = Item.sellPrice(silver: 10);
      }
      else if (type == 57)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.rare = 1;
        this.value = Item.sellPrice(silver: 30);
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 8;
      }
      else if (type == 58)
      {
        this.width = 12;
        this.height = 12;
      }
      else if (type == 59)
      {
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 23;
        this.width = 14;
        this.height = 14;
        this.value = 500;
        this.autoReuse = true;
      }
      else if (type == 60)
      {
        this.width = 16;
        this.height = 18;
        this.maxStack = 99;
        this.value = 50;
      }
      else if (type == 61)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 25;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 62)
      {
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 2;
        this.width = 14;
        this.height = 14;
        this.value = 20;
        this.autoReuse = true;
      }
      else if (type == 63)
      {
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 27;
        this.width = 26;
        this.height = 26;
        this.value = Item.buyPrice(silver: 50);
      }
      else if (type == 64)
      {
        this.mana = 10;
        this.damage = 10;
        this.useStyle = 1;
        this.shootSpeed = 32f;
        this.shoot = 7;
        this.width = 26;
        this.height = 28;
        this.useAnimation = 28;
        this.useTime = 28;
        this.rare = 1;
        this.noMelee = true;
        this.knockBack = 1f;
        this.value = this.shadowOrbPrice;
        this.magic = true;
      }
      else if (type == 65)
      {
        this.knockBack = 5f;
        this.alpha = 100;
        this.color = new Color(150, 150, 150, 0);
        this.damage = 22;
        this.useStyle = 1;
        this.scale = 1.25f;
        this.shootSpeed = 20f;
        this.shoot = 9;
        this.width = 14;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 20;
        this.useTime = 40;
        this.rare = 2;
        this.value = 50000;
        this.melee = true;
      }
      else if (type == 66)
      {
        this.useStyle = 1;
        this.shootSpeed = 4f;
        this.shoot = 10;
        this.width = 16;
        this.height = 24;
        this.maxStack = 99;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noMelee = true;
        this.value = 75;
      }
      else if (type == 67)
      {
        this.damage = 0;
        this.useStyle = 1;
        this.shootSpeed = 4f;
        this.shoot = 11;
        this.width = 16;
        this.height = 24;
        this.maxStack = 99;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noMelee = true;
        this.value = 100;
      }
      else if (type == 68)
      {
        this.width = 18;
        this.height = 20;
        this.maxStack = 99;
        this.value = 10;
      }
      else if (type == 69)
      {
        this.width = 8;
        this.height = 20;
        this.maxStack = 99;
        this.value = 100;
      }
      else if (type == 70)
      {
        this.useStyle = 4;
        this.consumable = true;
        this.useAnimation = 45;
        this.useTime = 45;
        this.width = 28;
        this.height = 28;
        this.maxStack = 20;
        this.rare = 1;
      }
      else if (type == 71)
      {
        this.width = 10;
        this.height = 10;
        this.maxStack = 100;
        this.value = 5;
        this.ammo = AmmoID.Coin;
        this.shoot = 158;
        this.notAmmo = true;
        this.damage = 25;
        this.shootSpeed = 1f;
        this.ranged = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 330;
        this.noMelee = true;
      }
      else if (type == 72)
      {
        this.width = 10;
        this.height = 12;
        this.maxStack = 100;
        this.value = 500;
        this.ammo = AmmoID.Coin;
        this.notAmmo = true;
        this.damage = 50;
        this.shoot = 159;
        this.shootSpeed = 2f;
        this.ranged = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 331;
        this.noMelee = true;
      }
      else if (type == 73)
      {
        this.width = 10;
        this.height = 14;
        this.maxStack = 100;
        this.value = 50000;
        this.ammo = AmmoID.Coin;
        this.notAmmo = true;
        this.damage = 100;
        this.shoot = 160;
        this.shootSpeed = 3f;
        this.ranged = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 332;
        this.noMelee = true;
      }
      else if (type == 74)
      {
        this.width = 12;
        this.height = 14;
        this.maxStack = 999;
        this.value = 5000000;
        this.ammo = AmmoID.Coin;
        this.notAmmo = true;
        this.damage = 200;
        this.shoot = 161;
        this.shootSpeed = 4f;
        this.ranged = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 333;
        this.noMelee = true;
      }
      else if (type == 75)
      {
        this.width = 18;
        this.height = 18;
        this.maxStack = 999;
        this.alpha = 75;
        this.ammo = AmmoID.FallenStar;
        this.value = Item.sellPrice(silver: 5);
        this.useStyle = 4;
        this.UseSound = SoundID.Item4;
        this.useTurn = false;
        this.useAnimation = 17;
        this.useTime = 17;
        this.consumable = true;
        this.rare = 1;
      }
      else if (type == 76)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 1;
        this.legSlot = 1;
        this.value = 1000;
      }
      else if (type == 77)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 2;
        this.legSlot = 2;
        this.value = 4000;
      }
      else if (type == 78)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 3;
        this.legSlot = 3;
        this.value = 10000;
      }
      else if (type == 79)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 4;
        this.legSlot = 4;
        this.value = 20000;
      }
      else if (type == 80)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 2;
        this.bodySlot = 1;
        this.value = 1250;
      }
      else if (type == 81)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 3;
        this.bodySlot = 2;
        this.value = 5000;
      }
      else if (type == 82)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 4;
        this.bodySlot = 3;
        this.value = 12500;
      }
      else if (type == 83)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 5;
        this.bodySlot = 4;
        this.value = 25000;
      }
      else if (type == 84)
      {
        this.noUseGraphic = true;
        this.damage = 0;
        this.knockBack = 7f;
        this.useStyle = 5;
        this.shootSpeed = 11.5f;
        this.shoot = 13;
        this.width = 18;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 20;
        this.useTime = 20;
        this.rare = 1;
        this.noMelee = true;
        this.value = 20000;
      }
      else if (type == 85)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 8;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 214;
        this.width = 12;
        this.height = 12;
        this.value = 200;
        this.tileBoost += 3;
      }
      else if (type == 86)
      {
        this.width = 14;
        this.height = 18;
        this.maxStack = 999;
        this.rare = 1;
        this.value = 500;
      }
      else if (type == 87)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 29;
        this.width = 20;
        this.height = 12;
        this.value = 10000;
      }
      else if (type == 88)
      {
        this.width = 22;
        this.height = 16;
        this.defense = 1;
        this.headSlot = 11;
        this.rare = 1;
        this.value = Item.buyPrice(gold: 4);
      }
      else if (type == 89)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 1;
        this.headSlot = 1;
        this.value = 750;
      }
      else if (type == 90)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 2;
        this.headSlot = 2;
        this.value = 3000;
      }
      else if (type == 91)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 3;
        this.headSlot = 3;
        this.value = 7500;
      }
      else if (type == 92)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 4;
        this.headSlot = 4;
        this.value = 15000;
      }
      else if (type == 93)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 4;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 94)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 19;
        this.width = 8;
        this.height = 10;
      }
      else if (type == 95)
      {
        this.useStyle = 5;
        this.useAnimation = 16;
        this.useTime = 16;
        this.width = 24;
        this.height = 28;
        this.shoot = 14;
        this.useAmmo = AmmoID.Bullet;
        this.UseSound = SoundID.Item11;
        this.damage = 10;
        this.shootSpeed = 5f;
        this.noMelee = true;
        this.value = 50000;
        this.scale = 0.9f;
        this.rare = 1;
        this.ranged = true;
      }
      else if (type == 96)
      {
        this.useStyle = 5;
        this.autoReuse = true;
        this.useAnimation = 36;
        this.useTime = 36;
        this.width = 44;
        this.height = 14;
        this.shoot = 10;
        this.useAmmo = AmmoID.Bullet;
        this.UseSound = SoundID.Item11;
        this.damage = 31;
        this.shootSpeed = 9f;
        this.noMelee = true;
        this.value = this.shadowOrbPrice;
        this.knockBack = 5.25f;
        this.rare = 1;
        this.ranged = true;
        this.crit = 7;
      }
      else if (type == 97)
      {
        this.shootSpeed = 4f;
        this.shoot = 14;
        this.damage = 7;
        this.width = 8;
        this.height = 8;
        this.maxStack = 999;
        this.consumable = true;
        this.ammo = AmmoID.Bullet;
        this.knockBack = 2f;
        this.value = 7;
        this.ranged = true;
      }
      else if (type == 98)
      {
        this.useStyle = 5;
        this.autoReuse = true;
        this.useAnimation = 8;
        this.useTime = 8;
        this.width = 50;
        this.height = 18;
        this.shoot = 10;
        this.useAmmo = AmmoID.Bullet;
        this.UseSound = SoundID.Item11;
        this.damage = 6;
        this.shootSpeed = 7f;
        this.noMelee = true;
        this.value = 350000;
        this.rare = 2;
        this.ranged = true;
      }
      else if (type == 99)
      {
        this.useStyle = 5;
        this.useAnimation = 28;
        this.useTime = 28;
        this.width = 12;
        this.height = 28;
        this.shoot = 1;
        this.useAmmo = AmmoID.Arrow;
        this.UseSound = SoundID.Item5;
        this.damage = 8;
        this.shootSpeed = 6.6f;
        this.noMelee = true;
        this.value = 1400;
        this.ranged = true;
      }
      else if (type == 100)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 6;
        this.legSlot = 5;
        this.rare = 1;
        this.value = 22500;
      }
      else if (type == 101)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 7;
        this.bodySlot = 5;
        this.rare = 1;
        this.value = 30000;
      }
      else if (type == 102)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 6;
        this.headSlot = 5;
        this.rare = 1;
        this.value = 37500;
      }
      else if (type == 103)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 20;
        this.useTime = 15;
        this.autoReuse = true;
        this.width = 24;
        this.height = 28;
        this.damage = 9;
        this.pick = 65;
        this.UseSound = SoundID.Item1;
        this.knockBack = 3f;
        this.rare = 1;
        this.value = 18000;
        this.scale = 1.15f;
        this.melee = true;
      }
      else if (type == 104)
      {
        this.autoReuse = true;
        this.useStyle = 1;
        this.useAnimation = 45;
        this.useTime = 19;
        this.hammer = 55;
        this.width = 24;
        this.height = 28;
        this.damage = 24;
        this.knockBack = 6f;
        this.scale = 1.3f;
        this.UseSound = SoundID.Item1;
        this.rare = 1;
        this.value = 15000;
        this.melee = true;
      }
      else if (type == 105)
      {
        this.flame = true;
        this.noWet = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 33;
        this.width = 8;
        this.height = 18;
        this.value = Item.sellPrice(silver: 3);
        this.holdStyle = 1;
      }
      else if (type == 106)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 34;
        this.width = 26;
        this.height = 26;
        this.value = 3000;
      }
      else if (type == 107)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 34;
        this.placeStyle = 1;
        this.width = 26;
        this.height = 26;
        this.value = 12000;
      }
      else if (type == 108)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 34;
        this.placeStyle = 2;
        this.width = 26;
        this.height = 26;
        this.value = 24000;
      }
      else if (type == 109)
      {
        this.maxStack = 99;
        this.consumable = true;
        this.width = 18;
        this.height = 18;
        this.useStyle = 4;
        this.useTime = 30;
        this.UseSound = SoundID.Item29;
        this.useAnimation = 30;
        this.rare = 2;
      }
      else if (type == 110)
      {
        this.UseSound = SoundID.Item3;
        this.healMana = 50;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 50;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.value = Item.buyPrice(silver: 1);
      }
      else if (type == 111)
      {
        this.width = 22;
        this.height = 22;
        this.accessory = true;
        this.rare = 1;
        this.value = this.shadowOrbPrice;
        this.handOnSlot = (sbyte) 3;
      }
      else if (type == 112)
      {
        this.mana = 15;
        this.damage = 48;
        this.useStyle = 1;
        this.shootSpeed = 6f;
        this.shoot = 15;
        this.width = 26;
        this.height = 28;
        this.UseSound = SoundID.Item20;
        this.useAnimation = 20;
        this.useTime = 20;
        this.rare = 3;
        this.noMelee = true;
        this.knockBack = 5.5f;
        this.value = this.hellPrice;
        this.magic = true;
      }
      else if (type == 113)
      {
        this.mana = 12;
        this.channel = true;
        this.damage = 27;
        this.useStyle = 1;
        this.shootSpeed = 6f;
        this.shoot = 16;
        this.width = 26;
        this.height = 28;
        this.UseSound = SoundID.Item9;
        this.useAnimation = 18;
        this.useTime = 18;
        this.rare = 2;
        this.noMelee = true;
        this.knockBack = 7.5f;
        this.value = this.dungeonPrice;
        this.magic = true;
      }
      else if (type == 114)
      {
        this.channel = true;
        this.knockBack = 5f;
        this.useStyle = 1;
        this.shoot = 17;
        this.width = 26;
        this.height = 28;
        this.UseSound = SoundID.Item8;
        this.useAnimation = 20;
        this.useTime = 20;
        this.rare = 1;
        this.noMelee = true;
        this.value = Item.buyPrice(gold: 5);
      }
      else if (type == 115)
      {
        this.channel = true;
        this.damage = 0;
        this.useStyle = 4;
        this.shoot = 18;
        this.width = 24;
        this.height = 24;
        this.UseSound = SoundID.Item8;
        this.useAnimation = 20;
        this.useTime = 20;
        this.rare = 1;
        this.noMelee = true;
        this.value = this.shadowOrbPrice;
        this.buffType = 19;
      }
      else if (type == 116)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 37;
        this.width = 12;
        this.height = 12;
        this.value = 1000;
      }
      else if (type == 117)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.rare = 1;
        this.value = 7000;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 9;
      }
      else if (type == 118)
      {
        this.maxStack = 99;
        this.width = 18;
        this.height = 18;
        this.value = 1000;
      }
      else if (type == 119)
      {
        this.noMelee = true;
        this.useStyle = 1;
        this.shootSpeed = 11f;
        this.shoot = 19;
        this.damage = 32;
        this.knockBack = 8f;
        this.width = 14;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noUseGraphic = true;
        this.rare = 3;
        this.value = 100000;
        this.melee = true;
      }
      else if (type == 120)
      {
        this.useStyle = 5;
        this.useAnimation = 22;
        this.useTime = 22;
        this.width = 14;
        this.height = 32;
        this.shoot = 1;
        this.useAmmo = AmmoID.Arrow;
        this.UseSound = SoundID.Item5;
        this.damage = 31;
        this.shootSpeed = 8f;
        this.knockBack = 2f;
        this.alpha = 30;
        this.rare = 3;
        this.noMelee = true;
        this.scale = 1.1f;
        this.value = 27000;
        this.ranged = true;
      }
      else if (type == 121)
      {
        this.useStyle = 1;
        this.useAnimation = 30;
        this.knockBack = 6.5f;
        this.width = 24;
        this.height = 28;
        this.damage = 36;
        this.scale = 1.3f;
        this.UseSound = SoundID.Item1;
        this.rare = 3;
        this.value = 27000;
        this.melee = true;
      }
      if (type == 122)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 23;
        this.useTime = 18;
        this.autoReuse = true;
        this.width = 24;
        this.height = 28;
        this.damage = 12;
        this.pick = 100;
        this.scale = 1.15f;
        this.UseSound = SoundID.Item1;
        this.knockBack = 2f;
        this.rare = 3;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 123)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 5;
        this.headSlot = 6;
        this.rare = 1;
        this.value = 45000;
      }
      else if (type == 124)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 6;
        this.bodySlot = 6;
        this.rare = 1;
        this.value = 30000;
      }
      else if (type == 125)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 5;
        this.legSlot = 6;
        this.rare = 1;
        this.value = 30000;
      }
      else if (type == 126)
      {
        this.UseSound = SoundID.Item3;
        this.healLife = 20;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 999;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.potion = true;
        this.value = 20;
      }
      else if (type == (int) sbyte.MaxValue)
      {
        this.autoReuse = true;
        this.useStyle = 5;
        this.useAnimation = 17;
        this.useTime = 17;
        this.width = 24;
        this.height = 28;
        this.shoot = 20;
        this.mana = 7;
        this.UseSound = SoundID.Item157;
        this.knockBack = 0.75f;
        this.damage = 19;
        this.shootSpeed = 10f;
        this.noMelee = true;
        this.scale = 0.8f;
        this.rare = 1;
        this.magic = true;
        this.value = 20000;
      }
      else if (type == 128)
      {
        this.width = 28;
        this.height = 24;
        this.accessory = true;
        this.rare = 3;
        this.value = 50000;
        this.shoeSlot = (sbyte) 12;
      }
      else if (type == 129)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 38;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 130)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 5;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 131)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 39;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 132)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 6;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 133)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 40;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 134)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 41;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 135)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 17;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 136)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 42;
        this.width = 12;
        this.height = 28;
        this.value = Item.sellPrice(copper: 30);
      }
      else if (type == 137)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 43;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 138)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 18;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 139)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 44;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 140)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 19;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 141)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 45;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 142)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 10;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 143)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 46;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 144)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 11;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 145)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 47;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 146)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 7;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createWall = 12;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 147)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 48;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 148)
      {
        this.flame = true;
        this.noWet = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 49;
        this.width = 8;
        this.height = 18;
        this.value = Item.sellPrice(silver: 1);
        this.holdStyle = 1;
        this.rare = 1;
      }
      else if (type == 149)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 50;
        this.width = 24;
        this.height = 28;
        this.value = Item.sellPrice(copper: 75);
      }
      else if (type == 150)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 51;
        this.width = 20;
        this.height = 24;
        this.alpha = 100;
      }
      else if (type == 151)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 5;
        this.headSlot = 7;
        this.rare = 2;
        this.value = 45000;
      }
      else if (type == 152)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 6;
        this.bodySlot = 7;
        this.rare = 2;
        this.value = 30000;
      }
      else if (type == 153)
      {
        this.width = 18;
        this.height = 18;
        this.defense = 5;
        this.legSlot = 7;
        this.rare = 2;
        this.value = 30000;
      }
      else if (type == 154)
      {
        this.maxStack = 999;
        this.consumable = true;
        this.width = 12;
        this.height = 14;
        this.value = 50;
        this.useAnimation = 12;
        this.useTime = 12;
        this.useStyle = 1;
        this.UseSound = SoundID.Item1;
        this.shootSpeed = 8f;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.damage = 20;
        this.knockBack = 2.3f;
        this.shoot = 21;
        this.ranged = true;
        this.ammo = 154;
      }
      else if (type == 155)
      {
        this.autoReuse = true;
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 18;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1.1f;
        this.UseSound = SoundID.Item1;
        this.rare = 2;
        this.value = this.dungeonPrice;
        this.knockBack = 2.5f;
        this.melee = true;
      }
      else if (type == 156)
      {
        this.width = 24;
        this.height = 28;
        this.rare = 2;
        this.value = this.dungeonPrice;
        this.accessory = true;
        this.defense = 1;
        this.shieldSlot = (sbyte) 1;
      }
      else if (type == 157)
      {
        this.mana = 6;
        this.autoReuse = true;
        this.useStyle = 5;
        this.useAnimation = 16;
        this.useTime = 8;
        this.knockBack = 5f;
        this.width = 38;
        this.height = 10;
        this.damage = 16;
        this.scale = 1f;
        this.shoot = 22;
        this.shootSpeed = 12.5f;
        this.UseSound = SoundID.Item13;
        this.noMelee = true;
        this.rare = 2;
        this.value = this.dungeonPrice;
        this.magic = true;
      }
      else if (type == 158)
      {
        this.width = 20;
        this.height = 22;
        this.rare = 1;
        this.value = 27000;
        this.accessory = true;
      }
      else if (type == 159)
      {
        this.width = 14;
        this.height = 28;
        this.rare = 1;
        this.value = Item.sellPrice(gold: 1, silver: 50);
        this.accessory = true;
        this.balloonSlot = (sbyte) 8;
      }
      else if (type == 160)
      {
        this.autoReuse = true;
        this.noMelee = true;
        this.useStyle = 5;
        this.useAnimation = 30;
        this.useTime = 30;
        this.knockBack = 6f;
        this.width = 30;
        this.height = 10;
        this.damage = 25;
        this.scale = 1.1f;
        this.shoot = 23;
        this.shootSpeed = 11f;
        this.UseSound = SoundID.Item10;
        this.rare = 2;
        this.value = 27000;
        this.ranged = true;
      }
      else if (type == 161)
      {
        this.useStyle = 1;
        this.shootSpeed = 5f;
        this.shoot = 24;
        this.knockBack = 1f;
        this.damage = 15;
        this.width = 10;
        this.height = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.value = 80;
        this.ranged = true;
      }
      else if (type == 162)
      {
        this.useStyle = 5;
        this.useAnimation = 45;
        this.useTime = 45;
        this.knockBack = 5.5f;
        this.width = 30;
        this.height = 10;
        this.damage = 15;
        this.scale = 1.1f;
        this.noUseGraphic = true;
        this.shoot = 25;
        this.shootSpeed = 12f;
        this.UseSound = SoundID.Item1;
        this.rare = 1;
        this.value = this.shadowOrbPrice;
        this.melee = true;
        this.channel = true;
        this.noMelee = true;
      }
      else if (type == 163)
      {
        this.noMelee = true;
        this.useStyle = 5;
        this.useAnimation = 45;
        this.useTime = 45;
        this.knockBack = 6f;
        this.width = 30;
        this.height = 10;
        this.damage = 27;
        this.scale = 1.1f;
        this.noUseGraphic = true;
        this.shoot = 26;
        this.shootSpeed = 12f;
        this.UseSound = SoundID.Item1;
        this.rare = 2;
        this.value = this.dungeonPrice;
        this.melee = true;
        this.channel = true;
      }
      else if (type == 164)
      {
        this.autoReuse = false;
        this.useStyle = 5;
        this.useAnimation = 10;
        this.useTime = 10;
        this.width = 24;
        this.height = 24;
        this.shoot = 14;
        this.knockBack = 3f;
        this.useAmmo = AmmoID.Bullet;
        this.UseSound = SoundID.Item41;
        this.damage = 17;
        this.shootSpeed = 10f;
        this.noMelee = true;
        this.value = this.dungeonPrice;
        this.scale = 0.85f;
        this.rare = 2;
        this.ranged = true;
      }
      else if (type == 165)
      {
        this.autoReuse = true;
        this.rare = 2;
        this.mana = 10;
        this.UseSound = SoundID.Item21;
        this.noMelee = true;
        this.useStyle = 5;
        this.damage = 19;
        this.useAnimation = 17;
        this.useTime = 17;
        this.width = 24;
        this.height = 28;
        this.shoot = 27;
        this.scale = 0.9f;
        this.shootSpeed = 4.5f;
        this.knockBack = 5f;
        this.magic = true;
        this.value = Item.sellPrice(gold: 1, silver: 50);
      }
      else if (type == 166)
      {
        this.useStyle = 1;
        this.shootSpeed = 5f;
        this.shoot = 28;
        this.width = 20;
        this.height = 20;
        this.maxStack = 99;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 25;
        this.useTime = 25;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.value = Item.buyPrice(silver: 3);
        this.damage = 0;
      }
      else if (type == 167)
      {
        this.useStyle = 1;
        this.shootSpeed = 4f;
        this.shoot = 29;
        this.width = 8;
        this.height = 28;
        this.maxStack = 99;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 40;
        this.useTime = 40;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.value = Item.buyPrice(silver: 20);
        this.rare = 1;
      }
      else if (type == 168)
      {
        this.useStyle = 5;
        this.shootSpeed = 5.5f;
        this.shoot = 30;
        this.width = 20;
        this.height = 20;
        this.maxStack = 99;
        this.consumable = true;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 45;
        this.useTime = 45;
        this.noUseGraphic = true;
        this.noMelee = true;
        this.value = 75;
        this.damage = 60;
        this.knockBack = 8f;
        this.ranged = true;
      }
      else if (type == 169)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 53;
        this.width = 12;
        this.height = 12;
        this.ammo = AmmoID.Sand;
        this.notAmmo = true;
      }
      else if (type == 170)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 54;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 171)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 55;
        this.width = 28;
        this.height = 28;
      }
      else if (type == 172)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 57;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 173)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 56;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 174)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 58;
        this.width = 12;
        this.height = 12;
        this.rare = 2;
        this.value = Item.sellPrice(silver: 2, copper: 50);
      }
      else if (type == 175)
      {
        this.width = 20;
        this.height = 20;
        this.maxStack = 999;
        this.rare = 2;
        this.value = 20000;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.consumable = true;
        this.createTile = 239;
        this.placeStyle = 10;
      }
      else if (type == 176)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 59;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 181)
      {
        this.createTile = 178;
        this.placeStyle = 0;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 1875;
      }
      else if (type == 180)
      {
        this.createTile = 178;
        this.placeStyle = 1;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 3750;
      }
      else if (type == 177)
      {
        this.createTile = 178;
        this.placeStyle = 2;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 5625;
      }
      else if (type == 179)
      {
        this.createTile = 178;
        this.placeStyle = 3;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 7500;
      }
      else if (type == 178)
      {
        this.createTile = 178;
        this.placeStyle = 4;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 11250;
      }
      else if (type == 182)
      {
        this.createTile = 178;
        this.placeStyle = 5;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.alpha = 50;
        this.width = 10;
        this.height = 14;
        this.value = 15000;
      }
      else if (type == 183)
      {
        this.width = 16;
        this.height = 18;
        this.value = 50;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 190;
      }
      else if (type == 184)
      {
        this.width = 12;
        this.height = 12;
      }
      else if (type == 185)
      {
        this.noUseGraphic = true;
        this.damage = 0;
        this.knockBack = 7f;
        this.useStyle = 5;
        this.shootSpeed = 13f;
        this.shoot = 32;
        this.width = 18;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 20;
        this.useTime = 20;
        this.rare = 3;
        this.noMelee = true;
        this.value = 20000;
      }
      else if (type == 186)
      {
        this.width = 44;
        this.height = 44;
        this.rare = 1;
        this.value = 10000;
        this.holdStyle = 2;
        this.useStyle = 1;
        this.useAnimation = 27;
        this.useTime = 19;
        this.knockBack = 4f;
        this.damage = 10;
        this.UseSound = SoundID.Item1;
        this.melee = true;
      }
      else if (type == 187)
      {
        this.width = 28;
        this.height = 28;
        this.rare = 1;
        this.value = 10000;
        this.accessory = true;
        this.shoeSlot = (sbyte) 1;
      }
      else if (type == 188)
      {
        this.UseSound = SoundID.Item3;
        this.healLife = 100;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 30;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.rare = 1;
        this.potion = true;
        this.value = 1000;
      }
      else if (type == 189)
      {
        this.UseSound = SoundID.Item3;
        this.healMana = 100;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 75;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.rare = 1;
        this.value = Item.buyPrice(silver: 2, copper: 50);
      }
      else if (type == 190)
      {
        this.useStyle = 1;
        this.useAnimation = 30;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 28;
        this.scale = 1.4f;
        this.UseSound = SoundID.Item1;
        this.rare = 3;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 191)
      {
        this.noMelee = true;
        this.useStyle = 1;
        this.shootSpeed = 11f;
        this.shoot = 33;
        this.damage = 25;
        this.knockBack = 8f;
        this.width = 14;
        this.height = 28;
        this.UseSound = SoundID.Item1;
        this.useAnimation = 15;
        this.useTime = 15;
        this.noUseGraphic = true;
        this.rare = 3;
        this.value = 50000;
        this.melee = true;
      }
      else if (type == 192)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 75;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 193)
      {
        this.width = 20;
        this.height = 22;
        this.rare = 2;
        this.value = 27000;
        this.accessory = true;
        this.faceSlot = (sbyte) 12;
        this.defense = 1;
      }
      else if (type == 194)
      {
        this.autoReuse = true;
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 70;
        this.width = 14;
        this.height = 14;
        this.value = 150;
      }
      else if (type == 195)
      {
        this.autoReuse = true;
        this.useTurn = true;
        this.useStyle = 1;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 60;
        this.width = 14;
        this.height = 14;
        this.value = 150;
      }
      else if (type == 196)
      {
        this.autoReuse = true;
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 37;
        this.useTime = 25;
        this.hammer = 25;
        this.width = 24;
        this.height = 28;
        this.damage = 2;
        this.knockBack = 5.5f;
        this.scale = 1.2f;
        this.UseSound = SoundID.Item1;
        this.tileBoost = -1;
        this.value = 50;
        this.melee = true;
      }
      else if (type == 197)
      {
        this.autoReuse = true;
        this.useStyle = 5;
        this.useAnimation = 12;
        this.useTime = 12;
        this.width = 50;
        this.height = 18;
        this.shoot = 12;
        this.useAmmo = AmmoID.FallenStar;
        this.UseSound = SoundID.Item9;
        this.damage = 55;
        this.shootSpeed = 14f;
        this.noMelee = true;
        this.value = 500000;
        this.rare = 2;
        this.ranged = true;
      }
      else if (type == 198)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 199)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 200)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 201)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 202)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 203)
      {
        this.useStyle = 1;
        this.useAnimation = 25;
        this.knockBack = 3f;
        this.width = 40;
        this.height = 40;
        this.damage = 21;
        this.scale = 1f;
        this.UseSound = SoundID.Item15;
        this.rare = 1;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 204)
      {
        this.useTurn = true;
        this.autoReuse = true;
        this.useStyle = 1;
        this.useAnimation = 30;
        this.useTime = 16;
        this.hammer = 60;
        this.axe = 20;
        this.width = 24;
        this.height = 28;
        this.damage = 20;
        this.knockBack = 7f;
        this.scale = 1.2f;
        this.UseSound = SoundID.Item1;
        this.rare = 1;
        this.value = 15000;
        this.melee = true;
      }
      else if (type == 205)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.width = 20;
        this.height = 20;
        this.headSlot = 13;
        this.defense = 1;
        this.maxStack = 99;
        this.autoReuse = true;
      }
      else if (type == 206)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.width = 20;
        this.height = 20;
        this.maxStack = 99;
        this.autoReuse = true;
      }
      else if (type == 207)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.width = 20;
        this.height = 20;
        this.maxStack = 99;
        this.autoReuse = true;
      }
      else if (type == 208)
      {
        this.width = 20;
        this.height = 20;
        this.value = 100;
        this.headSlot = 23;
        this.vanity = true;
      }
      else if (type == 209)
      {
        this.width = 16;
        this.height = 18;
        this.maxStack = 99;
        this.value = 200;
      }
      else if (type == 210)
      {
        this.width = 14;
        this.height = 20;
        this.maxStack = 99;
        this.value = 1000;
      }
      else if (type == 211)
      {
        this.width = 20;
        this.height = 20;
        this.accessory = true;
        this.rare = 3;
        this.value = 50000;
        this.handOnSlot = (sbyte) 5;
        this.handOffSlot = (sbyte) 9;
      }
      else if (type == 212)
      {
        this.width = 20;
        this.height = 20;
        this.accessory = true;
        this.rare = 3;
        this.value = 50000;
      }
      else if (type == 213)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 25;
        this.useTime = 13;
        this.autoReuse = true;
        this.width = 24;
        this.height = 28;
        this.damage = 7;
        this.createTile = 2;
        this.UseSound = SoundID.Item1;
        this.knockBack = 3f;
        this.rare = 3;
        this.value = 2000;
        this.melee = true;
      }
      else if (type == 214)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 999;
        this.consumable = true;
        this.createTile = 76;
        this.width = 12;
        this.height = 12;
      }
      else if (type == 215)
      {
        this.width = 18;
        this.height = 18;
        this.useTurn = true;
        this.useTime = 30;
        this.useAnimation = 30;
        this.noUseGraphic = true;
        this.useStyle = 10;
        this.UseSound = SoundID.Item16;
        this.rare = 2;
        this.value = 100;
      }
      else if (type == 216)
      {
        this.width = 20;
        this.height = 20;
        this.rare = 1;
        this.value = Item.sellPrice(silver: 20);
        this.accessory = true;
        this.defense = 1;
        this.handOffSlot = (sbyte) 7;
        this.handOnSlot = (sbyte) 12;
      }
      else if (type == 217)
      {
        this.useTurn = true;
        this.autoReuse = true;
        this.useStyle = 1;
        this.useAnimation = 27;
        this.useTime = 14;
        this.hammer = 70;
        this.axe = 30;
        this.width = 24;
        this.height = 28;
        this.damage = 20;
        this.knockBack = 7f;
        this.scale = 1.4f;
        this.UseSound = SoundID.Item1;
        this.rare = 3;
        this.value = 27000;
        this.melee = true;
      }
      else if (type == 218)
      {
        this.mana = 18;
        this.channel = true;
        this.damage = 36;
        this.useStyle = 1;
        this.shootSpeed = 6f;
        this.shoot = 34;
        this.width = 26;
        this.height = 28;
        this.UseSound = SoundID.Item20;
        this.useAnimation = 30;
        this.useTime = 30;
        this.rare = 3;
        this.noMelee = true;
        this.knockBack = 6.5f;
        this.value = this.hellPrice;
        this.magic = true;
      }
      else if (type == 219)
      {
        this.autoReuse = false;
        this.useStyle = 5;
        this.useAnimation = 11;
        this.useTime = 11;
        this.width = 24;
        this.height = 22;
        this.shoot = 14;
        this.knockBack = 2f;
        this.useAmmo = AmmoID.Bullet;
        this.UseSound = SoundID.Item41;
        this.damage = 24;
        this.shootSpeed = 13f;
        this.noMelee = true;
        this.value = Item.sellPrice(gold: 3, silver: 50);
        this.scale = 0.85f;
        this.rare = 3;
        this.ranged = true;
      }
      else if (type == 220)
      {
        this.noMelee = true;
        this.useStyle = 5;
        this.useAnimation = 45;
        this.useTime = 45;
        this.knockBack = 6.75f;
        this.width = 30;
        this.height = 10;
        this.damage = 35;
        this.crit = 7;
        this.scale = 1.1f;
        this.noUseGraphic = true;
        this.shoot = 35;
        this.shootSpeed = 12f;
        this.UseSound = SoundID.Item1;
        this.rare = 3;
        this.value = this.hellPrice;
        this.melee = true;
        this.channel = true;
      }
      else if (type == 221)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 77;
        this.width = 26;
        this.height = 24;
        this.value = 3000;
      }
      else if (type == 222)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.autoReuse = true;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 78;
        this.width = 14;
        this.height = 14;
        this.value = 100;
      }
      else if (type == 223)
      {
        this.width = 20;
        this.height = 22;
        this.rare = 3;
        this.value = 27000;
        this.accessory = true;
        this.faceSlot = (sbyte) 1;
      }
      else if (type == 224)
      {
        this.useStyle = 1;
        this.useTurn = true;
        this.useAnimation = 15;
        this.useTime = 10;
        this.maxStack = 99;
        this.consumable = true;
        this.createTile = 79;
        this.width = 28;
        this.height = 20;
        this.value = 2000;
      }
      else if (type == 225)
      {
        this.maxStack = 999;
        this.width = 22;
        this.height = 22;
        this.value = 1000;
      }
      else if (type == 226 || type == 227)
      {
        this.type = 227;
        this.UseSound = SoundID.Item3;
        this.healLife = 90;
        this.useStyle = 9;
        this.useTurn = true;
        this.useAnimation = 17;
        this.useTime = 17;
        this.maxStack = 30;
        this.consumable = true;
        this.width = 14;
        this.height = 24;
        this.potion = true;
        this.value = 1500;
        this.rare = 1;
      }
      else
      {
        switch (type)
        {
          case 228:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.headSlot = 8;
            this.rare = 3;
            this.value = 45000;
            break;
          case 229:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.bodySlot = 8;
            this.rare = 3;
            this.value = 30000;
            break;
          case 230:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.legSlot = 8;
            this.rare = 3;
            this.value = 30000;
            break;
          case 231:
            this.width = 18;
            this.height = 18;
            this.defense = 8;
            this.headSlot = 9;
            this.rare = 3;
            this.value = 45000;
            break;
          case 232:
            this.width = 18;
            this.height = 18;
            this.defense = 9;
            this.bodySlot = 9;
            this.rare = 3;
            this.value = 30000;
            break;
          case 233:
            this.width = 18;
            this.height = 18;
            this.defense = 8;
            this.legSlot = 9;
            this.rare = 3;
            this.value = 30000;
            break;
          case 234:
            this.shootSpeed = 3f;
            this.shoot = 36;
            this.damage = 9;
            this.width = 8;
            this.height = 8;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Bullet;
            this.knockBack = 1f;
            this.value = 8;
            this.rare = 1;
            this.ranged = true;
            break;
          case 235:
            this.useStyle = 1;
            this.shootSpeed = 5f;
            this.shoot = 37;
            this.width = 20;
            this.height = 20;
            this.maxStack = 99;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 25;
            this.useTime = 25;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 500;
            this.damage = 0;
            break;
          case 236:
            this.width = 12;
            this.height = 20;
            this.maxStack = 99;
            this.value = 5000;
            break;
          case 237:
            this.width = 28;
            this.height = 12;
            this.headSlot = 12;
            this.rare = 2;
            this.value = 10000;
            this.vanity = true;
            break;
          case 238:
            this.width = 28;
            this.height = 20;
            this.headSlot = 14;
            this.rare = 2;
            this.value = 10000;
            this.defense = 2;
            break;
          case 239:
            this.width = 18;
            this.height = 18;
            this.headSlot = 15;
            this.value = 10000;
            this.vanity = true;
            break;
          case 240:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 10;
            this.value = 5000;
            this.vanity = true;
            break;
          case 241:
            this.width = 18;
            this.height = 18;
            this.legSlot = 10;
            this.value = 5000;
            this.vanity = true;
            break;
          case 242:
            this.width = 18;
            this.height = 18;
            this.headSlot = 16;
            this.value = 10000;
            this.vanity = true;
            break;
          case 243:
            this.width = 18;
            this.height = 18;
            this.headSlot = 17;
            this.value = 20000;
            this.vanity = true;
            break;
          case 244:
            this.width = 18;
            this.height = 12;
            this.headSlot = 18;
            this.value = 10000;
            this.vanity = true;
            break;
          case 245:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 11;
            this.value = 250000;
            this.vanity = true;
            break;
          case 246:
            this.width = 18;
            this.height = 18;
            this.legSlot = 11;
            this.value = 250000;
            this.vanity = true;
            break;
          case 247:
            this.width = 18;
            this.height = 12;
            this.headSlot = 19;
            this.value = 10000;
            this.vanity = true;
            break;
          case 248:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 12;
            this.value = 5000;
            this.vanity = true;
            break;
          case 249:
            this.width = 18;
            this.height = 18;
            this.legSlot = 12;
            this.value = 5000;
            this.vanity = true;
            break;
          case 250:
            this.width = 18;
            this.height = 18;
            this.headSlot = 20;
            this.value = 10000;
            this.vanity = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 282;
            this.width = 12;
            this.height = 12;
            break;
          case 251:
            this.width = 18;
            this.height = 12;
            this.headSlot = 21;
            this.value = 10000;
            this.vanity = true;
            break;
          case 252:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 13;
            this.value = 5000;
            this.vanity = true;
            break;
          case 253:
            this.width = 18;
            this.height = 18;
            this.legSlot = 13;
            this.value = 5000;
            this.vanity = true;
            break;
          case 254:
            this.maxStack = 99;
            this.width = 12;
            this.height = 20;
            this.value = 10000;
            break;
          case (int) byte.MaxValue:
            this.maxStack = 99;
            this.width = 12;
            this.height = 20;
            this.value = 2000;
            break;
          case 256:
            this.width = 18;
            this.height = 12;
            this.headSlot = 22;
            this.value = 10000;
            this.defense = 2;
            this.rare = 1;
            break;
          case 257:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 14;
            this.value = 5000;
            this.defense = 4;
            this.rare = 1;
            break;
          case 258:
            this.width = 18;
            this.height = 18;
            this.legSlot = 14;
            this.value = 5000;
            this.defense = 3;
            this.rare = 1;
            break;
          case 259:
            this.width = 18;
            this.height = 20;
            this.maxStack = 99;
            this.value = 50;
            break;
          case 260:
            this.width = 18;
            this.height = 14;
            this.headSlot = 24;
            this.value = 1000;
            this.vanity = true;
            break;
          case 261:
            this.useStyle = 1;
            this.autoReuse = true;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.width = 12;
            this.height = 12;
            this.noUseGraphic = true;
            this.makeNPC = (short) 55;
            break;
          case 262:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 15;
            this.value = 2000;
            this.vanity = true;
            break;
          case 263:
            this.width = 18;
            this.height = 18;
            this.headSlot = 25;
            this.value = 10000;
            this.vanity = true;
            break;
          case 264:
            this.width = 18;
            this.height = 18;
            this.headSlot = 26;
            this.value = 10000;
            this.vanity = true;
            break;
          case 265:
            this.shootSpeed = 6.5f;
            this.shoot = 41;
            this.damage = 13;
            this.width = 10;
            this.height = 28;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Arrow;
            this.knockBack = 8f;
            this.value = 100;
            this.rare = 2;
            this.ranged = true;
            break;
          case 266:
            this.useStyle = 5;
            this.useAnimation = 16;
            this.useTime = 16;
            this.autoReuse = true;
            this.width = 40;
            this.height = 20;
            this.shoot = 42;
            this.useAmmo = AmmoID.Sand;
            this.UseSound = SoundID.Item11;
            this.damage = 30;
            this.shootSpeed = 12f;
            this.noMelee = true;
            this.knockBack = 5f;
            this.value = 10000;
            this.rare = 2;
            this.ranged = true;
            break;
          case 267:
            this.accessory = true;
            this.width = 14;
            this.height = 26;
            this.value = 1000;
            break;
          case 268:
            this.headSlot = 27;
            this.defense = 2;
            this.width = 20;
            this.height = 20;
            this.value = 1000;
            this.rare = 2;
            break;
          case 269:
            this.bodySlot = 0;
            this.width = 20;
            this.height = 20;
            this.value = 10000;
            this.color = Main.player[Main.myPlayer].shirtColor;
            this.vanity = true;
            break;
          case 270:
            this.legSlot = 0;
            this.width = 20;
            this.height = 20;
            this.value = 10000;
            this.color = Main.player[Main.myPlayer].pantsColor;
            this.vanity = true;
            break;
          case 271:
            this.headSlot = 0;
            this.width = 20;
            this.height = 20;
            this.value = 10000;
            this.color = Main.player[Main.myPlayer].hairColor;
            this.vanity = true;
            break;
          case 272:
            this.mana = 14;
            this.damage = 35;
            this.useStyle = 5;
            this.shootSpeed = 0.2f;
            this.shoot = 45;
            this.width = 26;
            this.height = 28;
            this.UseSound = SoundID.Item8;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 3;
            this.noMelee = true;
            this.knockBack = 5f;
            this.scale = 0.9f;
            this.value = Item.sellPrice(gold: 1, silver: 50);
            this.magic = true;
            break;
          case 273:
            this.useStyle = 1;
            this.useAnimation = 27;
            this.useTime = 27;
            this.knockBack = 4.5f;
            this.width = 40;
            this.height = 40;
            this.damage = 42;
            this.scale = 1.15f;
            this.UseSound = SoundID.Item1;
            this.rare = 3;
            this.value = Item.sellPrice(gold: 4);
            this.melee = true;
            break;
          case 274:
            this.useStyle = 5;
            this.useAnimation = 22;
            this.useTime = 22;
            this.shootSpeed = 6f;
            this.knockBack = 5f;
            this.width = 40;
            this.height = 40;
            this.damage = 29;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 46;
            this.rare = 3;
            this.value = this.hellPrice;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 275:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 81;
            this.width = 20;
            this.height = 22;
            this.value = Item.sellPrice(silver: 2);
            break;
          case 276:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 188;
            this.width = 12;
            this.height = 12;
            this.value = 10;
            break;
          case 277:
            this.useStyle = 5;
            this.useAnimation = 31;
            this.useTime = 31;
            this.shootSpeed = 4f;
            this.knockBack = 6f;
            this.width = 40;
            this.height = 40;
            this.damage = 14;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 47;
            this.rare = 1;
            this.value = 10000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 278:
            this.shootSpeed = 4.5f;
            this.shoot = 14;
            this.damage = 9;
            this.width = 8;
            this.height = 8;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Bullet;
            this.knockBack = 3f;
            this.value = 15;
            this.ranged = true;
            break;
          case 279:
            this.useStyle = 1;
            this.shootSpeed = 10f;
            this.shoot = 48;
            this.damage = 12;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 50;
            this.knockBack = 2f;
            this.ranged = true;
            break;
          case 280:
            this.useStyle = 5;
            this.useAnimation = 31;
            this.useTime = 31;
            this.shootSpeed = 3.7f;
            this.knockBack = 6.5f;
            this.width = 32;
            this.height = 32;
            this.damage = 8;
            this.scale = 1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 49;
            this.value = 1000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 281:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.width = 38;
            this.height = 6;
            this.shoot = 10;
            this.useAmmo = AmmoID.Dart;
            this.UseSound = SoundID.Item63;
            this.damage = 9;
            this.shootSpeed = 11f;
            this.noMelee = true;
            this.value = 10000;
            this.knockBack = 3.5f;
            this.ranged = true;
            break;
          case 282:
            this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
            this.useStyle = 1;
            this.shootSpeed = 6f;
            this.shoot = 50;
            this.width = 12;
            this.height = 12;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noMelee = true;
            this.value = 10;
            this.holdStyle = 1;
            break;
          case 283:
            this.shoot = 51;
            this.width = 8;
            this.height = 8;
            this.maxStack = 999;
            this.ammo = AmmoID.Dart;
            this.damage = 3;
            this.ranged = true;
            this.consumable = true;
            break;
          case 284:
            this.noMelee = true;
            this.useStyle = 1;
            this.shootSpeed = 6.5f;
            this.shoot = 52;
            this.damage = 8;
            this.knockBack = 5f;
            this.width = 14;
            this.height = 28;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 16;
            this.useTime = 16;
            this.noUseGraphic = true;
            this.value = 5000;
            this.melee = true;
            break;
          case 285:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 286:
            this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
            this.useStyle = 1;
            this.shootSpeed = 6f;
            this.shoot = 53;
            this.width = 12;
            this.height = 12;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noMelee = true;
            this.value = 20;
            this.holdStyle = 1;
            break;
          case 287:
            this.crit = 4;
            this.useStyle = 1;
            this.shootSpeed = 12f;
            this.shoot = 54;
            this.damage = 14;
            this.autoReuse = true;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 60;
            this.knockBack = 2.4f;
            this.ranged = true;
            break;
          case 288:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 1;
            this.buffTime = 21600;
            this.value = 1000;
            this.rare = 1;
            break;
          case 289:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 2;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 290:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 3;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 291:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 4;
            this.buffTime = 14400;
            this.value = 1000;
            this.rare = 1;
            break;
          case 292:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 5;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 293:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 6;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 294:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 7;
            this.buffTime = 14400;
            this.value = 1000;
            this.rare = 1;
            break;
          case 295:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 8;
            this.buffTime = 36000;
            this.value = 1000;
            this.rare = 1;
            break;
          case 296:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 9;
            this.buffTime = 18000;
            this.value = 1000;
            this.rare = 1;
            break;
          case 297:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 10;
            this.buffTime = 10800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 298:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 11;
            this.buffTime = 36000;
            this.value = 1000;
            this.rare = 1;
            break;
          case 299:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 12;
            this.buffTime = 36000;
            this.value = 1000;
            this.rare = 1;
            break;
          case 300:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 13;
            this.buffTime = 25200;
            this.value = 1000;
            this.rare = 1;
            break;
          case 301:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 14;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 302:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 15;
            this.buffTime = 36000;
            this.value = 1000;
            this.rare = 1;
            break;
          case 303:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 16;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 304:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 17;
            this.buffTime = 28800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 305:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.buffType = 18;
            this.buffTime = 10800;
            this.value = 1000;
            this.rare = 1;
            break;
          case 306:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 1;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 307:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 0;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 308:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 1;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 309:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 2;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 310:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 3;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 311:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 4;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 312:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 82;
            this.placeStyle = 5;
            this.width = 12;
            this.height = 14;
            this.value = 80;
            break;
          case 313:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 314:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 315:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 316:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 317:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 318:
            this.maxStack = 999;
            this.width = 12;
            this.height = 14;
            this.value = 100;
            break;
          case 319:
            this.maxStack = 99;
            this.width = 16;
            this.height = 14;
            this.value = 200;
            this.color = new Color(123, 167, 163, (int) byte.MaxValue);
            break;
          case 320:
            this.maxStack = 99;
            this.width = 16;
            this.height = 14;
            this.value = 50;
            break;
          case 321:
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 85;
            this.width = 20;
            this.height = 20;
            break;
          case 322:
            this.headSlot = 28;
            this.width = 20;
            this.height = 20;
            this.value = 20000;
            this.vanity = true;
            break;
          case 323:
            this.width = 10;
            this.height = 20;
            this.maxStack = 99;
            this.value = 50;
            break;
          case 324:
            this.width = 10;
            this.height = 20;
            this.maxStack = 99;
            this.value = 200000;
            break;
          case 325:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 16;
            this.value = 200000;
            this.vanity = true;
            break;
          case 326:
            this.width = 18;
            this.height = 18;
            this.legSlot = 15;
            this.value = 200000;
            this.vanity = true;
            break;
          case 327:
            this.width = 14;
            this.height = 20;
            this.maxStack = 99;
            break;
          case 328:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 3;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 329:
            this.width = 14;
            this.height = 20;
            this.maxStack = 1;
            this.value = this.dungeonPrice;
            break;
          case 330:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 20;
            this.width = 12;
            this.height = 12;
            break;
          case 331:
            this.width = 18;
            this.height = 16;
            this.maxStack = 99;
            this.value = 100;
            break;
          case 332:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 86;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 333:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 87;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 334:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 88;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 335:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 89;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 336:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 90;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 337:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 0;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 338:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 1;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 339:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 2;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 340:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 3;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 341:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 92;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 342:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 93;
            this.width = 10;
            this.height = 24;
            this.value = 500;
            break;
          case 343:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 5;
            this.width = 20;
            this.height = 20;
            this.value = 500;
            break;
          case 344:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 95;
            this.width = 20;
            this.height = 20;
            this.value = 500;
            break;
          case 345:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 96;
            this.width = 20;
            this.height = 20;
            this.value = 500;
            break;
          case 346:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 97;
            this.width = 20;
            this.height = 20;
            this.value = 200000;
            break;
          case 347:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 98;
            this.width = 20;
            this.height = 20;
            this.value = 500;
            break;
          case 348:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 6;
            this.width = 20;
            this.height = 20;
            this.value = 1000;
            break;
          case 349:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 100;
            this.width = 20;
            this.height = 20;
            this.value = 1500;
            break;
          case 350:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 13;
            this.placeStyle = 3;
            this.width = 16;
            this.height = 24;
            this.value = 70;
            break;
          case 351:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 13;
            this.placeStyle = 4;
            this.width = 16;
            this.height = 24;
            this.value = 20;
            break;
          case 352:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 94;
            this.width = 24;
            this.height = 24;
            this.value = 600;
            break;
          case 354:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 101;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 355:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 102;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 356:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 103;
            this.width = 16;
            this.height = 24;
            this.value = 20;
            break;
          case 358:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 1;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 359:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 104;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 360:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 361:
            this.useStyle = 4;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.width = 28;
            this.height = 28;
            this.maxStack = 20;
            break;
          case 362:
            this.maxStack = 99;
            this.width = 24;
            this.height = 24;
            this.value = 30;
            break;
          case 363:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 106;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 364:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 107;
            this.width = 12;
            this.height = 12;
            this.value = 3500;
            this.rare = 3;
            break;
          case 365:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 108;
            this.width = 12;
            this.height = 12;
            this.value = 5500;
            this.rare = 3;
            break;
          case 366:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 111;
            this.width = 12;
            this.height = 12;
            this.value = 7500;
            this.rare = 3;
            break;
          case 367:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 27;
            this.useTime = 14;
            this.hammer = 80;
            this.width = 24;
            this.height = 28;
            this.damage = 26;
            this.knockBack = 7.5f;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 39000;
            this.melee = true;
            break;
          case 368:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.knockBack = 4.5f;
            this.width = 40;
            this.height = 40;
            this.damage = 66;
            this.scale = 1.15f;
            this.UseSound = SoundID.Item1;
            this.rare = 5;
            this.value = 230000;
            this.melee = true;
            break;
          case 369:
            this.autoReuse = true;
            this.useTurn = true;
            this.useStyle = 1;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 109;
            this.width = 14;
            this.height = 14;
            this.value = 2000;
            this.rare = 3;
            break;
          case 370:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 112;
            this.width = 12;
            this.height = 12;
            this.ammo = AmmoID.Sand;
            this.notAmmo = true;
            break;
          case 371:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.headSlot = 29;
            this.rare = 4;
            this.value = 75000;
            break;
          case 372:
            this.width = 18;
            this.height = 18;
            this.defense = 11;
            this.headSlot = 30;
            this.rare = 4;
            this.value = 75000;
            break;
          case 373:
            this.width = 18;
            this.height = 18;
            this.defense = 4;
            this.headSlot = 31;
            this.rare = 4;
            this.value = 75000;
            break;
          case 374:
            this.width = 18;
            this.height = 18;
            this.defense = 8;
            this.bodySlot = 17;
            this.rare = 4;
            this.value = 60000;
            break;
          case 375:
            this.width = 18;
            this.height = 18;
            this.defense = 7;
            this.legSlot = 16;
            this.rare = 4;
            this.value = 45000;
            break;
          case 376:
            this.width = 18;
            this.height = 18;
            this.defense = 3;
            this.headSlot = 32;
            this.rare = 4;
            this.value = 112500;
            break;
          case 377:
            this.width = 18;
            this.height = 18;
            this.defense = 16;
            this.headSlot = 33;
            this.rare = 4;
            this.value = 112500;
            break;
          case 378:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.headSlot = 34;
            this.rare = 4;
            this.value = 112500;
            break;
          case 379:
            this.width = 18;
            this.height = 18;
            this.defense = 12;
            this.bodySlot = 18;
            this.rare = 4;
            this.value = 90000;
            break;
          case 380:
            this.width = 18;
            this.height = 18;
            this.defense = 9;
            this.legSlot = 17;
            this.rare = 4;
            this.value = 67500;
            break;
          case 381:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 10500;
            this.rare = 3;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 11;
            break;
          case 382:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 22000;
            this.rare = 3;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 13;
            break;
          case 383:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 13;
            this.shootSpeed = 40f;
            this.knockBack = 2.75f;
            this.width = 20;
            this.height = 12;
            this.damage = 23;
            this.axe = 14;
            this.UseSound = SoundID.Item23;
            this.shoot = 57;
            this.rare = 4;
            this.value = 54000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 384:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 10;
            this.shootSpeed = 40f;
            this.knockBack = 3f;
            this.width = 20;
            this.height = 12;
            this.damage = 29;
            this.axe = 17;
            this.UseSound = SoundID.Item23;
            this.shoot = 58;
            this.rare = 4;
            this.value = 81000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 385:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 13;
            this.shootSpeed = 32f;
            this.knockBack = 0.0f;
            this.width = 20;
            this.height = 12;
            this.damage = 10;
            this.pick = 110;
            this.UseSound = SoundID.Item23;
            this.shoot = 59;
            this.rare = 4;
            this.value = 54000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 386:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 10;
            this.shootSpeed = 32f;
            this.knockBack = 0.0f;
            this.width = 20;
            this.height = 12;
            this.damage = 15;
            this.pick = 150;
            this.UseSound = SoundID.Item23;
            this.shoot = 60;
            this.rare = 4;
            this.value = 81000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 387:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 8;
            this.shootSpeed = 40f;
            this.knockBack = 4.5f;
            this.width = 20;
            this.height = 12;
            this.damage = 33;
            this.axe = 20;
            this.UseSound = SoundID.Item23;
            this.shoot = 61;
            this.rare = 4;
            this.value = 108000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 388:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 8;
            this.shootSpeed = 32f;
            this.knockBack = 0.0f;
            this.width = 20;
            this.height = 12;
            this.damage = 20;
            this.pick = 180;
            this.UseSound = SoundID.Item23;
            this.shoot = 62;
            this.rare = 4;
            this.value = 108000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 389:
            this.noMelee = true;
            this.useStyle = 5;
            this.useAnimation = 45;
            this.useTime = 45;
            this.knockBack = 6f;
            this.width = 30;
            this.height = 10;
            this.damage = 50;
            this.scale = 1.1f;
            this.noUseGraphic = true;
            this.shoot = 63;
            this.shootSpeed = 15f;
            this.UseSound = SoundID.Item1;
            this.rare = 5;
            this.value = 144000;
            this.melee = true;
            this.channel = true;
            break;
          case 390:
            this.useStyle = 5;
            this.useAnimation = 26;
            this.useTime = 26;
            this.shootSpeed = 4.5f;
            this.knockBack = 5f;
            this.width = 40;
            this.height = 40;
            this.damage = 35;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 64;
            this.rare = 4;
            this.value = 67500;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 391:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 37500;
            this.rare = 3;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 15;
            break;
          case 392:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 21;
            this.width = 12;
            this.height = 12;
            break;
          case 393:
            this.width = 24;
            this.height = 28;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 25);
            this.accessory = true;
            break;
          case 394:
            this.width = 24;
            this.height = 28;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.faceSlot = (sbyte) 4;
            break;
          case 395:
            this.width = 24;
            this.height = 28;
            this.rare = 3;
            this.value = Item.sellPrice(gold: 3);
            this.accessory = true;
            break;
          case 396:
            this.width = 24;
            this.height = 28;
            this.rare = 4;
            this.value = Item.buyPrice(gold: 6);
            this.accessory = true;
            break;
          case 397:
            this.width = 24;
            this.height = 28;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.defense = 2;
            this.shieldSlot = (sbyte) 3;
            break;
          case 398:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 114;
            this.width = 26;
            this.height = 20;
            this.value = 100000;
            break;
          case 399:
            this.width = 14;
            this.height = 28;
            this.rare = 4;
            this.value = 150000;
            this.accessory = true;
            this.balloonSlot = (sbyte) 4;
            break;
          case 400:
            this.width = 18;
            this.height = 18;
            this.defense = 4;
            this.headSlot = 35;
            this.rare = 4;
            this.value = 150000;
            break;
          case 401:
            this.width = 18;
            this.height = 18;
            this.defense = 22;
            this.headSlot = 36;
            this.rare = 4;
            this.value = 150000;
            break;
          case 402:
            this.width = 18;
            this.height = 18;
            this.defense = 8;
            this.headSlot = 37;
            this.rare = 4;
            this.value = 150000;
            break;
          case 403:
            this.width = 18;
            this.height = 18;
            this.defense = 16;
            this.bodySlot = 19;
            this.rare = 4;
            this.value = 120000;
            break;
          case 404:
            this.width = 18;
            this.height = 18;
            this.defense = 12;
            this.legSlot = 18;
            this.rare = 4;
            this.value = 90000;
            break;
          case 405:
            this.width = 28;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            this.shoeSlot = (sbyte) 13;
            break;
          case 406:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 25;
            this.shootSpeed = 5f;
            this.knockBack = 6f;
            this.width = 40;
            this.height = 40;
            this.damage = 38;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 66;
            this.rare = 4;
            this.value = 90000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 407:
            this.width = 28;
            this.height = 24;
            this.accessory = true;
            this.rare = 3;
            this.value = 100000;
            this.waistSlot = (sbyte) 5;
            break;
          case 408:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 116;
            this.width = 12;
            this.height = 12;
            this.ammo = AmmoID.Sand;
            this.notAmmo = true;
            break;
          case 409:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 117;
            this.width = 12;
            this.height = 12;
            break;
          case 410:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.bodySlot = 20;
            this.value = 5000;
            this.rare = 1;
            break;
          case 411:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 19;
            this.value = 5000;
            this.rare = 1;
            break;
          case 412:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 118;
            this.width = 12;
            this.height = 12;
            break;
          case 413:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 119;
            this.width = 12;
            this.height = 12;
            break;
          case 414:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 120;
            this.width = 12;
            this.height = 12;
            break;
          case 415:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 121;
            this.width = 12;
            this.height = 12;
            break;
          case 416:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 122;
            this.width = 12;
            this.height = 12;
            break;
          case 417:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 22;
            this.width = 12;
            this.height = 12;
            break;
          case 418:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 23;
            this.width = 12;
            this.height = 12;
            break;
          case 419:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 24;
            this.width = 12;
            this.height = 12;
            break;
          case 420:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 25;
            this.width = 12;
            this.height = 12;
            break;
          case 421:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 26;
            this.width = 12;
            this.height = 12;
            break;
          case 422:
            this.useStyle = 1;
            this.shootSpeed = 9f;
            this.rare = 3;
            this.damage = 20;
            this.shoot = 69;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.knockBack = 3f;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 200;
            break;
          case 423:
            this.useStyle = 1;
            this.shootSpeed = 9f;
            this.rare = 3;
            this.damage = 20;
            this.shoot = 70;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.knockBack = 3f;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 100;
            break;
          case 424:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 123;
            this.width = 12;
            this.height = 12;
            break;
          case 425:
            this.channel = true;
            this.damage = 0;
            this.useStyle = 1;
            this.width = 24;
            this.height = 24;
            this.UseSound = SoundID.Item25;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 5;
            this.noMelee = true;
            this.value = this.value = 250000;
            this.buffType = 27;
            break;
          case 426:
            this.useStyle = 1;
            this.useAnimation = 29;
            this.knockBack = 8f;
            this.width = 60;
            this.height = 70;
            this.damage = 43;
            this.scale = 1.05f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 150000;
            this.melee = true;
            break;
          case 427:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 1;
            this.width = 10;
            this.height = 12;
            this.value = 200;
            break;
          case 428:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 2;
            this.width = 10;
            this.height = 12;
            this.value = 200;
            break;
          case 429:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 3;
            this.width = 10;
            this.height = 12;
            this.value = 200;
            break;
          case 430:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 4;
            this.width = 10;
            this.height = 12;
            this.value = 200;
            break;
          case 431:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 5;
            this.width = 10;
            this.height = 12;
            this.value = 500;
            break;
          case 432:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 6;
            this.width = 10;
            this.height = 12;
            this.value = 200;
            break;
          case 433:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 7;
            this.width = 10;
            this.height = 12;
            this.value = 300;
            break;
          case 434:
            this.autoReuse = true;
            this.useStyle = 5;
            this.useAnimation = 12;
            this.useTime = 4;
            this.reuseDelay = 14;
            this.width = 50;
            this.height = 18;
            this.shoot = 10;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item31;
            this.damage = 17;
            this.shootSpeed = 7.75f;
            this.noMelee = true;
            this.value = 150000;
            this.rare = 4;
            this.ranged = true;
            break;
          case 435:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 24;
            this.useTime = 24;
            this.width = 50;
            this.height = 18;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 32;
            this.shootSpeed = 9f;
            this.noMelee = true;
            this.value = 60000;
            this.ranged = true;
            this.rare = 4;
            this.knockBack = 1.5f;
            break;
          case 436:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 22;
            this.useTime = 22;
            this.width = 50;
            this.height = 18;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 36;
            this.shootSpeed = 9.5f;
            this.noMelee = true;
            this.value = 90000;
            this.ranged = true;
            this.rare = 4;
            this.knockBack = 2f;
            break;
          case 437:
            this.noUseGraphic = true;
            this.damage = 0;
            this.knockBack = 7f;
            this.useStyle = 5;
            this.shootSpeed = 14f;
            this.shoot = 73;
            this.width = 18;
            this.height = 28;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 4;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 15);
            break;
          case 438:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 2;
            break;
          case 439:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 3;
            break;
          case 440:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 4;
            break;
          case 441:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 5;
            break;
          case 442:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 6;
            break;
          case 443:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 7;
            break;
          case 444:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 8;
            break;
          case 445:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 9;
            break;
          case 446:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 10;
            break;
          case 447:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 11;
            break;
          case 448:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 12;
            break;
          case 449:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 13;
            break;
          case 450:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 14;
            break;
          case 451:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 15;
            break;
          case 452:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 16;
            break;
          case 453:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 17;
            break;
          case 454:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 18;
            break;
          case 455:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 19;
            break;
          case 456:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 20;
            break;
          case 457:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 21;
            break;
          case 458:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 22;
            break;
          case 459:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 23;
            break;
          case 460:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 24;
            break;
          case 461:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 25;
            break;
          case 462:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 26;
            break;
          case 463:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 27;
            break;
          case 464:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 28;
            break;
          case 465:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 29;
            break;
          case 466:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 30;
            break;
          case 467:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 31;
            break;
          case 468:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 32;
            break;
          case 469:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 33;
            break;
          case 470:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 349;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 471:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 35;
            break;
          case 472:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 36;
            break;
          case 473:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 37;
            break;
          case 474:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 38;
            break;
          case 475:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 39;
            break;
          case 476:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 40;
            break;
          case 477:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 41;
            break;
          case 478:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 105;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            this.placeStyle = 42;
            break;
          case 479:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 27;
            this.width = 12;
            this.height = 12;
            break;
          case 480:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 124;
            this.width = 12;
            this.height = 12;
            break;
          case 481:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 19;
            this.useTime = 19;
            this.width = 50;
            this.height = 18;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 40;
            this.shootSpeed = 10f;
            this.noMelee = true;
            this.value = 120000;
            this.ranged = true;
            this.rare = 4;
            this.knockBack = 2.5f;
            break;
          case 482:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 26;
            this.useTime = 26;
            this.knockBack = 6f;
            this.width = 40;
            this.height = 40;
            this.damage = 56;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 138000;
            this.melee = true;
            break;
          case 483:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 23;
            this.useTime = 23;
            this.knockBack = 3.85f;
            this.width = 40;
            this.height = 40;
            this.damage = 39;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 69000;
            this.melee = true;
            break;
          case 484:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 26;
            this.useTime = 26;
            this.knockBack = 6f;
            this.width = 40;
            this.height = 40;
            this.damage = 49;
            this.scale = 1.15f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 103500;
            this.melee = true;
            break;
          case 485:
            this.rare = 4;
            this.width = 24;
            this.height = 28;
            this.accessory = true;
            this.value = 150000;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 486:
            this.autoReuse = true;
            this.useStyle = 13;
            this.useAnimation = 20;
            this.useTime = 5;
            this.reuseDelay = 10;
            this.width = 40;
            this.height = 18;
            this.shoot = 842;
            this.UseSound = SoundID.Item1;
            this.damage = 12;
            this.shootSpeed = 2.4f;
            this.noMelee = true;
            this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 10));
            this.melee = true;
            this.knockBack = 0.5f;
            this.noUseGraphic = true;
            break;
          case 487:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 125;
            this.width = 22;
            this.height = 22;
            this.value = 100000;
            this.rare = 3;
            break;
          case 488:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 126;
            this.width = 22;
            this.height = 26;
            this.value = 10000;
            break;
          case 489:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.value = 100000;
            this.rare = 4;
            break;
          case 490:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.value = 100000;
            this.rare = 4;
            break;
          case 491:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.value = 100000;
            this.rare = 4;
            break;
          case 492:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 1;
            break;
          case 493:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 2;
            break;
          case 494:
            this.rare = 5;
            this.useStyle = 5;
            this.useAnimation = 12;
            this.useTime = 12;
            this.width = 12;
            this.height = 28;
            this.shoot = 76;
            this.holdStyle = 3;
            this.autoReuse = true;
            this.damage = 32;
            this.shootSpeed = 4.5f;
            this.noMelee = true;
            this.value = 200000;
            this.mana = 4;
            this.magic = true;
            break;
          case 495:
            this.rare = 5;
            this.mana = 21;
            this.channel = true;
            this.damage = 50;
            this.useStyle = 1;
            this.shootSpeed = 6f;
            this.shoot = 79;
            this.width = 26;
            this.height = 28;
            this.UseSound = SoundID.Item28;
            this.useAnimation = 25;
            this.useTime = 25;
            this.noMelee = true;
            this.knockBack = 6f;
            this.value = 200000;
            this.magic = true;
            break;
          case 496:
            this.rare = 4;
            this.mana = 6;
            this.damage = 28;
            this.useStyle = 1;
            this.shootSpeed = 12f;
            this.shoot = 80;
            this.width = 26;
            this.height = 28;
            this.UseSound = SoundID.Item28;
            this.useAnimation = 9;
            this.useTime = 9;
            this.rare = 4;
            this.autoReuse = true;
            this.noMelee = true;
            this.knockBack = 0.0f;
            this.value = Item.buyPrice(gold: 50);
            this.magic = true;
            this.knockBack = 2f;
            break;
          case 497:
            this.width = 24;
            this.height = 28;
            this.accessory = true;
            this.value = this.eclipsePrice;
            this.rare = 5;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 498:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 128;
            this.width = 12;
            this.height = 12;
            this.createTile = 470;
            this.placeStyle = 0;
            break;
          case 499:
            this.UseSound = SoundID.Item3;
            this.healLife = 150;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.rare = 3;
            this.potion = true;
            this.value = 5000;
            break;
          case 500:
            this.UseSound = SoundID.Item3;
            this.healMana = 200;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 75;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.rare = 3;
            this.value = Item.buyPrice(silver: 5);
            break;
          case 501:
            this.width = 16;
            this.height = 14;
            this.maxStack = 99;
            this.value = 500;
            this.rare = 1;
            break;
          case 502:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 129;
            this.width = 24;
            this.height = 24;
            this.value = 8000;
            this.rare = 1;
            break;
          case 503:
            this.width = 18;
            this.height = 18;
            this.headSlot = 40;
            this.value = 20000;
            this.vanity = true;
            this.rare = 2;
            break;
          case 504:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 23;
            this.value = 10000;
            this.vanity = true;
            this.rare = 2;
            break;
          case 505:
            this.width = 18;
            this.height = 18;
            this.legSlot = 22;
            this.value = 10000;
            this.vanity = true;
            this.rare = 2;
            break;
          case 506:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 30;
            this.useTime = 6;
            this.width = 50;
            this.height = 18;
            this.shoot = 85;
            this.useAmmo = AmmoID.Gel;
            this.UseSound = SoundID.Item34;
            this.damage = 35;
            this.knockBack = 0.3f;
            this.shootSpeed = 7f;
            this.noMelee = true;
            this.value = 500000;
            this.rare = 5;
            this.ranged = true;
            break;
          case 507:
            this.rare = 3;
            this.useStyle = 1;
            this.useAnimation = 12;
            this.useTime = 12;
            this.width = 12;
            this.height = 28;
            this.autoReuse = true;
            this.noMelee = true;
            this.value = 10000;
            break;
          case 508:
            this.rare = 3;
            this.useStyle = 5;
            this.useAnimation = 12;
            this.useTime = 12;
            this.width = 12;
            this.height = 28;
            this.autoReuse = true;
            this.noMelee = true;
            this.value = 10000;
            break;
          case 509:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 5;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.rare = 1;
            this.value = 20000;
            this.mech = true;
            this.tileBoost = 20;
            break;
          case 510:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 5;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.rare = 1;
            this.value = 20000;
            this.mech = true;
            this.tileBoost = 20;
            break;
          case 511:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 130;
            this.width = 12;
            this.height = 12;
            this.value = 1000;
            this.mech = true;
            break;
          case 512:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 131;
            this.width = 12;
            this.height = 12;
            this.value = 1000;
            this.mech = true;
            break;
          case 513:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 132;
            this.width = 24;
            this.height = 24;
            this.value = 3000;
            this.mech = true;
            break;
          case 514:
            this.autoReuse = true;
            this.useStyle = 5;
            this.useAnimation = 12;
            this.useTime = 12;
            this.width = 36;
            this.height = 22;
            this.shoot = 88;
            this.mana = 8;
            this.UseSound = SoundID.Item12;
            this.knockBack = 2.5f;
            this.damage = 29;
            this.shootSpeed = 17f;
            this.noMelee = true;
            this.rare = 4;
            this.magic = true;
            this.value = 150000;
            break;
          case 515:
            this.shootSpeed = 5f;
            this.shoot = 89;
            this.damage = 9;
            this.width = 8;
            this.height = 8;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Bullet;
            this.knockBack = 1f;
            this.value = 30;
            this.ranged = true;
            this.rare = 3;
            break;
          case 516:
            this.shootSpeed = 3.5f;
            this.shoot = 91;
            this.damage = 13;
            this.width = 10;
            this.height = 28;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Arrow;
            this.knockBack = 2f;
            this.value = 80;
            this.ranged = true;
            this.rare = 3;
            break;
          case 517:
            this.useStyle = 1;
            this.shootSpeed = 12f;
            this.shoot = 93;
            this.damage = 40;
            this.width = 18;
            this.height = 20;
            this.mana = 6;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 8;
            this.useTime = 8;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 5);
            this.knockBack = 3.75f;
            this.magic = true;
            this.rare = 4;
            break;
          case 518:
            this.autoReuse = true;
            this.rare = 4;
            this.mana = 5;
            this.UseSound = SoundID.Item9;
            this.noMelee = true;
            this.useStyle = 5;
            this.damage = 32;
            this.useAnimation = 7;
            this.useTime = 7;
            this.width = 24;
            this.height = 28;
            this.shoot = 94;
            this.scale = 0.9f;
            this.shootSpeed = 16f;
            this.knockBack = 5f;
            this.magic = true;
            this.value = Item.sellPrice(gold: 4);
            break;
          case 519:
            this.autoReuse = true;
            this.rare = 4;
            this.mana = 9;
            this.UseSound = SoundID.Item20;
            this.noMelee = true;
            this.useStyle = 5;
            this.damage = 50;
            this.useAnimation = 15;
            this.useTime = 15;
            this.width = 24;
            this.height = 28;
            this.shoot = 95;
            this.scale = 0.9f;
            this.shootSpeed = 10f;
            this.knockBack = 6.5f;
            this.magic = true;
            this.value = Item.sellPrice(gold: 4);
            break;
          case 520:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 1000;
            this.rare = 3;
            break;
          case 521:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 1000;
            this.rare = 3;
            break;
          case 522:
            this.width = 12;
            this.height = 14;
            this.maxStack = 99;
            this.value = 4000;
            this.rare = 3;
            break;
          case 523:
            this.flame = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 8;
            this.width = 10;
            this.height = 12;
            this.value = 150;
            this.rare = 1;
            break;
          case 524:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 133;
            this.width = 44;
            this.height = 30;
            this.value = 50000;
            this.rare = 3;
            break;
          case 525:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 134;
            this.width = 28;
            this.height = 14;
            this.value = 25000;
            this.rare = 3;
            break;
          case 526:
            this.width = 14;
            this.height = 14;
            this.maxStack = 99;
            this.value = 15000;
            this.rare = 1;
            break;
          case 527:
            this.width = 14;
            this.height = 14;
            this.maxStack = 99;
            this.value = 4500;
            this.rare = 2;
            break;
          case 528:
            this.width = 14;
            this.height = 14;
            this.maxStack = 99;
            this.value = 4500;
            this.rare = 2;
            break;
          case 529:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 0;
            this.mech = true;
            this.value = 5000;
            this.mech = true;
            break;
          case 530:
            this.width = 12;
            this.height = 18;
            this.maxStack = 999;
            this.value = 500;
            this.mech = true;
            break;
          case 531:
            this.width = 12;
            this.height = 18;
            this.maxStack = 99;
            this.value = 50000;
            this.rare = 1;
            break;
          case 532:
            this.width = 20;
            this.height = 24;
            this.value = 100000;
            this.accessory = true;
            this.rare = 4;
            this.backSlot = (sbyte) 2;
            break;
          case 533:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 7;
            this.useTime = 7;
            this.width = 50;
            this.height = 18;
            this.shoot = 10;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item11;
            this.damage = 25;
            this.shootSpeed = 10f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 35);
            this.rare = 5;
            this.knockBack = 1f;
            this.ranged = true;
            break;
          case 534:
            this.knockBack = 6.5f;
            this.useStyle = 5;
            this.useAnimation = 45;
            this.useTime = 45;
            this.width = 50;
            this.height = 14;
            this.shoot = 10;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item36;
            this.damage = 24;
            this.shootSpeed = 7f;
            this.noMelee = true;
            this.value = 250000;
            this.rare = 4;
            this.ranged = true;
            break;
          case 535:
            this.width = 12;
            this.height = 18;
            this.value = 100000;
            this.accessory = true;
            this.rare = 4;
            break;
          case 536:
            this.width = 12;
            this.height = 18;
            this.value = 100000;
            this.rare = 4;
            this.accessory = true;
            this.handOnSlot = (sbyte) 15;
            this.handOffSlot = (sbyte) 8;
            break;
          case 537:
            this.useStyle = 5;
            this.useAnimation = 28;
            this.useTime = 28;
            this.shootSpeed = 4.3f;
            this.knockBack = 4f;
            this.width = 40;
            this.height = 40;
            this.damage = 29;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 97;
            this.rare = 4;
            this.value = 45000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 538:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 136;
            this.width = 12;
            this.height = 12;
            this.value = 2000;
            this.mech = true;
            break;
          case 539:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 137;
            this.width = 12;
            this.height = 12;
            this.value = 10000;
            this.mech = true;
            break;
          case 540:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 138;
            this.width = 12;
            this.height = 12;
            this.mech = true;
            break;
          case 541:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 1;
            this.mech = true;
            this.value = 5000;
            break;
          case 542:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 2;
            this.mech = true;
            this.value = 5000;
            break;
          case 543:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 3;
            this.mech = true;
            this.value = 5000;
            break;
          case 544:
            this.useStyle = 4;
            this.width = 22;
            this.height = 14;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.maxStack = 20;
            this.rare = 3;
            break;
          case 545:
            this.shootSpeed = 4f;
            this.shoot = 103;
            this.damage = 17;
            this.width = 10;
            this.height = 28;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Arrow;
            this.knockBack = 3f;
            this.value = 40;
            this.ranged = true;
            this.rare = 3;
            break;
          case 546:
            this.shootSpeed = 5f;
            this.shoot = 104;
            this.damage = 12;
            this.width = 8;
            this.height = 8;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Bullet;
            this.knockBack = 4f;
            this.value = 30;
            this.rare = 1;
            this.ranged = true;
            this.rare = 3;
            break;
          case 547:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 40000;
            this.rare = 5;
            break;
          case 548:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 40000;
            this.rare = 5;
            break;
          case 549:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 40000;
            this.rare = 5;
            break;
          case 550:
            this.useStyle = 5;
            this.useAnimation = 22;
            this.useTime = 22;
            this.shootSpeed = 5.6f;
            this.knockBack = 6.4f;
            this.width = 40;
            this.height = 40;
            this.damage = 42;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 105;
            this.rare = 5;
            this.value = 230000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 551:
            this.width = 18;
            this.height = 18;
            this.defense = 15;
            this.bodySlot = 24;
            this.rare = 5;
            this.value = 200000;
            break;
          case 552:
            this.width = 18;
            this.height = 18;
            this.defense = 11;
            this.legSlot = 23;
            this.rare = 5;
            this.value = 150000;
            break;
          case 553:
            this.width = 18;
            this.height = 18;
            this.defense = 9;
            this.headSlot = 41;
            this.rare = 5;
            this.value = 250000;
            break;
          case 554:
            this.width = 20;
            this.height = 24;
            this.value = Item.buyPrice(gold: 10);
            this.accessory = true;
            this.rare = 4;
            this.neckSlot = (sbyte) 2;
            break;
          case 555:
            this.width = 20;
            this.height = 24;
            this.value = 50000;
            this.accessory = true;
            this.rare = 4;
            this.waistSlot = (sbyte) 6;
            break;
          case 556:
            this.useStyle = 4;
            this.width = 22;
            this.height = 14;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.maxStack = 20;
            this.rare = 3;
            break;
          case 557:
            this.useStyle = 4;
            this.width = 22;
            this.height = 14;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.maxStack = 20;
            this.rare = 3;
            break;
          case 558:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.headSlot = 42;
            this.rare = 5;
            this.value = 250000;
            break;
          case 559:
            this.width = 18;
            this.height = 18;
            this.defense = 24;
            this.headSlot = 43;
            this.rare = 5;
            this.value = 250000;
            break;
          case 560:
            this.useStyle = 4;
            this.width = 22;
            this.height = 14;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.maxStack = 20;
            this.rare = 1;
            break;
          case 561:
            this.melee = true;
            this.autoReuse = true;
            this.noMelee = true;
            this.useStyle = 1;
            this.shootSpeed = 13f;
            this.shoot = 106;
            this.damage = 57;
            this.knockBack = 8f;
            this.width = 24;
            this.height = 24;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.rare = 5;
            this.maxStack = 5;
            this.value = Item.sellPrice(gold: 6);
            break;
          case 562:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 0;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 563:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 1;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 564:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 2;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 565:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 3;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 566:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 4;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 567:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 5;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 568:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 6;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 569:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 7;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 570:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 8;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 571:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 9;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 572:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 10;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 573:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 11;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 574:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 139;
            this.placeStyle = 12;
            this.width = 24;
            this.height = 24;
            this.rare = 4;
            this.value = 100000;
            this.accessory = true;
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 575:
            this.width = 18;
            this.height = 18;
            this.maxStack = 999;
            this.value = 1000;
            this.rare = 3;
            break;
          case 576:
            this.width = 24;
            this.height = 24;
            this.rare = 3;
            this.value = 100000;
            this.accessory = true;
            break;
          case 577:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 140;
            this.width = 12;
            this.height = 12;
            break;
          case 578:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 16;
            this.useTime = 16;
            this.width = 50;
            this.height = 18;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 53;
            this.shootSpeed = 11f;
            this.noMelee = true;
            this.value = 200000;
            this.ranged = true;
            this.rare = 4;
            this.knockBack = 2.5f;
            break;
          case 579:
            this.useStyle = 5;
            this.useAnimation = 25;
            this.useTime = 7;
            this.shootSpeed = 36f;
            this.knockBack = 4.75f;
            this.width = 20;
            this.height = 12;
            this.damage = 35;
            this.pick = 200;
            this.axe = 22;
            this.UseSound = SoundID.Item23;
            this.shoot = 107;
            this.rare = 4;
            this.value = 220000;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            this.channel = true;
            break;
          case 580:
            this.mech = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 141;
            this.width = 12;
            this.height = 12;
            this.value = Item.sellPrice(silver: 10);
            break;
          case 581:
            this.mech = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 142;
            this.width = 12;
            this.height = 12;
            break;
          case 582:
            this.mech = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 143;
            this.width = 12;
            this.height = 12;
            break;
          case 583:
            this.mech = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 144;
            this.placeStyle = 0;
            this.width = 10;
            this.height = 12;
            this.value = 50;
            break;
          case 584:
            this.mech = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 144;
            this.placeStyle = 1;
            this.width = 10;
            this.height = 12;
            this.value = 50;
            break;
          case 585:
            this.mech = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 144;
            this.placeStyle = 2;
            this.width = 10;
            this.height = 12;
            this.value = 50;
            break;
          case 586:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 145;
            this.width = 12;
            this.height = 12;
            break;
          case 587:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 29;
            this.width = 12;
            this.height = 12;
            break;
          case 588:
            this.width = 18;
            this.height = 12;
            this.headSlot = 44;
            this.value = 150000;
            this.vanity = true;
            break;
          case 589:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 25;
            this.value = 150000;
            this.vanity = true;
            break;
          case 590:
            this.width = 18;
            this.height = 18;
            this.legSlot = 24;
            this.value = 150000;
            this.vanity = true;
            break;
          case 591:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 146;
            this.width = 12;
            this.height = 12;
            break;
          case 592:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 30;
            this.width = 12;
            this.height = 12;
            break;
          case 593:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 147;
            this.width = 12;
            this.height = 12;
            break;
          case 594:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 148;
            this.width = 12;
            this.height = 12;
            break;
          case 595:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 31;
            this.width = 12;
            this.height = 12;
            break;
          case 596:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 149;
            this.placeStyle = 0;
            this.width = 12;
            this.height = 12;
            this.value = 500;
            break;
          case 597:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 149;
            this.placeStyle = 1;
            this.width = 12;
            this.height = 12;
            this.value = 500;
            break;
          case 598:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 149;
            this.placeStyle = 2;
            this.width = 12;
            this.height = 12;
            this.value = 500;
            break;
          case 599:
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            break;
          case 600:
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            break;
          case 601:
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            break;
          case 602:
            this.useStyle = 4;
            this.consumable = true;
            this.useAnimation = 45;
            this.useTime = 45;
            this.width = 28;
            this.height = 28;
            this.rare = 2;
            this.maxStack = 20;
            break;
          case 603:
            this.damage = 0;
            this.useStyle = 1;
            this.shoot = 111;
            this.width = 16;
            this.height = 30;
            this.UseSound = SoundID.Item2;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 3;
            this.noMelee = true;
            this.value = 0;
            this.buffType = 40;
            break;
          case 604:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 150;
            this.width = 12;
            this.height = 12;
            break;
          case 605:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 32;
            this.width = 12;
            this.height = 12;
            break;
          case 606:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 33;
            this.width = 12;
            this.height = 12;
            break;
          case 607:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 151;
            this.width = 12;
            this.height = 12;
            break;
          case 608:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 34;
            this.width = 12;
            this.height = 12;
            break;
          case 609:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 152;
            this.width = 12;
            this.height = 12;
            break;
          case 610:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 35;
            this.width = 12;
            this.height = 12;
            break;
          case 611:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 153;
            this.width = 12;
            this.height = 12;
            break;
          case 612:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 154;
            this.width = 12;
            this.height = 12;
            break;
          case 613:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 155;
            this.width = 12;
            this.height = 12;
            break;
          case 614:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 156;
            this.width = 12;
            this.height = 12;
            break;
          case 615:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 36;
            this.width = 12;
            this.height = 12;
            break;
          case 616:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 37;
            this.width = 12;
            this.height = 12;
            break;
          case 617:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 38;
            this.width = 12;
            this.height = 12;
            break;
          case 618:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 39;
            this.width = 12;
            this.height = 12;
            break;
          case 619:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 157;
            this.width = 8;
            this.height = 10;
            break;
          case 620:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 158;
            this.width = 8;
            this.height = 10;
            break;
          case 621:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 159;
            this.width = 8;
            this.height = 10;
            break;
          case 622:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 41;
            this.width = 12;
            this.height = 12;
            break;
          case 623:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 42;
            this.width = 12;
            this.height = 12;
            break;
          case 624:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 43;
            this.width = 12;
            this.height = 12;
            break;
          case 625:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 7;
            this.width = 26;
            this.height = 22;
            this.value = 500;
            break;
          case 626:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 8;
            this.width = 26;
            this.height = 22;
            this.value = 500;
            break;
          case 627:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 9;
            this.width = 26;
            this.height = 22;
            this.value = 500;
            break;
          case 628:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 2;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 629:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 3;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 630:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 4;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 631:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 19;
            this.placeStyle = 1;
            this.width = 8;
            this.height = 10;
            break;
          case 632:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 19;
            this.placeStyle = 2;
            this.width = 8;
            this.height = 10;
            break;
          case 633:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 19;
            this.placeStyle = 3;
            this.width = 8;
            this.height = 10;
            break;
          case 634:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 19;
            this.placeStyle = 4;
            this.width = 8;
            this.height = 10;
            break;
          case 635:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 1;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 636:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 2;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 637:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 3;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 638:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 1;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 639:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 2;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 640:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 3;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 641:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 87;
            this.placeStyle = 1;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 642:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 87;
            this.placeStyle = 2;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 643:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 87;
            this.placeStyle = 3;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 644:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 79;
            this.placeStyle = 1;
            this.width = 28;
            this.height = 20;
            this.value = 2000;
            break;
          case 645:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 79;
            this.placeStyle = 2;
            this.width = 28;
            this.height = 20;
            this.value = 2000;
            break;
          case 646:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 79;
            this.placeStyle = 3;
            this.width = 28;
            this.height = 20;
            this.value = 2000;
            break;
          case 647:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 88;
            this.placeStyle = 1;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 648:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 88;
            this.placeStyle = 2;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 649:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 88;
            this.placeStyle = 3;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 650:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 1;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 651:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 2;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 652:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 3;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 653:
            this.useStyle = 1;
            this.useTurn = false;
            this.useAnimation = 21;
            this.useTime = 21;
            this.width = 24;
            this.height = 28;
            this.damage = 10;
            this.knockBack = 5f;
            this.UseSound = SoundID.Item1;
            this.scale = 1f;
            this.value = 100;
            this.melee = true;
            break;
          case 654:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 30;
            this.useTime = 20;
            this.hammer = 40;
            this.width = 24;
            this.height = 28;
            this.damage = 7;
            this.knockBack = 5.5f;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.value = 50;
            this.melee = true;
            break;
          case 655:
            this.useStyle = 5;
            this.useAnimation = 28;
            this.useTime = 28;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 8;
            this.shootSpeed = 6.6f;
            this.noMelee = true;
            this.value = 100;
            this.ranged = true;
            break;
          case 656:
            this.useStyle = 1;
            this.useTurn = false;
            this.useAnimation = 23;
            this.useTime = 23;
            this.width = 24;
            this.height = 28;
            this.damage = 8;
            this.knockBack = 5f;
            this.UseSound = SoundID.Item1;
            this.scale = 1f;
            this.value = 100;
            this.melee = true;
            break;
          case 657:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 33;
            this.useTime = 23;
            this.hammer = 35;
            this.width = 24;
            this.height = 28;
            this.damage = 4;
            this.knockBack = 5.5f;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.value = 50;
            this.melee = true;
            break;
          case 658:
            this.useStyle = 5;
            this.useAnimation = 29;
            this.useTime = 29;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 6;
            this.shootSpeed = 6.6f;
            this.noMelee = true;
            this.value = 100;
            this.ranged = true;
            break;
          case 659:
            this.useStyle = 1;
            this.useTurn = false;
            this.useAnimation = 21;
            this.useTime = 21;
            this.width = 24;
            this.height = 28;
            this.damage = 11;
            this.knockBack = 5f;
            this.UseSound = SoundID.Item1;
            this.scale = 1f;
            this.value = 100;
            this.melee = true;
            break;
          case 660:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 29;
            this.useTime = 19;
            this.hammer = 45;
            this.width = 24;
            this.height = 28;
            this.damage = 9;
            this.knockBack = 5.5f;
            this.scale = 1.25f;
            this.UseSound = SoundID.Item1;
            this.value = 50;
            this.melee = true;
            break;
          case 661:
            this.useStyle = 5;
            this.useAnimation = 27;
            this.useTime = 27;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 9;
            this.shootSpeed = 6.6f;
            this.noMelee = true;
            this.value = 100;
            this.ranged = true;
            break;
          case 662:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 160;
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            break;
          case 663:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 44;
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            break;
          case 664:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 161;
            this.width = 12;
            this.height = 12;
            break;
          case 665:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.rare = 9;
            this.wingSlot = (sbyte) 3;
            this.value = 400000;
            break;
          case 666:
            this.width = 18;
            this.height = 18;
            this.headSlot = 45;
            this.rare = 9;
            this.vanity = true;
            this.value = Item.sellPrice(gold: 5);
            break;
          case 667:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 26;
            this.rare = 9;
            this.vanity = true;
            this.value = Item.sellPrice(gold: 5);
            break;
          case 668:
            this.width = 18;
            this.height = 18;
            this.legSlot = 25;
            this.rare = 9;
            this.vanity = true;
            this.value = Item.sellPrice(gold: 5);
            break;
          case 669:
            this.damage = 0;
            this.useStyle = 1;
            this.shoot = 112;
            this.width = 16;
            this.height = 30;
            this.UseSound = SoundID.Item2;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 3;
            this.noMelee = true;
            this.buffType = 41;
            this.value = Item.sellPrice(gold: 2);
            break;
          case 670:
            this.crit = 2;
            this.noMelee = true;
            this.useStyle = 1;
            this.shootSpeed = 11.5f;
            this.shoot = 113;
            this.damage = 16;
            this.knockBack = 8.5f;
            this.width = 14;
            this.height = 28;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noUseGraphic = true;
            this.rare = 1;
            this.value = 50000;
            this.melee = true;
            break;
          case 671:
            this.crit = 13;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.knockBack = 6.5f;
            this.width = 40;
            this.height = 40;
            this.damage = 85;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.rare = 8;
            this.value = Item.buyPrice(gold: 20);
            this.melee = true;
            break;
          case 672:
            this.useStyle = 1;
            this.useAnimation = 18;
            this.knockBack = 4f;
            this.width = 24;
            this.height = 28;
            this.damage = 49;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 180000;
            this.melee = true;
            this.autoReuse = true;
            this.useTurn = true;
            break;
          case 673:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 23;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 674:
            this.useStyle = 1;
            this.useAnimation = 16;
            this.useTime = 16;
            this.shoot = 156;
            this.shootSpeed = 11f;
            this.knockBack = 4.5f;
            this.width = 40;
            this.height = 40;
            this.damage = 66;
            this.scale = 1.05f;
            this.UseSound = SoundID.Item1;
            this.rare = 8;
            this.value = Item.sellPrice(gold: 10);
            this.melee = true;
            break;
          case 675:
            this.useStyle = 1;
            this.useAnimation = 26;
            this.useTime = 26;
            this.shoot = 157;
            this.shootSpeed = 10f;
            this.knockBack = 4.75f;
            this.width = 40;
            this.height = 40;
            this.damage = 105;
            this.scale = 1.15f;
            this.UseSound = SoundID.Item1;
            this.rare = 8;
            this.value = Item.sellPrice(gold: 10);
            this.melee = true;
            break;
          case 676:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 23;
            this.useTime = 55;
            this.knockBack = 4.5f;
            this.width = 24;
            this.height = 28;
            this.damage = 49;
            this.scale = 1.15f;
            this.UseSound = SoundID.Item1;
            this.rare = 5;
            this.shoot = 119;
            this.shootSpeed = 12f;
            this.value = 250000;
            this.melee = true;
            break;
          case 677:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 28;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 678:
            this.UseSound = SoundID.Item3;
            this.useStyle = 9;
            this.useTurn = true;
            this.useAnimation = 17;
            this.useTime = 17;
            this.maxStack = 30;
            this.consumable = true;
            this.width = 14;
            this.height = 24;
            this.rare = 4;
            break;
          case 679:
            this.autoReuse = true;
            this.knockBack = 7f;
            this.useStyle = 5;
            this.useAnimation = 34;
            this.useTime = 34;
            this.width = 50;
            this.height = 14;
            this.shoot = 10;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item38;
            this.damage = 29;
            this.shootSpeed = 6f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 40);
            this.rare = 8;
            this.ranged = true;
            break;
          case 680:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 10;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 681:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 11;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 682:
            this.useStyle = 5;
            this.useAnimation = 19;
            this.useTime = 19;
            this.width = 14;
            this.height = 32;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 50;
            this.shootSpeed = 11f;
            this.knockBack = 4.7f;
            this.rare = 5;
            this.crit = 5;
            this.noMelee = true;
            this.scale = 1.1f;
            this.value = 27000;
            this.ranged = true;
            break;
          case 683:
            this.autoReuse = true;
            this.rare = 6;
            this.mana = 19;
            this.UseSound = SoundID.Item20;
            this.noMelee = true;
            this.useStyle = 5;
            this.damage = 73;
            this.useAnimation = 17;
            this.useTime = 17;
            this.width = 30;
            this.height = 30;
            this.shoot = 114;
            this.shootSpeed = 13f;
            this.knockBack = 6.5f;
            this.magic = true;
            this.value = 500000;
            break;
          case 684:
            this.width = 18;
            this.height = 18;
            this.defense = 10;
            this.headSlot = 46;
            this.rare = 5;
            this.value = 250000;
            break;
          case 685:
            this.width = 18;
            this.height = 18;
            this.defense = 20;
            this.bodySlot = 27;
            this.rare = 5;
            this.value = 200000;
            break;
          case 686:
            this.width = 18;
            this.height = 18;
            this.defense = 13;
            this.legSlot = 26;
            this.rare = 5;
            this.value = 150000;
            break;
          case 687:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.headSlot = 47;
            this.value = 1125;
            break;
          case 688:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.bodySlot = 28;
            this.value = 1875;
            break;
          case 689:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 27;
            this.value = 1500;
            break;
          case 690:
            this.width = 18;
            this.height = 18;
            this.defense = 3;
            this.headSlot = 48;
            this.value = 4500;
            break;
          case 691:
            this.width = 18;
            this.height = 18;
            this.defense = 3;
            this.bodySlot = 29;
            this.value = 7500;
            break;
          case 692:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.legSlot = 28;
            this.value = 6000;
            break;
          case 693:
            this.width = 18;
            this.height = 18;
            this.defense = 4;
            this.headSlot = 49;
            this.value = 11250;
            break;
          case 694:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.bodySlot = 30;
            this.value = 18750;
            break;
          case 695:
            this.width = 18;
            this.height = 18;
            this.defense = 3;
            this.legSlot = 29;
            this.value = 15000;
            break;
          case 696:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.headSlot = 50;
            this.value = 22500;
            break;
          case 697:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.bodySlot = 31;
            this.value = 37500;
            break;
          case 698:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.legSlot = 30;
            this.value = 30000;
            break;
          case 699:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 166;
            this.width = 12;
            this.height = 12;
            this.value = 375;
            break;
          case 700:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 167;
            this.width = 12;
            this.height = 12;
            this.value = 750;
            break;
          case 701:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 168;
            this.width = 12;
            this.height = 12;
            this.value = Item.sellPrice(silver: 2, copper: 25);
            break;
          case 702:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 169;
            this.width = 12;
            this.height = 12;
            this.value = Item.sellPrice(silver: 4, copper: 50);
            break;
          case 703:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 1125;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 1;
            break;
          case 704:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 2250;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 3;
            break;
          case 705:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 4500;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 5;
            break;
          case 706:
            this.width = 20;
            this.height = 20;
            this.maxStack = 999;
            this.value = 9000;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.consumable = true;
            this.createTile = 239;
            this.placeStyle = 7;
            break;
          case 707:
            this.width = 24;
            this.height = 28;
            this.accessory = true;
            this.value = 1500;
            this.waistSlot = (sbyte) 8;
            break;
          case 708:
            this.width = 24;
            this.height = 28;
            this.accessory = true;
            this.value = 7500;
            this.waistSlot = (sbyte) 9;
            break;
          case 709:
            this.width = 24;
            this.height = 28;
            this.accessory = true;
            this.rare = 1;
            this.value = 15000;
            this.waistSlot = (sbyte) 4;
            break;
          case 710:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 34;
            this.placeStyle = 3;
            this.width = 26;
            this.height = 26;
            this.value = 4500;
            break;
          case 711:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 34;
            this.placeStyle = 4;
            this.width = 26;
            this.height = 26;
            this.value = 18000;
            break;
          case 712:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 34;
            this.placeStyle = 5;
            this.width = 26;
            this.height = 26;
            this.value = 36000;
            break;
          case 713:
            this.flame = true;
            this.noWet = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 174;
            this.width = 8;
            this.height = 18;
            this.value = Item.sellPrice(silver: 3);
            this.holdStyle = 1;
            break;
          case 714:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 173;
            this.width = 20;
            this.height = 20;
            this.value = Item.buyPrice(silver: 15);
            break;
          case 715:
            this.width = 18;
            this.height = 18;
            this.headSlot = 51;
            this.value = 15000;
            this.vanity = true;
            break;
          case 716:
            this.placeStyle = 1;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 16;
            this.width = 28;
            this.height = 14;
            this.value = 7500;
            break;
          case 717:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 175;
            this.width = 12;
            this.height = 12;
            break;
          case 718:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 176;
            this.width = 12;
            this.height = 12;
            break;
          case 719:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 177;
            this.width = 12;
            this.height = 12;
            break;
          case 720:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 45;
            this.width = 12;
            this.height = 12;
            break;
          case 721:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 46;
            this.width = 12;
            this.height = 12;
            break;
          case 722:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 47;
            this.width = 12;
            this.height = 12;
            break;
          case 723:
            this.rare = 4;
            this.UseSound = SoundID.Item1;
            this.useStyle = 1;
            this.damage = 52;
            this.useAnimation = 20;
            this.useTime = 60;
            this.width = 30;
            this.height = 30;
            this.shoot = 116;
            this.shootSpeed = 11f;
            this.knockBack = 6.5f;
            this.melee = true;
            this.value = Item.sellPrice(gold: 3);
            break;
          case 724:
            this.autoReuse = true;
            this.crit = 2;
            this.rare = 1;
            this.UseSound = SoundID.Item1;
            this.useStyle = 1;
            this.damage = 17;
            this.useAnimation = 20;
            this.useTime = 55;
            this.width = 30;
            this.height = 30;
            this.shoot = 118;
            this.shootSpeed = 9.5f;
            this.knockBack = 4.75f;
            this.melee = true;
            this.value = 20000;
            break;
          case 725:
            this.useStyle = 5;
            this.useAnimation = 16;
            this.useTime = 16;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 39;
            this.shootSpeed = 10f;
            this.knockBack = 4.5f;
            this.alpha = 30;
            this.rare = 5;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 5);
            this.ranged = true;
            this.channel = true;
            this.autoReuse = true;
            break;
          case 726:
            this.autoReuse = true;
            this.rare = 5;
            this.mana = 12;
            this.UseSound = SoundID.Item20;
            this.useStyle = 5;
            this.damage = 46;
            this.useAnimation = 16;
            this.useTime = 16;
            this.width = 30;
            this.height = 30;
            this.shoot = 359;
            this.shootSpeed = 16f;
            this.knockBack = 5f;
            this.magic = true;
            this.value = Item.sellPrice(gold: 4);
            this.noMelee = true;
            break;
          case 727:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.headSlot = 52;
            break;
          case 728:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.bodySlot = 32;
            break;
          case 729:
            this.width = 18;
            this.height = 18;
            this.defense = 0;
            this.legSlot = 31;
            break;
          case 730:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.headSlot = 53;
            break;
          case 731:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.bodySlot = 33;
            break;
          case 732:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 32;
            break;
          case 733:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.headSlot = 54;
            break;
          case 734:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.bodySlot = 34;
            break;
          case 735:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 33;
            break;
          case 736:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.headSlot = 55;
            break;
          case 737:
            this.width = 18;
            this.height = 18;
            this.defense = 3;
            this.bodySlot = 35;
            break;
          case 738:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.legSlot = 34;
            break;
          case 739:
            this.mana = 3;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 14;
            this.useAnimation = 40;
            this.useTime = 40;
            this.width = 40;
            this.height = 40;
            this.shoot = 121;
            this.shootSpeed = 6f;
            this.knockBack = 3.25f;
            this.value = 2000;
            this.magic = true;
            this.noMelee = true;
            break;
          case 740:
            this.mana = 4;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 15;
            this.useAnimation = 38;
            this.useTime = 38;
            this.width = 40;
            this.height = 40;
            this.shoot = 122;
            this.shootSpeed = 6.5f;
            this.knockBack = 3.5f;
            this.value = 3000;
            this.magic = true;
            this.noMelee = true;
            break;
          case 741:
            this.mana = 5;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 17;
            this.useAnimation = 34;
            this.useTime = 34;
            this.width = 40;
            this.height = 40;
            this.shoot = 123;
            this.shootSpeed = 7.5f;
            this.knockBack = 4f;
            this.value = 10000;
            this.magic = true;
            this.rare = 1;
            this.noMelee = true;
            break;
          case 742:
            this.mana = 6;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 19;
            this.useAnimation = 32;
            this.useTime = 32;
            this.width = 40;
            this.height = 40;
            this.shoot = 124;
            this.shootSpeed = 8f;
            this.knockBack = 4.25f;
            this.magic = true;
            this.autoReuse = true;
            this.value = 15000;
            this.rare = 1;
            this.noMelee = true;
            break;
          case 743:
            this.mana = 7;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 21;
            this.useAnimation = 28;
            this.useTime = 28;
            this.width = 40;
            this.height = 40;
            this.shoot = 125;
            this.shootSpeed = 9f;
            this.knockBack = 4.75f;
            this.magic = true;
            this.autoReuse = true;
            this.value = 20000;
            this.rare = 1;
            this.noMelee = true;
            break;
          case 744:
            this.mana = 8;
            this.UseSound = SoundID.Item43;
            this.useStyle = 5;
            this.damage = 23;
            this.useAnimation = 26;
            this.useTime = 26;
            this.width = 40;
            this.height = 40;
            this.shoot = 126;
            this.shootSpeed = 9.5f;
            this.knockBack = 5.5f;
            this.magic = true;
            this.autoReuse = true;
            this.value = 30000;
            this.rare = 2;
            this.noMelee = true;
            break;
          case 745:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 66;
            this.width = 12;
            this.height = 12;
            this.value = 10;
            break;
          case 746:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 67;
            this.width = 12;
            this.height = 12;
            this.value = 10;
            break;
          case 747:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 68;
            this.width = 12;
            this.height = 12;
            this.value = 10;
            break;
          case 748:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 4;
            break;
          case 749:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 5;
            break;
          case 750:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 72;
            this.width = 12;
            this.height = 12;
            break;
          case 751:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 189;
            this.width = 12;
            this.height = 12;
            break;
          case 752:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 73;
            this.width = 12;
            this.height = 12;
            break;
          case 753:
            this.damage = 0;
            this.useStyle = 1;
            this.shoot = (int) sbyte.MaxValue;
            this.width = 16;
            this.height = 30;
            this.UseSound = SoundID.Item2;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 3;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 2);
            this.buffType = 42;
            break;
          case 754:
            this.width = 28;
            this.height = 20;
            this.headSlot = 56;
            this.rare = 5;
            this.value = 50000;
            this.vanity = true;
            break;
          case 755:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 36;
            this.value = 50000;
            this.vanity = true;
            this.rare = 5;
            break;
          case 756:
            this.rare = 7;
            this.useStyle = 5;
            this.useAnimation = 40;
            this.useTime = 40;
            this.shootSpeed = 5.5f;
            this.knockBack = 6.2f;
            this.width = 32;
            this.height = 32;
            this.damage = 60;
            this.scale = 1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 130;
            this.value = Item.buyPrice(gold: 70);
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 757:
            this.rare = 8;
            this.UseSound = SoundID.Item1;
            this.useStyle = 1;
            this.damage = 95;
            this.useAnimation = 16;
            this.useTime = 16;
            this.width = 30;
            this.height = 30;
            this.shoot = 132;
            this.scale = 1.1f;
            this.shootSpeed = 12f;
            this.knockBack = 6.5f;
            this.melee = true;
            this.value = Item.sellPrice(gold: 20);
            this.autoReuse = true;
            break;
          case 758:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 20;
            this.useTime = 20;
            this.useAmmo = AmmoID.Rocket;
            this.width = 50;
            this.height = 20;
            this.shoot = 133;
            this.UseSound = SoundID.Item61;
            this.damage = 60;
            this.shootSpeed = 10f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 35);
            this.knockBack = 4f;
            this.rare = 8;
            this.ranged = true;
            break;
          case 759:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 30;
            this.useTime = 30;
            this.useAmmo = AmmoID.Rocket;
            this.width = 50;
            this.height = 20;
            this.shoot = 134;
            this.UseSound = SoundID.Item11;
            this.damage = 45;
            this.shootSpeed = 5f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 40);
            this.knockBack = 4f;
            this.rare = 8;
            this.ranged = true;
            break;
          case 760:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 50;
            this.useTime = 50;
            this.useAmmo = AmmoID.Rocket;
            this.width = 50;
            this.height = 20;
            this.shoot = 135;
            this.UseSound = SoundID.Item11;
            this.damage = 80;
            this.shootSpeed = 12f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 35);
            this.knockBack = 4f;
            this.rare = 8;
            this.ranged = true;
            break;
          case 761:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 6;
            break;
          case 762:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 193;
            this.width = 12;
            this.height = 12;
            break;
          case 763:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 195;
            this.width = 12;
            this.height = 12;
            break;
          case 764:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 74;
            this.width = 12;
            this.height = 12;
            break;
          case 765:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 196;
            this.width = 12;
            this.height = 12;
            break;
          case 766:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 194;
            this.width = 12;
            this.height = 12;
            break;
          case 767:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 197;
            this.width = 12;
            this.height = 12;
            break;
          case 768:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 75;
            this.width = 12;
            this.height = 12;
            break;
          case 769:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 76;
            this.width = 12;
            this.height = 12;
            break;
          case 770:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 77;
            this.width = 12;
            this.height = 12;
            break;
          case 771:
            this.shoot = 0;
            this.damage = 40;
            this.width = 20;
            this.height = 14;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Rocket;
            this.knockBack = 4f;
            this.value = Item.buyPrice(copper: 50);
            this.ranged = true;
            break;
          case 772:
            this.shoot = 3;
            this.damage = 40;
            this.width = 20;
            this.height = 14;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Rocket;
            this.knockBack = 4f;
            this.value = Item.buyPrice(silver: 2, copper: 50);
            this.ranged = true;
            this.rare = 1;
            break;
          case 773:
            this.shoot = 6;
            this.damage = 65;
            this.width = 20;
            this.height = 14;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Rocket;
            this.knockBack = 6f;
            this.value = Item.buyPrice(silver: 1);
            this.ranged = true;
            this.rare = 1;
            break;
          case 774:
            this.shoot = 9;
            this.damage = 65;
            this.width = 20;
            this.height = 14;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Rocket;
            this.knockBack = 6f;
            this.value = this.value = Item.buyPrice(silver: 5);
            this.ranged = true;
            this.rare = 2;
            break;
          case 775:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 198;
            this.width = 12;
            this.height = 12;
            break;
          case 776:
            this.useStyle = 1;
            this.useTurn = true;
            this.autoReuse = true;
            this.useAnimation = 25;
            this.useTime = 13;
            this.knockBack = 5f;
            this.width = 20;
            this.height = 12;
            this.damage = 10;
            this.pick = 110;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 54000;
            this.melee = true;
            this.scale = 1.15f;
            break;
          case 777:
            this.useStyle = 1;
            this.useAnimation = 25;
            this.useTime = 10;
            this.knockBack = 5f;
            this.useTurn = true;
            this.autoReuse = true;
            this.width = 20;
            this.height = 12;
            this.damage = 15;
            this.pick = 150;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 81000;
            this.melee = true;
            this.scale = 1.15f;
            break;
          case 778:
            this.useStyle = 1;
            this.useAnimation = 25;
            this.useTime = 8;
            this.knockBack = 5f;
            this.useTurn = true;
            this.autoReuse = true;
            this.width = 20;
            this.height = 12;
            this.damage = 20;
            this.pick = 180;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 108000;
            this.melee = true;
            this.scale = 1.15f;
            break;
          case 779:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 30;
            this.useTime = 5;
            this.width = 50;
            this.height = 18;
            this.shoot = 145;
            this.useAmmo = AmmoID.Solution;
            this.UseSound = SoundID.Item34;
            this.knockBack = 0.3f;
            this.shootSpeed = 7f;
            this.noMelee = true;
            this.value = Item.buyPrice(2);
            this.rare = 5;
            break;
          case 780:
            this.shoot = 0;
            this.ammo = AmmoID.Solution;
            this.width = 10;
            this.height = 12;
            this.value = Item.buyPrice(silver: 25);
            this.rare = 3;
            this.maxStack = 999;
            this.consumable = true;
            break;
          case 781:
            this.shoot = 1;
            this.ammo = AmmoID.Solution;
            this.width = 10;
            this.height = 12;
            this.value = Item.buyPrice(silver: 25);
            this.rare = 3;
            this.maxStack = 999;
            this.consumable = true;
            break;
          case 782:
            this.shoot = 2;
            this.ammo = AmmoID.Solution;
            this.width = 10;
            this.height = 12;
            this.value = Item.buyPrice(silver: 25);
            this.rare = 3;
            this.maxStack = 999;
            this.consumable = true;
            break;
          case 783:
            this.shoot = 3;
            this.ammo = AmmoID.Solution;
            this.width = 10;
            this.height = 12;
            this.value = Item.buyPrice(silver: 25);
            this.rare = 3;
            this.maxStack = 999;
            this.consumable = true;
            break;
          case 784:
            this.shoot = 4;
            this.ammo = AmmoID.Solution;
            this.width = 10;
            this.height = 12;
            this.value = Item.buyPrice(silver: 25);
            this.rare = 3;
            this.maxStack = 999;
            this.consumable = true;
            break;
          case 785:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 7;
            break;
          case 786:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 8;
            break;
          case 787:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 27;
            this.useTime = 14;
            this.hammer = 85;
            this.width = 24;
            this.height = 28;
            this.damage = 26;
            this.knockBack = 7.5f;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.rare = 7;
            this.value = Item.buyPrice(gold: 40);
            this.melee = true;
            break;
          case 788:
            this.mana = 12;
            this.damage = 35;
            this.useStyle = 5;
            this.shootSpeed = 32f;
            this.shoot = 150;
            this.width = 26;
            this.height = 28;
            this.useAnimation = 25;
            this.useTime = 25;
            this.autoReuse = true;
            this.rare = 7;
            this.noMelee = true;
            this.knockBack = 1f;
            this.value = 200000;
            this.magic = true;
            break;
          case 789:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 4;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 790:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 5;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 791:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 6;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 792:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.headSlot = 57;
            this.value = 50000;
            this.rare = 1;
            break;
          case 793:
            this.width = 18;
            this.height = 18;
            this.defense = 7;
            this.bodySlot = 37;
            this.value = 40000;
            this.rare = 1;
            break;
          case 794:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.legSlot = 35;
            this.value = 30000;
            this.rare = 1;
            break;
          case 795:
            this.useStyle = 1;
            this.useAnimation = 25;
            this.knockBack = 5f;
            this.width = 24;
            this.height = 28;
            this.damage = 22;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.rare = 1;
            this.value = 13500;
            this.melee = true;
            break;
          case 796:
            this.useStyle = 5;
            this.useAnimation = 30;
            this.useTime = 30;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 19;
            this.shootSpeed = 6.7f;
            this.knockBack = 1f;
            this.alpha = 30;
            this.rare = 1;
            this.noMelee = true;
            this.value = 18000;
            this.ranged = true;
            break;
          case 797:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 40;
            this.useTime = 19;
            this.hammer = 55;
            this.width = 24;
            this.height = 28;
            this.damage = 23;
            this.knockBack = 6f;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.rare = 1;
            this.value = 15000;
            this.melee = true;
            break;
          case 798:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 22;
            this.useTime = 14;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.damage = 12;
            this.pick = 70;
            this.UseSound = SoundID.Item1;
            this.knockBack = 3.5f;
            this.rare = 1;
            this.value = 18000;
            this.scale = 1.15f;
            this.melee = true;
            break;
          case 799:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 32;
            this.knockBack = 6f;
            this.useTime = 15;
            this.width = 24;
            this.height = 28;
            this.damage = 22;
            this.axe = 15;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.rare = 1;
            this.value = 13500;
            this.melee = true;
            break;
          case 800:
            this.useStyle = 5;
            this.useAnimation = 23;
            this.useTime = 23;
            this.width = 24;
            this.height = 28;
            this.shoot = 14;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item11;
            this.damage = 15;
            this.shootSpeed = 6f;
            this.noMelee = true;
            this.knockBack = 1f;
            this.value = this.shadowOrbPrice;
            this.scale = 0.9f;
            this.rare = 1;
            this.ranged = true;
            break;
          case 801:
            this.useStyle = 5;
            this.useAnimation = 45;
            this.useTime = 45;
            this.knockBack = 5.5f;
            this.width = 30;
            this.height = 10;
            this.damage = 17;
            this.scale = 1.1f;
            this.noUseGraphic = true;
            this.shoot = 154;
            this.shootSpeed = 12f;
            this.UseSound = SoundID.Item1;
            this.rare = 1;
            this.value = 27000;
            this.melee = true;
            this.channel = true;
            this.noMelee = true;
            break;
          case 802:
            this.useStyle = 5;
            this.useAnimation = 31;
            this.useTime = 31;
            this.shootSpeed = 4f;
            this.knockBack = 5f;
            this.width = 40;
            this.height = 40;
            this.damage = 14;
            this.scale = 1.1f;
            this.UseSound = SoundID.Item1;
            this.shoot = 153;
            this.rare = 1;
            this.value = this.shadowOrbPrice;
            this.noMelee = true;
            this.noUseGraphic = true;
            this.melee = true;
            break;
          case 803:
            this.width = 18;
            this.height = 18;
            this.headSlot = 58;
            this.value = 50000;
            this.defense = 1;
            break;
          case 804:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 38;
            this.value = 40000;
            this.defense = 2;
            break;
          case 805:
            this.width = 18;
            this.height = 18;
            this.legSlot = 36;
            this.value = 30000;
            this.defense = 1;
            break;
          case 806:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 5;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 807:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 6;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 808:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 7;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 809:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 8;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 810:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 9;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 811:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 4;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 812:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 5;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 813:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 6;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 814:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 7;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 815:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 8;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 816:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 4;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 817:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 5;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 818:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 6;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 819:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 7;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 820:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 8;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 821:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 9;
            break;
          case 822:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 5;
            this.wingSlot = (sbyte) 10;
            break;
          case 823:
            this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
            this.alpha = (int) byte.MaxValue;
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.value = 400000;
            this.rare = 8;
            this.wingSlot = (sbyte) 11;
            break;
          case 824:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 202;
            this.width = 12;
            this.height = 12;
            break;
          case 825:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 82;
            this.width = 12;
            this.height = 12;
            break;
          case 826:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 10;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 827:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 4;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 828:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 5;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 829:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 6;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 830:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 7;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 831:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 12;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 832:
            this.tileWand = 9;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.createTile = 191;
            this.width = 8;
            this.height = 10;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 25);
            break;
          case 833:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 163;
            this.width = 12;
            this.height = 12;
            break;
          case 834:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 164;
            this.width = 12;
            this.height = 12;
            break;
          case 835:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 200;
            this.width = 12;
            this.height = 12;
            break;
          case 836:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 203;
            this.width = 12;
            this.height = 12;
            break;
          case 837:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 9;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 838:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 13;
            this.width = 26;
            this.height = 22;
            this.value = 5000;
            break;
          case 839:
            this.width = 28;
            this.height = 20;
            this.headSlot = 59;
            this.rare = 2;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 1, silver: 50);
            break;
          case 840:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 39;
            this.rare = 2;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 1, silver: 50);
            break;
          case 841:
            this.width = 18;
            this.height = 14;
            this.legSlot = 37;
            this.rare = 2;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 1, silver: 50);
            break;
          case 842:
            this.width = 28;
            this.height = 20;
            this.headSlot = 60;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 843:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 40;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 844:
            this.width = 18;
            this.height = 14;
            this.legSlot = 38;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 845:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 7;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 846:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 8;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 847:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 91;
            this.placeStyle = 9;
            this.width = 10;
            this.height = 24;
            this.value = 5000;
            break;
          case 848:
            this.width = 28;
            this.height = 20;
            this.headSlot = 61;
            this.rare = 1;
            this.vanity = true;
            break;
          case 849:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.maxStack = 999;
            this.mech = true;
            this.value = Item.buyPrice(silver: 10);
            break;
          case 850:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 5;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.rare = 1;
            this.value = 20000;
            this.mech = true;
            this.tileBoost = 20;
            break;
          case 851:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 5;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.rare = 1;
            this.value = 20000;
            this.mech = true;
            this.tileBoost = 20;
            break;
          case 852:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 4;
            this.mech = true;
            this.value = 5000;
            break;
          case 853:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 135;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 5;
            this.mech = true;
            this.value = 5000;
            break;
          case 854:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 50000;
            break;
          case 855:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 50000;
            break;
          case 856:
            this.noWet = true;
            this.holdStyle = 1;
            this.width = 30;
            this.height = 30;
            this.value = 500;
            this.rare = 2;
            this.vanity = true;
            break;
          case 857:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 2;
            this.value = 50000;
            this.waistSlot = (sbyte) 15;
            break;
          case 858:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 89;
            this.placeStyle = 24;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 859:
            this.useStyle = 1;
            this.shootSpeed = 6f;
            this.shoot = 155;
            this.width = 44;
            this.height = 44;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 20;
            break;
          case 860:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 6;
            this.lifeRegen = 1;
            this.value = Item.buyPrice(gold: 20);
            this.handOnSlot = (sbyte) 4;
            break;
          case 861:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 6;
            this.value = Item.buyPrice(gold: 40);
            this.canBePlacedInVanityRegardlessOfConditions = true;
            break;
          case 862:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 6;
            this.value = Item.buyPrice(gold: 10);
            this.neckSlot = (sbyte) 5;
            break;
          case 863:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 200000;
            this.shoeSlot = (sbyte) 2;
            break;
          case 864:
            this.width = 28;
            this.height = 20;
            this.headSlot = 62;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 25);
            break;
          case 865:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 41;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 10);
            break;
          case 866:
            this.width = 18;
            this.height = 14;
            this.bodySlot = 42;
            this.rare = 1;
            this.vanity = true;
            break;
          case 867:
            this.width = 28;
            this.height = 20;
            this.headSlot = 63;
            this.rare = 1;
            this.defense = 2;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 868:
            this.width = 28;
            this.height = 20;
            this.headSlot = 64;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 2);
            break;
          case 869:
            this.width = 28;
            this.height = 20;
            this.headSlot = 65;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 2, silver: 50);
            break;
          case 870:
            this.width = 28;
            this.height = 20;
            this.headSlot = 66;
            this.rare = 1;
            this.vanity = true;
            break;
          case 871:
            this.width = 28;
            this.height = 20;
            this.bodySlot = 43;
            this.rare = 1;
            this.vanity = true;
            break;
          case 872:
            this.width = 28;
            this.height = 20;
            this.legSlot = 39;
            this.rare = 1;
            this.vanity = true;
            break;
          case 873:
            this.width = 28;
            this.height = 20;
            this.headSlot = 67;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 874:
            this.width = 28;
            this.height = 20;
            this.bodySlot = 44;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 875:
            this.width = 28;
            this.height = 20;
            this.legSlot = 40;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 876:
            this.width = 28;
            this.height = 20;
            this.headSlot = 68;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 877:
            this.width = 28;
            this.height = 20;
            this.bodySlot = 45;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 878:
            this.width = 28;
            this.height = 20;
            this.legSlot = 41;
            this.rare = 1;
            this.vanity = true;
            this.value = Item.buyPrice(gold: 5);
            break;
          case 879:
            this.width = 28;
            this.height = 20;
            this.headSlot = 69;
            this.rare = 1;
            this.defense = 4;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 880:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 204;
            this.width = 12;
            this.height = 12;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 13);
            break;
          case 881:
            this.useStyle = 1;
            this.useTurn = false;
            this.useAnimation = 32;
            this.useTime = 32;
            this.width = 24;
            this.height = 28;
            this.damage = 8;
            this.knockBack = 4.5f;
            this.UseSound = SoundID.Item1;
            this.scale = 1f;
            this.value = 1800;
            this.melee = true;
            break;
          case 882:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 25;
            this.useTime = 16;
            this.autoReuse = true;
            this.width = 24;
            this.height = 28;
            this.damage = 4;
            this.pick = 35;
            this.UseSound = SoundID.Item1;
            this.knockBack = 2f;
            this.value = 2000;
            this.melee = true;
            break;
          case 883:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 206;
            this.width = 12;
            this.height = 12;
            break;
          case 884:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 84;
            this.width = 12;
            this.height = 12;
            break;
          case 885:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 886:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 887:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 888:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            this.faceSlot = (sbyte) 5;
            break;
          case 889:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 890:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 891:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 2;
            this.value = 100000;
            break;
          case 892:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 893:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = 100000;
            break;
          case 894:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.headSlot = 70;
            this.value = Item.sellPrice(copper: 40);
            break;
          case 895:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.bodySlot = 46;
            this.value = Item.sellPrice(copper: 60);
            break;
          case 896:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 42;
            this.value = Item.sellPrice(copper: 50);
            break;
          case 897:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = Item.buyPrice(gold: 20);
            this.handOffSlot = (sbyte) 5;
            this.handOnSlot = (sbyte) 10;
            break;
          case 898:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 300000;
            this.shoeSlot = (sbyte) 10;
            break;
          case 899:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 7;
            this.value = 300000;
            this.handOnSlot = (sbyte) 13;
            break;
          case 900:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = this.eclipsePrice;
            this.handOnSlot = (sbyte) 14;
            break;
          case 901:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 100000;
            break;
          case 902:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 100000;
            break;
          case 903:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 100000;
            break;
          case 904:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 5;
            this.value = 100000;
            break;
          case 905:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 8;
            this.useTime = 8;
            this.width = 50;
            this.height = 18;
            this.shoot = 158;
            this.useAmmo = AmmoID.Coin;
            this.UseSound = SoundID.Item11;
            this.damage = 0;
            this.shootSpeed = 10f;
            this.noMelee = true;
            this.value = 300000;
            this.rare = 6;
            this.knockBack = 2f;
            this.ranged = true;
            break;
          case 906:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 3;
            this.value = 300000;
            break;
          case 907:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 4;
            this.value = Item.buyPrice(gold: 30);
            this.shoeSlot = (sbyte) 11;
            break;
          case 908:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 7;
            this.value = 500000;
            this.shoeSlot = (sbyte) 8;
            break;
          case 909:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 0;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 910:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 1;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 911:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 208;
            this.width = 8;
            this.height = 10;
            break;
          case 912:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 10;
            this.placeStyle = 10;
            this.width = 14;
            this.height = 28;
            this.value = 200;
            break;
          case 913:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 19;
            this.placeStyle = 5;
            this.width = 8;
            this.height = 10;
            break;
          case 914:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 14;
            this.width = 26;
            this.height = 22;
            this.value = 500;
            break;
          case 915:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 15;
            this.placeStyle = 11;
            this.width = 12;
            this.height = 30;
            this.value = 150;
            break;
          case 916:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 18;
            this.placeStyle = 9;
            this.width = 28;
            this.height = 14;
            this.value = 150;
            break;
          case 917:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 14;
            this.placeStyle = 8;
            this.width = 26;
            this.height = 20;
            this.value = 300;
            break;
          case 918:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 88;
            this.placeStyle = 4;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 919:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 87;
            this.placeStyle = 4;
            this.width = 20;
            this.height = 20;
            this.value = 300;
            break;
          case 920:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 79;
            this.placeStyle = 4;
            this.width = 28;
            this.height = 20;
            this.value = 2000;
            break;
          case 921:
            this.useStyle = 1;
            this.useTurn = false;
            this.useAnimation = 21;
            this.useTime = 21;
            this.width = 24;
            this.height = 28;
            this.damage = 10;
            this.knockBack = 5f;
            this.UseSound = SoundID.Item1;
            this.scale = 1f;
            this.value = 100;
            this.melee = true;
            break;
          case 922:
            this.autoReuse = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 30;
            this.useTime = 20;
            this.hammer = 40;
            this.width = 24;
            this.height = 28;
            this.damage = 7;
            this.knockBack = 5.5f;
            this.scale = 1.2f;
            this.UseSound = SoundID.Item1;
            this.value = 50;
            this.melee = true;
            break;
          case 923:
            this.useStyle = 5;
            this.useAnimation = 28;
            this.useTime = 28;
            this.width = 12;
            this.height = 28;
            this.shoot = 1;
            this.useAmmo = AmmoID.Arrow;
            this.UseSound = SoundID.Item5;
            this.damage = 8;
            this.shootSpeed = 6.6f;
            this.noMelee = true;
            this.value = 100;
            this.ranged = true;
            break;
          case 924:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.headSlot = 71;
            break;
          case 925:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.bodySlot = 47;
            break;
          case 926:
            this.width = 18;
            this.height = 18;
            this.defense = 1;
            this.legSlot = 43;
            break;
          case 927:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 85;
            this.width = 12;
            this.height = 12;
            break;
          case 928:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 209;
            this.width = 12;
            this.height = 12;
            this.rare = 3;
            this.value = Item.buyPrice(gold: 25);
            break;
          case 929:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 20;
            this.useTime = 20;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.width = 12;
            this.height = 12;
            this.damage = 300;
            this.noMelee = true;
            this.value = Item.buyPrice(silver: 15);
            break;
          case 930:
            this.useStyle = 5;
            this.useAnimation = 18;
            this.useTime = 18;
            this.width = 24;
            this.height = 28;
            this.shoot = 163;
            this.useAmmo = AmmoID.Flare;
            this.UseSound = SoundID.Item11;
            this.damage = 2;
            this.shootSpeed = 6f;
            this.noMelee = true;
            this.value = 50000;
            this.scale = 0.9f;
            this.rare = 1;
            this.holdStyle = 1;
            break;
          case 931:
            this.shootSpeed = 6f;
            this.shoot = 163;
            this.damage = 1;
            this.width = 12;
            this.height = 12;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Flare;
            this.knockBack = 1.5f;
            this.value = 7;
            this.ranged = true;
            break;
          case 932:
            this.tileWand = 154;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.createTile = 194;
            this.width = 8;
            this.height = 10;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 50);
            break;
          case 933:
            this.tileWand = 9;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.createTile = 192;
            this.width = 8;
            this.height = 10;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 25);
            break;
          case 934:
            this.width = 34;
            this.height = 12;
            this.accessory = true;
            this.rare = 2;
            this.value = 50000;
            break;
          case 935:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.value = 300000;
            this.rare = 5;
            break;
          case 936:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.rare = 6;
            this.value = Item.buyPrice(gold: 25);
            this.handOffSlot = (sbyte) 4;
            this.handOnSlot = (sbyte) 9;
            break;
          case 937:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 210;
            this.width = 12;
            this.height = 12;
            this.placeStyle = 0;
            this.mech = true;
            this.value = 50000;
            this.mech = true;
            break;
          case 938:
            this.width = 24;
            this.height = 24;
            this.accessory = true;
            this.rare = 8;
            this.defense = 6;
            this.value = 300000;
            this.shieldSlot = (sbyte) 2;
            break;
          case 939:
            this.noUseGraphic = true;
            this.damage = 0;
            this.knockBack = 7f;
            this.useStyle = 5;
            this.shootSpeed = 10f;
            this.shoot = 165;
            this.width = 18;
            this.height = 28;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 2;
            this.noMelee = true;
            this.value = 20000;
            break;
          case 940:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 2;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 941:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 3;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 942:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 4;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 943:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 5;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 944:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 6;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 945:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 207;
            this.placeStyle = 7;
            this.width = 26;
            this.height = 36;
            this.value = Item.buyPrice(gold: 4);
            this.rare = 1;
            break;
          case 946:
            this.width = 44;
            this.height = 44;
            this.rare = 1;
            this.value = 10000;
            this.holdStyle = 2;
            this.useStyle = 3;
            this.useAnimation = 22;
            this.useTime = 22;
            this.damage = 10;
            this.knockBack = 5f;
            this.UseSound = SoundID.Item1;
            this.melee = true;
            break;
          case 947:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 211;
            this.width = 12;
            this.height = 12;
            this.rare = 7;
            this.value = Item.sellPrice(silver: 15);
            break;
          case 948:
            this.width = 24;
            this.height = 8;
            this.accessory = true;
            this.rare = 8;
            this.wingSlot = (sbyte) 12;
            this.value = Item.buyPrice(3);
            break;
          case 949:
            this.useStyle = 1;
            this.shootSpeed = 7f;
            this.shoot = 166;
            this.ammo = AmmoID.Snowball;
            this.damage = 8;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 19;
            this.useTime = 19;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.ranged = true;
            this.knockBack = 5.75f;
            break;
          case 950:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 1;
            this.value = 50000;
            this.shoeSlot = (sbyte) 7;
            break;
          case 951:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 212;
            this.width = 20;
            this.height = 20;
            this.value = 50000;
            this.rare = 2;
            break;
          case 952:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 21;
            this.placeStyle = 15;
            this.width = 26;
            this.height = 22;
            this.value = 500;
            break;
          case 953:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 1;
            this.value = Item.sellPrice(silver: 50);
            this.handOnSlot = (sbyte) 11;
            this.handOffSlot = (sbyte) 6;
            break;
          case 954:
            this.width = 18;
            this.height = 18;
            this.defense = 2;
            this.headSlot = 72;
            this.value = 5000;
            break;
          case 955:
            this.width = 18;
            this.height = 18;
            this.defense = 4;
            this.headSlot = 73;
            this.value = 25000;
            break;
          case 956:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.headSlot = 74;
            this.rare = 1;
            this.value = 37500;
            break;
          case 957:
            this.width = 18;
            this.height = 18;
            this.defense = 7;
            this.bodySlot = 48;
            this.rare = 1;
            this.value = 30000;
            break;
          case 958:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.legSlot = 44;
            this.rare = 1;
            this.value = 22500;
            break;
          case 959:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.headSlot = 75;
            this.rare = 2;
            this.value = 45000;
            break;
          case 960:
            this.width = 18;
            this.height = 18;
            this.defense = 5;
            this.headSlot = 76;
            this.rare = 3;
            this.value = 45000;
            break;
          case 961:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.bodySlot = 49;
            this.rare = 3;
            this.value = 30000;
            break;
          case 962:
            this.width = 18;
            this.height = 18;
            this.defense = 6;
            this.legSlot = 45;
            this.rare = 3;
            this.value = 30000;
            break;
          case 963:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 7;
            this.value = Item.buyPrice(gold: 15);
            this.waistSlot = (sbyte) 10;
            break;
          case 964:
            this.knockBack = 5.75f;
            this.useStyle = 5;
            this.useAnimation = 40;
            this.useTime = 40;
            this.width = 50;
            this.height = 14;
            this.shoot = 10;
            this.useAmmo = AmmoID.Bullet;
            this.UseSound = SoundID.Item36;
            this.damage = 14;
            this.shootSpeed = 5.35f;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 2);
            this.rare = 2;
            this.ranged = true;
            break;
          case 965:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 8;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 213;
            this.width = 12;
            this.height = 12;
            this.value = 10;
            this.tileBoost += 3;
            break;
          case 966:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 215;
            this.width = 12;
            this.height = 12;
            break;
          case 967:
            this.width = 12;
            this.height = 12;
            this.maxStack = 99;
            this.value = 100;
            break;
          case 968:
            this.holdStyle = 1;
            this.width = 12;
            this.height = 12;
            this.value = 200;
            break;
          case 970:
            this.createTile = 216;
            this.placeStyle = 0;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.width = 12;
            this.height = 30;
            this.value = 1500;
            this.mech = true;
            break;
          case 971:
            this.createTile = 216;
            this.placeStyle = 1;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.width = 12;
            this.height = 30;
            this.value = 1500;
            this.mech = true;
            break;
          case 972:
            this.createTile = 216;
            this.placeStyle = 2;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.width = 12;
            this.height = 30;
            this.value = 1500;
            this.mech = true;
            break;
          case 973:
            this.createTile = 216;
            this.placeStyle = 3;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.width = 12;
            this.height = 30;
            this.value = 1500;
            this.mech = true;
            break;
          case 974:
            this.flame = true;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.holdStyle = 1;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createTile = 4;
            this.placeStyle = 9;
            this.width = 10;
            this.height = 12;
            this.value = 60;
            this.noWet = true;
            break;
          case 975:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 1;
            this.value = 50000;
            this.shoeSlot = (sbyte) 4;
            break;
          case 976:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 2;
            this.value = 50000;
            this.shoeSlot = (sbyte) 4;
            this.handOnSlot = (sbyte) 11;
            this.handOffSlot = (sbyte) 6;
            break;
          case 977:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 7;
            this.value = Item.buyPrice(gold: 15);
            this.shoeSlot = (sbyte) 3;
            break;
          case 978:
            this.width = 18;
            this.height = 18;
            this.headSlot = 77;
            this.value = 50000;
            this.defense = 1;
            break;
          case 979:
            this.width = 18;
            this.height = 18;
            this.bodySlot = 50;
            this.value = 40000;
            this.defense = 2;
            break;
          case 980:
            this.width = 18;
            this.height = 18;
            this.legSlot = 46;
            this.value = 30000;
            this.defense = 1;
            break;
          case 981:
            this.maxStack = 99;
            this.width = 12;
            this.height = 20;
            this.value = 10000;
            break;
          case 982:
            this.width = 22;
            this.height = 22;
            this.accessory = true;
            this.rare = 1;
            this.value = 50000;
            this.handOnSlot = (sbyte) 1;
            break;
          case 983:
            this.width = 14;
            this.height = 28;
            this.rare = 4;
            this.value = 150000;
            this.accessory = true;
            this.balloonSlot = (sbyte) 6;
            break;
          case 984:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 8;
            this.value = 500000;
            this.handOnSlot = (sbyte) 11;
            this.handOffSlot = (sbyte) 6;
            this.shoeSlot = (sbyte) 14;
            this.waistSlot = (sbyte) 10;
            break;
          case 985:
            this.useStyle = 1;
            this.shootSpeed = 10f;
            this.shoot = 171;
            this.damage = 0;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.noUseGraphic = true;
            this.noMelee = true;
            this.value = 100;
            break;
          case 986:
            this.useStyle = 5;
            this.autoReuse = true;
            this.useAnimation = 35;
            this.useTime = 35;
            this.width = 38;
            this.height = 6;
            this.shoot = 10;
            this.useAmmo = AmmoID.Dart;
            this.UseSound = SoundID.Item64;
            this.damage = 27;
            this.shootSpeed = 13f;
            this.noMelee = true;
            this.value = Item.buyPrice(gold: 5);
            this.knockBack = 4f;
            this.useAmmo = AmmoID.Dart;
            this.ranged = true;
            this.rare = 3;
            break;
          case 987:
            this.width = 16;
            this.height = 24;
            this.accessory = true;
            this.rare = 1;
            this.value = 50000;
            this.waistSlot = (sbyte) 13;
            break;
          case 988:
            this.shootSpeed = 3.75f;
            this.shoot = 172;
            this.damage = 9;
            this.width = 10;
            this.height = 28;
            this.maxStack = 999;
            this.consumable = true;
            this.ammo = AmmoID.Arrow;
            this.knockBack = 2.2f;
            this.value = 15;
            this.ranged = true;
            break;
          case 989:
            this.autoReuse = true;
            this.rare = 2;
            this.UseSound = SoundID.Item1;
            this.useStyle = 1;
            this.damage = 23;
            this.useAnimation = 21;
            this.useTime = 45;
            this.scale = 1.1f;
            this.width = 30;
            this.height = 30;
            this.shoot = 173;
            this.shootSpeed = 9.5f;
            this.knockBack = 4.25f;
            this.melee = true;
            this.value = Item.sellPrice(gold: 3);
            break;
          case 990:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 25;
            this.useTime = 7;
            this.knockBack = 4.75f;
            this.width = 20;
            this.height = 12;
            this.damage = 35;
            this.pick = 200;
            this.axe = 22;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 220000;
            this.melee = true;
            this.scale = 1.1f;
            break;
          case 991:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 35;
            this.useTime = 13;
            this.knockBack = 5f;
            this.width = 20;
            this.height = 12;
            this.damage = 33;
            this.axe = 14;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 54000;
            this.melee = true;
            this.scale = 1.1f;
            break;
          case 992:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 35;
            this.useTime = 10;
            this.knockBack = 6f;
            this.width = 20;
            this.height = 12;
            this.damage = 39;
            this.axe = 17;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 81000;
            this.melee = true;
            this.scale = 1.1f;
            break;
          case 993:
            this.useTurn = true;
            this.autoReuse = true;
            this.useStyle = 1;
            this.useAnimation = 35;
            this.useTime = 8;
            this.knockBack = 7f;
            this.width = 20;
            this.height = 12;
            this.damage = 43;
            this.axe = 20;
            this.UseSound = SoundID.Item1;
            this.rare = 4;
            this.value = 108000;
            this.melee = true;
            this.scale = 1.1f;
            break;
          case 994:
            this.damage = 0;
            this.useStyle = 1;
            this.shoot = 175;
            this.width = 16;
            this.height = 30;
            this.UseSound = SoundID.Item2;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 3;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 7, silver: 50);
            this.buffType = 45;
            break;
          case 995:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 217;
            this.width = 26;
            this.height = 20;
            this.value = 100000;
            break;
          case 996:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 218;
            this.width = 26;
            this.height = 20;
            this.value = 100000;
            break;
          case 997:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 219;
            this.width = 26;
            this.height = 20;
            this.value = 100000;
            break;
          case 998:
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 220;
            this.width = 26;
            this.height = 20;
            this.value = 100000;
            break;
          case 999:
            this.createTile = 178;
            this.placeStyle = 6;
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.alpha = 50;
            this.width = 10;
            this.height = 14;
            this.value = 15000;
            break;
          case 1000:
            this.useStyle = 5;
            this.shootSpeed = 10f;
            this.shoot = 178;
            this.damage = 0;
            this.width = 18;
            this.height = 20;
            this.maxStack = 999;
            this.consumable = true;
            this.UseSound = SoundID.Item11;
            this.useAnimation = 15;
            this.useTime = 15;
            this.noMelee = true;
            this.value = 100;
            this.ranged = true;
            break;
        }
      }
    }

    public void SetDefaults2(int type)
    {
      switch (type)
      {
        case 1001:
          this.width = 18;
          this.height = 18;
          this.defense = 20;
          this.headSlot = 78;
          this.rare = 7;
          this.value = 300000;
          break;
        case 1002:
          this.width = 18;
          this.height = 18;
          this.defense = 13;
          this.headSlot = 79;
          this.rare = 7;
          this.value = 300000;
          break;
        case 1003:
          this.width = 18;
          this.height = 18;
          this.defense = 7;
          this.headSlot = 80;
          this.rare = 7;
          this.value = 300000;
          break;
        case 1004:
          this.width = 18;
          this.height = 18;
          this.defense = 18;
          this.bodySlot = 51;
          this.rare = 7;
          this.value = 240000;
          break;
        case 1005:
          this.width = 18;
          this.height = 18;
          this.defense = 13;
          this.legSlot = 47;
          this.rare = 7;
          this.value = 180000;
          break;
        case 1006:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.value = Item.sellPrice(silver: 90);
          this.rare = 7;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 17;
          break;
        case 1007:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1008:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1009:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1010:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1011:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1012:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1013:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1014:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1015:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1016:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1017:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1018:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1019:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1020:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1021:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1022:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1023:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1024:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1025:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1026:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1027:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1028:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1029:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1030:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1031:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1032:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1033:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1034:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1035:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1036:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1037:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1038:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1039:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1040:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1041:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1042:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1043:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1044:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1045:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1046:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1047:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1048:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1049:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1050:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1051:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1052:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1053:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1054:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1055:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1056:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1057:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1058:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1059:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1060:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1061:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1062:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1063:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1064:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1065:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1066:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1067:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1068:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1069:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1070:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1071:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.width = 24;
          this.height = 24;
          this.value = 10000;
          break;
        case 1072:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.width = 24;
          this.height = 24;
          this.value = 10000;
          break;
        case 1073:
          this.paint = (byte) 1;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1074:
          this.paint = (byte) 2;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1075:
          this.paint = (byte) 3;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1076:
          this.paint = (byte) 4;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1077:
          this.paint = (byte) 5;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1078:
          this.paint = (byte) 6;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1079:
          this.paint = (byte) 7;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1080:
          this.paint = (byte) 8;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1081:
          this.paint = (byte) 9;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1082:
          this.paint = (byte) 10;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1083:
          this.paint = (byte) 11;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1084:
          this.paint = (byte) 12;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1085:
          this.paint = (byte) 13;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1086:
          this.paint = (byte) 14;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1087:
          this.paint = (byte) 15;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1088:
          this.paint = (byte) 16;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1089:
          this.paint = (byte) 17;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1090:
          this.paint = (byte) 18;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1091:
          this.paint = (byte) 19;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1092:
          this.paint = (byte) 20;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1093:
          this.paint = (byte) 21;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1094:
          this.paint = (byte) 22;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1095:
          this.paint = (byte) 23;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1096:
          this.paint = (byte) 24;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1097:
          this.paint = (byte) 25;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1098:
          this.paint = (byte) 26;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1099:
          this.paint = (byte) 27;
          this.width = 24;
          this.height = 24;
          this.value = 25;
          this.maxStack = 999;
          break;
        case 1100:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.width = 24;
          this.height = 24;
          this.value = 10000;
          break;
        case 1101:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 226;
          this.width = 12;
          this.height = 12;
          break;
        case 1102:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 112;
          this.width = 12;
          this.height = 12;
          break;
        case 1103:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 224;
          this.width = 12;
          this.height = 12;
          break;
        case 1104:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 221;
          this.width = 12;
          this.height = 12;
          this.value = 4500;
          this.rare = 3;
          break;
        case 1105:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 222;
          this.width = 12;
          this.height = 12;
          this.value = 6500;
          this.rare = 3;
          break;
        case 1106:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 223;
          this.width = 12;
          this.height = 12;
          this.value = 8500;
          this.rare = 3;
          break;
        case 1107:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 0;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1108:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 1;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1109:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 2;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1110:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 3;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1111:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 4;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1112:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 5;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1113:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1114:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          this.placeStyle = 7;
          this.createTile = 227;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1115:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1116:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1117:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1118:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1119:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = 10000;
          this.rare = 1;
          break;
        case 1120:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 228;
          this.width = 26;
          this.height = 20;
          this.value = Item.buyPrice(gold: 5);
          break;
        case 1121:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 12;
          this.useTime = 12;
          this.mana = 5;
          this.width = 50;
          this.height = 18;
          this.shoot = 181;
          this.UseSound = SoundID.Item11;
          this.damage = 9;
          this.shootSpeed = 8f;
          this.noMelee = true;
          this.value = this.queenBeePrice;
          this.rare = 2;
          this.magic = true;
          this.scale = 0.8f;
          break;
        case 1122:
          this.autoReuse = true;
          this.useStyle = 1;
          this.shootSpeed = 12f;
          this.shoot = 182;
          this.damage = 80;
          this.width = 18;
          this.height = 20;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 14;
          this.useTime = 14;
          this.noUseGraphic = true;
          this.noMelee = true;
          this.value = Item.buyPrice(gold: 35);
          this.knockBack = 5f;
          this.melee = true;
          this.rare = 7;
          break;
        case 1123:
          this.useStyle = 1;
          this.useAnimation = 22;
          this.knockBack = 5f;
          this.width = 40;
          this.height = 40;
          this.damage = 24;
          this.scale = 1.1f;
          this.UseSound = SoundID.Item1;
          this.rare = 3;
          this.value = this.queenBeePrice;
          this.melee = true;
          break;
        case 1124:
          this.width = 12;
          this.height = 12;
          this.maxStack = 999;
          break;
        case 1125:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 229;
          this.width = 12;
          this.height = 12;
          break;
        case 1126:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 108;
          this.width = 12;
          this.height = 12;
          break;
        case 1127:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 230;
          this.width = 12;
          this.height = 12;
          break;
        case 1128:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.autoReuse = true;
          break;
        case 1129:
          this.tileWand = 1124;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.createTile = 225;
          this.width = 8;
          this.height = 10;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 1130:
          this.useStyle = 1;
          this.shootSpeed = 6f;
          this.shoot = 183;
          this.knockBack = 1f;
          this.damage = 14;
          this.width = 10;
          this.height = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.noMelee = true;
          this.value = 200;
          this.ranged = true;
          break;
        case 1131:
          this.width = 22;
          this.height = 22;
          this.accessory = true;
          this.rare = 8;
          this.value = Item.sellPrice(gold: 40);
          this.expert = true;
          break;
        case 1132:
          this.width = 22;
          this.height = 22;
          this.accessory = true;
          this.rare = 2;
          this.value = 100000;
          break;
        case 1133:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          this.rare = 1;
          break;
        case 1134:
          this.UseSound = SoundID.Item3;
          this.healLife = 80;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.potion = true;
          this.value = 40;
          break;
        case 1135:
          this.width = 18;
          this.height = 18;
          this.headSlot = 81;
          this.value = 1000;
          this.defense = 1;
          break;
        case 1136:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 52;
          this.value = 1000;
          this.defense = 2;
          break;
        case 1137:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 12;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1138:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 13;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1139:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 14;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1140:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 15;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1141:
          this.width = 14;
          this.height = 20;
          this.maxStack = 99;
          this.rare = 7;
          break;
        case 1142:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 21;
          this.placeStyle = 16;
          this.width = 26;
          this.height = 22;
          this.value = 500;
          break;
        case 1143:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 15;
          this.placeStyle = 12;
          this.width = 12;
          this.height = 30;
          this.value = 150;
          break;
        case 1144:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 14;
          this.placeStyle = 9;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1145:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 18;
          this.placeStyle = 10;
          this.width = 28;
          this.height = 14;
          this.value = 150;
          break;
        case 1146:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 137;
          this.placeStyle = 1;
          this.width = 12;
          this.height = 12;
          this.value = 10000;
          this.mech = true;
          break;
        case 1147:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 137;
          this.placeStyle = 2;
          this.width = 12;
          this.height = 12;
          this.value = 10000;
          this.mech = true;
          break;
        case 1148:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 137;
          this.placeStyle = 3;
          this.width = 12;
          this.height = 12;
          this.value = 10000;
          this.mech = true;
          break;
        case 1149:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 137;
          this.placeStyle = 4;
          this.width = 12;
          this.height = 12;
          this.value = 10000;
          this.mech = true;
          break;
        case 1150:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 232;
          this.width = 12;
          this.height = 12;
          break;
        case 1151:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 135;
          this.width = 12;
          this.height = 12;
          this.placeStyle = 6;
          this.mech = true;
          this.value = 5000;
          break;
        case 1152:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 43;
          break;
        case 1153:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 44;
          break;
        case 1154:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 45;
          break;
        case 1155:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 18;
          this.useTime = 18;
          this.mana = 10;
          this.width = 50;
          this.height = 18;
          this.shoot = 189;
          this.UseSound = SoundID.Item11;
          this.damage = 31;
          this.shootSpeed = 9f;
          this.noMelee = true;
          this.value = 500000;
          this.rare = 8;
          this.magic = true;
          break;
        case 1156:
          this.channel = true;
          this.useStyle = 5;
          this.useAnimation = 30;
          this.useTime = 30;
          this.knockBack = 1f;
          this.width = 30;
          this.height = 10;
          this.damage = 38;
          this.scale = 1.1f;
          this.shoot = 190;
          this.shootSpeed = 14f;
          this.UseSound = SoundID.Item10;
          this.rare = 8;
          this.value = Item.sellPrice(gold: 20);
          this.ranged = true;
          this.noMelee = true;
          break;
        case 1157:
          this.mana = 10;
          this.damage = 34;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 191;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item44;
          this.useAnimation = 28;
          this.useTime = 28;
          this.rare = 7;
          this.noMelee = true;
          this.knockBack = 3f;
          this.buffType = 49;
          this.value = Item.buyPrice(gold: 35);
          this.summon = true;
          break;
        case 1158:
          this.rare = 7;
          this.width = 24;
          this.height = 28;
          this.accessory = true;
          this.value = Item.buyPrice(gold: 40);
          this.neckSlot = (sbyte) 4;
          break;
        case 1159:
          this.width = 18;
          this.height = 18;
          this.defense = 6;
          this.headSlot = 82;
          this.rare = 7;
          this.value = Item.buyPrice(gold: 50);
          break;
        case 1160:
          this.width = 18;
          this.height = 18;
          this.defense = 17;
          this.bodySlot = 53;
          this.rare = 7;
          this.value = Item.buyPrice(gold: 50);
          break;
        case 1161:
          this.width = 18;
          this.height = 18;
          this.defense = 12;
          this.legSlot = 48;
          this.rare = 7;
          this.value = Item.buyPrice(gold: 50);
          break;
        case 1162:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.value = Item.buyPrice(gold: 75);
          this.wingSlot = (sbyte) 13;
          this.rare = 5;
          break;
        case 1163:
          this.width = 14;
          this.height = 28;
          this.rare = 4;
          this.value = 150000;
          this.accessory = true;
          this.balloonSlot = (sbyte) 1;
          break;
        case 1164:
          this.width = 14;
          this.height = 28;
          this.rare = 8;
          this.value = 150000;
          this.accessory = true;
          this.balloonSlot = (sbyte) 3;
          break;
        case 1165:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.value = 400000;
          this.rare = 5;
          this.wingSlot = (sbyte) 14;
          break;
        case 1166:
          this.useStyle = 1;
          this.useAnimation = 22;
          this.knockBack = 4.5f;
          this.width = 24;
          this.height = 28;
          this.damage = 16;
          this.scale = 1.05f;
          this.UseSound = SoundID.Item1;
          this.rare = 3;
          this.value = 9000;
          this.melee = true;
          break;
        case 1167:
          this.rare = 7;
          this.width = 24;
          this.height = 28;
          this.accessory = true;
          this.value = Item.buyPrice(gold: 40);
          break;
        case 1168:
          this.useStyle = 1;
          this.shootSpeed = 6f;
          this.shoot = 196;
          this.width = 18;
          this.height = 20;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.noMelee = true;
          this.value = 20;
          break;
        case 1169:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 197;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 5);
          this.buffType = 50;
          break;
        case 1170:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 198;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 3);
          this.buffType = 51;
          break;
        case 1171:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 199;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.buffType = 52;
          this.value = Item.buyPrice(2);
          break;
        case 1172:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 200;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 2);
          this.buffType = 53;
          break;
        case 1173:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 85;
          this.placeStyle = 1;
          this.width = 20;
          this.height = 20;
          break;
        case 1174:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 85;
          this.placeStyle = 2;
          this.width = 20;
          this.height = 20;
          break;
        case 1175:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 85;
          this.placeStyle = 3;
          this.width = 20;
          this.height = 20;
          break;
        case 1176:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 85;
          this.placeStyle = 4;
          this.width = 20;
          this.height = 20;
          break;
        case 1177:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 85;
          this.placeStyle = 5;
          this.width = 20;
          this.height = 20;
          break;
        case 1178:
          this.useStyle = 5;
          this.mana = 4;
          this.autoReuse = true;
          this.useAnimation = 7;
          this.useTime = 7;
          this.width = 24;
          this.height = 18;
          this.shoot = 206;
          this.UseSound = SoundID.Item7;
          this.damage = 48;
          this.shootSpeed = 11f;
          this.noMelee = true;
          this.value = 300000;
          this.knockBack = 4f;
          this.rare = 7;
          this.magic = true;
          break;
        case 1179:
          this.shootSpeed = 5f;
          this.shoot = 207;
          this.damage = 10;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 4.5f;
          this.value = 50;
          this.ranged = true;
          this.rare = 7;
          break;
        case 1180:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 208;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.buffType = 54;
          this.value = Item.sellPrice(gold: 75);
          break;
        case 1181:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 209;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.buyPrice(gold: 45);
          this.buffType = 55;
          break;
        case 1182:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 210;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 2);
          this.buffType = 56;
          break;
        case 1183:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 211;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 5, silver: 50);
          this.buffType = 57;
          break;
        case 1184:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.value = 13500;
          this.rare = 3;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 12;
          break;
        case 1185:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 25;
          this.knockBack = 4.75f;
          this.width = 40;
          this.height = 40;
          this.damage = 45;
          this.scale = 1.125f;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 92000;
          this.melee = true;
          break;
        case 1186:
          this.useStyle = 5;
          this.useAnimation = 27;
          this.useTime = 27;
          this.shootSpeed = 4.4f;
          this.knockBack = 4.5f;
          this.width = 40;
          this.height = 40;
          this.damage = 32;
          this.scale = 1.1f;
          this.UseSound = SoundID.Item1;
          this.shoot = 212;
          this.rare = 4;
          this.value = 60000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          break;
        case 1187:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 23;
          this.useTime = 23;
          this.width = 50;
          this.height = 18;
          this.shoot = 1;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 34;
          this.shootSpeed = 9.25f;
          this.noMelee = true;
          this.value = 80000;
          this.ranged = true;
          this.rare = 4;
          this.knockBack = 1.75f;
          break;
        case 1188:
          this.useStyle = 1;
          this.useTurn = true;
          this.autoReuse = true;
          this.useAnimation = 25;
          this.useTime = 12;
          this.knockBack = 5f;
          this.width = 20;
          this.height = 12;
          this.damage = 12;
          this.pick = 130;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 72000;
          this.melee = true;
          this.scale = 1.15f;
          break;
        case 1189:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 12;
          this.shootSpeed = 32f;
          this.knockBack = 0.0f;
          this.width = 20;
          this.height = 12;
          this.damage = 12;
          this.pick = 130;
          this.UseSound = SoundID.Item23;
          this.shoot = 213;
          this.rare = 4;
          this.value = 72000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1190:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 12;
          this.shootSpeed = 40f;
          this.knockBack = 2.9f;
          this.width = 20;
          this.height = 12;
          this.damage = 26;
          this.axe = 15;
          this.UseSound = SoundID.Item23;
          this.shoot = 214;
          this.rare = 4;
          this.value = 72000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1191:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.value = Item.sellPrice(silver: 52);
          this.rare = 3;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 14;
          break;
        case 1192:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 25;
          this.knockBack = 6f;
          this.width = 40;
          this.height = 40;
          this.damage = 50;
          this.scale = 1.17f;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 126500;
          this.melee = true;
          break;
        case 1193:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 25;
          this.shootSpeed = 4.5f;
          this.knockBack = 5.5f;
          this.width = 40;
          this.height = 40;
          this.damage = 36;
          this.scale = 1.1f;
          this.UseSound = SoundID.Item1;
          this.shoot = 215;
          this.rare = 4;
          this.value = 82500;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          break;
        case 1194:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 21;
          this.useTime = 21;
          this.width = 50;
          this.height = 18;
          this.shoot = 1;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 38;
          this.shootSpeed = 9.75f;
          this.noMelee = true;
          this.value = 110000;
          this.ranged = true;
          this.rare = 4;
          this.knockBack = 2f;
          break;
        case 1195:
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 9;
          this.knockBack = 5f;
          this.useTurn = true;
          this.autoReuse = true;
          this.width = 20;
          this.height = 12;
          this.damage = 17;
          this.pick = 165;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 99000;
          this.melee = true;
          this.scale = 1.15f;
          break;
        case 1196:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 9;
          this.shootSpeed = 32f;
          this.knockBack = 0.0f;
          this.width = 20;
          this.height = 12;
          this.damage = 17;
          this.pick = 165;
          this.UseSound = SoundID.Item23;
          this.shoot = 216;
          this.rare = 4;
          this.value = 99000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1197:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 9;
          this.shootSpeed = 40f;
          this.knockBack = 3.75f;
          this.width = 20;
          this.height = 12;
          this.damage = 31;
          this.axe = 18;
          this.UseSound = SoundID.Item23;
          this.shoot = 217;
          this.rare = 4;
          this.value = 99000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1198:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.value = Item.sellPrice(silver: 85);
          this.rare = 3;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 16;
          break;
        case 1199:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 25;
          this.knockBack = 6f;
          this.width = 40;
          this.height = 40;
          this.damage = 58;
          this.scale = 1.2f;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 161000;
          this.melee = true;
          break;
        case 1200:
          this.useStyle = 5;
          this.useAnimation = 23;
          this.useTime = 23;
          this.shootSpeed = 5f;
          this.knockBack = 6.2f;
          this.width = 40;
          this.height = 40;
          this.damage = 40;
          this.scale = 1.1f;
          this.UseSound = SoundID.Item1;
          this.shoot = 218;
          this.rare = 4;
          this.value = 105000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          break;
        case 1201:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 18;
          this.useTime = 18;
          this.width = 50;
          this.height = 18;
          this.shoot = 1;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 41;
          this.shootSpeed = 10.5f;
          this.noMelee = true;
          this.value = 140000;
          this.ranged = true;
          this.rare = 4;
          this.knockBack = 2.5f;
          break;
        case 1202:
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 7;
          this.knockBack = 5f;
          this.useTurn = true;
          this.autoReuse = true;
          this.width = 20;
          this.height = 12;
          this.damage = 27;
          this.pick = 190;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 126000;
          this.melee = true;
          this.scale = 1.15f;
          break;
        case 1203:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 7;
          this.shootSpeed = 32f;
          this.knockBack = 0.0f;
          this.width = 20;
          this.height = 12;
          this.damage = 27;
          this.pick = 190;
          this.UseSound = SoundID.Item23;
          this.shoot = 219;
          this.rare = 4;
          this.value = 126000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1204:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 7;
          this.shootSpeed = 40f;
          this.knockBack = 4.6f;
          this.width = 20;
          this.height = 12;
          this.damage = 34;
          this.axe = 21;
          this.UseSound = SoundID.Item23;
          this.shoot = 220;
          this.rare = 4;
          this.value = 126000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          break;
        case 1205:
          this.width = 18;
          this.height = 18;
          this.defense = 14;
          this.headSlot = 83;
          this.rare = 4;
          this.value = 75000;
          break;
        case 1206:
          this.width = 18;
          this.height = 18;
          this.defense = 5;
          this.headSlot = 84;
          this.rare = 4;
          this.value = 75000;
          break;
        case 1207:
          this.width = 18;
          this.height = 18;
          this.defense = 3;
          this.headSlot = 85;
          this.rare = 4;
          this.value = 75000;
          break;
        case 1208:
          this.width = 18;
          this.height = 18;
          this.defense = 10;
          this.bodySlot = 54;
          this.rare = 4;
          this.value = 60000;
          break;
        case 1209:
          this.width = 18;
          this.height = 18;
          this.defense = 8;
          this.legSlot = 49;
          this.rare = 4;
          this.value = 45000;
          break;
        case 1210:
          this.width = 18;
          this.height = 18;
          this.defense = 19;
          this.headSlot = 86;
          this.rare = 4;
          this.value = 112500;
          break;
        case 1211:
          this.width = 18;
          this.height = 18;
          this.defense = 7;
          this.headSlot = 87;
          this.rare = 4;
          this.value = 112500;
          break;
        case 1212:
          this.width = 18;
          this.height = 18;
          this.defense = 4;
          this.headSlot = 88;
          this.rare = 4;
          this.value = 112500;
          break;
        case 1213:
          this.width = 18;
          this.height = 18;
          this.defense = 13;
          this.bodySlot = 55;
          this.rare = 4;
          this.value = 90000;
          break;
        case 1214:
          this.width = 18;
          this.height = 18;
          this.defense = 10;
          this.legSlot = 50;
          this.rare = 4;
          this.value = 67500;
          break;
        case 1215:
          this.width = 18;
          this.height = 18;
          this.defense = 23;
          this.headSlot = 89;
          this.rare = 4;
          this.value = 150000;
          break;
        case 1216:
          this.width = 18;
          this.height = 18;
          this.defense = 8;
          this.headSlot = 90;
          this.rare = 4;
          this.value = 150000;
          break;
        case 1217:
          this.width = 18;
          this.height = 18;
          this.defense = 4;
          this.headSlot = 91;
          this.rare = 4;
          this.value = 150000;
          break;
        case 1218:
          this.width = 18;
          this.height = 18;
          this.defense = 15;
          this.bodySlot = 56;
          this.rare = 4;
          this.value = 120000;
          break;
        case 1219:
          this.width = 18;
          this.height = 18;
          this.defense = 11;
          this.legSlot = 51;
          this.rare = 4;
          this.value = 90000;
          break;
        case 1220:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 134;
          this.placeStyle = 1;
          this.width = 28;
          this.height = 14;
          this.value = 25000;
          this.rare = 3;
          break;
        case 1221:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 133;
          this.placeStyle = 1;
          this.width = 44;
          this.height = 30;
          this.value = 50000;
          this.rare = 3;
          break;
        case 1222:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 35;
          this.useTime = 12;
          this.knockBack = 5.5f;
          this.width = 20;
          this.height = 12;
          this.damage = 36;
          this.axe = 15;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 72000;
          this.melee = true;
          this.scale = 1.1f;
          break;
        case 1223:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 35;
          this.useTime = 9;
          this.knockBack = 6.5f;
          this.width = 20;
          this.height = 12;
          this.damage = 41;
          this.axe = 18;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 99000;
          this.melee = true;
          this.scale = 1.1f;
          break;
        case 1224:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 35;
          this.useTime = 7;
          this.knockBack = 7.5f;
          this.width = 20;
          this.height = 12;
          this.damage = 44;
          this.axe = 21;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = 126000;
          this.melee = true;
          this.scale = 1.1f;
          break;
        case 1225:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.value = Item.sellPrice(silver: 40);
          this.rare = 4;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 18;
          break;
        case 1226:
          this.useStyle = 1;
          this.useAnimation = 26;
          this.useTime = 60;
          this.shoot = 229;
          this.shootSpeed = 8f;
          this.knockBack = 6f;
          this.width = 40;
          this.height = 40;
          this.damage = 80;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 276000;
          this.scale = 1.25f;
          this.melee = true;
          break;
        case 1227:
          this.autoReuse = true;
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 16;
          this.useTime = 42;
          this.shoot = 228;
          this.shootSpeed = 8f;
          this.knockBack = 4f;
          this.width = 40;
          this.height = 40;
          this.damage = 48;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 276000;
          this.melee = true;
          break;
        case 1228:
          this.useStyle = 5;
          this.useAnimation = 23;
          this.useTime = 23;
          this.shootSpeed = 5f;
          this.knockBack = 6.2f;
          this.width = 40;
          this.height = 40;
          this.damage = 49;
          this.scale = 1.1f;
          this.UseSound = SoundID.Item1;
          this.shoot = 222;
          this.rare = 7;
          this.value = 180000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          break;
        case 1229:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 19;
          this.useTime = 19;
          this.width = 50;
          this.height = 18;
          this.shoot = 1;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 34;
          this.shootSpeed = 11.5f;
          this.noMelee = true;
          this.value = 240000;
          this.ranged = true;
          this.rare = 7;
          this.knockBack = 2.75f;
          break;
        case 1230:
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 7;
          this.knockBack = 5f;
          this.useTurn = true;
          this.autoReuse = true;
          this.width = 20;
          this.height = 12;
          this.damage = 40;
          this.pick = 200;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 216000;
          this.melee = true;
          this.scale = 1.15f;
          ++this.tileBoost;
          break;
        case 1231:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 7;
          this.shootSpeed = 40f;
          this.knockBack = 1f;
          this.width = 20;
          this.height = 12;
          this.damage = 35;
          this.pick = 200;
          this.UseSound = SoundID.Item23;
          this.shoot = 223;
          this.rare = 7;
          this.value = 216000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          ++this.tileBoost;
          break;
        case 1232:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 7;
          this.shootSpeed = 46f;
          this.knockBack = 4.6f;
          this.width = 20;
          this.height = 12;
          this.damage = 50;
          this.axe = 23;
          this.UseSound = SoundID.Item23;
          this.shoot = 224;
          this.rare = 7;
          this.value = 216000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          ++this.tileBoost;
          break;
        case 1233:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 30;
          this.useTime = 7;
          this.knockBack = 7f;
          this.width = 20;
          this.height = 12;
          this.damage = 70;
          this.axe = 23;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 216000;
          this.melee = true;
          this.scale = 1.15f;
          ++this.tileBoost;
          break;
        case 1234:
          this.useTurn = true;
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 35;
          this.useTime = 14;
          this.hammer = 90;
          this.width = 24;
          this.height = 28;
          this.damage = 80;
          this.knockBack = 8f;
          this.scale = 1.25f;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 216000;
          this.melee = true;
          ++this.tileBoost;
          break;
        case 1235:
          this.shootSpeed = 4.5f;
          this.shoot = 225;
          this.damage = 16;
          this.width = 10;
          this.height = 28;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Arrow;
          this.knockBack = 3.5f;
          this.value = 100;
          this.ranged = true;
          this.rare = 7;
          break;
        case 1236:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 10f;
          this.shoot = 230;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1237:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 10.5f;
          this.shoot = 231;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1238:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 11f;
          this.shoot = 232;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1239:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 11.5f;
          this.shoot = 233;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1240:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 12f;
          this.shoot = 234;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1241:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 12.5f;
          this.shoot = 235;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 1242:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 236;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 3;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 7, silver: 50);
          this.buffType = 61;
          break;
        case 1243:
          this.width = 28;
          this.height = 20;
          this.headSlot = 92;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1244:
          this.mana = 10;
          this.damage = 36;
          this.useStyle = 1;
          this.shootSpeed = 16f;
          this.shoot = 237;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item66;
          this.useAnimation = 22;
          this.useTime = 22;
          this.rare = 6;
          this.noMelee = true;
          this.knockBack = 0.0f;
          this.value = Item.sellPrice(gold: 3, silver: 50);
          this.magic = true;
          break;
        case 1245:
          this.flame = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.holdStyle = 1;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 4;
          this.placeStyle = 10;
          this.width = 10;
          this.height = 12;
          this.value = 60;
          this.noWet = true;
          break;
        case 1246:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 234;
          this.width = 12;
          this.height = 12;
          this.ammo = AmmoID.Sand;
          this.notAmmo = true;
          break;
        case 1247:
          this.width = 20;
          this.height = 24;
          this.value = 150000;
          this.accessory = true;
          this.rare = 4;
          this.backSlot = (sbyte) 1;
          break;
        case 1248:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.value = Item.buyPrice(gold: 25);
          this.rare = 7;
          break;
        case 1249:
          this.width = 14;
          this.height = 28;
          this.rare = 2;
          this.value = Item.sellPrice(gold: 2);
          this.accessory = true;
          this.balloonSlot = (sbyte) 7;
          break;
        case 1250:
          this.width = 20;
          this.height = 22;
          this.rare = 4;
          this.value = Item.buyPrice(gold: 15);
          this.accessory = true;
          this.balloonSlot = (sbyte) 2;
          break;
        case 1251:
          this.width = 20;
          this.height = 22;
          this.rare = 4;
          this.value = Item.buyPrice(gold: 15);
          this.accessory = true;
          this.balloonSlot = (sbyte) 9;
          break;
        case 1252:
          this.width = 20;
          this.height = 22;
          this.rare = 4;
          this.value = Item.buyPrice(gold: 15);
          this.accessory = true;
          this.balloonSlot = (sbyte) 10;
          break;
        case 1253:
          this.width = 20;
          this.height = 24;
          this.value = 225000;
          this.accessory = true;
          this.rare = 5;
          break;
        case 1254:
          this.useStyle = 5;
          this.useAnimation = 36;
          this.useTime = 36;
          this.crit += 25;
          this.width = 44;
          this.height = 14;
          this.shoot = 10;
          this.useAmmo = AmmoID.Bullet;
          this.UseSound = SoundID.Item40;
          this.damage = 185;
          this.shootSpeed = 16f;
          this.noMelee = true;
          this.value = Item.buyPrice(gold: 40);
          this.knockBack = 8f;
          this.rare = 8;
          this.ranged = true;
          break;
        case 1255:
          this.autoReuse = false;
          this.useStyle = 5;
          this.useAnimation = 8;
          this.useTime = 8;
          this.width = 24;
          this.height = 22;
          this.shoot = 14;
          this.knockBack = 5.5f;
          this.useAmmo = AmmoID.Bullet;
          this.UseSound = SoundID.Item41;
          this.damage = 50;
          this.shootSpeed = 13.5f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 5);
          this.scale = 0.85f;
          this.rare = 7;
          this.ranged = true;
          break;
        case 1256:
          this.mana = 10;
          this.damage = 12;
          this.useStyle = 1;
          this.shootSpeed = 12f;
          this.shoot = 243;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item8;
          this.useAnimation = 24;
          this.useTime = 24;
          this.rare = 1;
          this.noMelee = true;
          this.knockBack = 0.0f;
          this.value = this.shadowOrbPrice;
          this.magic = true;
          break;
        case 1257:
          this.width = 20;
          this.height = 20;
          this.maxStack = 999;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 39);
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.consumable = true;
          this.createTile = 239;
          this.placeStyle = 19;
          break;
        case 1258:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 22;
          this.useTime = 22;
          this.width = 50;
          this.height = 18;
          this.shoot = 246;
          this.useAmmo = AmmoID.StyngerBolt;
          this.UseSound = SoundID.Item11;
          this.damage = 45;
          this.knockBack = 5f;
          this.shootSpeed = 9f;
          this.noMelee = true;
          this.value = Item.buyPrice(gold: 35);
          this.rare = 7;
          this.ranged = true;
          break;
        case 1259:
          this.noMelee = true;
          this.useStyle = 5;
          this.useAnimation = 40;
          this.useTime = 40;
          this.knockBack = 6.5f;
          this.width = 30;
          this.height = 10;
          this.damage = 65;
          this.scale = 1.1f;
          this.noUseGraphic = true;
          this.shoot = 247;
          this.shootSpeed = 15.9f;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 6);
          this.melee = true;
          this.channel = true;
          break;
        case 1260:
          this.useStyle = 5;
          this.useAnimation = 40;
          this.useTime = 40;
          this.width = 50;
          this.height = 18;
          this.shoot = 250;
          this.UseSound = SoundID.Item67;
          this.damage = 45;
          this.knockBack = 2.5f;
          this.shootSpeed = 16f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 20);
          this.rare = 8;
          this.magic = true;
          this.mana = 20;
          break;
        case 1261:
          this.shootSpeed = 2f;
          this.shoot = 246;
          this.damage = 17;
          this.width = 10;
          this.height = 28;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.StyngerBolt;
          this.knockBack = 1f;
          this.value = 75;
          this.rare = 5;
          this.ranged = true;
          break;
        case 1262:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 7;
          this.shootSpeed = 46f;
          this.knockBack = 5.2f;
          this.width = 20;
          this.height = 12;
          this.damage = 45;
          this.hammer = 90;
          this.UseSound = SoundID.Item23;
          this.shoot = 252;
          this.rare = 7;
          this.value = 216000;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.melee = true;
          this.channel = true;
          ++this.tileBoost;
          break;
        case 1263:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 235;
          this.width = 12;
          this.height = 12;
          this.value = Item.buyPrice(gold: 2, silver: 50);
          this.mech = true;
          break;
        case 1264:
          this.mana = 11;
          this.damage = 60;
          this.useStyle = 1;
          this.shootSpeed = 7f;
          this.shoot = 253;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item20;
          this.useAnimation = 12;
          this.useTime = 12;
          this.rare = 5;
          this.noMelee = true;
          this.knockBack = 6.5f;
          this.value = Item.sellPrice(gold: 5);
          this.magic = true;
          break;
        case 1265:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 9;
          this.useTime = 9;
          this.width = 24;
          this.height = 22;
          this.shoot = 14;
          this.knockBack = 3.5f;
          this.useAmmo = AmmoID.Bullet;
          this.UseSound = SoundID.Item11;
          this.damage = 30;
          this.shootSpeed = 13f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 7);
          this.scale = 0.75f;
          this.rare = 7;
          this.ranged = true;
          break;
        case 1266:
          this.rare = 8;
          this.mana = 14;
          this.UseSound = SoundID.Item20;
          this.noMelee = true;
          this.useStyle = 5;
          this.damage = 48;
          this.knockBack = 6f;
          this.useAnimation = 20;
          this.useTime = 20;
          this.width = 24;
          this.height = 28;
          this.shoot = 254;
          this.shootSpeed = 1.2f;
          this.magic = true;
          this.value = 500000;
          break;
        case 1267:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 88;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1268:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 89;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1269:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 90;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1270:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 91;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1271:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 92;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1272:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 93;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 1273:
          this.useStyle = 5;
          this.useAnimation = 25;
          this.useTime = 25;
          this.width = 30;
          this.height = 10;
          this.noUseGraphic = true;
          this.shoot = 256;
          this.shootSpeed = 15f;
          this.UseSound = SoundID.Item1;
          this.rare = 2;
          this.value = 45000;
          break;
        case 1274:
          this.width = 28;
          this.height = 20;
          this.headSlot = 93;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1275:
          this.width = 28;
          this.height = 20;
          this.headSlot = 94;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 1);
          break;
        case 1276:
          this.width = 28;
          this.height = 20;
          this.headSlot = 95;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 1);
          break;
        case 1277:
          this.width = 28;
          this.height = 20;
          this.headSlot = 96;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1278:
          this.width = 28;
          this.height = 20;
          this.headSlot = 97;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1279:
          this.width = 28;
          this.height = 20;
          this.bodySlot = 57;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1280:
          this.width = 28;
          this.height = 20;
          this.legSlot = 52;
          this.rare = 1;
          this.vanity = true;
          break;
        case 1281:
          this.width = 28;
          this.height = 20;
          this.headSlot = 98;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 75);
          this.vanity = true;
          break;
        case 1282:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 58;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 1283:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 59;
          this.defense = 1;
          this.value = Item.sellPrice(silver: 50) * 2;
          break;
        case 1284:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 60;
          this.defense = 1;
          this.value = Item.sellPrice(silver: 50) * 3;
          this.rare = 1;
          break;
        case 1285:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 61;
          this.defense = 2;
          this.value = Item.sellPrice(silver: 50) * 4;
          this.rare = 1;
          break;
        case 1286:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 62;
          this.defense = 2;
          this.value = Item.sellPrice(silver: 50) * 5;
          this.rare = 1;
          break;
        case 1287:
          this.defense = 3;
          this.width = 18;
          this.height = 14;
          this.bodySlot = 63;
          this.value = Item.sellPrice(silver: 50) * 6;
          this.rare = 2;
          break;
        case 1288:
          this.width = 28;
          this.height = 20;
          this.bodySlot = 64;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 25);
          break;
        case 1289:
          this.width = 28;
          this.height = 20;
          this.legSlot = 53;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 25);
          break;
        case 1290:
          this.width = 22;
          this.height = 22;
          this.accessory = true;
          this.rare = 1;
          this.value = this.shadowOrbPrice;
          this.neckSlot = (sbyte) 3;
          break;
        case 1291:
          this.maxStack = 99;
          this.consumable = true;
          this.width = 18;
          this.height = 18;
          this.useStyle = 4;
          this.useTime = 30;
          this.UseSound = SoundID.Item4;
          this.useAnimation = 30;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 1292:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 237;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1293:
          this.maxStack = 99;
          this.consumable = true;
          this.width = 22;
          this.height = 10;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 1294:
          this.useStyle = 1;
          this.useAnimation = 16;
          this.useTime = 6;
          this.knockBack = 5.5f;
          this.useTurn = true;
          this.autoReuse = true;
          this.width = 20;
          this.height = 12;
          this.damage = 34;
          this.pick = 210;
          this.axe = 25;
          this.UseSound = SoundID.Item1;
          this.rare = 7;
          this.value = 216000;
          this.melee = true;
          this.scale = 1.15f;
          ++this.tileBoost;
          break;
        case 1295:
          this.mana = 8;
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 10;
          this.useTime = 10;
          this.width = 24;
          this.height = 18;
          this.shoot = 260;
          this.UseSound = SoundID.Item12;
          this.damage = 80;
          this.shootSpeed = 15f;
          this.noMelee = true;
          this.value = 350000;
          this.knockBack = 3f;
          this.rare = 7;
          this.magic = true;
          break;
        case 1296:
          this.mana = 18;
          this.damage = 125;
          this.useStyle = 5;
          this.crit = 20;
          this.shootSpeed = 12f;
          this.shoot = 261;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item69;
          this.useAnimation = this.useTime = 24;
          this.rare = 7;
          this.noMelee = true;
          this.knockBack = 7.5f;
          this.value = Item.buyPrice(gold: 35);
          this.magic = true;
          break;
        case 1297:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 24;
          this.useTime = 24;
          this.knockBack = 12f;
          this.width = 30;
          this.height = 10;
          this.damage = 90;
          this.scale = 0.9f;
          this.shoot = 262;
          this.shootSpeed = 14f;
          this.UseSound = SoundID.Item10;
          this.rare = 7;
          this.value = Item.buyPrice(gold: 35);
          this.melee = true;
          this.noMelee = true;
          break;
        case 1298:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 21;
          this.placeStyle = 17;
          this.width = 26;
          this.height = 22;
          this.value = 500;
          break;
        case 1299:
          this.width = 14;
          this.height = 28;
          this.rare = 4;
          this.value = 150000;
          break;
        case 1300:
          this.width = 14;
          this.height = 28;
          this.rare = 4;
          this.value = 150000;
          this.accessory = true;
          break;
        case 1301:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.value = 300000;
          this.rare = 7;
          break;
        case 1302:
          this.shootSpeed = 4f;
          this.shoot = 242;
          this.damage = 10;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 4f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1303:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.value = Item.sellPrice(gold: 1);
          this.rare = 2;
          this.neckSlot = (sbyte) 1;
          break;
        case 1304:
          this.useStyle = 1;
          this.useTurn = false;
          this.useAnimation = 23;
          this.useTime = 23;
          this.width = 24;
          this.height = 28;
          this.damage = 12;
          this.knockBack = 4.25f;
          this.UseSound = SoundID.Item1;
          this.scale = 1f;
          this.value = 2000;
          this.melee = true;
          break;
        case 1305:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 23;
          this.knockBack = 7.25f;
          this.useTime = 7;
          this.width = 24;
          this.height = 28;
          this.damage = 72;
          this.axe = 35;
          this.hammer = 100;
          this.tileBoost = 1;
          this.scale = 1.15f;
          this.rare = 8;
          this.value = Item.sellPrice(gold: 10);
          this.melee = true;
          break;
        case 1306:
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 25;
          this.knockBack = 5.5f;
          this.width = 24;
          this.height = 28;
          this.damage = 42;
          this.scale = 1.15f;
          this.UseSound = SoundID.Item1;
          this.rare = 5;
          this.shoot = 263;
          this.shootSpeed = 8f;
          this.value = 250000;
          this.melee = true;
          break;
        case 1307:
          this.accessory = true;
          this.width = 14;
          this.height = 26;
          this.value = 1000;
          this.rare = 1;
          break;
        case 1308:
          this.mana = 22;
          this.UseSound = SoundID.Item43;
          this.useStyle = 5;
          this.damage = 43;
          this.useAnimation = 36;
          this.useTime = 36;
          this.width = 40;
          this.height = 40;
          this.shoot = 265;
          this.shootSpeed = 13.5f;
          this.knockBack = 5.6f;
          this.magic = true;
          this.autoReuse = true;
          this.rare = 6;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 4);
          break;
        case 1309:
          this.mana = 10;
          this.damage = 8;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 266;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item44;
          this.useAnimation = 28;
          this.useTime = 28;
          this.rare = 4;
          this.noMelee = true;
          this.knockBack = 2f;
          this.buffType = 64;
          this.value = 100000;
          this.summon = true;
          break;
        case 1310:
          this.shoot = 267;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.ammo = AmmoID.Dart;
          this.damage = 10;
          this.knockBack = 2f;
          this.shootSpeed = 2f;
          this.ranged = true;
          this.rare = 2;
          this.consumable = true;
          break;
        case 1311:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 268;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 6;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 3);
          this.buffType = 65;
          break;
        case 1312:
          this.damage = 0;
          this.useStyle = 1;
          this.shoot = 269;
          this.width = 16;
          this.height = 30;
          this.UseSound = SoundID.Item2;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 6;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 2, silver: 50);
          this.buffType = 66;
          break;
        case 1313:
          this.autoReuse = true;
          this.rare = 2;
          this.mana = 18;
          this.UseSound = SoundID.Item8;
          this.noMelee = true;
          this.useStyle = 5;
          this.damage = 29;
          this.useAnimation = 26;
          this.useTime = 26;
          this.width = 24;
          this.height = 28;
          this.shoot = 837;
          this.scale = 0.9f;
          this.shootSpeed = 3.5f;
          this.knockBack = 3.5f;
          this.magic = true;
          this.value = Item.sellPrice(gold: 1, silver: 50);
          break;
        case 1314:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 28;
          this.useTime = 28;
          this.knockBack = 6.5f;
          this.width = 30;
          this.height = 10;
          this.damage = 40;
          this.scale = 0.9f;
          this.shoot = 271;
          this.shootSpeed = 15f;
          this.UseSound = SoundID.Item10;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 3, silver: 50);
          this.melee = true;
          this.noMelee = true;
          break;
        case 1315:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          break;
        case 1316:
          this.width = 18;
          this.height = 18;
          this.defense = 21;
          this.headSlot = 99;
          this.rare = 8;
          this.value = 300000;
          break;
        case 1317:
          this.width = 18;
          this.height = 18;
          this.defense = 27;
          this.bodySlot = 65;
          this.rare = 8;
          this.value = 240000;
          break;
        case 1318:
          this.width = 18;
          this.height = 18;
          this.defense = 17;
          this.legSlot = 54;
          this.rare = 8;
          this.value = 180000;
          break;
        case 1319:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 19;
          this.useTime = 19;
          this.width = 44;
          this.height = 14;
          this.shoot = 166;
          this.useAmmo = AmmoID.Bullet;
          this.UseSound = SoundID.Item11;
          this.damage = 10;
          this.shootSpeed = 11f;
          this.noMelee = true;
          this.value = 100000;
          this.knockBack = 1f;
          this.rare = 1;
          this.ranged = true;
          this.useAmmo = AmmoID.Snowball;
          this.shoot = 166;
          break;
        case 1320:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 19;
          this.useTime = 11;
          this.autoReuse = true;
          this.width = 24;
          this.height = 28;
          this.damage = 8;
          this.pick = 55;
          this.UseSound = SoundID.Item1;
          this.knockBack = 3f;
          this.rare = 1;
          this.value = Item.buyPrice(gold: 1, silver: 50);
          this.scale = 1.15f;
          this.melee = true;
          break;
        case 1321:
          this.width = 24;
          this.height = 28;
          this.accessory = true;
          this.value = Item.sellPrice(gold: 5);
          this.rare = 4;
          this.backSlot = (sbyte) 7;
          break;
        case 1322:
          this.width = 24;
          this.height = 28;
          this.accessory = true;
          this.value = Item.sellPrice(gold: 2);
          this.rare = 3;
          break;
        case 1323:
          this.width = 24;
          this.height = 28;
          this.accessory = true;
          this.value = Item.sellPrice(gold: 2);
          this.rare = 3;
          this.faceSlot = (sbyte) 6;
          break;
        case 1324:
          this.autoReuse = true;
          this.noMelee = true;
          this.useStyle = 1;
          this.shootSpeed = 14f;
          this.shoot = 272;
          this.damage = 55;
          this.knockBack = 6.5f;
          this.width = 14;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 14;
          this.useTime = 14;
          this.noUseGraphic = true;
          this.rare = 5;
          this.value = 75000;
          this.melee = true;
          this.maxStack = 10;
          break;
        case 1325:
          this.autoReuse = false;
          this.useStyle = 5;
          this.useAnimation = 20;
          this.useTime = 20;
          this.knockBack = 3.5f;
          this.width = 30;
          this.height = 10;
          this.damage = 12;
          this.shoot = 273;
          this.shootSpeed = 12f;
          this.UseSound = SoundID.Item1;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 25);
          this.melee = true;
          this.noUseGraphic = true;
          break;
        case 1326:
          this.autoReuse = false;
          this.useStyle = 1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.width = 20;
          this.height = 20;
          this.UseSound = SoundID.Item8;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 10);
          break;
        case 1327:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useAnimation = 25;
          this.useTime = 25;
          this.knockBack = 7f;
          this.width = 24;
          this.height = 28;
          this.damage = 57;
          this.scale = 1.15f;
          this.UseSound = SoundID.Item71;
          this.rare = 6;
          this.shoot = 274;
          this.shootSpeed = 9f;
          this.value = this.eclipsePrice;
          this.melee = true;
          break;
        case 1328:
          this.width = 14;
          this.height = 18;
          this.maxStack = 99;
          this.rare = 7;
          this.value = 5000;
          break;
        case 1329:
          this.width = 14;
          this.height = 18;
          this.maxStack = 999;
          this.rare = 1;
          this.value = 750;
          break;
        case 1330:
          this.width = 18;
          this.height = 20;
          this.maxStack = 99;
          this.value = 12;
          break;
        case 1331:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          this.rare = 1;
          break;
        case 1332:
          this.width = 12;
          this.height = 14;
          this.maxStack = 99;
          this.value = 4500;
          this.rare = 3;
          break;
        case 1333:
          this.flame = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.holdStyle = 1;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 4;
          this.placeStyle = 11;
          this.width = 10;
          this.height = 12;
          this.value = 160;
          this.rare = 1;
          break;
        case 1334:
          this.shootSpeed = 4.25f;
          this.shoot = 278;
          this.damage = 16;
          this.width = 10;
          this.height = 28;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Arrow;
          this.knockBack = 3f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1335:
          this.shootSpeed = 5.25f;
          this.shoot = 279;
          this.damage = 13;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 4f;
          this.value = 30;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1336:
          this.mana = 7;
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 18;
          this.useTime = 6;
          this.knockBack = 4f;
          this.width = 38;
          this.height = 10;
          this.damage = 21;
          this.shoot = 280;
          this.shootSpeed = 10f;
          this.UseSound = SoundID.Item13;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 4);
          this.magic = true;
          this.noMelee = true;
          break;
        case 1337:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 209;
          this.placeStyle = 1;
          this.width = 12;
          this.height = 12;
          this.value = Item.buyPrice(gold: 50);
          break;
        case 1338:
          this.noUseGraphic = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 20;
          this.useTime = 20;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.damage = 350;
          this.noMelee = true;
          this.value = Item.buyPrice(silver: 35);
          this.makeNPC = (short) 614;
          break;
        case 1339:
          this.width = 12;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.buyPrice(silver: 15);
          break;
        case 1340:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 71;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1341:
          this.shootSpeed = 4.3f;
          this.shoot = 282;
          this.damage = 19;
          this.width = 10;
          this.height = 28;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Arrow;
          this.knockBack = 4.2f;
          this.value = 90;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1342:
          this.shootSpeed = 5.3f;
          this.shoot = 283;
          this.damage = 15;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 4.1f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1343:
          this.width = 16;
          this.height = 24;
          this.accessory = true;
          this.rare = 7;
          this.value = 300000;
          this.handOffSlot = (sbyte) 1;
          this.handOnSlot = (sbyte) 6;
          break;
        case 1344:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 272;
          this.width = 12;
          this.height = 12;
          this.value = Item.buyPrice(silver: 7);
          break;
        case 1345:
          this.width = 12;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.buyPrice(silver: 2);
          this.noMelee = true;
          this.useStyle = 1;
          this.useAnimation = this.useTime = 20;
          this.autoReuse = true;
          this.consumable = true;
          break;
        case 1346:
          this.width = 12;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.buyPrice(silver: 15);
          break;
        case 1347:
          this.width = 12;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.buyPrice(silver: 12);
          break;
        case 1348:
          this.width = 12;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.buyPrice(silver: 17);
          break;
        case 1349:
          this.shootSpeed = 5.1f;
          this.shoot = 284;
          this.damage = 10;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 5f;
          this.value = 10;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1350:
          this.shootSpeed = 4.6f;
          this.shoot = 285;
          this.damage = 15;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 3.6f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1351:
          this.shootSpeed = 4.7f;
          this.shoot = 286;
          this.damage = 10;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 6.6f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1352:
          this.shootSpeed = 4.6f;
          this.shoot = 287;
          this.damage = 10;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 3.6f;
          this.value = 40;
          this.ranged = true;
          this.rare = 3;
          break;
        case 1353:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 73;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1354:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 74;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1355:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 75;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1356:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 76;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1357:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 77;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1358:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 78;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 3);
          this.rare = 4;
          break;
        case 1359:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 79;
          this.buffTime = 72000;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 4;
          break;
        case 1360:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 0;
          this.rare = 1;
          break;
        case 1361:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 1;
          this.rare = 1;
          break;
        case 1362:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 2;
          this.rare = 1;
          break;
        case 1363:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 3;
          this.rare = 1;
          break;
        case 1364:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 4;
          this.rare = 1;
          break;
        case 1365:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 5;
          this.rare = 1;
          break;
        case 1366:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 6;
          this.rare = 1;
          break;
        case 1367:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 7;
          this.rare = 1;
          break;
        case 1368:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 8;
          this.rare = 1;
          break;
        case 1369:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 9;
          this.rare = 1;
          break;
        case 1370:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 10;
          this.rare = 1;
          break;
        case 1371:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.placeStyle = 11;
          this.rare = 1;
          break;
        case 1372:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 12;
          break;
        case 1373:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 13;
          break;
        case 1374:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 14;
          break;
        case 1375:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 15;
          break;
        case 1376:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.placeStyle = 16;
          break;
        case 1377:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.placeStyle = 17;
          break;
        case 1378:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 100;
          this.width = 12;
          this.height = 12;
          break;
        case 1379:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 101;
          this.width = 12;
          this.height = 12;
          break;
        case 1380:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 102;
          this.width = 12;
          this.height = 12;
          break;
        case 1381:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 103;
          this.width = 12;
          this.height = 12;
          break;
        case 1382:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 104;
          this.width = 12;
          this.height = 12;
          break;
        case 1383:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 105;
          this.width = 12;
          this.height = 12;
          break;
        case 1384:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 6;
          this.width = 8;
          this.height = 10;
          break;
        case 1385:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 7;
          this.width = 8;
          this.height = 10;
          break;
        case 1386:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 8;
          this.width = 8;
          this.height = 10;
          break;
        case 1387:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 9;
          this.width = 8;
          this.height = 10;
          break;
        case 1388:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 10;
          this.width = 8;
          this.height = 10;
          break;
        case 1389:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 11;
          this.width = 8;
          this.height = 10;
          break;
        case 1390:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 1;
          break;
        case 1391:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 2;
          break;
        case 1392:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 3;
          break;
        case 1393:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 4;
          break;
        case 1394:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 5;
          break;
        case 1395:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(copper: 30);
          this.placeStyle = 6;
          break;
        case 1396:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 15;
          this.placeStyle = 13;
          this.width = 12;
          this.height = 30;
          this.value = 150;
          break;
        case 1397:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 14;
          this.placeStyle = 10;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1398:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 18;
          this.placeStyle = 11;
          this.width = 28;
          this.height = 14;
          this.value = 150;
          break;
        case 1399:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 15;
          this.placeStyle = 14;
          this.width = 12;
          this.height = 30;
          this.value = 150;
          break;
        case 1400:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 14;
          this.placeStyle = 11;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1401:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 18;
          this.placeStyle = 12;
          this.width = 28;
          this.height = 14;
          this.value = 150;
          break;
        case 1402:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 15;
          this.placeStyle = 15;
          this.width = 12;
          this.height = 30;
          this.value = 150;
          break;
        case 1403:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 14;
          this.placeStyle = 12;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1404:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 18;
          this.placeStyle = 13;
          this.width = 28;
          this.height = 14;
          this.value = 150;
          break;
        case 1405:
          this.noWet = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 33;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.placeStyle = 1;
          break;
        case 1406:
          this.noWet = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 33;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.placeStyle = 2;
          break;
        case 1407:
          this.noWet = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 33;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.placeStyle = 3;
          break;
        case 1408:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 46;
          break;
        case 1409:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 47;
          break;
        case 1410:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 48;
          break;
        case 1411:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 16;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1412:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 17;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1413:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 18;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1414:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 101;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 1;
          break;
        case 1415:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 101;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 2;
          break;
        case 1416:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 101;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 3;
          break;
        case 1417:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 241;
          this.placeStyle = 0;
          this.width = 30;
          this.height = 30;
          break;
        case 1418:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 12;
          this.width = 8;
          this.height = 10;
          break;
        case 1419:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 18;
          break;
        case 1420:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 19;
          break;
        case 1421:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 0;
          break;
        case 1422:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 1;
          break;
        case 1423:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 2;
          break;
        case 1424:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 3;
          break;
        case 1425:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 4;
          break;
        case 1426:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 5;
          break;
        case 1427:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 20;
          break;
        case 1428:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 21;
          break;
        case 1429:
          this.width = 18;
          this.height = 18;
          this.headSlot = 100;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 1);
          break;
        case 1430:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 243;
          this.width = 26;
          this.height = 20;
          this.value = Item.buyPrice(gold: 7);
          this.rare = 2;
          break;
        case 1431:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 42;
          this.width = 12;
          this.height = 28;
          this.value = Item.sellPrice(silver: 5);
          this.placeStyle = 7;
          break;
        case 1432:
          this.width = 12;
          this.height = 20;
          this.maxStack = 999;
          this.value = Item.buyPrice(copper: 5);
          break;
        case 1433:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 6;
          break;
        case 1434:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 7;
          break;
        case 1435:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 8;
          break;
        case 1436:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 9;
          break;
        case 1437:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 10;
          break;
        case 1438:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 11;
          break;
        case 1439:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 12;
          break;
        case 1440:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 22;
          break;
        case 1441:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 23;
          break;
        case 1442:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 24;
          break;
        case 1443:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 25;
          break;
        case 1444:
          this.mana = 7;
          this.UseSound = SoundID.Item72;
          this.useStyle = 5;
          this.damage = 53;
          this.useAnimation = 16;
          this.useTime = 16;
          this.autoReuse = true;
          this.width = 40;
          this.height = 40;
          this.shoot = 294;
          this.shootSpeed = 6f;
          this.knockBack = 3.25f;
          this.value = Item.sellPrice(gold: 6);
          this.magic = true;
          this.rare = 8;
          this.noMelee = true;
          break;
        case 1445:
          this.mana = 18;
          this.UseSound = SoundID.Item73;
          this.useStyle = 5;
          this.damage = 65;
          this.useAnimation = 30;
          this.useTime = 30;
          this.width = 40;
          this.height = 40;
          this.shoot = 295;
          this.shootSpeed = 8f;
          this.knockBack = 8f;
          this.value = Item.sellPrice(gold: 6);
          this.magic = true;
          this.noMelee = true;
          this.rare = 8;
          break;
        case 1446:
          this.mana = 15;
          this.UseSound = SoundID.Item43;
          this.useStyle = 5;
          this.damage = 65;
          this.autoReuse = true;
          this.useAnimation = 24;
          this.useTime = 24;
          this.width = 40;
          this.height = 40;
          this.shoot = 297;
          this.shootSpeed = 6f;
          this.knockBack = 6f;
          this.value = Item.sellPrice(gold: 6);
          this.magic = true;
          this.noMelee = true;
          this.rare = 8;
          break;
        case 1447:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 106;
          this.width = 12;
          this.height = 12;
          break;
        case 1448:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 107;
          this.width = 12;
          this.height = 12;
          break;
        case 1449:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 244;
          this.width = 26;
          this.height = 20;
          this.value = Item.buyPrice(gold: 4);
          this.rare = 1;
          break;
        case 1450:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = false;
          this.useAnimation = 25;
          this.useTime = 25;
          this.width = 24;
          this.height = 28;
          this.scale = 1f;
          this.value = Item.buyPrice(gold: 5);
          this.noMelee = true;
          this.rare = 1;
          break;
        case 1451:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 10;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1452:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 11;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1453:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 12;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1454:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 13;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1455:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 14;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1456:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 15;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1457:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 19;
          this.placeStyle = 13;
          this.width = 8;
          this.height = 10;
          break;
        case 1458:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 10;
          this.placeStyle = 19;
          this.width = 14;
          this.height = 28;
          this.value = 200;
          break;
        case 1459:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 15;
          this.placeStyle = 16;
          this.width = 12;
          this.height = 30;
          this.value = 150;
          break;
        case 1460:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 14;
          this.placeStyle = 13;
          this.width = 26;
          this.height = 20;
          this.value = 300;
          break;
        case 1461:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 18;
          this.placeStyle = 14;
          this.width = 28;
          this.height = 14;
          this.value = 150;
          break;
        case 1462:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 105;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 49;
          break;
        case 1463:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 101;
          this.width = 20;
          this.height = 20;
          this.value = 300;
          this.placeStyle = 4;
          break;
        case 1464:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 16;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1465:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 17;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1466:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 18;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1467:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 19;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1468:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 20;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1469:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 21;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          break;
        case 1470:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 79;
          this.placeStyle = 5;
          this.width = 28;
          this.height = 20;
          this.value = 2000;
          break;
        case 1471:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 79;
          this.placeStyle = 6;
          this.width = 28;
          this.height = 20;
          this.value = 2000;
          break;
        case 1472:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 79;
          this.placeStyle = 7;
          this.width = 28;
          this.height = 20;
          this.value = 2000;
          break;
        case 1473:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 79;
          this.placeStyle = 8;
          this.width = 28;
          this.height = 20;
          this.value = 2000;
          break;
        default:
          if (type >= 1474 && type <= 1478)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 245;
            this.width = 30;
            this.height = 30;
            this.value = Item.sellPrice(silver: 10);
            this.placeStyle = type - 1474;
            break;
          }
          if (type >= 1479 && type <= 1494)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 246;
            this.width = 30;
            this.height = 30;
            this.value = type < 1481 || type > 1494 ? Item.sellPrice(silver: 10) : Item.buyPrice(gold: 1);
            this.placeStyle = type - 1479;
            break;
          }
          if (type == 1495)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 245;
            this.width = 30;
            this.height = 30;
            this.value = Item.sellPrice(silver: 10);
            this.placeStyle = 5;
            break;
          }
          if (type >= 1496 && type <= 1499)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 240;
            this.width = 30;
            this.height = 30;
            this.value = Item.sellPrice(silver: 10);
            this.placeStyle = 26 + type - 1496;
            break;
          }
          if (type >= 1500 && type <= 1502)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.autoReuse = true;
            this.maxStack = 99;
            this.consumable = true;
            this.createTile = 242;
            this.width = 30;
            this.height = 30;
            this.value = Item.sellPrice(silver: 10);
            this.placeStyle = 13 + type - 1500;
            break;
          }
          switch (type)
          {
            case 1503:
              this.width = 18;
              this.height = 18;
              this.defense = 6;
              this.headSlot = 101;
              this.rare = 8;
              this.value = 375000;
              return;
            case 1504:
              this.width = 18;
              this.height = 18;
              this.defense = 14;
              this.bodySlot = 66;
              this.rare = 8;
              this.value = 300000;
              return;
            case 1505:
              this.width = 18;
              this.height = 18;
              this.defense = 10;
              this.legSlot = 55;
              this.rare = 8;
              this.value = 225000;
              return;
            case 1506:
              this.useStyle = 1;
              this.useAnimation = 24;
              this.useTime = 10;
              this.knockBack = 5.25f;
              this.useTurn = true;
              this.autoReuse = true;
              this.width = 20;
              this.height = 12;
              this.damage = 32;
              this.pick = 200;
              this.UseSound = SoundID.Item1;
              this.rare = 8;
              this.value = 216000;
              this.melee = true;
              this.scale = 1.15f;
              this.tileBoost += 3;
              return;
            case 1507:
              this.useTurn = true;
              this.autoReuse = true;
              this.useStyle = 1;
              this.useAnimation = 28;
              this.useTime = 8;
              this.knockBack = 7f;
              this.width = 20;
              this.height = 12;
              this.damage = 60;
              this.axe = 30;
              this.hammer = 90;
              this.UseSound = SoundID.Item1;
              this.rare = 8;
              this.value = 216000;
              this.melee = true;
              this.scale = 1.05f;
              this.tileBoost += 3;
              return;
            case 1508:
              this.maxStack = 99;
              this.width = 16;
              this.height = 14;
              this.value = Item.sellPrice(silver: 50);
              this.rare = 8;
              return;
            case 1509:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 15;
              this.placeStyle = 17;
              this.width = 12;
              this.height = 30;
              this.value = 150;
              return;
            case 1510:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 14;
              this.placeStyle = 14;
              this.width = 26;
              this.height = 20;
              this.value = 300;
              return;
            case 1511:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 18;
              this.placeStyle = 15;
              this.width = 28;
              this.height = 14;
              this.value = 150;
              return;
            case 1512:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 5;
              return;
            case 1513:
              this.noMelee = true;
              this.useStyle = 1;
              this.shootSpeed = 14f;
              this.shoot = 301;
              this.damage = 90;
              this.knockBack = 9f;
              this.width = 14;
              this.height = 28;
              this.UseSound = SoundID.Item1;
              this.useAnimation = 15;
              this.useTime = 15;
              this.noUseGraphic = true;
              this.rare = 8;
              this.value = Item.sellPrice(gold: 10);
              this.melee = true;
              return;
            case 1514:
              this.width = 18;
              this.height = 18;
              this.headSlot = 102;
              this.rare = 1;
              this.value = Item.sellPrice(gold: 1);
              this.vanity = true;
              return;
            case 1515:
              this.width = 24;
              this.height = 8;
              this.accessory = true;
              this.value = 400000;
              this.rare = 5;
              this.wingSlot = (sbyte) 15;
              return;
            default:
              if (type >= 1516 && type <= 1521)
              {
                this.maxStack = 99;
                this.width = 16;
                this.height = 14;
                this.value = Item.sellPrice(gold: 2, silver: 50);
                this.rare = 5;
                return;
              }
              if (type >= 1522 && type <= 1527)
              {
                this.width = 20;
                this.height = 20;
                this.rare = 1;
                return;
              }
              if (type >= 1528 && type <= 1532)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 21;
                this.placeStyle = 18 + type - 1528;
                this.width = 26;
                this.height = 22;
                this.value = 2500;
                return;
              }
              if (type >= 1533 && type <= 1537)
              {
                this.width = 14;
                this.height = 20;
                this.maxStack = 99;
                this.rare = 8;
                return;
              }
              if (type >= 1538 && type <= 1540)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 240;
                this.width = 30;
                this.height = 30;
                this.value = Item.sellPrice(silver: 10);
                this.placeStyle = 30 + type - 1538;
                return;
              }
              if (type >= 1541 && type <= 1542)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 246;
                this.width = 30;
                this.height = 30;
                this.value = Item.sellPrice(silver: 10);
                this.placeStyle = 16 + type - 1541;
                return;
              }
              if (type >= 1543 && type <= 1545)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.width = 24;
                this.height = 24;
                this.value = Item.sellPrice(gold: 6);
                this.tileBoost += 3;
                return;
              }
              switch (type)
              {
                case 1546:
                  this.width = 18;
                  this.height = 18;
                  this.defense = 11;
                  this.headSlot = 103;
                  this.rare = 8;
                  this.value = 375000;
                  return;
                case 1547:
                  this.width = 18;
                  this.height = 18;
                  this.defense = 11;
                  this.headSlot = 104;
                  this.rare = 8;
                  this.value = 375000;
                  return;
                case 1548:
                  this.width = 18;
                  this.height = 18;
                  this.defense = 11;
                  this.headSlot = 105;
                  this.rare = 8;
                  this.value = 375000;
                  return;
                case 1549:
                  this.width = 18;
                  this.height = 18;
                  this.defense = 24;
                  this.bodySlot = 67;
                  this.rare = 8;
                  this.value = 300000;
                  return;
                case 1550:
                  this.width = 18;
                  this.height = 18;
                  this.defense = 16;
                  this.legSlot = 56;
                  this.rare = 8;
                  this.value = 225000;
                  return;
                case 1551:
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.maxStack = 99;
                  this.consumable = true;
                  this.createTile = 247;
                  this.width = 26;
                  this.height = 24;
                  this.value = Item.buyPrice(1);
                  return;
                case 1552:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 999;
                  this.rare = 7;
                  this.value = Item.sellPrice(gold: 1);
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.consumable = true;
                  this.createTile = 239;
                  this.placeStyle = 20;
                  return;
                case 1553:
                  this.useStyle = 5;
                  this.autoReuse = true;
                  this.useAnimation = 5;
                  this.useTime = 5;
                  this.crit += 10;
                  this.width = 60;
                  this.height = 26;
                  this.shoot = 10;
                  this.useAmmo = AmmoID.Bullet;
                  this.UseSound = SoundID.Item40;
                  this.damage = 85;
                  this.shootSpeed = 12f;
                  this.noMelee = true;
                  this.value = 750000;
                  this.rare = 10;
                  this.knockBack = 2.5f;
                  this.ranged = true;
                  return;
                case 1554:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.headSlot = 106;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1555:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.bodySlot = 68;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1556:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.legSlot = 57;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1557:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.headSlot = 107;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1558:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.bodySlot = 69;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1559:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.legSlot = 58;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1560:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.headSlot = 108;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1561:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.bodySlot = 70;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1562:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.legSlot = 59;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1563:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.headSlot = 109;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1564:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.bodySlot = 71;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1565:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.legSlot = 60;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1566:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.headSlot = 110;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1567:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.bodySlot = 72;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1568:
                  this.width = 18;
                  this.height = 18;
                  this.rare = 9;
                  this.vanity = true;
                  this.legSlot = 61;
                  this.value = Item.sellPrice(gold: 5);
                  return;
                case 1569:
                  this.autoReuse = true;
                  this.useStyle = 1;
                  this.shootSpeed = 15f;
                  this.shoot = 304;
                  this.damage = 29;
                  this.width = 18;
                  this.height = 20;
                  this.UseSound = SoundID.Item39;
                  this.useAnimation = 16;
                  this.useTime = 16;
                  this.noUseGraphic = true;
                  this.noMelee = true;
                  this.value = Item.sellPrice(gold: 20);
                  this.knockBack = 2.75f;
                  this.melee = true;
                  this.rare = 8;
                  return;
                case 1570:
                  this.width = 14;
                  this.height = 18;
                  this.maxStack = 99;
                  this.rare = 8;
                  this.value = this.eclipsePrice;
                  return;
                case 1571:
                  this.autoReuse = true;
                  this.useStyle = 5;
                  this.shootSpeed = 14f;
                  this.shoot = 306;
                  this.damage = 64;
                  this.width = 18;
                  this.height = 20;
                  this.UseSound = SoundID.Item39;
                  this.useAnimation = 20;
                  this.useTime = 20;
                  this.noUseGraphic = true;
                  this.noMelee = true;
                  this.value = Item.sellPrice(gold: 20);
                  this.knockBack = 5f;
                  this.melee = true;
                  this.rare = 8;
                  return;
                case 1572:
                  this.useStyle = 1;
                  this.shootSpeed = 14f;
                  this.shoot = 308;
                  this.damage = 100;
                  this.width = 18;
                  this.height = 20;
                  this.UseSound = SoundID.Item1;
                  this.useAnimation = 30;
                  this.useTime = 30;
                  this.noMelee = true;
                  this.value = Item.sellPrice(gold: 20);
                  this.knockBack = 7.5f;
                  this.rare = 8;
                  this.summon = true;
                  this.mana = 20;
                  this.sentry = true;
                  return;
                case 1573:
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.maxStack = 99;
                  this.consumable = true;
                  this.createTile = 242;
                  this.width = 30;
                  this.height = 30;
                  this.value = Item.sellPrice(silver: 10);
                  this.placeStyle = 16;
                  return;
                default:
                  if (type >= 1574 && type <= 1576)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 240;
                    this.width = 30;
                    this.height = 30;
                    this.value = Item.sellPrice(silver: 10);
                    this.placeStyle = 33 + type - 1574;
                    return;
                  }
                  switch (type)
                  {
                    case 1577:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 99;
                      this.consumable = true;
                      this.createTile = 245;
                      this.width = 30;
                      this.height = 30;
                      this.value = Item.sellPrice(silver: 10);
                      this.placeStyle = 6;
                      return;
                    case 1578:
                      this.width = 22;
                      this.height = 22;
                      this.accessory = true;
                      this.rare = 3;
                      this.value = 100000;
                      this.neckSlot = (sbyte) 6;
                      return;
                    case 1579:
                      this.width = 28;
                      this.height = 24;
                      this.accessory = true;
                      this.rare = 1;
                      this.value = 50000;
                      this.shoeSlot = (sbyte) 5;
                      return;
                    case 1580:
                      this.width = 18;
                      this.height = 18;
                      this.rare = 9;
                      this.vanity = true;
                      this.headSlot = 111;
                      this.value = Item.sellPrice(gold: 5);
                      return;
                    case 1581:
                      this.width = 18;
                      this.height = 18;
                      this.rare = 9;
                      this.vanity = true;
                      this.bodySlot = 73;
                      this.value = Item.sellPrice(gold: 5);
                      return;
                    case 1582:
                      this.width = 18;
                      this.height = 18;
                      this.rare = 9;
                      this.vanity = true;
                      this.legSlot = 62;
                      this.value = Item.sellPrice(gold: 5);
                      return;
                    case 1583:
                      this.width = 24;
                      this.height = 8;
                      this.accessory = true;
                      this.rare = 9;
                      this.wingSlot = (sbyte) 16;
                      this.value = 400000;
                      return;
                    case 1584:
                      this.width = 24;
                      this.height = 8;
                      this.accessory = true;
                      this.rare = 9;
                      this.wingSlot = (sbyte) 17;
                      this.value = 400000;
                      return;
                    case 1585:
                      this.width = 24;
                      this.height = 8;
                      this.accessory = true;
                      this.rare = 9;
                      this.wingSlot = (sbyte) 18;
                      this.value = 400000;
                      return;
                    case 1586:
                      this.width = 24;
                      this.height = 8;
                      this.accessory = true;
                      this.rare = 9;
                      this.wingSlot = (sbyte) 19;
                      this.value = 400000;
                      return;
                    case 1587:
                      this.width = 18;
                      this.height = 18;
                      this.rare = 9;
                      this.vanity = true;
                      this.bodySlot = 74;
                      this.value = Item.sellPrice(gold: 5);
                      return;
                    case 1588:
                      this.width = 18;
                      this.height = 18;
                      this.rare = 9;
                      this.vanity = true;
                      this.legSlot = 63;
                      this.value = Item.sellPrice(gold: 5);
                      return;
                    case 1589:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createTile = 248;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1590:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 7;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createWall = 109;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1591:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createTile = 249;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1592:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 7;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createWall = 110;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1593:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createTile = 250;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1594:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 7;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createWall = 111;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 1595:
                      this.width = 22;
                      this.height = 22;
                      this.accessory = true;
                      this.rare = 2;
                      this.value = 100000;
                      this.handOffSlot = (sbyte) 3;
                      this.handOnSlot = (sbyte) 8;
                      return;
                    default:
                      if (type >= 1596 && type <= 1610)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.consumable = true;
                        this.createTile = 139;
                        this.placeStyle = type - 1596 + 13;
                        this.width = 24;
                        this.height = 24;
                        this.rare = 4;
                        this.value = 100000;
                        this.accessory = true;
                        this.canBePlacedInVanityRegardlessOfConditions = true;
                        return;
                      }
                      switch (type)
                      {
                        case 1611:
                          this.maxStack = 99;
                          this.width = 16;
                          this.height = 14;
                          this.value = Item.sellPrice(gold: 2, silver: 50);
                          this.rare = 5;
                          return;
                        case 1612:
                          this.width = 16;
                          this.height = 24;
                          this.accessory = true;
                          this.rare = 6;
                          this.value = Item.sellPrice(gold: 3);
                          return;
                        case 1613:
                          this.width = 24;
                          this.height = 28;
                          this.rare = 7;
                          this.value = Item.sellPrice(gold: 5);
                          this.accessory = true;
                          this.defense = 4;
                          this.shieldSlot = (sbyte) 4;
                          return;
                        case 1614:
                          this.shootSpeed = 6f;
                          this.shoot = 310;
                          this.damage = 1;
                          this.width = 12;
                          this.height = 12;
                          this.maxStack = 999;
                          this.consumable = true;
                          this.ammo = AmmoID.Flare;
                          this.knockBack = 1.5f;
                          this.value = 7;
                          this.ranged = true;
                          return;
                        default:
                          if (type >= 1615 && type <= 1701)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 91;
                            this.placeStyle = 22 + type - 1615;
                            this.width = 10;
                            this.height = 24;
                            this.value = 1000;
                            this.rare = 1;
                            return;
                          }
                          if (type == 1702)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 999;
                            this.consumable = true;
                            this.createTile = 19;
                            this.placeStyle = 14;
                            this.width = 8;
                            this.height = 10;
                            return;
                          }
                          if (type >= 1703 && type <= 1708)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 15;
                            this.placeStyle = 18 + type - 1703;
                            this.width = 12;
                            this.height = 30;
                            this.value = 150;
                            return;
                          }
                          if (type >= 1709 && type <= 1712)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 10;
                            this.placeStyle = 20 + type - 1709;
                            this.width = 14;
                            this.height = 28;
                            this.value = 200;
                            return;
                          }
                          if (type >= 1713 && type <= 1718)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 14;
                            this.placeStyle = 15 + type - 1713;
                            this.width = 26;
                            this.height = 20;
                            this.value = 300;
                            return;
                          }
                          if (type >= 1719 && type <= 1722)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 79;
                            this.placeStyle = 9 + type - 1719;
                            this.width = 28;
                            this.height = 20;
                            this.value = 2000;
                            return;
                          }
                          switch (type)
                          {
                            case 1723:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 78;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1724:
                              this.width = 16;
                              this.height = 24;
                              this.accessory = true;
                              this.rare = 2;
                              this.value = 50000;
                              this.waistSlot = (sbyte) 14;
                              return;
                            case 1725:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 251;
                              this.width = 8;
                              this.height = 10;
                              this.value = Item.sellPrice(copper: 25);
                              return;
                            case 1726:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 113;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1727:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 252;
                              this.width = 8;
                              this.height = 10;
                              return;
                            case 1728:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 114;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1729:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 253;
                              this.width = 8;
                              this.height = 10;
                              return;
                            case 1730:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 115;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1731:
                              this.width = 18;
                              this.height = 18;
                              this.defense = 2;
                              this.headSlot = 112;
                              return;
                            case 1732:
                              this.width = 18;
                              this.height = 18;
                              this.defense = 3;
                              this.bodySlot = 75;
                              return;
                            case 1733:
                              this.width = 18;
                              this.height = 18;
                              this.defense = 2;
                              this.legSlot = 64;
                              return;
                            case 1734:
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1735:
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 1736:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 113;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1737:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 76;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1738:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 65;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1739:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 114;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1740:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 115;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1741:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 77;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1742:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 116;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1743:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 117;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1744:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 78;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1745:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 66;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1746:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 118;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1747:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 79;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1748:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 67;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1749:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 119;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1750:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 80;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1751:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 68;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1752:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 120;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1753:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 81;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1754:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 121;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1755:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 82;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1756:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 69;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1757:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 122;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1758:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 83;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1759:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 70;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1760:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 123;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1761:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 84;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1762:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 71;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1763:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 124;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1764:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 85;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1765:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 72;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1766:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 125;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1767:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 126;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1768:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 86;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1769:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 73;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1770:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 87;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1771:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 74;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1772:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = (int) sbyte.MaxValue;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1773:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 88;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1774:
                              this.width = 12;
                              this.height = 12;
                              this.rare = 3;
                              this.maxStack = 99;
                              this.value = Item.sellPrice(gold: 1);
                              return;
                            case 1775:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 89;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1776:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 75;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1777:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 128;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1778:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 90;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1779:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 129;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1780:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 91;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1781:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 76;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1782:
                              this.useStyle = 5;
                              this.autoReuse = true;
                              this.useAnimation = 9;
                              this.useTime = 9;
                              this.crit += 6;
                              this.width = 60;
                              this.height = 26;
                              this.shoot = 311;
                              this.useAmmo = AmmoID.CandyCorn;
                              this.UseSound = SoundID.Item11;
                              this.damage = 44;
                              this.shootSpeed = 10f;
                              this.noMelee = true;
                              this.value = Item.sellPrice(gold: 10);
                              this.rare = 8;
                              this.knockBack = 2f;
                              this.ranged = true;
                              return;
                            case 1783:
                              this.shootSpeed = 4f;
                              this.shoot = 311;
                              this.damage = 9;
                              this.width = 8;
                              this.height = 8;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.ammo = AmmoID.CandyCorn;
                              this.knockBack = 1.5f;
                              this.value = 5;
                              this.ranged = true;
                              return;
                            case 1784:
                              this.useStyle = 5;
                              this.autoReuse = true;
                              this.useAnimation = 30;
                              this.useTime = 30;
                              this.crit += 6;
                              this.width = 60;
                              this.height = 26;
                              this.shoot = 312;
                              this.useAmmo = AmmoID.JackOLantern;
                              this.UseSound = SoundID.Item11;
                              this.damage = 65;
                              this.shootSpeed = 7f;
                              this.noMelee = true;
                              this.value = Item.sellPrice(gold: 10);
                              this.rare = 8;
                              this.knockBack = 5f;
                              this.ranged = true;
                              return;
                            case 1785:
                              this.shootSpeed = 4f;
                              this.shoot = 312;
                              this.damage = 30;
                              this.width = 8;
                              this.height = 8;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.ammo = AmmoID.JackOLantern;
                              this.knockBack = 3f;
                              this.value = 15;
                              this.ranged = true;
                              return;
                            case 1786:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 24;
                              this.autoReuse = true;
                              this.width = 24;
                              this.height = 28;
                              this.damage = 9;
                              this.UseSound = SoundID.Item1;
                              this.knockBack = 2.25f;
                              this.value = Item.buyPrice(silver: 60);
                              this.melee = true;
                              return;
                            case 1788:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 130;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1789:
                              this.width = 18;
                              this.height = 18;
                              this.bodySlot = 92;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1790:
                              this.width = 18;
                              this.height = 18;
                              this.legSlot = 77;
                              this.vanity = true;
                              this.value = Item.buyPrice(gold: 3);
                              return;
                            case 1791:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 96;
                              this.placeStyle = 1;
                              this.width = 20;
                              this.height = 20;
                              this.value = Item.buyPrice(gold: 1, silver: 50);
                              return;
                            case 1792:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 15;
                              this.placeStyle = 24;
                              this.width = 12;
                              this.height = 30;
                              this.value = 150;
                              return;
                            case 1793:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 10;
                              this.placeStyle = 24;
                              this.width = 14;
                              this.height = 28;
                              this.value = 200;
                              return;
                            case 1794:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 14;
                              this.placeStyle = 21;
                              this.width = 26;
                              this.height = 20;
                              this.value = 300;
                              return;
                            case 1795:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 18;
                              this.placeStyle = 16;
                              this.width = 28;
                              this.height = 14;
                              this.value = 150;
                              return;
                            case 1796:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 19;
                              this.placeStyle = 15;
                              this.width = 8;
                              this.height = 10;
                              return;
                            case 1797:
                              this.width = 24;
                              this.height = 8;
                              this.accessory = true;
                              this.rare = 7;
                              this.value = 400000;
                              this.wingSlot = (sbyte) 20;
                              return;
                            case 1798:
                              this.damage = 0;
                              this.useStyle = 1;
                              this.shoot = 313;
                              this.width = 16;
                              this.height = 30;
                              this.UseSound = SoundID.Item2;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.rare = 3;
                              this.noMelee = true;
                              this.buffType = 81;
                              this.value = Item.sellPrice(gold: 2);
                              return;
                            case 1799:
                              this.damage = 0;
                              this.useStyle = 1;
                              this.shoot = 314;
                              this.width = 16;
                              this.height = 30;
                              this.UseSound = SoundID.Item2;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.rare = 3;
                              this.noMelee = true;
                              this.buffType = 82;
                              this.value = Item.sellPrice(gold: 2);
                              return;
                            case 1800:
                              this.noUseGraphic = true;
                              this.damage = 0;
                              this.knockBack = 7f;
                              this.useStyle = 5;
                              this.shootSpeed = 13.5f;
                              this.shoot = 315;
                              this.width = 18;
                              this.height = 28;
                              this.UseSound = SoundID.Item1;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.rare = 3;
                              this.noMelee = true;
                              this.value = Item.sellPrice(gold: 1, silver: 50);
                              return;
                            case 1801:
                              this.useStyle = 5;
                              this.autoReuse = true;
                              this.useAnimation = 12;
                              this.useTime = 12;
                              this.mana = 6;
                              this.width = 50;
                              this.height = 18;
                              this.shoot = 316;
                              this.UseSound = SoundID.Item32;
                              this.damage = 45;
                              this.shootSpeed = 10f;
                              this.noMelee = true;
                              this.value = Item.sellPrice(gold: 10);
                              this.rare = 8;
                              this.magic = true;
                              this.knockBack = 3f;
                              return;
                            case 1802:
                              this.mana = 10;
                              this.damage = 55;
                              this.useStyle = 1;
                              this.shootSpeed = 10f;
                              this.shoot = 317;
                              this.width = 26;
                              this.height = 28;
                              this.UseSound = SoundID.Item44;
                              this.useAnimation = 28;
                              this.useTime = 28;
                              this.rare = 8;
                              this.noMelee = true;
                              this.knockBack = 3f;
                              this.buffType = 83;
                              this.value = Item.sellPrice(gold: 10);
                              this.summon = true;
                              return;
                            default:
                              if (type >= 1803 && type <= 1807)
                                return;
                              switch (type)
                              {
                                case 1808:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 42;
                                  this.width = 12;
                                  this.height = 28;
                                  this.placeStyle = 8;
                                  return;
                                case 1809:
                                  this.useStyle = 1;
                                  this.shootSpeed = 9f;
                                  this.shoot = 318;
                                  this.damage = 13;
                                  this.width = 18;
                                  this.height = 20;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 19;
                                  this.useTime = 19;
                                  this.noUseGraphic = true;
                                  this.noMelee = true;
                                  this.ranged = true;
                                  this.knockBack = 6.5f;
                                  return;
                                case 1810:
                                  this.damage = 0;
                                  this.useStyle = 1;
                                  this.shoot = 319;
                                  this.width = 16;
                                  this.height = 30;
                                  this.UseSound = SoundID.Item2;
                                  this.useAnimation = 20;
                                  this.useTime = 20;
                                  this.rare = 3;
                                  this.noMelee = true;
                                  this.buffType = 84;
                                  this.value = Item.sellPrice(gold: 2);
                                  return;
                                case 1811:
                                  this.maxStack = 99;
                                  this.width = 16;
                                  this.height = 14;
                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                  this.rare = 5;
                                  return;
                                case 1812:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 34;
                                  this.placeStyle = 6;
                                  this.width = 26;
                                  this.height = 26;
                                  return;
                                case 1813:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 35;
                                  this.width = 26;
                                  this.height = 26;
                                  return;
                                case 1814:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 15;
                                  this.placeStyle = 25;
                                  this.width = 12;
                                  this.height = 30;
                                  this.value = 150;
                                  return;
                                case 1815:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 10;
                                  this.placeStyle = 25;
                                  this.width = 14;
                                  this.height = 28;
                                  this.value = 200;
                                  return;
                                case 1816:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 14;
                                  this.placeStyle = 22;
                                  this.width = 26;
                                  this.height = 20;
                                  this.value = 300;
                                  return;
                                case 1817:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 18;
                                  this.placeStyle = 17;
                                  this.width = 28;
                                  this.height = 14;
                                  this.value = 150;
                                  return;
                                case 1818:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 19;
                                  this.placeStyle = 16;
                                  this.width = 8;
                                  this.height = 10;
                                  return;
                                case 1819:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 131;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1820:
                                  this.width = 18;
                                  this.height = 18;
                                  this.bodySlot = 93;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1821:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 132;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1822:
                                  this.width = 18;
                                  this.height = 18;
                                  this.bodySlot = 94;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1823:
                                  this.width = 18;
                                  this.height = 18;
                                  this.legSlot = 78;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1824:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 133;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 3);
                                  return;
                                case 1825:
                                  this.noMelee = true;
                                  this.useStyle = 1;
                                  this.shootSpeed = 15f;
                                  this.shoot = 320;
                                  this.damage = 15;
                                  this.knockBack = 5f;
                                  this.width = 34;
                                  this.height = 34;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 15;
                                  this.useTime = 15;
                                  this.noUseGraphic = true;
                                  this.rare = 2;
                                  this.value = 50000;
                                  this.melee = true;
                                  return;
                                case 1826:
                                  this.autoReuse = true;
                                  this.useStyle = 1;
                                  this.useAnimation = 26;
                                  this.knockBack = 7.5f;
                                  this.width = 40;
                                  this.height = 40;
                                  this.damage = 75;
                                  this.scale = 1.15f;
                                  this.UseSound = SoundID.Item1;
                                  this.rare = 8;
                                  this.value = Item.sellPrice(gold: 10);
                                  this.melee = true;
                                  return;
                                case 1827:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.autoReuse = true;
                                  this.useAnimation = 8;
                                  this.useTime = 8;
                                  this.width = 24;
                                  this.height = 28;
                                  this.damage = 12;
                                  this.knockBack = 4f;
                                  this.UseSound = SoundID.Item1;
                                  this.scale = 1.35f;
                                  this.melee = true;
                                  this.rare = 2;
                                  this.value = 50000;
                                  this.melee = true;
                                  return;
                                case 1828:
                                  this.autoReuse = true;
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 254;
                                  this.width = 8;
                                  this.height = 10;
                                  this.value = Item.buyPrice(silver: 2, copper: 50);
                                  return;
                                case 1829:
                                  this.noUseGraphic = true;
                                  this.damage = 0;
                                  this.knockBack = 7f;
                                  this.useStyle = 5;
                                  this.shootSpeed = 15.5f;
                                  this.shoot = 322;
                                  this.width = 18;
                                  this.height = 28;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 20;
                                  this.useTime = 20;
                                  this.rare = 7;
                                  this.noMelee = true;
                                  this.value = Item.sellPrice(gold: 4);
                                  return;
                                case 1830:
                                  this.width = 24;
                                  this.height = 8;
                                  this.accessory = true;
                                  this.rare = 7;
                                  this.value = 400000;
                                  this.wingSlot = (sbyte) 21;
                                  return;
                                case 1831:
                                  this.maxStack = 99;
                                  this.width = 16;
                                  this.height = 14;
                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                  this.rare = 5;
                                  return;
                                case 1832:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 134;
                                  this.value = Item.sellPrice(gold: 1);
                                  this.defense = 9;
                                  this.rare = 8;
                                  return;
                                case 1833:
                                  this.width = 18;
                                  this.height = 18;
                                  this.bodySlot = 95;
                                  this.value = Item.sellPrice(gold: 1);
                                  this.defense = 11;
                                  this.rare = 8;
                                  return;
                                case 1834:
                                  this.width = 18;
                                  this.height = 18;
                                  this.legSlot = 79;
                                  this.value = Item.sellPrice(gold: 1);
                                  this.defense = 10;
                                  this.rare = 8;
                                  return;
                                case 1835:
                                  this.useStyle = 5;
                                  this.autoReuse = true;
                                  this.useAnimation = 26;
                                  this.useTime = 26;
                                  this.crit += 10;
                                  this.width = 40;
                                  this.height = 26;
                                  this.shoot = 323;
                                  this.useAmmo = AmmoID.Stake;
                                  this.UseSound = SoundID.Item5;
                                  this.damage = 75;
                                  this.shootSpeed = 9f;
                                  this.noMelee = true;
                                  this.value = Item.sellPrice(gold: 10);
                                  this.rare = 8;
                                  this.knockBack = 6.5f;
                                  this.ranged = true;
                                  return;
                                case 1836:
                                  this.shootSpeed = 3f;
                                  this.shoot = 323;
                                  this.damage = 25;
                                  this.width = 20;
                                  this.height = 14;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.ammo = AmmoID.Stake;
                                  this.knockBack = 4.5f;
                                  this.value = 15;
                                  this.ranged = true;
                                  return;
                                case 1837:
                                  this.useStyle = 1;
                                  this.shoot = 324;
                                  this.width = 16;
                                  this.height = 30;
                                  this.UseSound = SoundID.Item2;
                                  this.useAnimation = 20;
                                  this.useTime = 20;
                                  this.rare = 3;
                                  this.noMelee = true;
                                  this.buffType = 85;
                                  this.value = Item.sellPrice(gold: 2);
                                  return;
                                case 1838:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 135;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1839:
                                  this.width = 18;
                                  this.height = 18;
                                  this.bodySlot = 96;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1840:
                                  this.width = 18;
                                  this.height = 18;
                                  this.legSlot = 80;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1841:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 136;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1842:
                                  this.width = 18;
                                  this.height = 18;
                                  this.bodySlot = 97;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1843:
                                  this.width = 18;
                                  this.height = 18;
                                  this.legSlot = 81;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.vanity = true;
                                  return;
                                case 1844:
                                  this.useStyle = 4;
                                  this.width = 22;
                                  this.height = 14;
                                  this.consumable = true;
                                  this.useAnimation = 45;
                                  this.useTime = 45;
                                  this.maxStack = 20;
                                  this.rare = 8;
                                  return;
                                case 1845:
                                  this.rare = 8;
                                  this.width = 24;
                                  this.height = 28;
                                  this.accessory = true;
                                  this.value = Item.buyPrice(gold: 20);
                                  return;
                                default:
                                  if (type >= 1846 && type <= 1850)
                                  {
                                    this.useStyle = 1;
                                    this.useTurn = true;
                                    this.useAnimation = 15;
                                    this.useTime = 10;
                                    this.autoReuse = true;
                                    this.maxStack = 99;
                                    this.consumable = true;
                                    this.createTile = 242;
                                    this.width = 30;
                                    this.height = 30;
                                    this.value = Item.sellPrice(silver: 10);
                                    this.placeStyle = 17 + type - 1846;
                                    return;
                                  }
                                  switch (type)
                                  {
                                    case 1851:
                                      this.width = 18;
                                      this.height = 18;
                                      this.bodySlot = 98;
                                      this.value = Item.buyPrice(gold: 3);
                                      this.vanity = true;
                                      return;
                                    case 1852:
                                      this.width = 18;
                                      this.height = 18;
                                      this.legSlot = 82;
                                      this.value = Item.buyPrice(gold: 3);
                                      this.vanity = true;
                                      return;
                                    case 1853:
                                      this.width = 18;
                                      this.height = 18;
                                      this.bodySlot = 99;
                                      this.value = Item.buyPrice(gold: 3);
                                      this.vanity = true;
                                      return;
                                    case 1854:
                                      this.width = 18;
                                      this.height = 18;
                                      this.legSlot = 83;
                                      this.value = Item.buyPrice(gold: 3);
                                      this.vanity = true;
                                      return;
                                    default:
                                      if (type == 1855 || type == 1856)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 240;
                                        this.width = 30;
                                        this.height = 30;
                                        this.value = Item.sellPrice(gold: 1);
                                        this.rare = 1;
                                        this.placeStyle = 36 + type - 1855;
                                        return;
                                      }
                                      switch (type)
                                      {
                                        case 1857:
                                          this.width = 18;
                                          this.height = 18;
                                          this.headSlot = 137;
                                          this.value = Item.sellPrice(gold: 5);
                                          this.vanity = true;
                                          this.rare = 3;
                                          return;
                                        case 1858:
                                          this.width = 14;
                                          this.height = 28;
                                          this.rare = 7;
                                          this.value = 300000;
                                          this.accessory = true;
                                          return;
                                        case 1859:
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 42;
                                          this.width = 12;
                                          this.height = 28;
                                          this.placeStyle = 9;
                                          this.value = 75000;
                                          this.rare = 2;
                                          return;
                                        case 1860:
                                          this.width = 24;
                                          this.height = 28;
                                          this.rare = 5;
                                          this.value = 150000;
                                          this.accessory = true;
                                          this.faceSlot = (sbyte) 3;
                                          return;
                                        case 1861:
                                          this.width = 24;
                                          this.height = 28;
                                          this.rare = 6;
                                          this.value = 250000;
                                          this.accessory = true;
                                          this.faceSlot = (sbyte) 2;
                                          return;
                                        case 1862:
                                          this.width = 16;
                                          this.height = 24;
                                          this.accessory = true;
                                          this.rare = 7;
                                          this.value = 350000;
                                          this.shoeSlot = (sbyte) 9;
                                          return;
                                        case 1863:
                                          this.width = 14;
                                          this.height = 28;
                                          this.rare = 4;
                                          this.value = 150000;
                                          this.accessory = true;
                                          this.balloonSlot = (sbyte) 5;
                                          return;
                                        case 1864:
                                          this.rare = 8;
                                          this.width = 24;
                                          this.height = 28;
                                          this.accessory = true;
                                          this.value = Item.buyPrice(gold: 25);
                                          return;
                                        case 1865:
                                          this.width = 16;
                                          this.height = 24;
                                          this.accessory = true;
                                          this.rare = 7;
                                          this.value = 400000;
                                          return;
                                        case 1866:
                                          this.width = 24;
                                          this.height = 8;
                                          this.accessory = true;
                                          this.value = 400000;
                                          this.rare = 5;
                                          this.wingSlot = (sbyte) 22;
                                          return;
                                        case 1867:
                                          this.width = 12;
                                          this.height = 12;
                                          return;
                                        case 1868:
                                          this.width = 12;
                                          this.height = 12;
                                          return;
                                        case 1869:
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 36;
                                          this.width = 12;
                                          this.height = 28;
                                          this.rare = 1;
                                          return;
                                        case 1870:
                                          this.useStyle = 5;
                                          this.autoReuse = true;
                                          this.useAnimation = 38;
                                          this.useTime = 38;
                                          this.width = 44;
                                          this.height = 14;
                                          this.shoot = 10;
                                          this.useAmmo = AmmoID.Bullet;
                                          this.UseSound = SoundID.Item11;
                                          this.damage = 20;
                                          this.shootSpeed = 8f;
                                          this.noMelee = true;
                                          this.value = 100000;
                                          this.knockBack = 3.75f;
                                          this.rare = 1;
                                          this.ranged = true;
                                          return;
                                        case 1871:
                                          this.width = 24;
                                          this.height = 8;
                                          this.accessory = true;
                                          this.value = 400000;
                                          this.rare = 5;
                                          this.wingSlot = (sbyte) 23;
                                          return;
                                        case 1872:
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 170;
                                          this.width = 12;
                                          this.height = 12;
                                          return;
                                        case 1873:
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 171;
                                          this.width = 12;
                                          this.height = 12;
                                          this.value = Item.buyPrice(silver: 25);
                                          return;
                                        default:
                                          if (type >= 1874 && type <= 1905)
                                          {
                                            this.useStyle = 1;
                                            this.useTurn = true;
                                            this.useAnimation = 15;
                                            this.useTime = 10;
                                            this.autoReuse = true;
                                            this.maxStack = 999;
                                            this.consumable = true;
                                            this.width = 12;
                                            this.height = 12;
                                            this.noMelee = true;
                                            this.value = Item.buyPrice(silver: 5);
                                            return;
                                          }
                                          switch (type)
                                          {
                                            case 1906:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 138;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 1);
                                              return;
                                            case 1907:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 139;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 1);
                                              return;
                                            case 1908:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 246;
                                              this.width = 30;
                                              this.height = 30;
                                              this.value = Item.sellPrice(silver: 10);
                                              this.placeStyle = 18;
                                              return;
                                            case 1909:
                                              this.useStyle = 1;
                                              this.useAnimation = 27;
                                              this.knockBack = 5.3f;
                                              this.width = 24;
                                              this.height = 28;
                                              this.damage = 16;
                                              this.scale = 1.1f;
                                              this.UseSound = SoundID.Item1;
                                              this.rare = 1;
                                              this.value = 13500;
                                              this.melee = true;
                                              return;
                                            case 1910:
                                              this.useStyle = 5;
                                              this.autoReuse = true;
                                              this.useAnimation = 30;
                                              this.useTime = 5;
                                              this.width = 50;
                                              this.height = 18;
                                              this.shoot = 85;
                                              this.useAmmo = AmmoID.Gel;
                                              this.UseSound = SoundID.Item34;
                                              this.damage = 60;
                                              this.knockBack = 0.425f;
                                              this.shootSpeed = 8.5f;
                                              this.noMelee = true;
                                              this.value = 500000;
                                              this.rare = 8;
                                              this.ranged = true;
                                              return;
                                            case 1912:
                                              this.UseSound = SoundID.Item3;
                                              this.healLife = 80;
                                              this.useStyle = 9;
                                              this.useTurn = true;
                                              this.useAnimation = 17;
                                              this.useTime = 17;
                                              this.maxStack = 30;
                                              this.consumable = true;
                                              this.width = 14;
                                              this.height = 24;
                                              this.potion = true;
                                              this.value = 40;
                                              this.rare = 1;
                                              return;
                                            case 1913:
                                              this.useStyle = 1;
                                              this.shootSpeed = 12f;
                                              this.shoot = 330;
                                              this.damage = 14;
                                              this.width = 18;
                                              this.height = 20;
                                              this.maxStack = 999;
                                              this.consumable = true;
                                              this.UseSound = SoundID.Item1;
                                              this.useAnimation = 15;
                                              this.useTime = 15;
                                              this.noUseGraphic = true;
                                              this.noMelee = true;
                                              this.value = 25;
                                              this.ranged = true;
                                              return;
                                            case 1914:
                                              this.useStyle = 1;
                                              this.width = 16;
                                              this.height = 30;
                                              this.UseSound = SoundID.Item25;
                                              this.useAnimation = 20;
                                              this.useTime = 20;
                                              this.rare = 8;
                                              this.noMelee = true;
                                              this.mountType = 0;
                                              this.value = Item.sellPrice(gold: 5);
                                              return;
                                            case 1915:
                                              this.noUseGraphic = true;
                                              this.damage = 0;
                                              this.knockBack = 7f;
                                              this.useStyle = 5;
                                              this.shootSpeed = 11.5f;
                                              this.shoot = 331;
                                              this.width = 18;
                                              this.height = 28;
                                              this.UseSound = SoundID.Item1;
                                              this.useAnimation = 20;
                                              this.useTime = 20;
                                              this.rare = 7;
                                              this.noMelee = true;
                                              this.value = Item.sellPrice(gold: 2);
                                              return;
                                            case 1916:
                                              this.noUseGraphic = true;
                                              this.damage = 0;
                                              this.knockBack = 7f;
                                              this.useStyle = 5;
                                              this.shootSpeed = 15.5f;
                                              this.shoot = 332;
                                              this.width = 18;
                                              this.height = 28;
                                              this.UseSound = SoundID.Item1;
                                              this.useAnimation = 20;
                                              this.useTime = 20;
                                              this.rare = 7;
                                              this.noMelee = true;
                                              this.value = Item.sellPrice(gold: 4);
                                              return;
                                            case 1917:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 20;
                                              this.useTime = 16;
                                              this.autoReuse = true;
                                              this.width = 24;
                                              this.height = 28;
                                              this.damage = 7;
                                              this.pick = 55;
                                              this.UseSound = SoundID.Item1;
                                              this.knockBack = 2.5f;
                                              this.value = 10000;
                                              this.melee = true;
                                              return;
                                            case 1918:
                                              this.noMelee = true;
                                              this.useStyle = 1;
                                              this.shootSpeed = 11f;
                                              this.shoot = 333;
                                              this.damage = 14;
                                              this.knockBack = 8f;
                                              this.width = 14;
                                              this.height = 28;
                                              this.UseSound = SoundID.Item1;
                                              this.useAnimation = 15;
                                              this.useTime = 15;
                                              this.noUseGraphic = true;
                                              this.rare = 1;
                                              this.value = 50000;
                                              this.melee = true;
                                              return;
                                            case 1921:
                                              this.width = 16;
                                              this.height = 24;
                                              this.accessory = true;
                                              this.rare = 2;
                                              this.value = 50000;
                                              this.handOffSlot = (sbyte) 2;
                                              this.handOnSlot = (sbyte) 7;
                                              return;
                                            case 1922:
                                              this.width = 16;
                                              this.height = 24;
                                              return;
                                            case 1923:
                                              this.width = 16;
                                              this.height = 24;
                                              this.accessory = true;
                                              this.rare = 2;
                                              this.value = 50000;
                                              return;
                                            case 1924:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 10;
                                              this.placeStyle = 26;
                                              this.width = 14;
                                              this.height = 28;
                                              this.value = 200;
                                              return;
                                            case 1925:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 15;
                                              this.placeStyle = 26;
                                              this.width = 12;
                                              this.height = 30;
                                              this.value = 150;
                                              return;
                                            case 1926:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 14;
                                              this.placeStyle = 23;
                                              this.width = 26;
                                              this.height = 20;
                                              this.value = 300;
                                              return;
                                            case 1927:
                                              this.useStyle = 1;
                                              this.shoot = 334;
                                              this.width = 16;
                                              this.height = 30;
                                              this.UseSound = SoundID.Item2;
                                              this.useAnimation = 20;
                                              this.useTime = 20;
                                              this.rare = 3;
                                              this.noMelee = true;
                                              this.value = 0;
                                              this.buffType = 91;
                                              return;
                                            case 1928:
                                              this.useStyle = 1;
                                              this.autoReuse = true;
                                              this.useAnimation = 23;
                                              this.useTime = 23;
                                              this.knockBack = 7f;
                                              this.width = 40;
                                              this.height = 40;
                                              this.damage = 86;
                                              this.scale = 1.1f;
                                              this.shoot = 907;
                                              this.shootSpeed = 5f;
                                              this.UseSound = SoundID.Item1;
                                              this.rare = 8;
                                              this.value = Item.sellPrice(gold: 10);
                                              this.melee = true;
                                              return;
                                            case 1929:
                                              this.useStyle = 5;
                                              this.autoReuse = true;
                                              this.useAnimation = 4;
                                              this.useTime = 4;
                                              this.width = 50;
                                              this.height = 18;
                                              this.shoot = 10;
                                              this.useAmmo = AmmoID.Bullet;
                                              this.UseSound = SoundID.Item41;
                                              this.damage = 31;
                                              this.shootSpeed = 14f;
                                              this.noMelee = true;
                                              this.value = Item.buyPrice(gold: 45);
                                              this.rare = 8;
                                              this.knockBack = 1.75f;
                                              this.ranged = true;
                                              return;
                                            case 1930:
                                              this.autoReuse = true;
                                              this.mana = 5;
                                              this.UseSound = SoundID.Item39;
                                              this.useStyle = 5;
                                              this.damage = 48;
                                              this.useAnimation = 8;
                                              this.useTime = 8;
                                              this.width = 40;
                                              this.height = 40;
                                              this.shoot = 336;
                                              this.shootSpeed = 12f;
                                              this.knockBack = 3.25f;
                                              this.value = Item.buyPrice(gold: 45);
                                              this.magic = true;
                                              this.rare = 8;
                                              this.noMelee = true;
                                              return;
                                            case 1931:
                                              this.autoReuse = true;
                                              this.mana = 9;
                                              this.useStyle = 5;
                                              this.damage = 58;
                                              this.useAnimation = 10;
                                              this.useTime = 5;
                                              this.width = 40;
                                              this.height = 40;
                                              this.shoot = 337;
                                              this.shootSpeed = 10f;
                                              this.knockBack = 4.5f;
                                              this.value = Item.buyPrice(gold: 45);
                                              this.magic = true;
                                              this.rare = 8;
                                              this.noMelee = true;
                                              return;
                                            case 1932:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 140;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1933:
                                              this.width = 18;
                                              this.height = 18;
                                              this.bodySlot = 100;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1934:
                                              this.width = 18;
                                              this.height = 18;
                                              this.legSlot = 84;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1935:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 142;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1936:
                                              this.width = 18;
                                              this.height = 18;
                                              this.bodySlot = 102;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1937:
                                              this.width = 18;
                                              this.height = 18;
                                              this.legSlot = 86;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1938:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 143;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1939:
                                              this.width = 18;
                                              this.height = 18;
                                              this.bodySlot = 103;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1940:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 141;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1941:
                                              this.width = 18;
                                              this.height = 18;
                                              this.bodySlot = 101;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1942:
                                              this.width = 18;
                                              this.height = 18;
                                              this.legSlot = 85;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1943:
                                              this.width = 18;
                                              this.height = 18;
                                              this.headSlot = 144;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1944:
                                              this.width = 18;
                                              this.height = 18;
                                              this.bodySlot = 104;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1945:
                                              this.width = 18;
                                              this.height = 18;
                                              this.legSlot = 87;
                                              this.vanity = true;
                                              this.value = Item.buyPrice(gold: 3);
                                              return;
                                            case 1946:
                                              this.useStyle = 5;
                                              this.autoReuse = true;
                                              this.useAnimation = 15;
                                              this.useTime = 15;
                                              this.useAmmo = AmmoID.Rocket;
                                              this.width = 50;
                                              this.height = 20;
                                              this.shoot = 338;
                                              this.UseSound = SoundID.Item11;
                                              this.damage = 67;
                                              this.shootSpeed = 15f;
                                              this.noMelee = true;
                                              this.value = Item.buyPrice(gold: 45);
                                              this.knockBack = 4f;
                                              this.rare = 8;
                                              this.ranged = true;
                                              return;
                                            case 1947:
                                              this.useStyle = 5;
                                              this.useAnimation = 25;
                                              this.useTime = 25;
                                              this.shootSpeed = 4.75f;
                                              this.knockBack = 6.7f;
                                              this.width = 40;
                                              this.height = 40;
                                              this.damage = 73;
                                              this.scale = 1.1f;
                                              this.UseSound = SoundID.Item1;
                                              this.shoot = 342;
                                              this.rare = 7;
                                              this.value = Item.buyPrice(gold: 45);
                                              this.noMelee = true;
                                              this.noUseGraphic = true;
                                              this.melee = true;
                                              return;
                                            default:
                                              if (type >= 1948 && type <= 1957)
                                              {
                                                this.useStyle = 1;
                                                this.useTurn = true;
                                                this.useAnimation = 15;
                                                this.useTime = 7;
                                                this.autoReuse = true;
                                                this.maxStack = 999;
                                                this.consumable = true;
                                                this.createWall = 116 + type - 1948;
                                                this.width = 12;
                                                this.height = 12;
                                                this.value = Item.buyPrice(silver: 1);
                                                return;
                                              }
                                              if (type == 1958)
                                              {
                                                this.useStyle = 4;
                                                this.width = 22;
                                                this.height = 14;
                                                this.consumable = true;
                                                this.useAnimation = 45;
                                                this.useTime = 45;
                                                this.maxStack = 20;
                                                this.rare = 8;
                                                return;
                                              }
                                              if (type == 1959)
                                              {
                                                this.useStyle = 1;
                                                this.shoot = 353;
                                                this.width = 16;
                                                this.height = 30;
                                                this.UseSound = SoundID.Item2;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.rare = 3;
                                                this.noMelee = true;
                                                this.value = 0;
                                                this.buffType = 92;
                                                return;
                                              }
                                              if (type == 1960 || type == 1961 || type == 1962)
                                              {
                                                this.useStyle = 1;
                                                this.useTurn = true;
                                                this.useAnimation = 15;
                                                this.useTime = 10;
                                                this.autoReuse = true;
                                                this.maxStack = 99;
                                                this.consumable = true;
                                                this.createTile = 240;
                                                this.width = 30;
                                                this.height = 30;
                                                this.value = Item.sellPrice(gold: 1);
                                                this.rare = 1;
                                                this.placeStyle = 38 + type - 1960;
                                                return;
                                              }
                                              switch (type)
                                              {
                                                case 1963:
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.consumable = true;
                                                  this.createTile = 139;
                                                  this.placeStyle = 28;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.rare = 4;
                                                  this.value = 100000;
                                                  this.accessory = true;
                                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                                  return;
                                                case 1964:
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.consumable = true;
                                                  this.createTile = 139;
                                                  this.placeStyle = 29;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.rare = 4;
                                                  this.value = 100000;
                                                  this.accessory = true;
                                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                                  return;
                                                case 1965:
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.consumable = true;
                                                  this.createTile = 139;
                                                  this.placeStyle = 30;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.rare = 4;
                                                  this.value = 100000;
                                                  this.accessory = true;
                                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                                  return;
                                                case 1966:
                                                  this.paint = (byte) 28;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.value = 25;
                                                  this.maxStack = 999;
                                                  return;
                                                case 1967:
                                                  this.paint = (byte) 29;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.value = 50;
                                                  this.maxStack = 999;
                                                  return;
                                                case 1968:
                                                  this.paint = (byte) 30;
                                                  this.width = 24;
                                                  this.height = 24;
                                                  this.value = 75;
                                                  this.maxStack = 999;
                                                  return;
                                                case 1969:
                                                  this.width = 20;
                                                  this.height = 20;
                                                  this.maxStack = 99;
                                                  this.value = 10000;
                                                  this.rare = 1;
                                                  return;
                                                default:
                                                  if (type >= 1970 && type <= 1976)
                                                  {
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 262 + type - 1970;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    return;
                                                  }
                                                  if (type >= 1977 && type <= 1986)
                                                  {
                                                    this.width = 20;
                                                    this.height = 26;
                                                    this.maxStack = 99;
                                                    this.value = Item.buyPrice(gold: 5);
                                                    this.rare = 2;
                                                    if (type == 1980)
                                                      this.value = Item.buyPrice(gold: 10);
                                                    if (type == 1984)
                                                      this.value = Item.buyPrice(gold: 7, silver: 50);
                                                    if (type == 1985)
                                                      this.value = Item.buyPrice(gold: 15);
                                                    this.UseSound = SoundID.Item3;
                                                    this.useStyle = 9;
                                                    this.useTurn = true;
                                                    this.useAnimation = 17;
                                                    this.useTime = 17;
                                                    this.consumable = true;
                                                    return;
                                                  }
                                                  switch (type)
                                                  {
                                                    case 1987:
                                                      this.width = 18;
                                                      this.height = 12;
                                                      this.maxStack = 1;
                                                      this.value = Item.buyPrice(gold: 40);
                                                      this.rare = 5;
                                                      this.accessory = true;
                                                      this.faceSlot = (sbyte) 7;
                                                      this.vanity = true;
                                                      return;
                                                    case 1988:
                                                      this.width = 20;
                                                      this.height = 14;
                                                      this.maxStack = 1;
                                                      this.value = Item.buyPrice(gold: 3, silver: 50);
                                                      this.vanity = true;
                                                      this.headSlot = 145;
                                                      return;
                                                    case 1989:
                                                      this.useStyle = 1;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.autoReuse = true;
                                                      this.maxStack = 999;
                                                      this.consumable = true;
                                                      this.createTile = 269;
                                                      this.width = 22;
                                                      this.height = 32;
                                                      this.createTile = 470;
                                                      this.placeStyle = 2;
                                                      return;
                                                    case 1990:
                                                      this.width = 20;
                                                      this.height = 26;
                                                      this.maxStack = 99;
                                                      this.value = Item.buyPrice(gold: 2);
                                                      this.rare = 2;
                                                      this.UseSound = SoundID.Item3;
                                                      this.useStyle = 9;
                                                      this.useTurn = true;
                                                      this.hairDye = (short) 0;
                                                      this.useAnimation = 17;
                                                      this.useTime = 17;
                                                      this.consumable = true;
                                                      return;
                                                    case 1991:
                                                      this.useTurn = true;
                                                      this.useStyle = 1;
                                                      this.useAnimation = 25;
                                                      this.width = 24;
                                                      this.height = 28;
                                                      this.UseSound = SoundID.Item1;
                                                      this.value = Item.buyPrice(silver: 25);
                                                      this.autoReuse = true;
                                                      return;
                                                    case 1992:
                                                      this.useStyle = 1;
                                                      this.autoReuse = true;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.maxStack = 999;
                                                      this.consumable = true;
                                                      this.width = 12;
                                                      this.height = 12;
                                                      this.makeNPC = (short) 355;
                                                      this.noUseGraphic = true;
                                                      this.bait = 20;
                                                      return;
                                                    case 1993:
                                                      this.useStyle = 1;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.autoReuse = true;
                                                      this.maxStack = 999;
                                                      this.consumable = true;
                                                      this.createTile = 270;
                                                      this.width = 12;
                                                      this.height = 28;
                                                      return;
                                                    default:
                                                      if (type < 1994 || type > 2001)
                                                        return;
                                                      this.useStyle = 1;
                                                      this.autoReuse = true;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.maxStack = 999;
                                                      this.consumable = true;
                                                      this.width = 12;
                                                      this.height = 12;
                                                      this.makeNPC = (short) 356;
                                                      this.placeStyle = 1 + type - 1994;
                                                      this.noUseGraphic = true;
                                                      int num = type - 1994;
                                                      if (num == 0)
                                                        this.bait = 5;
                                                      if (num == 4)
                                                        this.bait = 10;
                                                      if (num == 6)
                                                        this.bait = 15;
                                                      if (num == 3)
                                                        this.bait = 20;
                                                      if (num == 7)
                                                        this.bait = 25;
                                                      if (num == 2)
                                                        this.bait = 30;
                                                      if (num == 1)
                                                        this.bait = 35;
                                                      if (num != 5)
                                                        return;
                                                      this.bait = 50;
                                                      return;
                                                  }
                                              }
                                          }
                                      }
                                  }
                              }
                          }
                      }
                  }
              }
          }
      }
    }

    public void SetDefaults3(int type)
    {
      switch (type)
      {
        case 2002:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.makeNPC = (short) 357;
          this.noUseGraphic = true;
          this.bait = 25;
          break;
        case 2003:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.makeNPC = (short) 300;
          this.noUseGraphic = true;
          break;
        case 2004:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.makeNPC = (short) 358;
          this.noUseGraphic = true;
          this.bait = 35;
          break;
        case 2005:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 271;
          this.width = 12;
          this.height = 28;
          break;
        case 2006:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.makeNPC = (short) 359;
          this.noUseGraphic = true;
          this.bait = 10;
          break;
        case 2007:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.makeNPC = (short) 360;
          this.noUseGraphic = true;
          this.bait = 15;
          break;
        default:
          if (type >= 2008 && type <= 2014)
          {
            this.useStyle = 1;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 7;
            this.autoReuse = true;
            this.maxStack = 999;
            this.consumable = true;
            this.createWall = 126 + type - 2008;
            this.width = 12;
            this.height = 12;
            this.value = Item.buyPrice(silver: 1);
            break;
          }
          if (type >= 2015 && type <= 2019)
          {
            this.useStyle = 1;
            this.autoReuse = true;
            this.useTurn = true;
            this.useAnimation = 15;
            this.useTime = 10;
            this.maxStack = 999;
            this.consumable = true;
            this.width = 12;
            this.height = 12;
            this.noUseGraphic = true;
            if (type == 2015)
              this.makeNPC = (short) 74;
            if (type == 2016)
              this.makeNPC = (short) 297;
            if (type == 2017)
              this.makeNPC = (short) 298;
            if (type == 2018)
              this.makeNPC = (short) 299;
            if (type != 2019)
              break;
            this.makeNPC = (short) 46;
            break;
          }
          switch (type)
          {
            case 2020:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 6;
              return;
            case 2021:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 7;
              return;
            case 2022:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 8;
              return;
            case 2023:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 9;
              return;
            case 2024:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 10;
              return;
            case 2025:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 11;
              return;
            case 2026:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 12;
              return;
            case 2027:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 13;
              return;
            case 2028:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 14;
              return;
            case 2029:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 15;
              return;
            case 2030:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 16;
              return;
            case 2031:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 101;
              this.width = 20;
              this.height = 20;
              this.value = 300;
              this.placeStyle = 17;
              return;
            case 2032:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 10;
              this.value = 150;
              return;
            case 2033:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 11;
              this.value = 150;
              return;
            case 2034:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 12;
              this.value = 150;
              return;
            case 2035:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 13;
              this.value = 150;
              return;
            case 2036:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 14;
              this.value = 150;
              return;
            case 2037:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 15;
              this.value = 150;
              return;
            case 2038:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 16;
              this.value = 150;
              return;
            case 2039:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 17;
              this.value = 150;
              return;
            case 2040:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 18;
              this.value = 150;
              return;
            case 2041:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 19;
              this.value = 150;
              return;
            case 2042:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 20;
              this.value = 150;
              return;
            case 2043:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.autoReuse = true;
              this.maxStack = 999;
              this.consumable = true;
              this.createTile = 42;
              this.width = 12;
              this.height = 28;
              this.placeStyle = 21;
              this.value = 150;
              return;
            case 2044:
              this.useStyle = 1;
              this.useTurn = true;
              this.useAnimation = 15;
              this.useTime = 10;
              this.maxStack = 99;
              this.consumable = true;
              this.createTile = 10;
              this.placeStyle = 27;
              this.width = 14;
              this.height = 28;
              this.value = 200;
              return;
            default:
              if (type >= 2045 && type <= 2054)
              {
                this.noWet = true;
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 33;
                this.width = 8;
                this.height = 18;
                this.value = Item.sellPrice(copper: 60);
                this.placeStyle = 4 + type - 2045;
                return;
              }
              if (type >= 2055 && type <= 2065)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 34;
                this.placeStyle = 7 + type - 2055;
                this.width = 26;
                this.height = 26;
                this.value = 3000;
                return;
              }
              if (type >= 2066 && type <= 2071)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.maxStack = 99;
                this.consumable = true;
                this.autoReuse = true;
                this.createTile = 79;
                this.placeStyle = 13 + type - 2066;
                this.width = 28;
                this.height = 20;
                this.value = 2000;
                return;
              }
              if (type >= 2072 && type <= 2081)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 90;
                this.placeStyle = type + 1 - 2072;
                this.width = 20;
                this.height = 20;
                this.value = 300;
                return;
              }
              if (type >= 2082 && type <= 2091)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 93;
                this.placeStyle = type + 1 - 2082;
                this.width = 10;
                this.height = 24;
                this.value = 500;
                return;
              }
              if (type >= 2092 && type <= 2103)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 100;
                this.placeStyle = type + 1 - 2092;
                this.width = 20;
                this.height = 20;
                this.value = 1500;
                return;
              }
              if (type >= 2104 && type <= 2113)
              {
                this.width = 28;
                this.height = 20;
                this.headSlot = type + 146 - 2104;
                this.rare = 1;
                this.value = Item.sellPrice(silver: 75);
                this.vanity = true;
                return;
              }
              if (type >= 2114 && type <= 2118)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 15;
                this.useTime = 10;
                this.autoReuse = true;
                this.maxStack = 99;
                this.consumable = true;
                this.createTile = 240;
                this.width = 30;
                this.height = 30;
                this.value = Item.sellPrice(silver: 5);
                this.placeStyle = 41 + type - 2114;
                this.maxStack = 99;
                return;
              }
              switch (type)
              {
                case 2119:
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.createTile = 273;
                  this.width = 12;
                  this.height = 12;
                  return;
                case 2120:
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.createTile = 274;
                  this.width = 12;
                  this.height = 12;
                  return;
                case 2121:
                  this.useStyle = 1;
                  this.autoReuse = true;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.width = 12;
                  this.height = 12;
                  this.makeNPC = (short) 361;
                  this.noUseGraphic = true;
                  return;
                case 2122:
                  this.useStyle = 1;
                  this.autoReuse = true;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.width = 12;
                  this.height = 12;
                  this.makeNPC = (short) 362;
                  this.noUseGraphic = true;
                  return;
                case 2123:
                  this.useStyle = 1;
                  this.autoReuse = true;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.width = 12;
                  this.height = 12;
                  this.makeNPC = (short) 364;
                  this.noUseGraphic = true;
                  return;
                default:
                  if (type >= 2124 && type <= 2128)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 90;
                    this.placeStyle = type + 11 - 2124;
                    this.width = 20;
                    this.height = 20;
                    this.value = 300;
                    return;
                  }
                  if (type >= 2129 && type <= 2134)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 93;
                    this.placeStyle = type + 11 - 2129;
                    this.width = 10;
                    this.height = 24;
                    this.value = 500;
                    return;
                  }
                  if (type >= 2135 && type <= 2138)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 101;
                    this.width = 20;
                    this.height = 20;
                    this.value = 300;
                    this.placeStyle = 18 + type - 2135;
                    return;
                  }
                  if (type == 2139)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.autoReuse = true;
                    this.createTile = 79;
                    this.placeStyle = 19;
                    this.width = 28;
                    this.height = 20;
                    this.value = 2000;
                    return;
                  }
                  if (type == 2140)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.autoReuse = true;
                    this.createTile = 79;
                    this.placeStyle = 20;
                    this.width = 28;
                    this.height = 20;
                    this.value = 2000;
                    return;
                  }
                  if (type >= 2141 && type <= 2144)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 34;
                    this.placeStyle = 18 + type - 2141;
                    this.width = 26;
                    this.height = 26;
                    this.value = 3000;
                    return;
                  }
                  if (type >= 2145 && type <= 2148)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 999;
                    this.consumable = true;
                    this.createTile = 42;
                    this.width = 12;
                    this.height = 28;
                    this.placeStyle = 22 + type - 2145;
                    this.value = 150;
                    return;
                  }
                  if (type >= 2149 && type <= 2152)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 100;
                    this.placeStyle = type + 13 - 2149;
                    this.width = 20;
                    this.height = 20;
                    this.value = 1500;
                    return;
                  }
                  if (type >= 2153 && type <= 2155)
                  {
                    this.noWet = true;
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 33;
                    this.width = 8;
                    this.height = 18;
                    this.value = Item.sellPrice(copper: 60);
                    this.placeStyle = 14 + type - 2153;
                    return;
                  }
                  if (type == 2156)
                  {
                    this.useStyle = 1;
                    this.autoReuse = true;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.maxStack = 999;
                    this.consumable = true;
                    this.width = 12;
                    this.height = 12;
                    this.makeNPC = (short) 366;
                    this.noUseGraphic = true;
                    this.bait = 15;
                    return;
                  }
                  if (type == 2157)
                  {
                    this.useStyle = 1;
                    this.autoReuse = true;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.maxStack = 999;
                    this.consumable = true;
                    this.width = 12;
                    this.height = 12;
                    this.makeNPC = (short) 367;
                    this.noUseGraphic = true;
                    this.bait = 10;
                    return;
                  }
                  if (type >= 2158 && type <= 2160)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 7;
                    this.autoReuse = true;
                    this.maxStack = 999;
                    this.consumable = true;
                    this.createWall = 133 + type - 2158;
                    this.width = 12;
                    this.height = 12;
                    this.value = Item.buyPrice(silver: 1);
                    return;
                  }
                  if (type == 2161)
                  {
                    this.width = 18;
                    this.height = 18;
                    this.maxStack = 999;
                    this.value = 50000;
                    this.rare = 5;
                    return;
                  }
                  if (type >= 2162 && type <= 2168)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 99;
                    this.consumable = true;
                    this.createTile = 275 + type - 2162;
                    this.width = 12;
                    this.height = 12;
                    return;
                  }
                  switch (type)
                  {
                    case 2169:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 7;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createWall = 136;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 2170:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 7;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createWall = 137;
                      this.width = 12;
                      this.height = 12;
                      return;
                    case 2171:
                      this.autoReuse = true;
                      this.useTurn = true;
                      this.useStyle = 1;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createTile = 199;
                      this.width = 14;
                      this.height = 14;
                      this.value = 500;
                      return;
                    case 2172:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 99;
                      this.consumable = true;
                      this.createTile = 283;
                      this.width = 28;
                      this.height = 14;
                      this.value = 500;
                      return;
                    case 2173:
                      this.useStyle = 1;
                      this.useTurn = true;
                      this.useAnimation = 15;
                      this.useTime = 10;
                      this.autoReuse = true;
                      this.maxStack = 999;
                      this.consumable = true;
                      this.createTile = 284;
                      this.width = 12;
                      this.height = 12;
                      return;
                    default:
                      if (type >= 2174 && type <= 2175)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 99;
                        this.consumable = true;
                        this.createTile = 285 + type - 2174;
                        this.width = 12;
                        this.height = 12;
                        return;
                      }
                      if (type == 2176)
                      {
                        this.useStyle = 1;
                        this.useAnimation = 12;
                        this.useTime = 4;
                        this.knockBack = 6f;
                        this.useTurn = true;
                        this.autoReuse = true;
                        this.width = 20;
                        this.height = 12;
                        this.damage = 45;
                        this.pick = 200;
                        this.axe = 25;
                        this.UseSound = SoundID.Item1;
                        this.rare = 8;
                        this.value = Item.sellPrice(gold: 4);
                        this.melee = true;
                        --this.tileBoost;
                        return;
                      }
                      if (type == 2177)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 999;
                        this.consumable = true;
                        this.createTile = 287;
                        this.width = 22;
                        this.height = 22;
                        this.value = Item.buyPrice(gold: 15);
                        this.rare = 6;
                        return;
                      }
                      if (type >= 2178 && type <= 2187)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 99;
                        this.consumable = true;
                        this.createTile = 288 + type - 2178;
                        this.width = 12;
                        this.height = 12;
                        return;
                      }
                      if (type == 2189)
                      {
                        this.width = 18;
                        this.height = 18;
                        this.defense = 18;
                        this.headSlot = 156;
                        this.rare = 8;
                        this.value = 375000;
                        return;
                      }
                      if (type == 2188)
                      {
                        this.mana = 25;
                        this.UseSound = SoundID.Item43;
                        this.useStyle = 5;
                        this.damage = 44;
                        this.useAnimation = 30;
                        this.useTime = 30;
                        this.width = 40;
                        this.height = 40;
                        this.shoot = 355;
                        this.shootSpeed = 14f;
                        this.knockBack = 7f;
                        this.magic = true;
                        this.autoReuse = true;
                        this.rare = 7;
                        this.noMelee = true;
                        this.value = Item.sellPrice(gold: 7);
                        return;
                      }
                      if (type >= 2190 && type <= 2191)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 99;
                        this.consumable = true;
                        this.createTile = 298 + type - 2190;
                        this.width = 12;
                        this.height = 12;
                        return;
                      }
                      if (type >= 2192 && type <= 2198 || type == 2203 || type == 2204)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 99;
                        this.consumable = true;
                        this.createTile = type != 2203 ? (type != 2204 ? 300 + type - 2192 : 308) : 307;
                        this.width = 12;
                        this.height = 12;
                        this.value = Item.buyPrice(gold: 10);
                        return;
                      }
                      switch (type)
                      {
                        case 2199:
                          this.width = 18;
                          this.height = 18;
                          this.defense = 23;
                          this.headSlot = 157;
                          this.rare = 8;
                          this.value = 300000;
                          return;
                        case 2200:
                          this.width = 18;
                          this.height = 18;
                          this.defense = 20;
                          this.bodySlot = 105;
                          this.rare = 8;
                          this.value = 240000;
                          return;
                        case 2201:
                          this.width = 18;
                          this.height = 18;
                          this.defense = 32;
                          this.bodySlot = 106;
                          this.rare = 8;
                          this.value = 240000;
                          return;
                        case 2202:
                          this.width = 18;
                          this.height = 18;
                          this.defense = 18;
                          this.legSlot = 98;
                          this.rare = 8;
                          this.value = 180000;
                          return;
                        case 2205:
                          this.useStyle = 1;
                          this.autoReuse = true;
                          this.useTurn = true;
                          this.useAnimation = 15;
                          this.useTime = 10;
                          this.maxStack = 999;
                          this.consumable = true;
                          this.width = 12;
                          this.height = 12;
                          this.makeNPC = (short) 148;
                          this.noUseGraphic = true;
                          return;
                        default:
                          if (type == 2206 || type == 2207)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 309 + type - 2206;
                            this.width = 12;
                            this.height = 12;
                            return;
                          }
                          if (type == 2208)
                          {
                            this.width = 18;
                            this.height = 20;
                            this.maxStack = 99;
                            return;
                          }
                          if (type == 2209)
                          {
                            this.UseSound = SoundID.Item3;
                            this.healMana = 300;
                            this.useStyle = 9;
                            this.useTurn = true;
                            this.useAnimation = 17;
                            this.useTime = 17;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.width = 14;
                            this.height = 24;
                            this.rare = 4;
                            this.value = 1500;
                            return;
                          }
                          if (type >= 2210 && type <= 2213)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 7;
                            this.autoReuse = true;
                            this.maxStack = 999;
                            this.consumable = true;
                            this.createWall = 138 + type - 2210;
                            this.width = 12;
                            this.height = 12;
                            return;
                          }
                          if (type >= 2214 && type <= 2217)
                          {
                            this.width = 30;
                            this.height = 30;
                            this.accessory = true;
                            this.rare = 3;
                            this.value = Item.buyPrice(gold: 10);
                            return;
                          }
                          switch (type)
                          {
                            case 2218:
                              this.width = 14;
                              this.height = 18;
                              this.maxStack = 99;
                              this.rare = 8;
                              this.value = Item.sellPrice(silver: 50);
                              return;
                            case 2219:
                              this.width = 24;
                              this.height = 24;
                              this.accessory = true;
                              this.value = Item.buyPrice(gold: 15);
                              this.rare = 4;
                              return;
                            case 2220:
                              this.width = 24;
                              this.height = 24;
                              this.accessory = true;
                              this.value = Item.buyPrice(gold: 16);
                              this.rare = 5;
                              return;
                            case 2221:
                              this.width = 24;
                              this.height = 24;
                              this.accessory = true;
                              this.rare = 5;
                              this.value = Item.buyPrice(gold: 16);
                              this.handOffSlot = (sbyte) 10;
                              this.handOnSlot = (sbyte) 17;
                              return;
                            case 2222:
                              this.width = 18;
                              this.height = 18;
                              this.headSlot = 158;
                              this.vanity = true;
                              this.value = Item.sellPrice(silver: 25);
                              return;
                            case 2223:
                              this.autoReuse = true;
                              this.useStyle = 5;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.width = 50;
                              this.height = 18;
                              this.shoot = 10;
                              this.useAmmo = AmmoID.Arrow;
                              this.UseSound = SoundID.Item75;
                              this.crit = 7;
                              this.damage = 85;
                              this.knockBack = 3f;
                              this.shootSpeed = 7.75f;
                              this.noMelee = true;
                              this.value = Item.buyPrice(gold: 45);
                              this.rare = 8;
                              this.ranged = true;
                              return;
                            case 2224:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 34;
                              this.placeStyle = 22;
                              this.width = 26;
                              this.height = 26;
                              this.value = 160;
                              return;
                            case 2225:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 93;
                              this.placeStyle = 17;
                              this.width = 10;
                              this.height = 24;
                              this.value = 120;
                              return;
                            case 2226:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 42;
                              this.width = 12;
                              this.height = 28;
                              this.placeStyle = 26;
                              this.value = 200;
                              return;
                            case 2227:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 100;
                              this.placeStyle = 17;
                              this.width = 20;
                              this.height = 20;
                              this.value = 120;
                              return;
                            case 2228:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 15;
                              this.placeStyle = 27;
                              this.width = 12;
                              this.height = 30;
                              this.value = 150;
                              return;
                            case 2229:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 18;
                              this.placeStyle = 18;
                              this.width = 28;
                              this.height = 14;
                              this.value = 150;
                              return;
                            case 2230:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 21;
                              this.placeStyle = 28;
                              this.width = 26;
                              this.height = 22;
                              this.value = 320;
                              return;
                            case 2231:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.autoReuse = true;
                              this.createTile = 79;
                              this.placeStyle = 21;
                              this.width = 28;
                              this.height = 20;
                              this.value = 600;
                              return;
                            case 2232:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 90;
                              this.placeStyle = 16;
                              this.width = 20;
                              this.height = 20;
                              this.value = 300;
                              return;
                            case 2233:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 101;
                              this.width = 20;
                              this.height = 20;
                              this.value = 300;
                              this.placeStyle = 22;
                              return;
                            case 2234:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 13;
                              this.placeStyle = 5;
                              this.width = 16;
                              this.height = 24;
                              this.value = 20;
                              return;
                            case 2235:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 103;
                              this.placeStyle = 1;
                              this.width = 16;
                              this.height = 24;
                              this.value = 20;
                              return;
                            case 2236:
                              this.noWet = true;
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 99;
                              this.consumable = true;
                              this.createTile = 33;
                              this.width = 8;
                              this.height = 18;
                              this.value = Item.sellPrice(copper: 60);
                              this.placeStyle = 17;
                              return;
                            default:
                              if (type >= 2237 && type <= 2241)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 104;
                                this.placeStyle = 1 + type - 2237;
                                this.width = 20;
                                this.height = 20;
                                this.value = 300;
                                return;
                              }
                              if (type == 2242 || type == 2243)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 103;
                                this.placeStyle = 2 + type - 2242;
                                this.width = 16;
                                this.height = 24;
                                this.value = 20;
                                if (type != 2242)
                                  return;
                                this.value = Item.buyPrice(silver: 20);
                                return;
                              }
                              if (type == 2244)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 13;
                                this.placeStyle = 6;
                                this.width = 16;
                                this.height = 24;
                                this.value = 20;
                                return;
                              }
                              if (type >= 2245 && type <= 2247)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 87;
                                this.placeStyle = 5 + type - 2245;
                                this.width = 20;
                                this.height = 20;
                                this.value = 300;
                                return;
                              }
                              if (type == 2248)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 14;
                                this.placeStyle = 24;
                                this.width = 26;
                                this.height = 20;
                                this.value = 300;
                                return;
                              }
                              if (type == 2249 || type == 2250)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 21;
                                this.placeStyle = 29 + type - 2249;
                                this.width = 26;
                                this.height = 22;
                                this.value = 2500;
                                return;
                              }
                              if (type >= 2251 && type <= 2253)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 18;
                                this.placeStyle = 19 + type - 2251;
                                this.width = 28;
                                this.height = 14;
                                this.value = 150;
                                return;
                              }
                              if (type >= 2254 && type <= 2256)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 87;
                                this.placeStyle = 8 + type - 2254;
                                this.width = 20;
                                this.height = 20;
                                this.value = 300;
                                return;
                              }
                              if (type == 2257 || type == 2258)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 13;
                                this.placeStyle = 7 + type - 2257;
                                this.width = 16;
                                this.height = 24;
                                this.value = 20;
                                if (type != 2258)
                                  return;
                                this.value = Item.buyPrice(silver: 50);
                                return;
                              }
                              if (type == 2259)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 99;
                                this.consumable = true;
                                this.createTile = 14;
                                this.placeStyle = 25;
                                this.width = 26;
                                this.height = 20;
                                this.value = 300;
                                return;
                              }
                              if (type >= 2260 && type <= 2262)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 10;
                                this.autoReuse = true;
                                this.maxStack = 999;
                                this.consumable = true;
                                this.createTile = 311 + type - 2260;
                                this.width = 12;
                                this.height = 12;
                                this.value = Item.buyPrice(copper: 50);
                                return;
                              }
                              if (type >= 2263 && type <= 2264)
                              {
                                this.useStyle = 1;
                                this.useTurn = true;
                                this.useAnimation = 15;
                                this.useTime = 7;
                                this.autoReuse = true;
                                this.maxStack = 999;
                                this.consumable = true;
                                this.createWall = 142 + type - 2263;
                                this.width = 12;
                                this.height = 12;
                                return;
                              }
                              switch (type)
                              {
                                case 2265:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.createTile = 10;
                                  this.placeStyle = 28;
                                  this.width = 14;
                                  this.height = 28;
                                  this.value = 200;
                                  return;
                                case 2266:
                                  this.UseSound = SoundID.Item3;
                                  this.useStyle = 9;
                                  this.useTurn = true;
                                  this.useAnimation = 17;
                                  this.useTime = 17;
                                  this.maxStack = 30;
                                  this.consumable = true;
                                  this.width = 10;
                                  this.height = 10;
                                  this.buffType = 25;
                                  this.buffTime = 14400;
                                  this.rare = 1;
                                  this.value = Item.buyPrice(silver: 5);
                                  return;
                                case 2269:
                                  this.autoReuse = false;
                                  this.useStyle = 5;
                                  this.useAnimation = 22;
                                  this.useTime = 22;
                                  this.width = 24;
                                  this.height = 24;
                                  this.shoot = 14;
                                  this.knockBack = 4f;
                                  this.useAmmo = AmmoID.Bullet;
                                  this.UseSound = SoundID.Item41;
                                  this.damage = 20;
                                  this.shootSpeed = 16f;
                                  this.noMelee = true;
                                  this.value = Item.buyPrice(gold: 10);
                                  this.scale = 0.85f;
                                  this.rare = 2;
                                  this.ranged = true;
                                  this.crit = 5;
                                  return;
                                case 2270:
                                  this.useStyle = 5;
                                  this.autoReuse = true;
                                  this.useAnimation = 7;
                                  this.useTime = 7;
                                  this.width = 50;
                                  this.height = 18;
                                  this.shoot = 10;
                                  this.useAmmo = AmmoID.Bullet;
                                  this.UseSound = SoundID.Item41;
                                  this.damage = 21;
                                  this.shootSpeed = 8f;
                                  this.noMelee = true;
                                  this.value = Item.buyPrice(gold: 35);
                                  this.knockBack = 1.5f;
                                  this.rare = 4;
                                  this.ranged = true;
                                  return;
                                case 2271:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 7;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createWall = 144;
                                  this.width = 12;
                                  this.height = 12;
                                  this.value = Item.buyPrice(silver: 2, copper: 50);
                                  return;
                                case 2272:
                                  this.useStyle = 5;
                                  this.useAnimation = 20;
                                  this.useTime = 20;
                                  this.width = 38;
                                  this.height = 10;
                                  this.damage = 0;
                                  this.scale = 0.9f;
                                  this.shoot = 358;
                                  this.shootSpeed = 11f;
                                  this.value = Item.buyPrice(gold: 1, silver: 50);
                                  return;
                                case 2273:
                                  this.autoReuse = true;
                                  this.useTurn = true;
                                  this.useStyle = 1;
                                  this.useAnimation = 22;
                                  this.knockBack = 3.5f;
                                  this.width = 34;
                                  this.height = 34;
                                  this.damage = 16;
                                  this.crit = 15;
                                  this.scale = 1f;
                                  this.UseSound = SoundID.Item1;
                                  this.rare = 1;
                                  this.value = Item.buyPrice(gold: 10);
                                  this.melee = true;
                                  return;
                                case 2274:
                                  this.flame = true;
                                  this.noWet = true;
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.holdStyle = 1;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 4;
                                  this.placeStyle = 12;
                                  this.width = 10;
                                  this.height = 12;
                                  this.value = Item.buyPrice(silver: 3);
                                  return;
                                case 2275:
                                  this.width = 18;
                                  this.height = 18;
                                  this.headSlot = 159;
                                  this.value = Item.buyPrice(gold: 3);
                                  this.defense = 2;
                                  this.rare = 2;
                                  return;
                                case 2276:
                                  this.width = 24;
                                  this.height = 24;
                                  this.accessory = true;
                                  this.vanity = true;
                                  this.rare = 8;
                                  this.value = Item.buyPrice(2);
                                  this.handOnSlot = (sbyte) 16;
                                  return;
                                case 2277:
                                  this.width = 18;
                                  this.height = 14;
                                  this.bodySlot = 165;
                                  this.value = Item.buyPrice(gold: 2);
                                  this.defense = 4;
                                  this.rare = 1;
                                  return;
                                case 2278:
                                  this.width = 18;
                                  this.height = 14;
                                  this.bodySlot = 166;
                                  this.vanity = true;
                                  this.value = Item.buyPrice(gold: 1);
                                  return;
                                case 2279:
                                  this.width = 18;
                                  this.height = 14;
                                  this.bodySlot = 167;
                                  this.value = Item.buyPrice(gold: 3, silver: 50);
                                  this.defense = 2;
                                  this.rare = 1;
                                  return;
                                case 2280:
                                  this.width = 22;
                                  this.height = 20;
                                  this.accessory = true;
                                  this.value = 400000;
                                  this.rare = 7;
                                  this.wingSlot = (sbyte) 24;
                                  return;
                                default:
                                  if (type >= 2281 && type <= 2283)
                                  {
                                    this.useStyle = 1;
                                    this.useTurn = true;
                                    this.useAnimation = 15;
                                    this.useTime = 10;
                                    this.autoReuse = true;
                                    this.maxStack = 99;
                                    this.consumable = true;
                                    this.createTile = 242;
                                    this.width = 30;
                                    this.height = 30;
                                    this.value = Item.buyPrice(gold: 1);
                                    this.placeStyle = 22 + type - 2281;
                                    return;
                                  }
                                  if (type >= 2284 && type <= 2287)
                                  {
                                    this.width = 26;
                                    this.height = 30;
                                    this.maxStack = 1;
                                    this.value = Item.buyPrice(gold: 5);
                                    this.rare = 5;
                                    this.accessory = true;
                                    this.backSlot = (sbyte) (3 + type - 2284);
                                    this.frontSlot = (sbyte) (1 + type - 2284);
                                    this.vanity = true;
                                    return;
                                  }
                                  if (type == 2288)
                                  {
                                    this.useStyle = 1;
                                    this.useTurn = true;
                                    this.useAnimation = 15;
                                    this.useTime = 10;
                                    this.autoReuse = true;
                                    this.maxStack = 99;
                                    this.consumable = true;
                                    this.createTile = 15;
                                    this.placeStyle = 28;
                                    this.width = 12;
                                    this.height = 30;
                                    this.value = 150;
                                    return;
                                  }
                                  if (type == 2289 || type >= 2291 && type <= 2296)
                                  {
                                    this.useStyle = 1;
                                    this.useAnimation = 8;
                                    this.useTime = 8;
                                    this.width = 24;
                                    this.height = 28;
                                    this.UseSound = SoundID.Item1;
                                    this.shoot = 361 + type - 2291;
                                    switch (type)
                                    {
                                      case 2289:
                                        this.fishingPole = 5;
                                        this.shootSpeed = 9f;
                                        this.shoot = 360;
                                        this.value = Item.sellPrice(copper: 60);
                                        return;
                                      case 2291:
                                        this.fishingPole = 15;
                                        this.shootSpeed = 11f;
                                        this.value = Item.sellPrice(silver: 24);
                                        return;
                                      case 2292:
                                        this.fishingPole = 27;
                                        this.shootSpeed = 14f;
                                        this.rare = 2;
                                        this.value = Item.sellPrice(gold: 1);
                                        return;
                                      case 2293:
                                        this.fishingPole = 20;
                                        this.shootSpeed = 13f;
                                        this.rare = 1;
                                        this.value = Item.sellPrice(gold: 2, silver: 40);
                                        return;
                                      case 2294:
                                        this.fishingPole = 50;
                                        this.shootSpeed = 17f;
                                        this.rare = 3;
                                        this.value = Item.sellPrice(gold: 20);
                                        return;
                                      case 2295:
                                        this.fishingPole = 30;
                                        this.shootSpeed = 15f;
                                        this.rare = 2;
                                        this.value = Item.buyPrice(gold: 20);
                                        return;
                                      case 2296:
                                        this.fishingPole = 40;
                                        this.shootSpeed = 16f;
                                        this.rare = 2;
                                        this.value = Item.buyPrice(gold: 35);
                                        return;
                                      default:
                                        return;
                                    }
                                  }
                                  else
                                  {
                                    if (type >= 2421 && type <= 2422)
                                    {
                                      this.useStyle = 1;
                                      this.useAnimation = 8;
                                      this.useTime = 8;
                                      this.width = 24;
                                      this.height = 28;
                                      this.UseSound = SoundID.Item1;
                                      this.shoot = 381 + type - 2421;
                                      if (type == 2421)
                                      {
                                        this.fishingPole = 22;
                                        this.shootSpeed = 13.5f;
                                        this.rare = 1;
                                        this.value = Item.sellPrice(gold: 3, silver: 12);
                                        return;
                                      }
                                      this.fishingPole = 45;
                                      this.shootSpeed = 16.5f;
                                      this.rare = 3;
                                      this.value = Item.sellPrice(gold: 10);
                                      return;
                                    }
                                    if (type == 2320)
                                    {
                                      this.autoReuse = true;
                                      this.width = 26;
                                      this.height = 26;
                                      this.value = Item.sellPrice(gold: 1, silver: 50);
                                      this.useStyle = 1;
                                      this.useAnimation = 24;
                                      this.useTime = 14;
                                      this.hammer = 70;
                                      this.knockBack = 6f;
                                      this.damage = 24;
                                      this.scale = 1.05f;
                                      this.UseSound = SoundID.Item1;
                                      this.rare = 3;
                                      this.melee = true;
                                      return;
                                    }
                                    if (type == 2314)
                                    {
                                      this.maxStack = 30;
                                      this.width = 26;
                                      this.height = 26;
                                      this.value = Item.sellPrice(silver: 15);
                                      this.rare = 1;
                                      this.UseSound = SoundID.Item3;
                                      this.healLife = 120;
                                      this.useStyle = 2;
                                      this.useTurn = true;
                                      this.useAnimation = 17;
                                      this.useTime = 17;
                                      this.consumable = true;
                                      this.potion = true;
                                      return;
                                    }
                                    if (type >= 2290 && type <= 2321)
                                    {
                                      this.maxStack = 999;
                                      this.width = 26;
                                      this.height = 26;
                                      this.value = Item.sellPrice(silver: 5);
                                      if (type == 2308)
                                      {
                                        this.value = Item.sellPrice(gold: 10);
                                        this.rare = 4;
                                      }
                                      if (type == 2312)
                                      {
                                        this.value = Item.sellPrice(silver: 50);
                                        this.rare = 2;
                                      }
                                      if (type == 2317)
                                      {
                                        this.value = Item.sellPrice(gold: 3);
                                        this.rare = 4;
                                      }
                                      if (type == 2310)
                                      {
                                        this.value = Item.sellPrice(gold: 1);
                                        this.rare = 3;
                                      }
                                      if (type == 2321)
                                      {
                                        this.value = Item.sellPrice(silver: 25);
                                        this.rare = 1;
                                      }
                                      if (type == 2315)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 2;
                                      }
                                      if (type == 2303)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2304)
                                      {
                                        this.value = Item.sellPrice(silver: 30);
                                        this.rare = 1;
                                      }
                                      if (type == 2316)
                                        this.value = Item.sellPrice(silver: 15);
                                      if (type == 2311)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2313)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2306)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2307)
                                      {
                                        this.value = Item.sellPrice(silver: 25);
                                        this.rare = 2;
                                      }
                                      if (type == 2319)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2318)
                                      {
                                        this.value = Item.sellPrice(silver: 15);
                                        this.rare = 1;
                                      }
                                      if (type == 2298)
                                        this.value = Item.sellPrice(silver: 7, copper: 50);
                                      if (type == 2309)
                                      {
                                        this.value = Item.sellPrice(silver: 7, copper: 50);
                                        this.rare = 1;
                                      }
                                      if (type == 2300)
                                        this.value = Item.sellPrice(silver: 7, copper: 50);
                                      if (type == 2301)
                                        this.value = Item.sellPrice(silver: 7, copper: 50);
                                      if (type == 2302)
                                        this.value = Item.sellPrice(silver: 15);
                                      if (type == 2299)
                                        this.value = Item.sellPrice(silver: 7, copper: 50);
                                      if (type != 2305)
                                        return;
                                      this.value = Item.sellPrice(silver: 7, copper: 50);
                                      this.rare = 1;
                                      return;
                                    }
                                    switch (type)
                                    {
                                      case 2322:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 104;
                                        this.buffTime = 36000;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2323:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 105;
                                        this.buffTime = 28800;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2324:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 106;
                                        this.buffTime = 28800;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2325:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 107;
                                        this.buffTime = 162000;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2326:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 108;
                                        this.buffTime = 28800;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2327:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 109;
                                        this.buffTime = 28800;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2328:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 110;
                                        this.buffTime = 28800;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2329:
                                        this.UseSound = SoundID.Item3;
                                        this.useStyle = 9;
                                        this.useTurn = true;
                                        this.useAnimation = 17;
                                        this.useTime = 17;
                                        this.maxStack = 30;
                                        this.consumable = true;
                                        this.width = 14;
                                        this.height = 24;
                                        this.buffType = 111;
                                        this.buffTime = 36000;
                                        this.value = 1000;
                                        this.rare = 1;
                                        return;
                                      case 2330:
                                        this.autoReuse = true;
                                        this.useStyle = 1;
                                        this.useAnimation = 35;
                                        this.width = 24;
                                        this.height = 28;
                                        this.damage = 24;
                                        this.knockBack = 7f;
                                        this.scale = 1.15f;
                                        this.UseSound = SoundID.Item1;
                                        this.rare = 1;
                                        this.value = Item.sellPrice(gold: 1);
                                        this.melee = true;
                                        return;
                                      case 2331:
                                        this.useStyle = 5;
                                        this.useAnimation = 20;
                                        this.useTime = 20;
                                        this.shootSpeed = 4f;
                                        this.knockBack = 6.5f;
                                        this.width = 40;
                                        this.height = 40;
                                        this.damage = 70;
                                        this.crit = 20;
                                        this.UseSound = SoundID.Item1;
                                        this.shoot = 367;
                                        this.rare = 7;
                                        this.value = Item.sellPrice(gold: 1);
                                        this.noMelee = true;
                                        this.noUseGraphic = true;
                                        this.melee = true;
                                        return;
                                      case 2332:
                                        this.useStyle = 5;
                                        this.useAnimation = 20;
                                        this.useTime = 20;
                                        this.shootSpeed = 4f;
                                        this.knockBack = 4.25f;
                                        this.width = 40;
                                        this.height = 40;
                                        this.damage = 19;
                                        this.UseSound = SoundID.Item1;
                                        this.shoot = 368;
                                        this.rare = 2;
                                        this.value = Item.sellPrice(silver: 50);
                                        this.noMelee = true;
                                        this.noUseGraphic = true;
                                        this.melee = true;
                                        return;
                                      case 2333:
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 7;
                                        this.autoReuse = true;
                                        this.maxStack = 999;
                                        this.consumable = true;
                                        this.createWall = 145;
                                        this.width = 12;
                                        this.height = 12;
                                        return;
                                      case 2334:
                                        this.width = 12;
                                        this.height = 12;
                                        this.rare = 1;
                                        this.maxStack = 99;
                                        this.value = Item.sellPrice(silver: 10);
                                        this.createTile = 376;
                                        this.placeStyle = 0;
                                        this.useAnimation = 15;
                                        this.useTime = 15;
                                        this.autoReuse = true;
                                        this.useStyle = 1;
                                        this.consumable = true;
                                        return;
                                      case 2335:
                                        this.width = 12;
                                        this.height = 12;
                                        this.rare = 2;
                                        this.maxStack = 99;
                                        this.value = Item.sellPrice(silver: 50);
                                        this.createTile = 376;
                                        this.placeStyle = 1;
                                        this.useAnimation = 15;
                                        this.useTime = 15;
                                        this.autoReuse = true;
                                        this.useStyle = 1;
                                        this.consumable = true;
                                        return;
                                      case 2336:
                                        this.width = 12;
                                        this.height = 12;
                                        this.rare = 3;
                                        this.maxStack = 99;
                                        this.value = Item.sellPrice(gold: 2);
                                        this.createTile = 376;
                                        this.placeStyle = 2;
                                        this.useAnimation = 15;
                                        this.useTime = 15;
                                        this.autoReuse = true;
                                        this.useStyle = 1;
                                        this.consumable = true;
                                        return;
                                      default:
                                        if (type >= 2337 && type <= 2339)
                                        {
                                          this.width = 12;
                                          this.height = 12;
                                          this.rare = -1;
                                          this.maxStack = 99;
                                          return;
                                        }
                                        switch (type)
                                        {
                                          case 2340:
                                            this.useStyle = 1;
                                            this.useAnimation = 15;
                                            this.useTime = 7;
                                            this.useTurn = true;
                                            this.autoReuse = true;
                                            this.width = 16;
                                            this.height = 16;
                                            this.maxStack = 999;
                                            this.createTile = 314;
                                            this.placeStyle = 0;
                                            this.consumable = true;
                                            this.cartTrack = true;
                                            this.tileBoost = 5;
                                            return;
                                          case 2341:
                                            this.useStyle = 1;
                                            this.useTurn = true;
                                            this.useAnimation = 22;
                                            this.useTime = 18;
                                            this.autoReuse = true;
                                            this.width = 24;
                                            this.height = 28;
                                            this.damage = 16;
                                            this.pick = 59;
                                            this.scale = 1.15f;
                                            this.UseSound = SoundID.Item1;
                                            this.knockBack = 3f;
                                            this.rare = 3;
                                            this.value = Item.sellPrice(gold: 1, silver: 50);
                                            this.melee = true;
                                            return;
                                          case 2342:
                                            this.useStyle = 5;
                                            this.useAnimation = 25;
                                            this.useTime = 8;
                                            this.shootSpeed = 48f;
                                            this.knockBack = 2.25f;
                                            this.width = 20;
                                            this.height = 12;
                                            this.damage = 13;
                                            this.axe = 14;
                                            this.UseSound = SoundID.Item23;
                                            this.shoot = 369;
                                            this.rare = 3;
                                            this.value = Item.sellPrice(gold: 1, silver: 50);
                                            this.noMelee = true;
                                            this.noUseGraphic = true;
                                            this.melee = true;
                                            this.channel = true;
                                            return;
                                          case 2343:
                                            this.width = 48;
                                            this.height = 28;
                                            this.mountType = 6;
                                            this.rare = 1;
                                            this.value = Item.sellPrice(silver: 2);
                                            return;
                                          case 2344:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 112;
                                            this.buffTime = 28800;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2345:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 113;
                                            this.buffTime = 28800;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2346:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 114;
                                            this.buffTime = 14400;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2347:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 115;
                                            this.buffTime = 14400;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2348:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 116;
                                            this.buffTime = 14400;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2349:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 117;
                                            this.buffTime = 14400;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2350:
                                            this.UseSound = SoundID.Item6;
                                            this.useStyle = 6;
                                            this.useTurn = true;
                                            this.useTime = this.useAnimation = 30;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2351:
                                            this.UseSound = SoundID.Item6;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2352:
                                            this.useStyle = 1;
                                            this.shootSpeed = 9f;
                                            this.shoot = 370;
                                            this.width = 18;
                                            this.height = 20;
                                            this.maxStack = 99;
                                            this.consumable = true;
                                            this.UseSound = SoundID.Item1;
                                            this.useAnimation = 15;
                                            this.useTime = 15;
                                            this.noUseGraphic = true;
                                            this.noMelee = true;
                                            this.value = 200;
                                            return;
                                          case 2353:
                                            this.useStyle = 1;
                                            this.shootSpeed = 9f;
                                            this.shoot = 371;
                                            this.width = 18;
                                            this.height = 20;
                                            this.maxStack = 99;
                                            this.consumable = true;
                                            this.UseSound = SoundID.Item1;
                                            this.useAnimation = 15;
                                            this.useTime = 15;
                                            this.noUseGraphic = true;
                                            this.noMelee = true;
                                            this.value = 200;
                                            return;
                                          case 2354:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 121;
                                            this.buffTime = 28800;
                                            this.rare = 1;
                                            this.value = 1000;
                                            return;
                                          case 2355:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 122;
                                            this.buffTime = 28800;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2356:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 123;
                                            this.buffTime = 10800;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2357:
                                            this.autoReuse = true;
                                            this.useTurn = true;
                                            this.useStyle = 1;
                                            this.useAnimation = 15;
                                            this.useTime = 10;
                                            this.maxStack = 999;
                                            this.consumable = true;
                                            this.createTile = 82;
                                            this.placeStyle = 6;
                                            this.width = 12;
                                            this.height = 14;
                                            this.value = 80;
                                            return;
                                          case 2358:
                                            this.maxStack = 999;
                                            this.width = 12;
                                            this.height = 14;
                                            this.value = 100;
                                            return;
                                          case 2359:
                                            this.UseSound = SoundID.Item3;
                                            this.useStyle = 9;
                                            this.useTurn = true;
                                            this.useAnimation = 17;
                                            this.useTime = 17;
                                            this.maxStack = 30;
                                            this.consumable = true;
                                            this.width = 14;
                                            this.height = 24;
                                            this.buffType = 124;
                                            this.buffTime = 54000;
                                            this.value = 1000;
                                            this.rare = 1;
                                            return;
                                          case 2360:
                                            this.noUseGraphic = true;
                                            this.damage = 0;
                                            this.useStyle = 5;
                                            this.shootSpeed = 13f;
                                            this.shoot = 372;
                                            this.width = 18;
                                            this.height = 28;
                                            this.UseSound = SoundID.Item1;
                                            this.useAnimation = 20;
                                            this.useTime = 20;
                                            this.rare = 3;
                                            this.noMelee = true;
                                            this.value = 20000;
                                            return;
                                          case 2361:
                                            this.width = 18;
                                            this.height = 18;
                                            this.defense = 4;
                                            this.headSlot = 160;
                                            this.rare = 3;
                                            this.value = 45000;
                                            return;
                                          case 2362:
                                            this.width = 18;
                                            this.height = 18;
                                            this.defense = 5;
                                            this.bodySlot = 168;
                                            this.rare = 3;
                                            this.value = 30000;
                                            return;
                                          case 2363:
                                            this.width = 18;
                                            this.height = 18;
                                            this.defense = 4;
                                            this.legSlot = 103;
                                            this.rare = 3;
                                            this.value = 30000;
                                            return;
                                          case 2364:
                                            this.mana = 10;
                                            this.damage = 9;
                                            this.useStyle = 1;
                                            this.shootSpeed = 10f;
                                            this.shoot = 373;
                                            this.width = 26;
                                            this.height = 28;
                                            this.UseSound = SoundID.Item76;
                                            this.useAnimation = 22;
                                            this.useTime = 22;
                                            this.rare = 3;
                                            this.noMelee = true;
                                            this.knockBack = 2f;
                                            this.buffType = 125;
                                            this.value = 10000;
                                            this.summon = true;
                                            return;
                                          case 2365:
                                            this.mana = 10;
                                            this.damage = 17;
                                            this.useStyle = 1;
                                            this.shootSpeed = 10f;
                                            this.shoot = 375;
                                            this.width = 26;
                                            this.height = 28;
                                            this.UseSound = SoundID.Item77;
                                            this.useAnimation = 36;
                                            this.useTime = 36;
                                            this.rare = 3;
                                            this.noMelee = true;
                                            this.knockBack = 2f;
                                            this.buffType = 126;
                                            this.value = 10000;
                                            this.summon = true;
                                            return;
                                          case 2366:
                                            this.mana = 10;
                                            this.damage = 26;
                                            this.useStyle = 1;
                                            this.shootSpeed = 14f;
                                            this.shoot = 377;
                                            this.width = 18;
                                            this.height = 20;
                                            this.UseSound = SoundID.Item78;
                                            this.useAnimation = 30;
                                            this.useTime = 30;
                                            this.noMelee = true;
                                            this.value = Item.sellPrice(gold: 5);
                                            this.knockBack = 7.5f;
                                            this.rare = 4;
                                            this.summon = true;
                                            this.sentry = true;
                                            return;
                                          case 2367:
                                            this.width = 18;
                                            this.height = 18;
                                            this.defense = 1;
                                            this.headSlot = 161;
                                            this.rare = 1;
                                            this.value = Item.sellPrice(gold: 1);
                                            return;
                                          case 2368:
                                            this.width = 18;
                                            this.height = 18;
                                            this.bodySlot = 169;
                                            this.defense = 2;
                                            this.rare = 1;
                                            this.value = Item.sellPrice(gold: 1);
                                            return;
                                          case 2369:
                                            this.width = 18;
                                            this.height = 18;
                                            this.legSlot = 104;
                                            this.defense = 1;
                                            this.rare = 1;
                                            this.value = Item.sellPrice(gold: 1);
                                            return;
                                          case 2370:
                                            this.width = 18;
                                            this.height = 18;
                                            this.headSlot = 162;
                                            this.rare = 4;
                                            this.value = Item.sellPrice(silver: 75);
                                            this.defense = 5;
                                            return;
                                          case 2371:
                                            this.width = 18;
                                            this.height = 18;
                                            this.bodySlot = 170;
                                            this.rare = 4;
                                            this.value = Item.sellPrice(silver: 75);
                                            this.defense = 8;
                                            return;
                                          case 2372:
                                            this.width = 18;
                                            this.height = 18;
                                            this.legSlot = 105;
                                            this.rare = 4;
                                            this.value = Item.sellPrice(silver: 75);
                                            this.defense = 7;
                                            return;
                                          default:
                                            if (type >= 2373 && type <= 2375)
                                            {
                                              this.width = 26;
                                              this.height = 30;
                                              this.maxStack = 1;
                                              this.value = Item.sellPrice(gold: 1);
                                              this.rare = 1;
                                              this.accessory = true;
                                              return;
                                            }
                                            if (type >= 2376 && type <= 2385)
                                            {
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 87;
                                              this.placeStyle = 11 + type - 2376;
                                              this.width = 20;
                                              this.height = 20;
                                              this.value = 300;
                                              if (type != 2379)
                                                return;
                                              this.value = Item.buyPrice(gold: 10);
                                              return;
                                            }
                                            if (type >= 2386 && type <= 2396)
                                            {
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 88;
                                              this.placeStyle = 5 + type - 2386;
                                              this.width = 20;
                                              this.height = 20;
                                              this.value = 300;
                                              if (type != 2389)
                                                return;
                                              this.value = Item.buyPrice(gold: 10);
                                              return;
                                            }
                                            if (type >= 2397 && type <= 2416)
                                            {
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 99;
                                              this.consumable = true;
                                              this.createTile = 89;
                                              this.placeStyle = 1 + type - 2397;
                                              this.width = 20;
                                              this.height = 20;
                                              this.value = 300;
                                              return;
                                            }
                                            switch (type)
                                            {
                                              case 2417:
                                                this.width = 18;
                                                this.height = 18;
                                                this.headSlot = 163;
                                                this.vanity = true;
                                                this.value = Item.sellPrice(gold: 1);
                                                return;
                                              case 2418:
                                                this.width = 18;
                                                this.height = 18;
                                                this.bodySlot = 171;
                                                this.vanity = true;
                                                this.value = Item.sellPrice(gold: 1);
                                                return;
                                              case 2419:
                                                this.width = 18;
                                                this.height = 18;
                                                this.legSlot = 106;
                                                this.vanity = true;
                                                this.value = Item.sellPrice(gold: 1);
                                                return;
                                              case 2420:
                                                this.damage = 0;
                                                this.useStyle = 1;
                                                this.shoot = 380;
                                                this.width = 16;
                                                this.height = 30;
                                                this.UseSound = SoundID.Item2;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.rare = 3;
                                                this.noMelee = true;
                                                this.value = Item.sellPrice(gold: 3);
                                                this.buffType = (int) sbyte.MaxValue;
                                                return;
                                              case 2423:
                                                this.width = 16;
                                                this.height = 24;
                                                this.accessory = true;
                                                this.rare = 1;
                                                this.value = 50000;
                                                this.shoeSlot = (sbyte) 15;
                                                return;
                                              case 2424:
                                                this.noMelee = true;
                                                this.useStyle = 1;
                                                this.shootSpeed = 20f;
                                                this.shoot = 383;
                                                this.damage = 55;
                                                this.knockBack = 5f;
                                                this.width = 34;
                                                this.height = 34;
                                                this.UseSound = SoundID.Item1;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.noUseGraphic = true;
                                                this.rare = 3;
                                                this.value = 50000;
                                                this.melee = true;
                                                return;
                                              case 2428:
                                                this.useStyle = 1;
                                                this.width = 16;
                                                this.height = 30;
                                                this.UseSound = SoundID.Item79;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.rare = 8;
                                                this.noMelee = true;
                                                this.mountType = 1;
                                                this.value = Item.sellPrice(gold: 5);
                                                return;
                                              case 2429:
                                                this.useStyle = 1;
                                                this.width = 16;
                                                this.height = 30;
                                                this.UseSound = SoundID.Item80;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.rare = 8;
                                                this.noMelee = true;
                                                this.mountType = 2;
                                                this.value = Item.sellPrice(gold: 5);
                                                return;
                                              case 2430:
                                                this.useStyle = 1;
                                                this.width = 16;
                                                this.height = 30;
                                                this.UseSound = SoundID.Item81;
                                                this.useAnimation = 20;
                                                this.useTime = 20;
                                                this.rare = 8;
                                                this.noMelee = true;
                                                this.mountType = 3;
                                                this.value = Item.sellPrice(gold: 5);
                                                return;
                                              case 2431:
                                                this.width = 18;
                                                this.height = 16;
                                                this.maxStack = 99;
                                                this.value = 100;
                                                return;
                                              default:
                                                if (type >= 2432 && type <= 2434)
                                                {
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 7;
                                                  this.autoReuse = true;
                                                  this.maxStack = 999;
                                                  this.consumable = true;
                                                  this.createWall = 146 + type - 2432;
                                                  this.width = 12;
                                                  this.height = 12;
                                                  if (type != 2434)
                                                    return;
                                                  this.value = Item.buyPrice(copper: 50);
                                                  return;
                                                }
                                                if (type == 2435)
                                                {
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.maxStack = 999;
                                                  this.consumable = true;
                                                  this.createTile = 315;
                                                  this.width = 12;
                                                  this.height = 12;
                                                  this.value = Item.buyPrice(copper: 50);
                                                  return;
                                                }
                                                if (type >= 2436 && type <= 2438)
                                                {
                                                  this.useStyle = 1;
                                                  this.autoReuse = true;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.maxStack = 999;
                                                  this.consumable = true;
                                                  this.width = 12;
                                                  this.height = 12;
                                                  this.noUseGraphic = true;
                                                  this.bait = 20;
                                                  this.value = Item.sellPrice(gold: 3, silver: 50);
                                                  return;
                                                }
                                                if (type >= 2439 && type <= 2441)
                                                {
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.maxStack = 99;
                                                  this.consumable = true;
                                                  this.createTile = 316 + type - 2439;
                                                  this.width = 12;
                                                  this.height = 12;
                                                  return;
                                                }
                                                if (type >= 2442 && type <= 2449)
                                                {
                                                  this.useStyle = 1;
                                                  this.useTurn = true;
                                                  this.useAnimation = 15;
                                                  this.useTime = 10;
                                                  this.autoReuse = true;
                                                  this.maxStack = 99;
                                                  this.consumable = true;
                                                  this.createTile = 240;
                                                  this.width = 30;
                                                  this.height = 30;
                                                  this.value = Item.sellPrice(silver: 50);
                                                  this.placeStyle = 46 + type - 2442;
                                                  return;
                                                }
                                                if (type >= 2450 && type <= 2488)
                                                {
                                                  this.DefaultToQuestFish();
                                                  return;
                                                }
                                                switch (type)
                                                {
                                                  case 2413:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 89;
                                                    this.placeStyle = 23;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2489:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 240;
                                                    this.width = 30;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    this.placeStyle = 54;
                                                    this.rare = 1;
                                                    return;
                                                  case 2490:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 319;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    this.value = Item.sellPrice(gold: 3);
                                                    return;
                                                  case 2491:
                                                    this.useStyle = 1;
                                                    this.width = 16;
                                                    this.height = 30;
                                                    this.UseSound = SoundID.Item25;
                                                    this.useAnimation = 20;
                                                    this.useTime = 20;
                                                    this.rare = 8;
                                                    this.noMelee = true;
                                                    this.mountType = 4;
                                                    this.value = Item.sellPrice(gold: 5);
                                                    return;
                                                  case 2492:
                                                    this.useStyle = 1;
                                                    this.useAnimation = 15;
                                                    this.useTime = 7;
                                                    this.useTurn = true;
                                                    this.autoReuse = true;
                                                    this.width = 16;
                                                    this.height = 16;
                                                    this.maxStack = 99;
                                                    this.createTile = 314;
                                                    this.placeStyle = 1;
                                                    this.consumable = true;
                                                    this.cartTrack = true;
                                                    this.mech = true;
                                                    this.tileBoost = 2;
                                                    this.value = Item.sellPrice(silver: 10);
                                                    return;
                                                  case 2493:
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.headSlot = 164;
                                                    this.rare = 1;
                                                    this.value = Item.sellPrice(silver: 75);
                                                    this.vanity = true;
                                                    return;
                                                  case 2494:
                                                    this.width = 22;
                                                    this.height = 20;
                                                    this.accessory = true;
                                                    this.value = Item.buyPrice(gold: 40);
                                                    this.rare = 4;
                                                    this.wingSlot = (sbyte) 25;
                                                    return;
                                                  case 2495:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 242;
                                                    this.width = 30;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    this.placeStyle = 25;
                                                    return;
                                                  case 2496:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 320;
                                                    this.placeStyle = 0;
                                                    this.width = 22;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    return;
                                                  case 2497:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 242;
                                                    this.width = 30;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(silver: 50);
                                                    this.placeStyle = 26;
                                                    return;
                                                  case 2498:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.headSlot = 165;
                                                    this.vanity = true;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    return;
                                                  case 2499:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.bodySlot = 172;
                                                    this.vanity = true;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    return;
                                                  case 2500:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.legSlot = 107;
                                                    this.vanity = true;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    return;
                                                  case 2501:
                                                    this.width = 18;
                                                    this.height = 12;
                                                    this.maxStack = 1;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    this.rare = 5;
                                                    this.accessory = true;
                                                    this.faceSlot = (sbyte) 8;
                                                    this.vanity = true;
                                                    return;
                                                  case 2502:
                                                    this.useStyle = 1;
                                                    this.width = 16;
                                                    this.height = 30;
                                                    this.UseSound = SoundID.Item25;
                                                    this.useAnimation = 20;
                                                    this.useTime = 20;
                                                    this.rare = 8;
                                                    this.noMelee = true;
                                                    this.mountType = 5;
                                                    this.value = Item.sellPrice(gold: 5);
                                                    return;
                                                  case 2503:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 321;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2504:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 322;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2505:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 7;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createWall = 149;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    return;
                                                  case 2506:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 7;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createWall = 151;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    return;
                                                  case 2507:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 7;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createWall = 150;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    return;
                                                  case 2508:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 7;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createWall = 152;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    return;
                                                  case 2509:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.headSlot = 166;
                                                    return;
                                                  case 2510:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.bodySlot = 173;
                                                    return;
                                                  case 2511:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.legSlot = 108;
                                                    return;
                                                  case 2512:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.headSlot = 167;
                                                    return;
                                                  case 2513:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.bodySlot = 174;
                                                    return;
                                                  case 2514:
                                                    this.width = 18;
                                                    this.height = 18;
                                                    this.defense = 1;
                                                    this.legSlot = 109;
                                                    return;
                                                  case 2515:
                                                    this.useStyle = 5;
                                                    this.useAnimation = 29;
                                                    this.useTime = 29;
                                                    this.width = 12;
                                                    this.height = 28;
                                                    this.shoot = 1;
                                                    this.useAmmo = AmmoID.Arrow;
                                                    this.UseSound = SoundID.Item5;
                                                    this.damage = 6;
                                                    this.shootSpeed = 6.6f;
                                                    this.noMelee = true;
                                                    this.value = 100;
                                                    this.ranged = true;
                                                    return;
                                                  case 2516:
                                                    this.autoReuse = true;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 33;
                                                    this.useTime = 23;
                                                    this.hammer = 35;
                                                    this.width = 24;
                                                    this.height = 28;
                                                    this.damage = 4;
                                                    this.knockBack = 5.5f;
                                                    this.scale = 1.1f;
                                                    this.UseSound = SoundID.Item1;
                                                    this.value = 50;
                                                    this.melee = true;
                                                    return;
                                                  case 2517:
                                                    this.useStyle = 1;
                                                    this.useTurn = false;
                                                    this.useAnimation = 23;
                                                    this.useTime = 23;
                                                    this.width = 24;
                                                    this.height = 28;
                                                    this.damage = 8;
                                                    this.knockBack = 5f;
                                                    this.UseSound = SoundID.Item1;
                                                    this.scale = 1f;
                                                    this.value = 100;
                                                    this.melee = true;
                                                    return;
                                                  case 2518:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 19;
                                                    this.placeStyle = 17;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2519:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 90;
                                                    this.placeStyle = 17;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2520:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.autoReuse = true;
                                                    this.createTile = 79;
                                                    this.placeStyle = 22;
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.value = 2000;
                                                    return;
                                                  case 2521:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 89;
                                                    this.placeStyle = 21;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2522:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 100;
                                                    this.placeStyle = 18;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 1500;
                                                    return;
                                                  case 2523:
                                                    this.noWet = true;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 33;
                                                    this.placeStyle = 18;
                                                    this.width = 8;
                                                    this.value = Item.sellPrice(copper: 60);
                                                    this.height = 18;
                                                    return;
                                                  case 2524:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 15;
                                                    this.placeStyle = 29;
                                                    this.width = 12;
                                                    this.height = 30;
                                                    this.value = 150;
                                                    return;
                                                  case 2525:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 34;
                                                    this.placeStyle = 23;
                                                    this.width = 26;
                                                    this.height = 26;
                                                    this.value = 3000;
                                                    return;
                                                  case 2526:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 21;
                                                    this.placeStyle = 31;
                                                    this.width = 26;
                                                    this.height = 22;
                                                    this.value = 500;
                                                    return;
                                                  case 2527:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 89;
                                                    this.placeStyle = 22;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2528:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 10;
                                                    this.placeStyle = 29;
                                                    this.width = 14;
                                                    this.height = 28;
                                                    this.value = 200;
                                                    return;
                                                  case 2529:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 88;
                                                    this.placeStyle = 16;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2530:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 42;
                                                    this.width = 12;
                                                    this.height = 28;
                                                    this.placeStyle = 27;
                                                    this.value = 150;
                                                    return;
                                                  case 2531:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 87;
                                                    this.placeStyle = 21;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2532:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 14;
                                                    this.placeStyle = 26;
                                                    this.width = 26;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2533:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 93;
                                                    this.placeStyle = 18;
                                                    this.width = 10;
                                                    this.height = 24;
                                                    this.value = 500;
                                                    return;
                                                  case 2534:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 18;
                                                    this.placeStyle = 22;
                                                    this.width = 28;
                                                    this.height = 14;
                                                    this.value = 150;
                                                    return;
                                                  case 2535:
                                                    this.mana = 10;
                                                    this.damage = 30;
                                                    this.useStyle = 1;
                                                    this.shootSpeed = 10f;
                                                    this.shoot = 387;
                                                    this.width = 26;
                                                    this.height = 28;
                                                    this.UseSound = SoundID.Item82;
                                                    this.useAnimation = 36;
                                                    this.useTime = 36;
                                                    this.rare = 5;
                                                    this.noMelee = true;
                                                    this.knockBack = 2f;
                                                    this.buffType = 134;
                                                    this.value = Item.buyPrice(gold: 10);
                                                    this.summon = true;
                                                    return;
                                                  case 2536:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 101;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    this.placeStyle = 23;
                                                    return;
                                                  case 2537:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 90;
                                                    this.placeStyle = 18;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2538:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.autoReuse = true;
                                                    this.createTile = 79;
                                                    this.placeStyle = 23;
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.value = 2000;
                                                    return;
                                                  case 2539:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 89;
                                                    this.placeStyle = 23;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2540:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 101;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    this.placeStyle = 24;
                                                    return;
                                                  case 2541:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 100;
                                                    this.placeStyle = 19;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 1500;
                                                    return;
                                                  case 2542:
                                                    this.noWet = true;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 33;
                                                    this.placeStyle = 19;
                                                    this.width = 8;
                                                    this.value = Item.sellPrice(copper: 60);
                                                    this.height = 18;
                                                    return;
                                                  case 2543:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 34;
                                                    this.placeStyle = 24;
                                                    this.width = 26;
                                                    this.height = 26;
                                                    this.value = 3000;
                                                    return;
                                                  case 2544:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 21;
                                                    this.placeStyle = 32;
                                                    this.width = 26;
                                                    this.height = 22;
                                                    this.value = 500;
                                                    return;
                                                  case 2545:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 88;
                                                    this.placeStyle = 17;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2546:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 42;
                                                    this.width = 12;
                                                    this.height = 28;
                                                    this.placeStyle = 28;
                                                    this.value = 150;
                                                    return;
                                                  case 2547:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 93;
                                                    this.placeStyle = 19;
                                                    this.width = 10;
                                                    this.height = 24;
                                                    this.value = 500;
                                                    return;
                                                  case 2548:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 87;
                                                    this.placeStyle = 22;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2549:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 19;
                                                    this.placeStyle = 18;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2550:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 14;
                                                    this.placeStyle = 27;
                                                    this.width = 26;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2551:
                                                    this.mana = 10;
                                                    this.damage = 26;
                                                    this.useStyle = 1;
                                                    this.shootSpeed = 10f;
                                                    this.shoot = 390;
                                                    this.width = 26;
                                                    this.height = 28;
                                                    this.UseSound = SoundID.Item83;
                                                    this.useAnimation = 36;
                                                    this.useTime = 36;
                                                    this.rare = 4;
                                                    this.noMelee = true;
                                                    this.knockBack = 3f;
                                                    this.buffType = 133;
                                                    this.value = Item.buyPrice(gold: 5);
                                                    this.summon = true;
                                                    return;
                                                  case 2552:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 90;
                                                    this.placeStyle = 19;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2553:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.autoReuse = true;
                                                    this.createTile = 79;
                                                    this.placeStyle = 24;
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.value = 2000;
                                                    return;
                                                  case 2554:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 101;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    this.placeStyle = 25;
                                                    return;
                                                  case 2555:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 100;
                                                    this.placeStyle = 20;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 1500;
                                                    return;
                                                  case 2556:
                                                    this.noWet = true;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 33;
                                                    this.placeStyle = 20;
                                                    this.width = 8;
                                                    this.value = Item.sellPrice(copper: 60);
                                                    this.height = 18;
                                                    return;
                                                  case 2557:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 15;
                                                    this.placeStyle = 30;
                                                    this.width = 12;
                                                    this.height = 30;
                                                    this.value = 150;
                                                    return;
                                                  case 2558:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 34;
                                                    this.placeStyle = 25;
                                                    this.width = 26;
                                                    this.height = 26;
                                                    this.value = 3000;
                                                    return;
                                                  case 2559:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 21;
                                                    this.placeStyle = 33;
                                                    this.width = 26;
                                                    this.height = 22;
                                                    this.value = 500;
                                                    return;
                                                  case 2560:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 104;
                                                    this.placeStyle = 6;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2561:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 10;
                                                    this.placeStyle = 30;
                                                    this.width = 14;
                                                    this.height = 28;
                                                    this.value = 200;
                                                    return;
                                                  case 2562:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 88;
                                                    this.placeStyle = 18;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2563:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 93;
                                                    this.placeStyle = 20;
                                                    this.width = 10;
                                                    this.height = 24;
                                                    this.value = 500;
                                                    return;
                                                  case 2564:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 42;
                                                    this.placeStyle = 29;
                                                    this.width = 12;
                                                    this.height = 28;
                                                    this.value = 150;
                                                    return;
                                                  case 2565:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 87;
                                                    this.placeStyle = 23;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2566:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 19;
                                                    this.placeStyle = 19;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2567:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 90;
                                                    this.placeStyle = 20;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2568:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.autoReuse = true;
                                                    this.createTile = 79;
                                                    this.placeStyle = 25;
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.value = 2000;
                                                    return;
                                                  case 2569:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 101;
                                                    this.placeStyle = 26;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2570:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 100;
                                                    this.placeStyle = 21;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 1500;
                                                    return;
                                                  case 2571:
                                                    this.noWet = true;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 33;
                                                    this.placeStyle = 21;
                                                    this.width = 8;
                                                    this.value = Item.sellPrice(copper: 60);
                                                    this.height = 18;
                                                    return;
                                                  case 2572:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 15;
                                                    this.placeStyle = 31;
                                                    this.width = 12;
                                                    this.height = 30;
                                                    this.value = 150;
                                                    return;
                                                  case 2573:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 34;
                                                    this.placeStyle = 26;
                                                    this.width = 26;
                                                    this.height = 26;
                                                    this.value = 3000;
                                                    return;
                                                  case 2574:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 21;
                                                    this.placeStyle = 34;
                                                    this.width = 26;
                                                    this.height = 22;
                                                    this.value = 500;
                                                    return;
                                                  case 2575:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 104;
                                                    this.placeStyle = 7;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2576:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 10;
                                                    this.placeStyle = 31;
                                                    this.width = 14;
                                                    this.height = 28;
                                                    this.value = 200;
                                                    return;
                                                  case 2577:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 88;
                                                    this.placeStyle = 19;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2578:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 93;
                                                    this.placeStyle = 21;
                                                    this.width = 10;
                                                    this.height = 24;
                                                    this.value = 500;
                                                    return;
                                                  case 2579:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 42;
                                                    this.placeStyle = 30;
                                                    this.width = 12;
                                                    this.height = 28;
                                                    this.value = 150;
                                                    return;
                                                  case 2580:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 87;
                                                    this.placeStyle = 24;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2581:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 19;
                                                    this.placeStyle = 20;
                                                    this.width = 8;
                                                    this.height = 10;
                                                    return;
                                                  case 2582:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 89;
                                                    this.placeStyle = 25;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2583:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 14;
                                                    this.placeStyle = 29;
                                                    this.width = 26;
                                                    this.height = 20;
                                                    this.value = 300;
                                                    return;
                                                  case 2584:
                                                    this.mana = 10;
                                                    this.damage = 40;
                                                    this.useStyle = 1;
                                                    this.shootSpeed = 10f;
                                                    this.shoot = 393;
                                                    this.width = 26;
                                                    this.height = 28;
                                                    this.UseSound = SoundID.Item44;
                                                    this.useAnimation = 36;
                                                    this.useTime = 36;
                                                    this.rare = 5;
                                                    this.noMelee = true;
                                                    this.knockBack = 6f;
                                                    this.buffType = 135;
                                                    this.value = Item.buyPrice(gold: 5);
                                                    this.summon = true;
                                                    return;
                                                  case 2585:
                                                    this.noUseGraphic = true;
                                                    this.damage = 0;
                                                    this.useStyle = 5;
                                                    this.shootSpeed = 13f;
                                                    this.shoot = 396;
                                                    this.width = 18;
                                                    this.height = 28;
                                                    this.UseSound = SoundID.Item1;
                                                    this.useAnimation = 20;
                                                    this.useTime = 20;
                                                    this.rare = 3;
                                                    this.noMelee = true;
                                                    this.value = 20000;
                                                    return;
                                                  case 2586:
                                                    this.useStyle = 5;
                                                    this.shootSpeed = 5.5f;
                                                    this.shoot = 397;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.UseSound = SoundID.Item1;
                                                    this.useAnimation = 45;
                                                    this.useTime = 45;
                                                    this.noUseGraphic = true;
                                                    this.noMelee = true;
                                                    this.value = 75;
                                                    this.damage = 60;
                                                    this.knockBack = 8f;
                                                    this.ranged = true;
                                                    return;
                                                  case 2587:
                                                    this.damage = 0;
                                                    this.useStyle = 1;
                                                    this.shoot = 398;
                                                    this.width = 16;
                                                    this.height = 30;
                                                    this.UseSound = SoundID.Item2;
                                                    this.useAnimation = 20;
                                                    this.useTime = 20;
                                                    this.rare = 3;
                                                    this.noMelee = true;
                                                    this.buffType = 136;
                                                    this.value = Item.sellPrice(gold: 2);
                                                    return;
                                                  case 2588:
                                                    this.width = 28;
                                                    this.height = 20;
                                                    this.headSlot = 168;
                                                    this.rare = 1;
                                                    this.value = Item.sellPrice(silver: 75);
                                                    this.vanity = true;
                                                    return;
                                                  case 2589:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 240;
                                                    this.width = 30;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(gold: 1);
                                                    this.placeStyle = 55;
                                                    this.rare = 1;
                                                    return;
                                                  case 2590:
                                                    this.useStyle = 5;
                                                    this.shootSpeed = 6.5f;
                                                    this.shoot = 399;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.UseSound = SoundID.Item1;
                                                    this.useAnimation = 40;
                                                    this.useTime = 40;
                                                    this.noUseGraphic = true;
                                                    this.noMelee = true;
                                                    this.value = Item.sellPrice(silver: 1);
                                                    this.damage = 23;
                                                    this.knockBack = 7f;
                                                    this.ranged = true;
                                                    this.rare = 1;
                                                    return;
                                                  default:
                                                    if (type >= 2591 && type <= 2606)
                                                    {
                                                      this.useStyle = 1;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.autoReuse = true;
                                                      this.maxStack = 99;
                                                      this.consumable = true;
                                                      this.createTile = 104;
                                                      this.placeStyle = 8 + type - 2591;
                                                      this.width = 20;
                                                      this.height = 20;
                                                      this.value = 300;
                                                      return;
                                                    }
                                                    switch (type)
                                                    {
                                                      case 2607:
                                                        this.maxStack = 99;
                                                        this.width = 12;
                                                        this.height = 12;
                                                        this.rare = 4;
                                                        this.value = Item.sellPrice(silver: 5);
                                                        return;
                                                      case 2608:
                                                        this.autoReuse = true;
                                                        this.scale = 1.05f;
                                                        this.useStyle = 1;
                                                        this.useAnimation = 20;
                                                        this.knockBack = 6f;
                                                        this.width = 24;
                                                        this.height = 28;
                                                        this.damage = 25;
                                                        this.scale = 1.05f;
                                                        this.UseSound = SoundID.Item1;
                                                        this.rare = 4;
                                                        this.value = 10000;
                                                        this.melee = true;
                                                        return;
                                                      case 2609:
                                                        this.width = 22;
                                                        this.height = 20;
                                                        this.accessory = true;
                                                        this.value = Item.buyPrice(gold: 40);
                                                        this.rare = 8;
                                                        this.wingSlot = (sbyte) 26;
                                                        return;
                                                      case 2610:
                                                        this.useStyle = 5;
                                                        this.useAnimation = 12;
                                                        this.useTime = 12;
                                                        this.width = 38;
                                                        this.height = 10;
                                                        this.damage = 0;
                                                        this.scale = 0.9f;
                                                        this.shoot = 406;
                                                        this.shootSpeed = 8f;
                                                        this.autoReuse = true;
                                                        this.value = Item.buyPrice(gold: 1, silver: 50);
                                                        return;
                                                      case 2611:
                                                        this.autoReuse = false;
                                                        this.useStyle = 5;
                                                        this.useAnimation = 20;
                                                        this.useTime = 20;
                                                        this.autoReuse = true;
                                                        this.knockBack = 4.5f;
                                                        this.width = 30;
                                                        this.height = 10;
                                                        this.damage = 66;
                                                        this.shoot = 404;
                                                        this.shootSpeed = 14f;
                                                        this.UseSound = SoundID.Item1;
                                                        this.rare = 8;
                                                        this.value = Item.sellPrice(gold: 5);
                                                        this.melee = true;
                                                        this.noUseGraphic = true;
                                                        return;
                                                      default:
                                                        if (type >= 2612 && type <= 2620)
                                                        {
                                                          this.useStyle = 1;
                                                          this.useTurn = true;
                                                          this.useAnimation = 15;
                                                          this.useTime = 10;
                                                          this.autoReuse = true;
                                                          this.maxStack = 99;
                                                          this.consumable = true;
                                                          this.createTile = 21;
                                                          this.placeStyle = type > 2614 ? 41 + type - 2615 : 35 + (type - 2612) * 2;
                                                          this.width = 26;
                                                          this.height = 22;
                                                          this.value = 500;
                                                          return;
                                                        }
                                                        switch (type)
                                                        {
                                                          case 2621:
                                                            this.mana = 10;
                                                            this.damage = 50;
                                                            this.useStyle = 1;
                                                            this.shootSpeed = 10f;
                                                            this.shoot = 407;
                                                            this.width = 26;
                                                            this.height = 28;
                                                            this.UseSound = SoundID.Item44;
                                                            this.useAnimation = 36;
                                                            this.useTime = 36;
                                                            this.rare = 8;
                                                            this.noMelee = true;
                                                            this.knockBack = 2f;
                                                            this.buffType = 139;
                                                            this.value = Item.sellPrice(gold: 5);
                                                            this.summon = true;
                                                            return;
                                                          case 2622:
                                                            this.mana = 16;
                                                            this.damage = 60;
                                                            this.useStyle = 5;
                                                            this.shootSpeed = 6f;
                                                            this.shoot = 409;
                                                            this.width = 26;
                                                            this.height = 28;
                                                            this.UseSound = SoundID.Item84;
                                                            this.useAnimation = 40;
                                                            this.useTime = 20;
                                                            this.autoReuse = true;
                                                            this.rare = 8;
                                                            this.noMelee = true;
                                                            this.knockBack = 5f;
                                                            this.scale = 0.9f;
                                                            this.value = Item.sellPrice(gold: 5);
                                                            this.magic = true;
                                                            return;
                                                          case 2624:
                                                            this.useStyle = 5;
                                                            this.autoReuse = true;
                                                            this.useAnimation = 24;
                                                            this.useTime = 24;
                                                            this.width = 50;
                                                            this.height = 18;
                                                            this.shoot = 1;
                                                            this.useAmmo = AmmoID.Arrow;
                                                            this.UseSound = SoundID.Item5;
                                                            this.damage = 60;
                                                            this.shootSpeed = 10f;
                                                            this.noMelee = true;
                                                            this.value = Item.sellPrice(gold: 5);
                                                            this.ranged = true;
                                                            this.rare = 8;
                                                            this.knockBack = 2f;
                                                            return;
                                                          default:
                                                            if (type == 2625 || type == 2626)
                                                            {
                                                              this.DefaultToSeaShelll();
                                                              return;
                                                            }
                                                            if (type >= 2627 && type <= 2630)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 999;
                                                              this.consumable = true;
                                                              this.createTile = 19;
                                                              this.placeStyle = 21 + type - 2627;
                                                              this.width = 8;
                                                              this.height = 10;
                                                              return;
                                                            }
                                                            if (type >= 2631 && type <= 2633)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 18;
                                                              this.placeStyle = 24 + type - 2631;
                                                              this.width = 28;
                                                              this.height = 14;
                                                              this.value = 150;
                                                              return;
                                                            }
                                                            if (type >= 2634 && type <= 2636)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 89;
                                                              this.placeStyle = 26 + type - 2634;
                                                              this.width = 20;
                                                              this.height = 20;
                                                              this.value = 300;
                                                              return;
                                                            }
                                                            if (type == 2623)
                                                            {
                                                              this.autoReuse = true;
                                                              this.mana = 4;
                                                              this.UseSound = SoundID.Item85;
                                                              this.useStyle = 5;
                                                              this.damage = 70;
                                                              this.useAnimation = 9;
                                                              this.useTime = 9;
                                                              this.width = 40;
                                                              this.height = 40;
                                                              this.shoot = 410;
                                                              this.shootSpeed = 11f;
                                                              this.knockBack = 3f;
                                                              this.value = Item.sellPrice(gold: 5);
                                                              this.magic = true;
                                                              this.rare = 8;
                                                              this.noMelee = true;
                                                              return;
                                                            }
                                                            if (type >= 2637 && type <= 2640)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 88;
                                                              this.placeStyle = 20 + type - 2637;
                                                              this.width = 20;
                                                              this.height = 20;
                                                              this.value = 300;
                                                              return;
                                                            }
                                                            if (type == 2641 || type == 2642)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 999;
                                                              this.consumable = true;
                                                              this.createTile = 42;
                                                              this.placeStyle = type != 2641 ? 32 : 31;
                                                              this.width = 12;
                                                              this.height = 28;
                                                              this.value = 150;
                                                              return;
                                                            }
                                                            if (type >= 2643 && type <= 2647)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 93;
                                                              this.placeStyle = 22 + type - 2643;
                                                              this.width = 10;
                                                              this.height = 24;
                                                              this.value = 500;
                                                              return;
                                                            }
                                                            if (type >= 2648 && type <= 2651)
                                                            {
                                                              this.noWet = true;
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 33;
                                                              this.width = 8;
                                                              this.height = 18;
                                                              this.value = Item.sellPrice(copper: 60);
                                                              this.placeStyle = 22 + type - 2648;
                                                              return;
                                                            }
                                                            if (type >= 2652 && type <= 2657)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 34;
                                                              this.placeStyle = 27 + type - 2652;
                                                              this.width = 26;
                                                              this.height = 26;
                                                              this.value = 3000;
                                                              return;
                                                            }
                                                            if (type >= 2658 && type <= 2663)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 90;
                                                              this.placeStyle = 21 + type - 2658;
                                                              this.width = 20;
                                                              this.height = 20;
                                                              this.value = 300;
                                                              return;
                                                            }
                                                            if (type >= 2664 && type <= 2668)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 100;
                                                              this.placeStyle = 22 + type - 2664;
                                                              this.width = 20;
                                                              this.height = 20;
                                                              this.value = 1500;
                                                              return;
                                                            }
                                                            switch (type)
                                                            {
                                                              case 2669:
                                                                this.useStyle = 1;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.maxStack = 99;
                                                                this.consumable = true;
                                                                this.autoReuse = true;
                                                                this.createTile = 79;
                                                                this.placeStyle = 26;
                                                                this.width = 28;
                                                                this.height = 20;
                                                                this.value = 2000;
                                                                return;
                                                              case 2670:
                                                                this.useStyle = 1;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.autoReuse = true;
                                                                this.maxStack = 99;
                                                                this.consumable = true;
                                                                this.createTile = 101;
                                                                this.width = 20;
                                                                this.height = 20;
                                                                this.value = 300;
                                                                this.placeStyle = 27;
                                                                return;
                                                              case 2671:
                                                                this.useStyle = 1;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.autoReuse = true;
                                                                this.maxStack = 99;
                                                                this.consumable = true;
                                                                this.createTile = 87;
                                                                this.placeStyle = 25;
                                                                this.width = 20;
                                                                this.height = 20;
                                                                this.value = 300;
                                                                return;
                                                              case 2672:
                                                                this.useStyle = 1;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.autoReuse = true;
                                                                this.maxStack = 99;
                                                                this.consumable = true;
                                                                this.createTile = 105;
                                                                this.width = 20;
                                                                this.height = 20;
                                                                this.value = 300;
                                                                this.placeStyle = 50;
                                                                return;
                                                              case 2673:
                                                                this.useStyle = 1;
                                                                this.autoReuse = true;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.maxStack = 999;
                                                                this.consumable = true;
                                                                this.width = 12;
                                                                this.height = 12;
                                                                this.makeNPC = (short) 374;
                                                                this.noUseGraphic = true;
                                                                this.bait = 666;
                                                                return;
                                                              default:
                                                                if (type >= 2674 && type <= 2676)
                                                                {
                                                                  this.maxStack = 999;
                                                                  this.consumable = true;
                                                                  this.width = 12;
                                                                  this.height = 12;
                                                                  if (type == 2675)
                                                                  {
                                                                    this.bait = 30;
                                                                    this.value = Item.sellPrice(silver: 3);
                                                                    return;
                                                                  }
                                                                  if (type == 2676)
                                                                  {
                                                                    this.bait = 50;
                                                                    this.value = Item.sellPrice(silver: 10);
                                                                    return;
                                                                  }
                                                                  this.bait = 15;
                                                                  this.value = Item.sellPrice(silver: 1);
                                                                  return;
                                                                }
                                                                if (type >= 2677 && type <= 2690)
                                                                {
                                                                  this.useStyle = 1;
                                                                  this.useTurn = true;
                                                                  this.useAnimation = 15;
                                                                  this.useTime = 7;
                                                                  this.autoReuse = true;
                                                                  this.maxStack = 999;
                                                                  this.consumable = true;
                                                                  switch (type)
                                                                  {
                                                                    case 2677:
                                                                      this.createWall = 153;
                                                                      break;
                                                                    case 2678:
                                                                      this.createWall = 157;
                                                                      break;
                                                                    case 2679:
                                                                      this.createWall = 154;
                                                                      break;
                                                                    case 2680:
                                                                      this.createWall = 158;
                                                                      break;
                                                                    case 2681:
                                                                      this.createWall = 155;
                                                                      break;
                                                                    case 2682:
                                                                      this.createWall = 159;
                                                                      break;
                                                                    case 2683:
                                                                      this.createWall = 156;
                                                                      break;
                                                                    case 2684:
                                                                      this.createWall = 160;
                                                                      break;
                                                                    case 2685:
                                                                      this.createWall = 164;
                                                                      break;
                                                                    case 2686:
                                                                      this.createWall = 161;
                                                                      break;
                                                                    case 2687:
                                                                      this.createWall = 165;
                                                                      break;
                                                                    case 2688:
                                                                      this.createWall = 162;
                                                                      break;
                                                                    case 2689:
                                                                      this.createWall = 166;
                                                                      break;
                                                                    case 2690:
                                                                      this.createWall = 163;
                                                                      break;
                                                                  }
                                                                  this.width = 12;
                                                                  this.height = 12;
                                                                  return;
                                                                }
                                                                switch (type)
                                                                {
                                                                  case 2691:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 7;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createWall = 167;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2692:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 325;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2693:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 326;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2694:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 327;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2695:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 328;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2696:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 7;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createWall = 168;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2697:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 329;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2698:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 7;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createWall = 169;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  case 2699:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 99;
                                                                    this.consumable = true;
                                                                    this.createTile = 471;
                                                                    this.width = 30;
                                                                    this.height = 30;
                                                                    this.value = Item.sellPrice(copper: 50);
                                                                    return;
                                                                  case 2700:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 99;
                                                                    this.consumable = true;
                                                                    this.createTile = 335;
                                                                    this.width = 26;
                                                                    this.height = 22;
                                                                    this.value = Item.buyPrice(gold: 5);
                                                                    this.mech = true;
                                                                    return;
                                                                  case 2701:
                                                                    this.useStyle = 1;
                                                                    this.useTurn = true;
                                                                    this.useAnimation = 15;
                                                                    this.useTime = 10;
                                                                    this.autoReuse = true;
                                                                    this.maxStack = 999;
                                                                    this.consumable = true;
                                                                    this.createTile = 336;
                                                                    this.width = 12;
                                                                    this.height = 12;
                                                                    return;
                                                                  default:
                                                                    if (type >= 2702 && type <= 2737)
                                                                    {
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 99;
                                                                      this.consumable = true;
                                                                      this.createTile = 337;
                                                                      this.width = 20;
                                                                      this.height = 20;
                                                                      this.value = 300;
                                                                      this.placeStyle = type - 2702;
                                                                      return;
                                                                    }
                                                                    switch (type)
                                                                    {
                                                                      case 2738:
                                                                        this.createTile = 338;
                                                                        this.placeStyle = 0;
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.maxStack = 99;
                                                                        this.consumable = true;
                                                                        this.width = 12;
                                                                        this.height = 30;
                                                                        this.value = Item.buyPrice(gold: 3);
                                                                        this.mech = true;
                                                                        return;
                                                                      case 2739:
                                                                        this.useStyle = 1;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 7;
                                                                        this.useTurn = true;
                                                                        this.autoReuse = true;
                                                                        this.width = 16;
                                                                        this.height = 16;
                                                                        this.maxStack = 99;
                                                                        this.createTile = 314;
                                                                        this.placeStyle = 2;
                                                                        this.consumable = true;
                                                                        this.cartTrack = true;
                                                                        this.mech = true;
                                                                        this.tileBoost = 2;
                                                                        this.value = Item.buyPrice(silver: 50);
                                                                        return;
                                                                      case 2740:
                                                                        this.useStyle = 1;
                                                                        this.autoReuse = true;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.maxStack = 999;
                                                                        this.consumable = true;
                                                                        this.width = 12;
                                                                        this.height = 12;
                                                                        this.makeNPC = (short) 377;
                                                                        this.noUseGraphic = true;
                                                                        this.bait = 10;
                                                                        return;
                                                                      case 2741:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.maxStack = 99;
                                                                        this.consumable = true;
                                                                        this.createTile = 339;
                                                                        this.width = 12;
                                                                        this.height = 12;
                                                                        return;
                                                                      case 2742:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.consumable = true;
                                                                        this.createTile = 139;
                                                                        this.placeStyle = 31;
                                                                        this.width = 24;
                                                                        this.height = 24;
                                                                        this.rare = 4;
                                                                        this.value = 100000;
                                                                        this.accessory = true;
                                                                        this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                        return;
                                                                      case 2743:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.maxStack = 99;
                                                                        this.consumable = true;
                                                                        this.createTile = 14;
                                                                        this.placeStyle = 30;
                                                                        this.width = 26;
                                                                        this.height = 20;
                                                                        this.value = 300;
                                                                        return;
                                                                      case 2744:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.maxStack = 999;
                                                                        this.consumable = true;
                                                                        this.createTile = 19;
                                                                        this.placeStyle = 25;
                                                                        this.width = 8;
                                                                        this.height = 10;
                                                                        return;
                                                                      case 2745:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = false;
                                                                        this.useAnimation = 23;
                                                                        this.useTime = 23;
                                                                        this.width = 24;
                                                                        this.height = 28;
                                                                        this.damage = 8;
                                                                        this.knockBack = 5f;
                                                                        this.UseSound = SoundID.Item1;
                                                                        this.scale = 1f;
                                                                        this.value = 100;
                                                                        this.melee = true;
                                                                        return;
                                                                      case 2746:
                                                                        this.autoReuse = true;
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 33;
                                                                        this.useTime = 23;
                                                                        this.hammer = 35;
                                                                        this.width = 24;
                                                                        this.height = 28;
                                                                        this.damage = 4;
                                                                        this.knockBack = 5.5f;
                                                                        this.scale = 1.1f;
                                                                        this.UseSound = SoundID.Item1;
                                                                        this.value = 50;
                                                                        this.melee = true;
                                                                        return;
                                                                      case 2747:
                                                                        this.useStyle = 5;
                                                                        this.useAnimation = 29;
                                                                        this.useTime = 29;
                                                                        this.width = 12;
                                                                        this.height = 28;
                                                                        this.shoot = 1;
                                                                        this.useAmmo = AmmoID.Arrow;
                                                                        this.UseSound = SoundID.Item5;
                                                                        this.damage = 6;
                                                                        this.shootSpeed = 6.6f;
                                                                        this.noMelee = true;
                                                                        this.value = 100;
                                                                        this.ranged = true;
                                                                        return;
                                                                      case 2748:
                                                                        this.useStyle = 1;
                                                                        this.useTurn = true;
                                                                        this.useAnimation = 15;
                                                                        this.useTime = 10;
                                                                        this.autoReuse = true;
                                                                        this.maxStack = 99;
                                                                        this.consumable = true;
                                                                        this.createTile = 21;
                                                                        this.placeStyle = 47;
                                                                        this.width = 26;
                                                                        this.height = 22;
                                                                        this.value = 500;
                                                                        return;
                                                                      case 2749:
                                                                        this.mana = 10;
                                                                        this.damage = 36;
                                                                        this.useStyle = 1;
                                                                        this.shootSpeed = 10f;
                                                                        this.shoot = 423;
                                                                        this.width = 26;
                                                                        this.height = 28;
                                                                        this.UseSound = SoundID.Item44;
                                                                        this.useAnimation = 36;
                                                                        this.useTime = 36;
                                                                        this.rare = 8;
                                                                        this.noMelee = true;
                                                                        this.knockBack = 2f;
                                                                        this.buffType = 140;
                                                                        this.value = Item.sellPrice(gold: 10);
                                                                        this.summon = true;
                                                                        return;
                                                                      case 2750:
                                                                        this.autoReuse = true;
                                                                        this.mana = 13;
                                                                        this.useStyle = 5;
                                                                        this.damage = 50;
                                                                        this.useAnimation = 10;
                                                                        this.useTime = 10;
                                                                        this.width = 40;
                                                                        this.height = 40;
                                                                        this.shoot = 424;
                                                                        this.shootSpeed = 10f;
                                                                        this.knockBack = 4.5f;
                                                                        this.value = Item.sellPrice(gold: 2);
                                                                        this.magic = true;
                                                                        this.rare = 5;
                                                                        this.noMelee = true;
                                                                        this.UseSound = SoundID.Item88;
                                                                        return;
                                                                      default:
                                                                        if (type >= 2751 && type <= 2755)
                                                                        {
                                                                          this.useStyle = 1;
                                                                          this.useTurn = true;
                                                                          this.useAnimation = 15;
                                                                          this.useTime = 10;
                                                                          this.autoReuse = true;
                                                                          this.maxStack = 999;
                                                                          this.consumable = true;
                                                                          this.createTile = 340 + type - 2751;
                                                                          this.width = 12;
                                                                          this.height = 12;
                                                                          return;
                                                                        }
                                                                        switch (type)
                                                                        {
                                                                          case 2756:
                                                                            this.UseSound = SoundID.Item6;
                                                                            this.useStyle = 9;
                                                                            this.useTurn = true;
                                                                            this.useAnimation = 17;
                                                                            this.useTime = 17;
                                                                            this.maxStack = 30;
                                                                            this.consumable = true;
                                                                            this.width = 14;
                                                                            this.height = 24;
                                                                            this.value = 1000;
                                                                            this.rare = 1;
                                                                            return;
                                                                          case 2757:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 14;
                                                                            this.headSlot = 169;
                                                                            this.glowMask = (short) 26;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7);
                                                                            return;
                                                                          case 2758:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 28;
                                                                            this.bodySlot = 175;
                                                                            this.glowMask = (short) 27;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7) * 2;
                                                                            return;
                                                                          case 2759:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 20;
                                                                            this.legSlot = 110;
                                                                            this.rare = 10;
                                                                            this.value = (int) ((double) Item.sellPrice(gold: 7) * 1.5);
                                                                            return;
                                                                          case 2760:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 14;
                                                                            this.headSlot = 170;
                                                                            this.glowMask = (short) 28;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7);
                                                                            return;
                                                                          case 2761:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 18;
                                                                            this.bodySlot = 176;
                                                                            this.glowMask = (short) 29;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7) * 2;
                                                                            return;
                                                                          case 2762:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 14;
                                                                            this.legSlot = 111;
                                                                            this.glowMask = (short) 30;
                                                                            this.rare = 10;
                                                                            this.value = (int) ((double) Item.sellPrice(gold: 7) * 1.5);
                                                                            return;
                                                                          case 2763:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 24;
                                                                            this.headSlot = 171;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7);
                                                                            return;
                                                                          case 2764:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 34;
                                                                            this.bodySlot = 177;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7) * 2;
                                                                            return;
                                                                          case 2765:
                                                                            this.width = 18;
                                                                            this.height = 18;
                                                                            this.defense = 20;
                                                                            this.legSlot = 112;
                                                                            this.rare = 10;
                                                                            this.value = (int) ((double) Item.sellPrice(gold: 7) * 1.5);
                                                                            return;
                                                                          case 2766:
                                                                            this.width = 22;
                                                                            this.height = 14;
                                                                            this.maxStack = 99;
                                                                            this.rare = 8;
                                                                            return;
                                                                          case 2767:
                                                                            this.useStyle = 4;
                                                                            this.width = 22;
                                                                            this.height = 14;
                                                                            this.consumable = true;
                                                                            this.useAnimation = 45;
                                                                            this.useTime = 45;
                                                                            this.maxStack = 20;
                                                                            this.rare = 8;
                                                                            return;
                                                                          case 2768:
                                                                            this.useStyle = 1;
                                                                            this.width = 32;
                                                                            this.height = 30;
                                                                            this.UseSound = SoundID.Item25;
                                                                            this.useAnimation = 20;
                                                                            this.useTime = 20;
                                                                            this.rare = 8;
                                                                            this.noMelee = true;
                                                                            this.mountType = 8;
                                                                            this.value = Item.sellPrice(gold: 5);
                                                                            return;
                                                                          case 2769:
                                                                            this.useStyle = 1;
                                                                            this.width = 32;
                                                                            this.height = 30;
                                                                            this.UseSound = SoundID.Item25;
                                                                            this.useAnimation = 20;
                                                                            this.useTime = 20;
                                                                            this.rare = 8;
                                                                            this.noMelee = true;
                                                                            this.mountType = 7;
                                                                            this.value = Item.sellPrice(gold: 5);
                                                                            return;
                                                                          case 2770:
                                                                            this.width = 22;
                                                                            this.height = 20;
                                                                            this.accessory = true;
                                                                            this.value = this.eclipseMothronPrice;
                                                                            this.rare = 8;
                                                                            this.wingSlot = (sbyte) 27;
                                                                            return;
                                                                          case 2771:
                                                                            this.useStyle = 1;
                                                                            this.channel = true;
                                                                            this.width = 34;
                                                                            this.height = 34;
                                                                            this.UseSound = SoundID.Item90;
                                                                            this.useAnimation = 20;
                                                                            this.useTime = 20;
                                                                            this.rare = 8;
                                                                            this.noMelee = true;
                                                                            this.mountType = 9;
                                                                            this.value = Item.sellPrice(gold: 5);
                                                                            return;
                                                                          case 2772:
                                                                            this.autoReuse = true;
                                                                            this.useStyle = 1;
                                                                            this.useAnimation = 25;
                                                                            this.knockBack = 6f;
                                                                            this.useTime = 7;
                                                                            this.width = 54;
                                                                            this.height = 54;
                                                                            this.damage = 100;
                                                                            this.axe = 27;
                                                                            this.UseSound = SoundID.Item1;
                                                                            this.rare = 10;
                                                                            this.scale = 1.05f;
                                                                            this.value = Item.sellPrice(gold: 6);
                                                                            this.melee = true;
                                                                            this.glowMask = (short) 1;
                                                                            this.tileBoost += 4;
                                                                            return;
                                                                          case 2773:
                                                                            this.useStyle = 5;
                                                                            this.useAnimation = 25;
                                                                            this.useTime = 7;
                                                                            this.shootSpeed = 28f;
                                                                            this.knockBack = 4f;
                                                                            this.width = 56;
                                                                            this.height = 22;
                                                                            this.damage = 80;
                                                                            this.axe = 27;
                                                                            this.UseSound = SoundID.Item23;
                                                                            this.shoot = 427;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 6);
                                                                            this.noMelee = true;
                                                                            this.noUseGraphic = true;
                                                                            this.melee = true;
                                                                            this.channel = true;
                                                                            this.glowMask = (short) 20;
                                                                            this.tileBoost += 4;
                                                                            return;
                                                                          case 2774:
                                                                            this.useStyle = 5;
                                                                            this.useAnimation = 25;
                                                                            this.useTime = 4;
                                                                            this.shootSpeed = 32f;
                                                                            this.knockBack = 0.0f;
                                                                            this.width = 54;
                                                                            this.height = 26;
                                                                            this.damage = 50;
                                                                            this.pick = 225;
                                                                            this.UseSound = SoundID.Item23;
                                                                            this.shoot = 428;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7);
                                                                            this.noMelee = true;
                                                                            this.noUseGraphic = true;
                                                                            this.melee = true;
                                                                            this.channel = true;
                                                                            this.glowMask = (short) 21;
                                                                            this.tileBoost += 3;
                                                                            return;
                                                                          case 2775:
                                                                            this.useTurn = true;
                                                                            this.autoReuse = true;
                                                                            this.useStyle = 1;
                                                                            this.useAnimation = 30;
                                                                            this.useTime = 7;
                                                                            this.knockBack = 7f;
                                                                            this.width = 44;
                                                                            this.height = 42;
                                                                            this.damage = 110;
                                                                            this.hammer = 100;
                                                                            this.UseSound = SoundID.Item1;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 8);
                                                                            this.melee = true;
                                                                            this.scale = 1.1f;
                                                                            this.glowMask = (short) 4;
                                                                            this.tileBoost += 4;
                                                                            return;
                                                                          case 2776:
                                                                            this.useStyle = 1;
                                                                            this.useAnimation = 12;
                                                                            this.useTime = 6;
                                                                            this.knockBack = 5.5f;
                                                                            this.useTurn = true;
                                                                            this.autoReuse = true;
                                                                            this.width = 36;
                                                                            this.height = 36;
                                                                            this.damage = 80;
                                                                            this.pick = 225;
                                                                            this.UseSound = SoundID.Item1;
                                                                            this.rare = 10;
                                                                            this.value = Item.sellPrice(gold: 7);
                                                                            this.melee = true;
                                                                            this.glowMask = (short) 5;
                                                                            this.tileBoost += 4;
                                                                            return;
                                                                          case 2777:
                                                                            this.SetDefaults3(2772);
                                                                            type = 2777;
                                                                            this.glowMask = (short) 6;
                                                                            return;
                                                                          case 2778:
                                                                            this.SetDefaults3(2773);
                                                                            type = 2778;
                                                                            this.shoot = 429;
                                                                            this.glowMask = (short) 22;
                                                                            return;
                                                                          case 2779:
                                                                            this.SetDefaults3(2774);
                                                                            type = 2779;
                                                                            this.shoot = 430;
                                                                            this.glowMask = (short) 23;
                                                                            return;
                                                                          case 2780:
                                                                            this.SetDefaults3(2775);
                                                                            type = 2780;
                                                                            this.glowMask = (short) 9;
                                                                            return;
                                                                          case 2781:
                                                                            this.SetDefaults3(2776);
                                                                            type = 2781;
                                                                            this.glowMask = (short) 10;
                                                                            return;
                                                                          case 2782:
                                                                            this.SetDefaults3(2772);
                                                                            type = 2782;
                                                                            this.glowMask = (short) -1;
                                                                            return;
                                                                          case 2783:
                                                                            this.SetDefaults3(2773);
                                                                            type = 2783;
                                                                            this.shoot = 431;
                                                                            this.glowMask = (short) -1;
                                                                            return;
                                                                          case 2784:
                                                                            this.SetDefaults3(2774);
                                                                            type = 2784;
                                                                            this.shoot = 432;
                                                                            this.glowMask = (short) -1;
                                                                            return;
                                                                          case 2785:
                                                                            this.SetDefaults3(2775);
                                                                            type = 2785;
                                                                            this.glowMask = (short) -1;
                                                                            return;
                                                                          case 2786:
                                                                            this.SetDefaults3(2776);
                                                                            type = 2786;
                                                                            this.glowMask = (short) -1;
                                                                            return;
                                                                          case 2787:
                                                                            this.useStyle = 1;
                                                                            this.useTurn = true;
                                                                            this.useAnimation = 15;
                                                                            this.useTime = 10;
                                                                            this.autoReuse = true;
                                                                            this.maxStack = 999;
                                                                            this.consumable = true;
                                                                            this.createTile = 345;
                                                                            this.width = 12;
                                                                            this.height = 12;
                                                                            return;
                                                                          case 2788:
                                                                            this.useStyle = 1;
                                                                            this.useTurn = true;
                                                                            this.useAnimation = 15;
                                                                            this.useTime = 7;
                                                                            this.autoReuse = true;
                                                                            this.maxStack = 999;
                                                                            this.consumable = true;
                                                                            this.createWall = 172;
                                                                            this.width = 12;
                                                                            this.height = 12;
                                                                            return;
                                                                          default:
                                                                            if (type >= 2789 && type <= 2791)
                                                                            {
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 7;
                                                                              this.autoReuse = true;
                                                                              this.maxStack = 999;
                                                                              this.consumable = true;
                                                                              this.createWall = 173 + type - 2789;
                                                                              this.width = 12;
                                                                              this.height = 12;
                                                                              return;
                                                                            }
                                                                            if (type >= 2792 && type <= 2794)
                                                                            {
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.maxStack = 999;
                                                                              this.consumable = true;
                                                                              this.createTile = 346 + type - 2792;
                                                                              this.width = 12;
                                                                              this.height = 12;
                                                                              return;
                                                                            }
                                                                            switch (type)
                                                                            {
                                                                              case 2795:
                                                                                this.useStyle = 5;
                                                                                this.useAnimation = 20;
                                                                                this.useTime = 20;
                                                                                this.shootSpeed = 20f;
                                                                                this.knockBack = 2f;
                                                                                this.width = 20;
                                                                                this.height = 12;
                                                                                this.damage = 60;
                                                                                this.shoot = 439;
                                                                                this.mana = 6;
                                                                                this.rare = 8;
                                                                                this.value = Item.sellPrice(gold: 10);
                                                                                this.noMelee = true;
                                                                                this.noUseGraphic = true;
                                                                                this.magic = true;
                                                                                this.channel = true;
                                                                                this.glowMask = (short) 47;
                                                                                return;
                                                                              case 2796:
                                                                                this.useStyle = 5;
                                                                                this.useAnimation = 12;
                                                                                this.useTime = 12;
                                                                                this.width = 50;
                                                                                this.height = 18;
                                                                                this.shoot = 442;
                                                                                this.useAmmo = 771;
                                                                                this.glowMask = (short) 36;
                                                                                this.UseSound = SoundID.Item92;
                                                                                this.damage = 40;
                                                                                this.shootSpeed = 12f;
                                                                                this.noMelee = true;
                                                                                this.value = Item.sellPrice(gold: 10);
                                                                                this.ranged = true;
                                                                                this.rare = 8;
                                                                                this.knockBack = 2f;
                                                                                return;
                                                                              case 2797:
                                                                                this.useStyle = 5;
                                                                                this.useAnimation = 21;
                                                                                this.useTime = 21;
                                                                                this.autoReuse = true;
                                                                                this.width = 50;
                                                                                this.height = 18;
                                                                                this.shoot = 444;
                                                                                this.useAmmo = AmmoID.Bullet;
                                                                                this.glowMask = (short) 38;
                                                                                this.UseSound = SoundID.Item95;
                                                                                this.damage = 45;
                                                                                this.shootSpeed = 12f;
                                                                                this.noMelee = true;
                                                                                this.value = Item.sellPrice(gold: 10);
                                                                                this.ranged = true;
                                                                                this.rare = 8;
                                                                                this.knockBack = 3f;
                                                                                return;
                                                                              case 2798:
                                                                                this.useStyle = 5;
                                                                                this.useAnimation = 25;
                                                                                this.useTime = 6;
                                                                                this.shootSpeed = 36f;
                                                                                this.knockBack = 4.75f;
                                                                                this.width = 20;
                                                                                this.height = 12;
                                                                                this.damage = 35;
                                                                                this.pick = 230;
                                                                                this.shoot = 445;
                                                                                this.rare = 8;
                                                                                this.value = Item.sellPrice(gold: 10);
                                                                                this.tileBoost = 11;
                                                                                this.noMelee = true;
                                                                                this.noUseGraphic = true;
                                                                                this.melee = true;
                                                                                this.channel = true;
                                                                                this.glowMask = (short) 39;
                                                                                return;
                                                                              case 2799:
                                                                                this.width = 10;
                                                                                this.height = 26;
                                                                                this.accessory = true;
                                                                                this.value = Item.buyPrice(gold: 1);
                                                                                this.rare = 1;
                                                                                return;
                                                                              case 2800:
                                                                                this.noUseGraphic = true;
                                                                                this.damage = 0;
                                                                                this.knockBack = 7f;
                                                                                this.useStyle = 5;
                                                                                this.shootSpeed = 14f;
                                                                                this.shoot = 446;
                                                                                this.width = 18;
                                                                                this.height = 28;
                                                                                this.UseSound = SoundID.Item1;
                                                                                this.useAnimation = 20;
                                                                                this.useTime = 20;
                                                                                this.rare = 7;
                                                                                this.noMelee = true;
                                                                                this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                return;
                                                                              case 2801:
                                                                                this.width = 28;
                                                                                this.height = 20;
                                                                                this.headSlot = 172;
                                                                                this.rare = 1;
                                                                                this.vanity = true;
                                                                                return;
                                                                              case 2802:
                                                                                this.width = 28;
                                                                                this.height = 20;
                                                                                this.headSlot = 173;
                                                                                this.rare = 1;
                                                                                this.vanity = true;
                                                                                return;
                                                                              case 2803:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.headSlot = 174;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                return;
                                                                              case 2804:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.bodySlot = 178;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                return;
                                                                              case 2805:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.legSlot = 113;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                return;
                                                                              case 2806:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.headSlot = 175;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                this.glowMask = (short) 46;
                                                                                return;
                                                                              case 2807:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.bodySlot = 179;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                this.glowMask = (short) 45;
                                                                                return;
                                                                              case 2808:
                                                                                this.width = 18;
                                                                                this.height = 18;
                                                                                this.legSlot = 114;
                                                                                this.vanity = true;
                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                return;
                                                                              case 2809:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 104;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                this.placeStyle = 24;
                                                                                return;
                                                                              case 2810:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 90;
                                                                                this.placeStyle = 27;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                return;
                                                                              case 2811:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.autoReuse = true;
                                                                                this.createTile = 79;
                                                                                this.placeStyle = 27;
                                                                                this.width = 28;
                                                                                this.height = 20;
                                                                                this.value = 2000;
                                                                                return;
                                                                              case 2812:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 15;
                                                                                this.placeStyle = 32;
                                                                                this.width = 12;
                                                                                this.height = 30;
                                                                                this.value = 150;
                                                                                return;
                                                                              case 2813:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 34;
                                                                                this.placeStyle = 33;
                                                                                this.width = 26;
                                                                                this.height = 26;
                                                                                this.value = 3000;
                                                                                return;
                                                                              case 2814:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 21;
                                                                                this.placeStyle = 48;
                                                                                this.width = 26;
                                                                                this.height = 22;
                                                                                this.value = 500;
                                                                                return;
                                                                              case 2815:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 10;
                                                                                this.placeStyle = 32;
                                                                                this.width = 14;
                                                                                this.height = 28;
                                                                                this.value = 200;
                                                                                return;
                                                                              case 2816:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 88;
                                                                                this.placeStyle = 24;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                return;
                                                                              case 2817:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 101;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                this.placeStyle = 28;
                                                                                return;
                                                                              case 2818:
                                                                                this.noWet = true;
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 33;
                                                                                this.placeStyle = 26;
                                                                                this.width = 8;
                                                                                this.value = Item.sellPrice(copper: 60);
                                                                                this.height = 18;
                                                                                return;
                                                                              case 2819:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 93;
                                                                                this.placeStyle = 27;
                                                                                this.width = 10;
                                                                                this.height = 24;
                                                                                this.value = 500;
                                                                                return;
                                                                              case 2820:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 999;
                                                                                this.consumable = true;
                                                                                this.createTile = 42;
                                                                                this.width = 12;
                                                                                this.height = 28;
                                                                                this.placeStyle = 33;
                                                                                this.value = 150;
                                                                                return;
                                                                              case 2821:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 87;
                                                                                this.placeStyle = 26;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                return;
                                                                              case 2822:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 999;
                                                                                this.consumable = true;
                                                                                this.createTile = 19;
                                                                                this.placeStyle = 26;
                                                                                this.width = 8;
                                                                                this.height = 10;
                                                                                return;
                                                                              case 2823:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 89;
                                                                                this.placeStyle = 29;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                return;
                                                                              case 2824:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 14;
                                                                                this.placeStyle = 31;
                                                                                this.width = 26;
                                                                                this.height = 20;
                                                                                this.value = 300;
                                                                                return;
                                                                              case 2825:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 100;
                                                                                this.placeStyle = 27;
                                                                                this.width = 20;
                                                                                this.height = 20;
                                                                                this.value = 1500;
                                                                                return;
                                                                              case 2826:
                                                                                this.useStyle = 1;
                                                                                this.useTurn = true;
                                                                                this.useAnimation = 15;
                                                                                this.useTime = 10;
                                                                                this.autoReuse = true;
                                                                                this.maxStack = 99;
                                                                                this.consumable = true;
                                                                                this.createTile = 18;
                                                                                this.placeStyle = 27;
                                                                                this.width = 28;
                                                                                this.height = 14;
                                                                                this.value = 150;
                                                                                return;
                                                                              default:
                                                                                if (type >= 2827 && type <= 2855)
                                                                                {
                                                                                  this.useStyle = 1;
                                                                                  this.useTurn = true;
                                                                                  this.useAnimation = 15;
                                                                                  this.useTime = 10;
                                                                                  this.autoReuse = true;
                                                                                  this.maxStack = 99;
                                                                                  this.consumable = true;
                                                                                  this.createTile = 172;
                                                                                  this.placeStyle = type - 2827;
                                                                                  this.width = 20;
                                                                                  this.height = 20;
                                                                                  this.value = 300;
                                                                                  if (type != 2843)
                                                                                    return;
                                                                                  this.value = Item.buyPrice(gold: 10);
                                                                                  return;
                                                                                }
                                                                                switch (type)
                                                                                {
                                                                                  case 2856:
                                                                                    this.width = 28;
                                                                                    this.height = 20;
                                                                                    this.headSlot = 176;
                                                                                    this.rare = 1;
                                                                                    this.vanity = true;
                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                    return;
                                                                                  case 2857:
                                                                                    this.width = 28;
                                                                                    this.height = 20;
                                                                                    this.headSlot = 177;
                                                                                    this.rare = 1;
                                                                                    this.vanity = true;
                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                    return;
                                                                                  case 2858:
                                                                                    this.width = 18;
                                                                                    this.height = 14;
                                                                                    this.bodySlot = 180;
                                                                                    this.rare = 1;
                                                                                    this.vanity = true;
                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                    return;
                                                                                  case 2859:
                                                                                    this.width = 18;
                                                                                    this.height = 14;
                                                                                    this.bodySlot = 181;
                                                                                    this.rare = 1;
                                                                                    this.vanity = true;
                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                    return;
                                                                                  case 2860:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 999;
                                                                                    this.consumable = true;
                                                                                    this.glowMask = (short) 93;
                                                                                    this.createTile = 350;
                                                                                    this.width = 12;
                                                                                    this.height = 12;
                                                                                    return;
                                                                                  case 2861:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 7;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 999;
                                                                                    this.consumable = true;
                                                                                    this.glowMask = (short) 95;
                                                                                    this.createWall = 176;
                                                                                    this.width = 12;
                                                                                    this.height = 12;
                                                                                    return;
                                                                                  case 2862:
                                                                                    this.width = 28;
                                                                                    this.height = 12;
                                                                                    this.headSlot = 178;
                                                                                    this.rare = 3;
                                                                                    this.value = Item.sellPrice(gold: 1);
                                                                                    this.vanity = true;
                                                                                    this.glowMask = (short) 97;
                                                                                    return;
                                                                                  case 2863:
                                                                                    this.width = 20;
                                                                                    this.height = 26;
                                                                                    this.maxStack = 99;
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 98;
                                                                                    this.value = Item.buyPrice(gold: 30);
                                                                                    this.UseSound = SoundID.Item3;
                                                                                    this.useStyle = 9;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 17;
                                                                                    this.useTime = 17;
                                                                                    this.consumable = true;
                                                                                    return;
                                                                                  case 2864:
                                                                                    this.glowMask = (short) 99;
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    return;
                                                                                  case 2865:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 99;
                                                                                    this.consumable = true;
                                                                                    this.createTile = 242;
                                                                                    this.width = 30;
                                                                                    this.height = 30;
                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                    this.placeStyle = 27;
                                                                                    return;
                                                                                  case 2866:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 99;
                                                                                    this.consumable = true;
                                                                                    this.createTile = 242;
                                                                                    this.width = 30;
                                                                                    this.height = 30;
                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                    this.placeStyle = 28;
                                                                                    return;
                                                                                  case 2867:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 99;
                                                                                    this.consumable = true;
                                                                                    this.createTile = 242;
                                                                                    this.width = 30;
                                                                                    this.height = 30;
                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                    this.placeStyle = 29;
                                                                                    return;
                                                                                  case 2868:
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 999;
                                                                                    this.consumable = true;
                                                                                    this.createTile = 351;
                                                                                    this.width = 12;
                                                                                    this.height = 12;
                                                                                    this.value = Item.buyPrice(silver: 1);
                                                                                    return;
                                                                                  case 2869:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    return;
                                                                                  case 2870:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    return;
                                                                                  case 2871:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(silver: 75);
                                                                                    this.rare = 2;
                                                                                    return;
                                                                                  case 2872:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(silver: 75);
                                                                                    this.rare = 2;
                                                                                    return;
                                                                                  case 2873:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    return;
                                                                                  case 2874:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 10000;
                                                                                    this.rare = 1;
                                                                                    return;
                                                                                  case 2875:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 10000;
                                                                                    this.rare = 1;
                                                                                    return;
                                                                                  case 2876:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 10000;
                                                                                    this.rare = 1;
                                                                                    return;
                                                                                  case 2877:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 10000;
                                                                                    this.rare = 1;
                                                                                    return;
                                                                                  case 2878:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 105;
                                                                                    return;
                                                                                  case 2879:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 104;
                                                                                    return;
                                                                                  case 2880:
                                                                                    this.useStyle = 1;
                                                                                    this.useAnimation = 20;
                                                                                    this.useTime = 20;
                                                                                    this.autoReuse = true;
                                                                                    this.shoot = 451;
                                                                                    this.shootSpeed = 11f;
                                                                                    this.knockBack = 4.5f;
                                                                                    this.width = 40;
                                                                                    this.height = 40;
                                                                                    this.damage = 110;
                                                                                    this.scale = 1.05f;
                                                                                    this.UseSound = SoundID.Item1;
                                                                                    this.rare = 8;
                                                                                    this.value = Item.sellPrice(gold: 10);
                                                                                    this.melee = true;
                                                                                    return;
                                                                                  case 2882:
                                                                                    this.useStyle = 5;
                                                                                    this.useAnimation = 20;
                                                                                    this.useTime = 20;
                                                                                    this.shootSpeed = 14f;
                                                                                    this.knockBack = 2f;
                                                                                    this.width = 16;
                                                                                    this.height = 16;
                                                                                    this.damage = 100;
                                                                                    this.UseSound = SoundID.Item75;
                                                                                    this.shoot = 460;
                                                                                    this.mana = 14;
                                                                                    this.rare = 8;
                                                                                    this.value = Item.sellPrice(gold: 10);
                                                                                    this.noMelee = true;
                                                                                    this.noUseGraphic = true;
                                                                                    this.magic = true;
                                                                                    this.channel = true;
                                                                                    this.glowMask = (short) 102;
                                                                                    return;
                                                                                  case 2883:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 103;
                                                                                    return;
                                                                                  case 2884:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 107;
                                                                                    return;
                                                                                  case 2885:
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                    this.rare = 3;
                                                                                    this.glowMask = (short) 106;
                                                                                    return;
                                                                                  case 2886:
                                                                                    this.damage = 0;
                                                                                    this.useStyle = 1;
                                                                                    this.shootSpeed = 4f;
                                                                                    this.shoot = 463;
                                                                                    this.width = 16;
                                                                                    this.height = 24;
                                                                                    this.maxStack = 99;
                                                                                    this.consumable = true;
                                                                                    this.UseSound = SoundID.Item1;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 15;
                                                                                    this.noMelee = true;
                                                                                    this.value = 100;
                                                                                    return;
                                                                                  case 2887:
                                                                                    this.width = 16;
                                                                                    this.height = 18;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 50;
                                                                                    return;
                                                                                  case 2888:
                                                                                    this.useStyle = 5;
                                                                                    this.useAnimation = 24;
                                                                                    this.useTime = 23;
                                                                                    this.width = 12;
                                                                                    this.height = 28;
                                                                                    this.shoot = 469;
                                                                                    this.useAmmo = AmmoID.Arrow;
                                                                                    this.UseSound = SoundID.Item97;
                                                                                    this.damage = 23;
                                                                                    this.shootSpeed = 8f;
                                                                                    this.knockBack = 3f;
                                                                                    this.rare = 3;
                                                                                    this.noMelee = true;
                                                                                    this.value = this.queenBeePrice;
                                                                                    this.ranged = true;
                                                                                    return;
                                                                                  default:
                                                                                    if (type >= 2889 && type <= 2895)
                                                                                    {
                                                                                      this.useStyle = 1;
                                                                                      this.autoReuse = true;
                                                                                      this.useTurn = true;
                                                                                      this.useAnimation = 15;
                                                                                      this.useTime = 10;
                                                                                      this.maxStack = 999;
                                                                                      this.consumable = true;
                                                                                      this.width = 12;
                                                                                      this.height = 12;
                                                                                      this.makeNPC = (short) (442 + type - 2889);
                                                                                      this.noUseGraphic = true;
                                                                                      this.value = Item.sellPrice(gold: 10);
                                                                                      this.rare = 3;
                                                                                      if (type != 2895 && type != 2893 && type != 2891)
                                                                                        return;
                                                                                      this.bait = 50;
                                                                                      return;
                                                                                    }
                                                                                    if (type == 2896)
                                                                                    {
                                                                                      this.useStyle = 1;
                                                                                      this.shootSpeed = 4f;
                                                                                      this.shoot = 470;
                                                                                      this.width = 8;
                                                                                      this.height = 28;
                                                                                      this.maxStack = 99;
                                                                                      this.consumable = true;
                                                                                      this.UseSound = SoundID.Item1;
                                                                                      this.useAnimation = 40;
                                                                                      this.useTime = 40;
                                                                                      this.noUseGraphic = true;
                                                                                      this.noMelee = true;
                                                                                      this.value = Item.buyPrice(silver: 20);
                                                                                      this.rare = 1;
                                                                                      return;
                                                                                    }
                                                                                    if (type >= 2897 && type <= 2994)
                                                                                    {
                                                                                      this.useStyle = 1;
                                                                                      this.useTurn = true;
                                                                                      this.useAnimation = 15;
                                                                                      this.useTime = 10;
                                                                                      this.autoReuse = true;
                                                                                      this.maxStack = 99;
                                                                                      this.consumable = true;
                                                                                      this.createTile = 91;
                                                                                      this.placeStyle = 109 + type - 2897;
                                                                                      this.width = 10;
                                                                                      this.height = 24;
                                                                                      this.value = 1000;
                                                                                      this.rare = 1;
                                                                                      return;
                                                                                    }
                                                                                    switch (type)
                                                                                    {
                                                                                      case 2995:
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 99;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 242;
                                                                                        this.width = 30;
                                                                                        this.height = 30;
                                                                                        this.value = Item.sellPrice(silver: 10);
                                                                                        this.placeStyle = 30;
                                                                                        return;
                                                                                      case 2996:
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 8;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 999;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 353;
                                                                                        this.width = 12;
                                                                                        this.height = 12;
                                                                                        this.tileBoost += 3;
                                                                                        return;
                                                                                      case 2997:
                                                                                        this.maxStack = 30;
                                                                                        this.consumable = true;
                                                                                        this.width = 14;
                                                                                        this.height = 24;
                                                                                        this.value = 1000;
                                                                                        this.rare = 1;
                                                                                        return;
                                                                                      case 2998:
                                                                                        this.width = 24;
                                                                                        this.height = 24;
                                                                                        this.accessory = true;
                                                                                        this.value = 100000;
                                                                                        this.rare = 4;
                                                                                        return;
                                                                                      case 2999:
                                                                                        this.rare = 1;
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 999;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 354;
                                                                                        this.width = 12;
                                                                                        this.height = 12;
                                                                                        this.value = 100000;
                                                                                        return;
                                                                                      case 3000:
                                                                                        this.rare = 1;
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 999;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 355;
                                                                                        this.width = 12;
                                                                                        this.height = 12;
                                                                                        this.value = 100000;
                                                                                        return;
                                                                                      default:
                                                                                        return;
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                  }
                              }
                          }
                      }
                  }
              }
          }
      }
    }

    private void DefaultToQuestFish()
    {
      this.questItem = true;
      this.maxStack = 1;
      this.width = 26;
      this.height = 26;
      this.uniqueStack = true;
      this.rare = -11;
    }

    public void SetDefaults4(int type)
    {
      switch (type)
      {
        case 3001:
          this.rare = 1;
          this.UseSound = SoundID.Item3;
          this.healLife = 80;
          this.healMana = 400;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.potion = true;
          this.value = Item.buyPrice(silver: 5);
          break;
        case 3002:
          this.alpha = 0;
          this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
          this.rare = 1;
          this.useStyle = 1;
          this.shootSpeed = 6f;
          this.shoot = 473;
          this.width = 12;
          this.height = 12;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noMelee = true;
          this.value = Item.buyPrice(silver: 1, copper: 50);
          this.holdStyle = 1;
          break;
        case 3003:
          this.shootSpeed = 3.5f;
          this.shoot = 474;
          this.damage = 6;
          this.width = 10;
          this.height = 28;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Arrow;
          this.knockBack = 2.5f;
          this.value = Item.buyPrice(copper: 15);
          this.ranged = true;
          break;
        case 3004:
          this.flame = true;
          this.noWet = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.holdStyle = 1;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 4;
          this.placeStyle = 13;
          this.width = 10;
          this.height = 12;
          this.value = Item.buyPrice(silver: 1);
          break;
        case 3005:
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 475;
          this.damage = 0;
          this.width = 18;
          this.height = 20;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.noUseGraphic = true;
          this.noMelee = true;
          break;
        case 3006:
          this.mana = 10;
          this.autoReuse = true;
          this.damage = 30;
          this.useStyle = 5;
          this.shootSpeed = 10f;
          this.shoot = 476;
          this.width = 26;
          this.height = 28;
          this.useAnimation = 12;
          this.useTime = 12;
          this.rare = 5;
          this.noMelee = true;
          this.knockBack = 2.5f;
          this.value = Item.sellPrice(gold: 8);
          this.magic = true;
          break;
        case 3007:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 22;
          this.useTime = 22;
          this.width = 38;
          this.height = 6;
          this.shoot = 10;
          this.useAmmo = AmmoID.Dart;
          this.UseSound = SoundID.Item98;
          this.damage = 33;
          this.shootSpeed = 13f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 8);
          this.knockBack = 3.5f;
          this.useAmmo = AmmoID.Dart;
          this.ranged = true;
          this.rare = 5;
          this.scale = 0.9f;
          break;
        case 3008:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 38;
          this.useTime = 38;
          this.width = 38;
          this.height = 6;
          this.shoot = 10;
          this.useAmmo = AmmoID.Dart;
          this.UseSound = SoundID.Item99;
          this.damage = 62;
          this.shootSpeed = 14.5f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 8);
          this.knockBack = 5.5f;
          this.useAmmo = AmmoID.Dart;
          this.ranged = true;
          this.rare = 5;
          this.scale = 1f;
          break;
        case 3009:
          this.shoot = 477;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.ammo = AmmoID.Dart;
          this.damage = 14;
          this.knockBack = 3.5f;
          this.shootSpeed = 1f;
          this.ranged = true;
          this.rare = 3;
          this.value = Item.sellPrice(copper: 6);
          this.consumable = true;
          break;
        case 3010:
          this.shoot = 478;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.ammo = AmmoID.Dart;
          this.damage = 10;
          this.knockBack = 2.2f;
          this.shootSpeed = 3f;
          this.ranged = true;
          this.rare = 3;
          this.value = Item.sellPrice(copper: 6);
          this.consumable = true;
          break;
        case 3011:
          this.shoot = 479;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.ammo = AmmoID.Dart;
          this.damage = 12;
          this.knockBack = 2.5f;
          this.shootSpeed = 3f;
          this.ranged = true;
          this.rare = 3;
          this.value = Item.sellPrice(copper: 6);
          this.consumable = true;
          break;
        case 3012:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 14;
          this.useTime = 14;
          this.knockBack = 3.25f;
          this.width = 30;
          this.height = 10;
          this.damage = 43;
          this.shoot = 481;
          this.shootSpeed = 14f;
          this.UseSound = SoundID.Item1;
          this.rare = 5;
          this.value = Item.sellPrice(gold: 8);
          this.melee = true;
          this.noUseGraphic = true;
          this.noMelee = true;
          break;
        case 3013:
          this.useStyle = 1;
          this.useTurn = true;
          this.autoReuse = true;
          this.useAnimation = 8;
          this.useTime = 8;
          this.width = 24;
          this.height = 28;
          this.damage = 60;
          this.knockBack = 6f;
          this.UseSound = SoundID.Item1;
          this.scale = 1.35f;
          this.melee = true;
          this.rare = 5;
          this.value = Item.sellPrice(gold: 8);
          this.melee = true;
          break;
        case 3014:
          this.mana = 40;
          this.autoReuse = true;
          this.damage = 43;
          this.useStyle = 1;
          this.shootSpeed = 15f;
          this.shoot = 482;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item100;
          this.useAnimation = 24;
          this.useTime = 24;
          this.rare = 5;
          this.noMelee = true;
          this.knockBack = 8f;
          this.value = Item.sellPrice(gold: 8);
          this.magic = true;
          break;
        case 3015:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.value = Item.sellPrice(gold: 8);
          this.rare = 6;
          break;
        case 3016:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.defense = 7;
          this.value = Item.sellPrice(gold: 8);
          this.rare = 5;
          break;
        case 3017:
          this.width = 16;
          this.height = 24;
          this.accessory = true;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 6);
          this.shoeSlot = (sbyte) 16;
          break;
        case 3018:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useAnimation = 23;
          this.useTime = 23;
          this.width = 50;
          this.height = 20;
          this.shoot = 483;
          this.UseSound = SoundID.Item1;
          this.damage = 50;
          this.shootSpeed = 12f;
          this.value = Item.sellPrice(gold: 10);
          this.knockBack = 6f;
          this.rare = 5;
          this.melee = true;
          break;
        case 3019:
          this.autoReuse = true;
          this.useStyle = 5;
          this.useAnimation = 13;
          this.useTime = 13;
          this.width = 18;
          this.height = 46;
          this.shoot = 485;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 22;
          this.knockBack = 5.5f;
          this.shootSpeed = 6f;
          this.noMelee = true;
          this.value = this.hellPrice;
          this.rare = 3;
          this.ranged = true;
          break;
        case 3024:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.rare = 9;
          this.value = Item.sellPrice(gold: 3);
          break;
        case 3061:
          this.width = 30;
          this.height = 30;
          this.accessory = true;
          this.rare = 5;
          this.value = Item.buyPrice(gold: 20);
          this.backSlot = (sbyte) 8;
          break;
        case 3599:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.rare = 9;
          this.value = Item.sellPrice(gold: 3);
          break;
        default:
          if (type >= 3020 && type <= 3023)
          {
            this.noUseGraphic = true;
            this.damage = 0;
            this.useStyle = 5;
            this.shootSpeed = 15f;
            this.shoot = 486 + type - 3020;
            this.width = 18;
            this.height = 28;
            this.UseSound = SoundID.Item1;
            this.useAnimation = 20;
            this.useTime = 20;
            this.rare = 6;
            this.noMelee = true;
            this.value = Item.sellPrice(gold: 6);
            if (type != 3021)
              break;
            this.shootSpeed = 16f;
            break;
          }
          switch (type)
          {
            case 3025:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(silver: 75);
              this.rare = 2;
              return;
            case 3026:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(silver: 75);
              this.rare = 2;
              return;
            case 3027:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(silver: 75);
              this.rare = 2;
              return;
            case 3029:
              this.useStyle = 5;
              this.autoReuse = true;
              this.useAnimation = 19;
              this.useTime = 19;
              this.width = 28;
              this.height = 60;
              this.shoot = 1;
              this.useAmmo = AmmoID.Arrow;
              this.UseSound = SoundID.Item5;
              this.damage = 38;
              this.shootSpeed = 12.5f;
              this.noMelee = true;
              this.value = Item.sellPrice(gold: 8);
              this.ranged = true;
              this.rare = 6;
              this.knockBack = 2.25f;
              return;
            case 3030:
              this.channel = true;
              this.damage = 40;
              this.useStyle = 1;
              this.shootSpeed = 17f;
              this.shoot = 491;
              this.width = 26;
              this.height = 28;
              this.UseSound = SoundID.Item1;
              this.useAnimation = 15;
              this.useTime = 15;
              this.rare = 6;
              this.noMelee = true;
              this.knockBack = 4.5f;
              this.value = Item.sellPrice(gold: 8);
              this.melee = true;
              this.noUseGraphic = true;
              return;
            case 3038:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(gold: 1, silver: 50);
              this.rare = 3;
              return;
            case 3190:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(silver: 75);
              this.rare = 2;
              return;
            case 3597:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(gold: 1, silver: 50);
              this.rare = 3;
              return;
            case 3598:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(gold: 1, silver: 50);
              this.rare = 3;
              return;
            case 3600:
              this.width = 20;
              this.height = 20;
              this.maxStack = 99;
              this.value = Item.sellPrice(gold: 1, silver: 50);
              this.rare = 3;
              return;
            default:
              if (type == 3031 || type == 3032)
              {
                this.useStyle = 1;
                this.useTurn = true;
                this.useAnimation = 12;
                this.useTime = 5;
                this.width = 20;
                this.height = 20;
                this.autoReuse = true;
                this.rare = 7;
                this.value = Item.sellPrice(gold: 10);
                this.tileBoost += 2;
                return;
              }
              switch (type)
              {
                case 3028:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 99;
                  this.value = Item.sellPrice(silver: 75);
                  this.rare = 2;
                  return;
                case 3033:
                  this.width = 16;
                  this.height = 24;
                  this.accessory = true;
                  this.rare = 5;
                  this.value = 50000;
                  return;
                case 3034:
                  this.width = 16;
                  this.height = 24;
                  this.accessory = true;
                  this.rare = 5;
                  this.value = 100000;
                  return;
                case 3035:
                  this.width = 16;
                  this.height = 24;
                  this.accessory = true;
                  this.rare = 6;
                  this.value = 150000;
                  return;
                case 3036:
                  this.width = 24;
                  this.height = 28;
                  this.rare = 3;
                  this.value = Item.sellPrice(gold: 3);
                  this.accessory = true;
                  return;
                case 3037:
                  this.width = 24;
                  this.height = 28;
                  this.rare = 1;
                  this.value = Item.sellPrice(gold: 1);
                  this.accessory = true;
                  return;
                case 3039:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 99;
                  this.value = Item.sellPrice(gold: 1, silver: 50);
                  this.rare = 3;
                  return;
                case 3040:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 99;
                  this.value = Item.sellPrice(silver: 75);
                  this.rare = 2;
                  return;
                case 3041:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 99;
                  this.value = Item.sellPrice(silver: 75);
                  this.rare = 2;
                  return;
                case 3042:
                  this.width = 20;
                  this.height = 20;
                  this.maxStack = 99;
                  this.value = Item.sellPrice(gold: 1, silver: 50);
                  this.rare = 3;
                  return;
                case 3043:
                  this.damage = 0;
                  this.useStyle = 1;
                  this.shoot = 492;
                  this.width = 16;
                  this.height = 30;
                  this.UseSound = SoundID.Item25;
                  this.useAnimation = 20;
                  this.useTime = 20;
                  this.rare = 3;
                  this.noMelee = true;
                  this.value = Item.buyPrice(gold: 10);
                  this.buffType = 152;
                  return;
                case 3044:
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.autoReuse = true;
                  this.consumable = true;
                  this.createTile = 139;
                  this.placeStyle = 32;
                  this.width = 24;
                  this.height = 24;
                  this.rare = 4;
                  this.value = 100000;
                  this.accessory = true;
                  this.canBePlacedInVanityRegardlessOfConditions = true;
                  return;
                case 3045:
                  this.flame = true;
                  this.noWet = true;
                  this.useStyle = 1;
                  this.useTurn = true;
                  this.useAnimation = 15;
                  this.useTime = 10;
                  this.holdStyle = 1;
                  this.autoReuse = true;
                  this.maxStack = 999;
                  this.consumable = true;
                  this.createTile = 4;
                  this.placeStyle = 14;
                  this.width = 10;
                  this.height = 12;
                  this.value = 250;
                  this.rare = 1;
                  return;
                default:
                  if (type >= 3046 && type <= 3050)
                  {
                    this.useStyle = 1;
                    this.useTurn = true;
                    this.useAnimation = 15;
                    this.useTime = 10;
                    this.autoReuse = true;
                    this.maxStack = 999;
                    this.consumable = true;
                    this.createTile = 215;
                    this.placeStyle = 1 + type - 3046;
                    this.width = 12;
                    this.height = 12;
                    return;
                  }
                  switch (type)
                  {
                    case 3051:
                      this.mana = 13;
                      this.damage = 25;
                      this.useStyle = 5;
                      this.shootSpeed = 32f;
                      this.shoot = 494;
                      this.width = 26;
                      this.height = 28;
                      this.useAnimation = 33;
                      this.useTime = 33;
                      this.rare = 5;
                      this.noMelee = true;
                      this.knockBack = 3f;
                      this.value = Item.sellPrice(gold: 8);
                      this.magic = true;
                      this.autoReuse = true;
                      return;
                    case 3052:
                      this.autoReuse = true;
                      this.useStyle = 5;
                      this.useAnimation = 20;
                      this.useTime = 20;
                      this.width = 14;
                      this.height = 32;
                      this.shoot = 495;
                      this.useAmmo = AmmoID.Arrow;
                      this.UseSound = SoundID.Item102;
                      this.damage = 47;
                      this.shootSpeed = 11f;
                      this.knockBack = 4.5f;
                      this.rare = 5;
                      this.crit = 3;
                      this.noMelee = true;
                      this.value = Item.sellPrice(gold: 2);
                      this.ranged = true;
                      return;
                    case 3053:
                      this.autoReuse = true;
                      this.rare = 5;
                      this.mana = 6;
                      this.UseSound = SoundID.Item103;
                      this.useStyle = 5;
                      this.damage = 40;
                      this.useAnimation = 21;
                      this.useTime = 7;
                      this.width = 24;
                      this.height = 28;
                      this.shoot = 496;
                      this.shootSpeed = 9f;
                      this.knockBack = 3.75f;
                      this.magic = true;
                      this.value = Item.sellPrice(gold: 2);
                      this.noMelee = true;
                      this.noUseGraphic = true;
                      this.crit = 3;
                      return;
                    case 3054:
                      this.crit = 3;
                      this.autoReuse = true;
                      this.useStyle = 1;
                      this.shootSpeed = 13f;
                      this.shoot = 497;
                      this.damage = 38;
                      this.width = 18;
                      this.height = 20;
                      this.UseSound = SoundID.Item1;
                      this.useAnimation = 12;
                      this.useTime = 12;
                      this.noUseGraphic = true;
                      this.noMelee = true;
                      this.value = Item.sellPrice(gold: 2);
                      this.knockBack = 5.75f;
                      this.melee = true;
                      this.rare = 5;
                      return;
                    default:
                      if (type >= 3055 && type <= 3059)
                      {
                        this.useStyle = 1;
                        this.useTurn = true;
                        this.useAnimation = 15;
                        this.useTime = 10;
                        this.autoReuse = true;
                        this.maxStack = 99;
                        this.consumable = true;
                        this.createTile = 242;
                        this.width = 30;
                        this.height = 30;
                        this.value = Item.sellPrice(silver: 10);
                        this.placeStyle = 31 + type - 3055;
                        return;
                      }
                      switch (type)
                      {
                        case 3060:
                          this.damage = 0;
                          this.useStyle = 1;
                          this.shoot = 499;
                          this.width = 16;
                          this.height = 30;
                          this.UseSound = SoundID.Item2;
                          this.useAnimation = 20;
                          this.useTime = 20;
                          this.rare = 3;
                          this.noMelee = true;
                          this.value = Item.sellPrice(gold: 7, silver: 50);
                          this.buffType = 154;
                          return;
                        case 3062:
                          this.channel = true;
                          this.damage = 0;
                          this.useStyle = 4;
                          this.shoot = 500;
                          this.width = 24;
                          this.height = 24;
                          this.UseSound = SoundID.Item8;
                          this.useAnimation = 20;
                          this.useTime = 20;
                          this.rare = 1;
                          this.noMelee = true;
                          this.value = this.shadowOrbPrice;
                          this.buffType = 155;
                          return;
                        case 3063:
                          this.rare = 10;
                          this.UseSound = SoundID.Item1;
                          this.useStyle = 1;
                          this.damage = 200;
                          this.useAnimation = 16;
                          this.useTime = 16;
                          this.width = 30;
                          this.height = 30;
                          this.shoot = 502;
                          this.scale = 1.1f;
                          this.shootSpeed = 12f;
                          this.knockBack = 6.5f;
                          this.melee = true;
                          this.value = Item.sellPrice(gold: 20);
                          this.autoReuse = true;
                          return;
                        case 3064:
                          this.useStyle = 1;
                          this.useTurn = true;
                          this.useAnimation = 15;
                          this.useTime = 10;
                          this.autoReuse = true;
                          this.maxStack = 99;
                          this.consumable = true;
                          this.createTile = 356;
                          this.width = 18;
                          this.height = 34;
                          this.value = Item.sellPrice(gold: 3);
                          this.rare = 7;
                          return;
                        case 3065:
                          this.rare = 9;
                          this.UseSound = SoundID.Item105;
                          this.useStyle = 1;
                          this.damage = 110;
                          this.useAnimation = 16;
                          this.useTime = 16;
                          this.width = 30;
                          this.height = 30;
                          this.shoot = 503;
                          this.scale = 1.1f;
                          this.shootSpeed = 8f;
                          this.knockBack = 6.5f;
                          this.melee = true;
                          this.value = Item.sellPrice(gold: 20);
                          this.autoReuse = true;
                          return;
                        case 3066:
                          this.useStyle = 1;
                          this.useTurn = true;
                          this.useAnimation = 15;
                          this.useTime = 10;
                          this.autoReuse = true;
                          this.maxStack = 999;
                          this.consumable = true;
                          this.createTile = 357;
                          this.width = 12;
                          this.height = 12;
                          return;
                        case 3067:
                          this.useStyle = 1;
                          this.useTurn = true;
                          this.useAnimation = 15;
                          this.useTime = 7;
                          this.autoReuse = true;
                          this.maxStack = 999;
                          this.consumable = true;
                          this.createWall = 177;
                          this.width = 12;
                          this.height = 12;
                          return;
                        case 3068:
                          this.width = 16;
                          this.height = 24;
                          this.accessory = true;
                          this.rare = 1;
                          this.value = Item.sellPrice(silver: 50);
                          return;
                        case 3069:
                          this.mana = 2;
                          this.damage = 14;
                          this.useStyle = 1;
                          this.shootSpeed = 7f;
                          this.shoot = 504;
                          this.width = 26;
                          this.height = 28;
                          this.UseSound = SoundID.Item8;
                          this.useAnimation = 26;
                          this.useTime = 26;
                          this.rare = 1;
                          this.noMelee = true;
                          this.value = 5000;
                          this.magic = true;
                          this.crit = 10;
                          return;
                        default:
                          if (type >= 3070 && type <= 3076)
                          {
                            this.useStyle = 1;
                            this.useTurn = true;
                            this.useAnimation = 15;
                            this.useTime = 10;
                            this.autoReuse = true;
                            this.maxStack = 99;
                            this.consumable = true;
                            this.createTile = 358 + type - 3070;
                            this.width = 12;
                            this.height = 12;
                            this.value = Item.sellPrice(gold: 10);
                            this.rare = 3;
                            return;
                          }
                          switch (type)
                          {
                            case 3077:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 8;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 365;
                              this.width = 12;
                              this.height = 12;
                              this.value = 10;
                              this.tileBoost += 3;
                              return;
                            case 3078:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 8;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 366;
                              this.width = 12;
                              this.height = 12;
                              this.value = 10;
                              this.tileBoost += 3;
                              return;
                            case 3079:
                              this.useStyle = 1;
                              this.shootSpeed = 10f;
                              this.shoot = 505;
                              this.damage = 0;
                              this.width = 18;
                              this.height = 20;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.UseSound = SoundID.Item1;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.noUseGraphic = true;
                              this.noMelee = true;
                              this.value = 100;
                              return;
                            case 3080:
                              this.useStyle = 1;
                              this.shootSpeed = 10f;
                              this.shoot = 506;
                              this.damage = 0;
                              this.width = 18;
                              this.height = 20;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.UseSound = SoundID.Item1;
                              this.useAnimation = 20;
                              this.useTime = 20;
                              this.noUseGraphic = true;
                              this.noMelee = true;
                              this.value = 100;
                              return;
                            case 3081:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 367;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3082:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 183;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3083:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 179;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3084:
                              this.width = 24;
                              this.height = 18;
                              this.accessory = true;
                              this.rare = 1;
                              this.value = Item.sellPrice(silver: 50);
                              return;
                            case 3085:
                              this.width = 12;
                              this.height = 12;
                              this.rare = 2;
                              this.maxStack = 99;
                              this.value = Item.buyPrice(gold: 2);
                              return;
                            case 3086:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 368;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3087:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 10;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createTile = 369;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3088:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 184;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3089:
                              this.useStyle = 1;
                              this.useTurn = true;
                              this.useAnimation = 15;
                              this.useTime = 7;
                              this.autoReuse = true;
                              this.maxStack = 999;
                              this.consumable = true;
                              this.createWall = 181;
                              this.width = 12;
                              this.height = 12;
                              return;
                            case 3090:
                              this.width = 16;
                              this.height = 24;
                              this.accessory = true;
                              this.rare = 2;
                              this.value = 100000;
                              this.expert = true;
                              return;
                            default:
                              if (type == 3091 || type == 3092)
                              {
                                this.width = 14;
                                this.height = 20;
                                this.maxStack = 99;
                                this.useAnimation = 20;
                                this.useTime = 20;
                                return;
                              }
                              switch (type)
                              {
                                case 3093:
                                  this.width = 12;
                                  this.height = 12;
                                  this.rare = 1;
                                  this.maxStack = 99;
                                  this.value = Item.sellPrice(silver: 10);
                                  return;
                                case 3094:
                                  this.useStyle = 1;
                                  this.shootSpeed = 11.5f;
                                  this.shoot = 507;
                                  this.damage = 17;
                                  this.width = 30;
                                  this.height = 30;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 24;
                                  this.useTime = 24;
                                  this.noUseGraphic = true;
                                  this.noMelee = true;
                                  this.knockBack = 4.75f;
                                  this.value = Item.sellPrice(copper: 5);
                                  this.ranged = true;
                                  return;
                                case 3095:
                                  this.width = 24;
                                  this.height = 18;
                                  this.accessory = true;
                                  this.rare = 1;
                                  this.value = Item.sellPrice(gold: 1);
                                  return;
                                case 3097:
                                  this.melee = true;
                                  this.damage = 30;
                                  this.width = 24;
                                  this.height = 28;
                                  this.rare = 1;
                                  this.value = Item.sellPrice(gold: 2);
                                  this.accessory = true;
                                  this.defense = 2;
                                  this.shieldSlot = (sbyte) 5;
                                  this.knockBack = 9f;
                                  this.expert = true;
                                  return;
                                case 3098:
                                  this.useStyle = 5;
                                  this.useAnimation = 25;
                                  this.useTime = 8;
                                  this.shootSpeed = 48f;
                                  this.knockBack = 8f;
                                  this.width = 54;
                                  this.height = 20;
                                  this.damage = 120;
                                  this.axe = 30;
                                  this.UseSound = SoundID.Item23;
                                  this.shoot = 509;
                                  this.rare = 8;
                                  this.value = this.eclipsePostPlanteraPrice;
                                  this.noMelee = true;
                                  this.noUseGraphic = true;
                                  this.melee = true;
                                  this.channel = true;
                                  return;
                                case 3099:
                                  this.width = 24;
                                  this.height = 18;
                                  this.accessory = true;
                                  this.rare = 1;
                                  this.value = Item.sellPrice(gold: 1);
                                  return;
                                case 3100:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 370;
                                  this.width = 12;
                                  this.height = 12;
                                  return;
                                case 3101:
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 7;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createWall = 182;
                                  this.width = 12;
                                  this.height = 12;
                                  return;
                                case 3102:
                                  this.width = 24;
                                  this.height = 18;
                                  this.accessory = true;
                                  this.rare = 1;
                                  this.value = Item.sellPrice(gold: 1);
                                  return;
                                case 3103:
                                  this.shootSpeed = 3f;
                                  this.shoot = 1;
                                  this.damage = 5;
                                  this.width = 26;
                                  this.height = 26;
                                  this.ammo = AmmoID.Arrow;
                                  this.knockBack = 2f;
                                  this.value = Item.sellPrice(gold: 1);
                                  this.ranged = true;
                                  this.rare = 2;
                                  return;
                                case 3104:
                                  this.shootSpeed = 4f;
                                  this.shoot = 14;
                                  this.damage = 7;
                                  this.width = 26;
                                  this.height = 26;
                                  this.ammo = AmmoID.Bullet;
                                  this.knockBack = 2f;
                                  this.value = Item.sellPrice(gold: 1);
                                  this.ranged = true;
                                  this.rare = 2;
                                  return;
                                case 3105:
                                  this.magic = true;
                                  this.mana = 30;
                                  this.useStyle = 1;
                                  this.shootSpeed = 9f;
                                  this.rare = 8;
                                  this.damage = 46;
                                  this.shoot = 510;
                                  this.width = 18;
                                  this.height = 20;
                                  this.knockBack = 4f;
                                  this.UseSound = SoundID.Item106;
                                  this.useAnimation = 28;
                                  this.useTime = 28;
                                  this.noUseGraphic = true;
                                  this.noMelee = true;
                                  this.value = this.eclipsePostPlanteraPrice;
                                  return;
                                case 3106:
                                  this.autoReuse = true;
                                  this.useStyle = 1;
                                  this.useAnimation = 8;
                                  this.useTime = 8;
                                  this.knockBack = 3.5f;
                                  this.width = 30;
                                  this.height = 30;
                                  this.damage = 85;
                                  this.scale = 1.1f;
                                  this.UseSound = SoundID.Item1;
                                  this.rare = 8;
                                  this.value = this.eclipsePostPlanteraPrice;
                                  this.melee = true;
                                  return;
                                case 3107:
                                  this.useStyle = 5;
                                  this.autoReuse = true;
                                  this.useAnimation = 15;
                                  this.useTime = 15;
                                  this.width = 50;
                                  this.height = 18;
                                  this.shoot = 514;
                                  this.useAmmo = AmmoID.NailFriendly;
                                  this.UseSound = SoundID.Item108;
                                  this.damage = 85;
                                  this.shootSpeed = 10f;
                                  this.noMelee = true;
                                  this.value = this.eclipsePostPlanteraPrice;
                                  this.rare = 8;
                                  this.ranged = true;
                                  return;
                                case 3108:
                                  this.shootSpeed = 6f;
                                  this.shoot = 514;
                                  this.damage = 30;
                                  this.width = 8;
                                  this.height = 8;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.ammo = AmmoID.NailFriendly;
                                  this.knockBack = 3f;
                                  this.value = Item.buyPrice(silver: 1);
                                  this.ranged = true;
                                  this.rare = 8;
                                  return;
                                case 3109:
                                  this.width = 22;
                                  this.height = 22;
                                  this.defense = 4;
                                  this.headSlot = 179;
                                  this.rare = 2;
                                  this.value = Item.sellPrice(gold: 1);
                                  return;
                                case 3110:
                                  this.width = 16;
                                  this.height = 24;
                                  this.accessory = true;
                                  this.rare = 8;
                                  this.value = 700000;
                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                  return;
                                case 3111:
                                  this.width = 10;
                                  this.height = 12;
                                  this.maxStack = 999;
                                  this.alpha = 100;
                                  this.value = 15;
                                  return;
                                case 3112:
                                  this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
                                  this.useStyle = 1;
                                  this.shootSpeed = 6f;
                                  this.shoot = 515;
                                  this.width = 12;
                                  this.height = 12;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 15;
                                  this.useTime = 15;
                                  this.noMelee = true;
                                  this.value = 10;
                                  this.holdStyle = 1;
                                  return;
                                case 3113:
                                  this.createTile = 371;
                                  this.width = 12;
                                  this.height = 12;
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  return;
                                case 3114:
                                  this.flame = true;
                                  this.noWet = true;
                                  this.holdStyle = 1;
                                  this.autoReuse = true;
                                  this.maxStack = 999;
                                  this.consumable = true;
                                  this.createTile = 4;
                                  this.placeStyle = 15;
                                  this.width = 10;
                                  this.height = 12;
                                  this.value = 80;
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  return;
                                case 3115:
                                  this.useStyle = 1;
                                  this.shootSpeed = 5f;
                                  this.shoot = 516;
                                  this.width = 20;
                                  this.height = 20;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 25;
                                  this.useTime = 25;
                                  this.noUseGraphic = true;
                                  this.noMelee = true;
                                  this.value = Item.buyPrice(silver: 4);
                                  this.damage = 0;
                                  return;
                                case 3116:
                                  this.useStyle = 5;
                                  this.shootSpeed = 6.5f;
                                  this.shoot = 517;
                                  this.width = 20;
                                  this.height = 20;
                                  this.maxStack = 99;
                                  this.consumable = true;
                                  this.UseSound = SoundID.Item1;
                                  this.useAnimation = 40;
                                  this.useTime = 40;
                                  this.noUseGraphic = true;
                                  this.noMelee = true;
                                  this.value = 100;
                                  this.damage = 65;
                                  this.knockBack = 8f;
                                  this.ranged = true;
                                  return;
                                case 3117:
                                  this.flame = true;
                                  this.noWet = true;
                                  this.createTile = 372;
                                  this.width = 8;
                                  this.height = 18;
                                  this.holdStyle = 1;
                                  this.rare = 1;
                                  this.useStyle = 1;
                                  this.useTurn = true;
                                  this.useAnimation = 15;
                                  this.useTime = 10;
                                  this.autoReuse = true;
                                  this.maxStack = 99;
                                  this.value = Item.sellPrice(silver: 1);
                                  this.consumable = true;
                                  return;
                                default:
                                  if (type >= 3203 && type <= 3208)
                                  {
                                    this.width = 12;
                                    this.height = 12;
                                    this.rare = 2;
                                    this.maxStack = 99;
                                    this.createTile = 376;
                                    this.placeStyle = 3 + type - 3203;
                                    this.useAnimation = 15;
                                    this.useTime = 15;
                                    this.autoReuse = true;
                                    this.useStyle = 1;
                                    this.consumable = true;
                                    this.value = Item.sellPrice(gold: 1);
                                    return;
                                  }
                                  switch (type)
                                  {
                                    case 3096:
                                      this.width = 24;
                                      this.height = 18;
                                      this.accessory = true;
                                      this.rare = 1;
                                      this.value = Item.sellPrice(gold: 1);
                                      return;
                                    case 3118:
                                      this.width = 24;
                                      this.height = 18;
                                      this.accessory = true;
                                      this.rare = 1;
                                      this.value = Item.sellPrice(gold: 1);
                                      return;
                                    case 3119:
                                      this.width = 24;
                                      this.height = 18;
                                      this.accessory = true;
                                      this.rare = 1;
                                      this.value = Item.sellPrice(gold: 1);
                                      return;
                                    case 3120:
                                      this.width = 24;
                                      this.height = 28;
                                      this.rare = 1;
                                      this.value = Item.sellPrice(gold: 1);
                                      this.accessory = true;
                                      return;
                                    case 3121:
                                      this.width = 24;
                                      this.height = 28;
                                      this.rare = 3;
                                      this.value = Item.sellPrice(gold: 3);
                                      this.accessory = true;
                                      return;
                                    case 3122:
                                      this.width = 24;
                                      this.height = 28;
                                      this.rare = 3;
                                      this.value = Item.sellPrice(gold: 3);
                                      this.accessory = true;
                                      return;
                                    case 3123:
                                      this.width = 24;
                                      this.height = 28;
                                      this.rare = 5;
                                      this.value = Item.sellPrice(gold: 5);
                                      this.accessory = true;
                                      return;
                                    case 3124:
                                      this.width = 24;
                                      this.height = 28;
                                      this.rare = 7;
                                      this.value = Item.sellPrice(gold: 8);
                                      this.useTurn = true;
                                      this.useStyle = 4;
                                      this.useTime = 90;
                                      this.UseSound = SoundID.Item6;
                                      this.useAnimation = 90;
                                      return;
                                    case 3209:
                                      this.mana = 9;
                                      this.UseSound = SoundID.Item109;
                                      this.useStyle = 5;
                                      this.damage = 40;
                                      this.useAnimation = 29;
                                      this.useTime = 29;
                                      this.width = 36;
                                      this.height = 40;
                                      this.shoot = 521;
                                      this.shootSpeed = 13f;
                                      this.knockBack = 4.4f;
                                      this.magic = true;
                                      this.autoReuse = true;
                                      this.value = Item.sellPrice(gold: 4);
                                      this.rare = 5;
                                      this.noMelee = true;
                                      return;
                                    case 3210:
                                      this.UseSound = SoundID.Item111;
                                      this.useStyle = 5;
                                      this.damage = 43;
                                      this.useAnimation = 10;
                                      this.useTime = 10;
                                      this.width = 30;
                                      this.height = 28;
                                      this.shoot = 523;
                                      this.shootSpeed = 8.5f;
                                      this.knockBack = 3f;
                                      this.ranged = true;
                                      this.autoReuse = true;
                                      this.value = Item.sellPrice(gold: 4);
                                      this.rare = 5;
                                      this.noMelee = true;
                                      return;
                                    case 3211:
                                      this.useStyle = 1;
                                      this.useAnimation = 28;
                                      this.useTime = 28;
                                      this.knockBack = 5.75f;
                                      this.width = 40;
                                      this.height = 40;
                                      this.damage = 55;
                                      this.scale = 1.125f;
                                      this.UseSound = SoundID.Item1;
                                      this.rare = 5;
                                      this.autoReuse = true;
                                      this.value = Item.sellPrice(gold: 4);
                                      this.melee = true;
                                      return;
                                    case 3212:
                                      this.width = 22;
                                      this.height = 22;
                                      this.accessory = true;
                                      this.rare = 1;
                                      this.value = Item.sellPrice(gold: 1);
                                      this.neckSlot = (sbyte) 7;
                                      return;
                                    case 3213:
                                      this.useStyle = 1;
                                      this.shootSpeed = 4f;
                                      this.shoot = 525;
                                      this.width = 26;
                                      this.height = 24;
                                      this.UseSound = SoundID.Item59;
                                      this.useAnimation = 28;
                                      this.useTime = 28;
                                      this.rare = 3;
                                      this.value = Item.sellPrice(gold: 2);
                                      return;
                                    default:
                                      if (type == 3159 || type == 3160 || type == 3161)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 90;
                                        switch (type)
                                        {
                                          case 3159:
                                            this.placeStyle = 28;
                                            break;
                                          case 3160:
                                            this.placeStyle = 30;
                                            break;
                                          case 3161:
                                            this.placeStyle = 29;
                                            break;
                                        }
                                        this.width = 20;
                                        this.height = 20;
                                        this.value = 300;
                                        return;
                                      }
                                      if (type == 3162 || type == 3163 || type == 3164)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.autoReuse = true;
                                        this.createTile = 79;
                                        this.width = 28;
                                        this.height = 20;
                                        this.value = 2000;
                                        switch (type)
                                        {
                                          case 3162:
                                            this.placeStyle = 28;
                                            return;
                                          case 3163:
                                            this.placeStyle = 30;
                                            return;
                                          case 3164:
                                            this.placeStyle = 29;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3165 || type == 3166 || type == 3167)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 101;
                                        this.width = 20;
                                        this.height = 20;
                                        this.value = 300;
                                        switch (type)
                                        {
                                          case 3165:
                                            this.placeStyle = 29;
                                            return;
                                          case 3166:
                                            this.placeStyle = 31;
                                            return;
                                          case 3167:
                                            this.placeStyle = 30;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3168 || type == 3169 || type == 3170)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 100;
                                        this.width = 20;
                                        this.height = 20;
                                        this.value = 1500;
                                        switch (type)
                                        {
                                          case 3168:
                                            this.placeStyle = 28;
                                            return;
                                          case 3169:
                                            this.placeStyle = 30;
                                            return;
                                          case 3170:
                                            this.placeStyle = 29;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3171 || type == 3172 || type == 3173)
                                      {
                                        this.noWet = true;
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 33;
                                        this.width = 8;
                                        this.height = 18;
                                        this.value = Item.sellPrice(copper: 60);
                                        switch (type)
                                        {
                                          case 3171:
                                            this.placeStyle = 27;
                                            return;
                                          case 3172:
                                            this.placeStyle = 29;
                                            return;
                                          case 3173:
                                            this.placeStyle = 28;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3174 || type == 3175 || type == 3176)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 15;
                                        this.width = 12;
                                        this.height = 30;
                                        this.value = 150;
                                        switch (type)
                                        {
                                          case 3174:
                                            this.placeStyle = 33;
                                            return;
                                          case 3175:
                                            this.placeStyle = 35;
                                            return;
                                          case 3176:
                                            this.placeStyle = 34;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3177 || type == 3178 || type == 3179)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 34;
                                        this.width = 26;
                                        this.height = 26;
                                        this.value = 3000;
                                        switch (type)
                                        {
                                          case 3177:
                                            this.placeStyle = 34;
                                            return;
                                          case 3178:
                                            this.placeStyle = 36;
                                            return;
                                          case 3179:
                                            this.placeStyle = 35;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3180 || type == 3181 || type == 3125)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 21;
                                        this.width = 26;
                                        this.height = 22;
                                        this.value = 500;
                                        switch (type)
                                        {
                                          case 3125:
                                            this.placeStyle = 50;
                                            return;
                                          case 3180:
                                            this.placeStyle = 49;
                                            return;
                                          case 3181:
                                            this.placeStyle = 51;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3126 || type == 3127 || type == 3128)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 104;
                                        this.width = 20;
                                        this.height = 20;
                                        this.value = 300;
                                        switch (type)
                                        {
                                          case 3126:
                                            this.placeStyle = 25;
                                            return;
                                          case 3127:
                                            this.placeStyle = 27;
                                            return;
                                          case 3128:
                                            this.placeStyle = 26;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3129 || type == 3130 || type == 3131)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 10;
                                        this.width = 14;
                                        this.height = 28;
                                        this.value = 200;
                                        switch (type)
                                        {
                                          case 3129:
                                            this.placeStyle = 33;
                                            return;
                                          case 3130:
                                            this.placeStyle = 35;
                                            return;
                                          case 3131:
                                            this.placeStyle = 34;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3132 || type == 3133 || type == 3134)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 88;
                                        this.width = 20;
                                        this.height = 20;
                                        this.value = 300;
                                        switch (type)
                                        {
                                          case 3132:
                                            this.placeStyle = 25;
                                            return;
                                          case 3133:
                                            this.placeStyle = 27;
                                            return;
                                          case 3134:
                                            this.placeStyle = 26;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else if (type == 3135 || type == 3136 || type == 3137)
                                      {
                                        this.useStyle = 1;
                                        this.useTurn = true;
                                        this.useAnimation = 15;
                                        this.useTime = 10;
                                        this.autoReuse = true;
                                        this.maxStack = 99;
                                        this.consumable = true;
                                        this.createTile = 93;
                                        this.width = 10;
                                        this.height = 24;
                                        this.value = 500;
                                        switch (type)
                                        {
                                          case 3135:
                                            this.placeStyle = 28;
                                            return;
                                          case 3136:
                                            this.placeStyle = 30;
                                            return;
                                          case 3137:
                                            this.placeStyle = 29;
                                            return;
                                          default:
                                            return;
                                        }
                                      }
                                      else
                                      {
                                        if (type == 3138 || type == 3139 || type == 3140)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 42;
                                          this.width = 12;
                                          this.height = 28;
                                          switch (type)
                                          {
                                            case 3138:
                                              this.placeStyle = 34;
                                              break;
                                            case 3139:
                                              this.placeStyle = 36;
                                              break;
                                            case 3140:
                                              this.placeStyle = 35;
                                              break;
                                          }
                                          this.value = 150;
                                          return;
                                        }
                                        if (type == 3141 || type == 3142 || type == 3143)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 99;
                                          this.consumable = true;
                                          this.createTile = 87;
                                          this.width = 20;
                                          this.height = 20;
                                          this.value = 300;
                                          switch (type)
                                          {
                                            case 3141:
                                              this.placeStyle = 27;
                                              return;
                                            case 3142:
                                              this.placeStyle = 29;
                                              return;
                                            case 3143:
                                              this.placeStyle = 28;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else if (type == 3144 || type == 3145 || type == 3146)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 999;
                                          this.consumable = true;
                                          this.createTile = 19;
                                          this.width = 8;
                                          this.height = 10;
                                          switch (type)
                                          {
                                            case 3144:
                                              this.placeStyle = 27;
                                              return;
                                            case 3145:
                                              this.placeStyle = 29;
                                              return;
                                            case 3146:
                                              this.placeStyle = 28;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else if (type == 3147 || type == 3148 || type == 3149)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 99;
                                          this.consumable = true;
                                          this.createTile = 172;
                                          this.width = 20;
                                          this.height = 20;
                                          this.value = 300;
                                          switch (type)
                                          {
                                            case 3147:
                                              this.placeStyle = 29;
                                              return;
                                            case 3148:
                                              this.placeStyle = 31;
                                              return;
                                            case 3149:
                                              this.placeStyle = 30;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else if (type == 3150 || type == 3151 || type == 3152)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 99;
                                          this.consumable = true;
                                          this.createTile = 89;
                                          this.width = 20;
                                          this.height = 20;
                                          this.value = 300;
                                          switch (type)
                                          {
                                            case 3150:
                                              this.placeStyle = 30;
                                              return;
                                            case 3151:
                                              this.placeStyle = 32;
                                              return;
                                            case 3152:
                                              this.placeStyle = 31;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else if (type == 3153 || type == 3154 || type == 3155)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 99;
                                          this.consumable = true;
                                          this.createTile = 14;
                                          this.width = 26;
                                          this.height = 20;
                                          this.value = 300;
                                          switch (type)
                                          {
                                            case 3153:
                                              this.placeStyle = 32;
                                              return;
                                            case 3154:
                                              this.placeStyle = 34;
                                              return;
                                            case 3155:
                                              this.placeStyle = 33;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else if (type == 3156 || type == 3157 || type == 3158)
                                        {
                                          this.useStyle = 1;
                                          this.useTurn = true;
                                          this.useAnimation = 15;
                                          this.useTime = 10;
                                          this.autoReuse = true;
                                          this.maxStack = 99;
                                          this.consumable = true;
                                          this.createTile = 18;
                                          this.width = 28;
                                          this.height = 14;
                                          this.value = 150;
                                          switch (type)
                                          {
                                            case 3156:
                                              this.placeStyle = 28;
                                              return;
                                            case 3157:
                                              this.placeStyle = 30;
                                              return;
                                            case 3158:
                                              this.placeStyle = 29;
                                              return;
                                            default:
                                              return;
                                          }
                                        }
                                        else
                                        {
                                          switch (type)
                                          {
                                            case 3182:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 999;
                                              this.consumable = true;
                                              this.createTile = 373;
                                              this.width = 24;
                                              this.height = 24;
                                              this.value = Item.sellPrice(copper: 40);
                                              return;
                                            case 3183:
                                              this.useTurn = true;
                                              this.useStyle = 1;
                                              this.useAnimation = 18;
                                              this.width = 24;
                                              this.height = 28;
                                              this.UseSound = SoundID.Item1;
                                              this.value = Item.sellPrice(gold: 5);
                                              this.autoReuse = true;
                                              this.rare = 4;
                                              this.scale = 1.15f;
                                              return;
                                            case 3184:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 999;
                                              this.consumable = true;
                                              this.createTile = 374;
                                              this.width = 24;
                                              this.height = 24;
                                              this.value = Item.sellPrice(copper: 40);
                                              return;
                                            case 3185:
                                              this.useStyle = 1;
                                              this.useTurn = true;
                                              this.useAnimation = 15;
                                              this.useTime = 10;
                                              this.autoReuse = true;
                                              this.maxStack = 999;
                                              this.consumable = true;
                                              this.createTile = 375;
                                              this.width = 24;
                                              this.height = 24;
                                              this.value = Item.sellPrice(copper: 40);
                                              return;
                                            case 3186:
                                              this.maxStack = 999;
                                              this.width = 24;
                                              this.height = 24;
                                              this.value = Item.buyPrice(silver: 1);
                                              return;
                                            case 3187:
                                              this.width = 18;
                                              this.height = 18;
                                              this.defense = 3;
                                              this.headSlot = 180;
                                              this.value = 17500;
                                              return;
                                            case 3188:
                                              this.width = 18;
                                              this.height = 18;
                                              this.defense = 4;
                                              this.bodySlot = 182;
                                              this.value = 14000;
                                              return;
                                            case 3189:
                                              this.width = 18;
                                              this.height = 18;
                                              this.defense = 3;
                                              this.legSlot = 122;
                                              this.value = 10500;
                                              return;
                                            default:
                                              if (type >= 3191 && type <= 3194)
                                              {
                                                this.useStyle = 1;
                                                this.autoReuse = true;
                                                this.useTurn = true;
                                                this.useAnimation = 15;
                                                this.useTime = 10;
                                                this.maxStack = 999;
                                                this.consumable = true;
                                                this.width = 12;
                                                this.height = 12;
                                                this.makeNPC = (short) (484 + type - 3191);
                                                this.noUseGraphic = true;
                                                switch (type)
                                                {
                                                  case 3192:
                                                    this.bait = 15;
                                                    return;
                                                  case 3193:
                                                    this.bait = 25;
                                                    return;
                                                  case 3194:
                                                    this.bait = 40;
                                                    return;
                                                  default:
                                                    this.bait = 35;
                                                    return;
                                                }
                                              }
                                              else
                                              {
                                                switch (type)
                                                {
                                                  case 3196:
                                                    this.useStyle = 1;
                                                    this.shootSpeed = 6f;
                                                    this.shoot = 519;
                                                    this.width = 26;
                                                    this.height = 26;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.UseSound = SoundID.Item1;
                                                    this.useAnimation = 25;
                                                    this.useTime = 25;
                                                    this.noUseGraphic = true;
                                                    this.noMelee = true;
                                                    this.value = Item.sellPrice(silver: 2);
                                                    this.damage = 0;
                                                    this.rare = 1;
                                                    return;
                                                  case 3197:
                                                    this.rare = 1;
                                                    this.useStyle = 1;
                                                    this.shootSpeed = 12.5f;
                                                    this.shoot = 520;
                                                    this.damage = 17;
                                                    this.width = 28;
                                                    this.height = 28;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.UseSound = SoundID.Item1;
                                                    this.useAnimation = 13;
                                                    this.useTime = 13;
                                                    this.noUseGraphic = true;
                                                    this.noMelee = true;
                                                    this.value = 80;
                                                    this.knockBack = 3.5f;
                                                    this.ranged = true;
                                                    return;
                                                  case 3198:
                                                    this.rare = 1;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 377;
                                                    this.width = 28;
                                                    this.height = 22;
                                                    this.value = 100000;
                                                    return;
                                                  case 3199:
                                                    this.useTurn = true;
                                                    this.width = 20;
                                                    this.height = 20;
                                                    this.useStyle = 4;
                                                    this.useTime = 90;
                                                    this.UseSound = SoundID.Item6;
                                                    this.useAnimation = 90;
                                                    this.rare = 1;
                                                    this.value = 50000;
                                                    return;
                                                  case 3200:
                                                    this.width = 28;
                                                    this.height = 24;
                                                    this.accessory = true;
                                                    this.rare = 1;
                                                    this.value = 50000;
                                                    this.shoeSlot = (sbyte) 17;
                                                    return;
                                                  case 3201:
                                                    this.width = 16;
                                                    this.height = 24;
                                                    this.accessory = true;
                                                    this.rare = 1;
                                                    this.value = 50000;
                                                    this.waistSlot = (sbyte) 11;
                                                    return;
                                                  case 3202:
                                                    this.rare = 1;
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 99;
                                                    this.consumable = true;
                                                    this.createTile = 378;
                                                    this.width = 20;
                                                    this.height = 30;
                                                    this.value = Item.sellPrice(silver: 1);
                                                    return;
                                                  case 3214:
                                                    this.useStyle = 1;
                                                    this.useTurn = true;
                                                    this.useAnimation = 15;
                                                    this.useTime = 10;
                                                    this.autoReuse = true;
                                                    this.maxStack = 999;
                                                    this.consumable = true;
                                                    this.createTile = 379;
                                                    this.width = 12;
                                                    this.height = 12;
                                                    this.value = Item.buyPrice(silver: 2);
                                                    return;
                                                  default:
                                                    if (type >= 3215 && type <= 3222)
                                                    {
                                                      this.useStyle = 1;
                                                      this.useTurn = true;
                                                      this.useAnimation = 15;
                                                      this.useTime = 10;
                                                      this.autoReuse = true;
                                                      this.maxStack = 999;
                                                      this.consumable = true;
                                                      this.createTile = 380;
                                                      this.placeStyle = type - 3215;
                                                      this.width = 24;
                                                      this.height = 20;
                                                      this.value = Item.buyPrice(silver: 1);
                                                      return;
                                                    }
                                                    switch (type)
                                                    {
                                                      case 3223:
                                                        this.width = 22;
                                                        this.height = 22;
                                                        this.accessory = true;
                                                        this.rare = 1;
                                                        this.value = 100000;
                                                        this.expert = true;
                                                        return;
                                                      case 3224:
                                                        this.width = 22;
                                                        this.height = 22;
                                                        this.accessory = true;
                                                        this.rare = 1;
                                                        this.value = 100000;
                                                        this.neckSlot = (sbyte) 8;
                                                        this.expert = true;
                                                        return;
                                                      case 3225:
                                                        this.width = 14;
                                                        this.height = 28;
                                                        this.rare = 1;
                                                        this.value = Item.sellPrice(gold: 2, silver: 50);
                                                        this.accessory = true;
                                                        this.balloonSlot = (sbyte) 11;
                                                        return;
                                                      case 3226:
                                                        this.width = 28;
                                                        this.height = 20;
                                                        this.headSlot = 181;
                                                        this.rare = 9;
                                                        this.vanity = true;
                                                        this.value = Item.sellPrice(gold: 5);
                                                        return;
                                                      case 3227:
                                                        this.width = 18;
                                                        this.height = 14;
                                                        this.bodySlot = 183;
                                                        this.rare = 9;
                                                        this.vanity = true;
                                                        this.value = Item.sellPrice(gold: 5);
                                                        return;
                                                      case 3228:
                                                        this.width = 24;
                                                        this.height = 8;
                                                        this.accessory = true;
                                                        this.rare = 9;
                                                        this.wingSlot = (sbyte) 28;
                                                        this.value = 400000;
                                                        return;
                                                      default:
                                                        if (type >= 3229 && type <= 3233)
                                                        {
                                                          this.useTurn = true;
                                                          this.useStyle = 1;
                                                          this.useAnimation = 15;
                                                          this.useTime = 10;
                                                          this.maxStack = 99;
                                                          this.consumable = true;
                                                          this.createTile = 85;
                                                          this.placeStyle = 6 + type - 3229;
                                                          this.width = 20;
                                                          this.height = 20;
                                                          return;
                                                        }
                                                        if (type == 3234)
                                                        {
                                                          this.useStyle = 1;
                                                          this.useTurn = true;
                                                          this.useAnimation = 15;
                                                          this.useTime = 10;
                                                          this.autoReuse = true;
                                                          this.maxStack = 999;
                                                          this.consumable = true;
                                                          this.createTile = 385;
                                                          this.width = 12;
                                                          this.height = 12;
                                                          return;
                                                        }
                                                        if (type >= 3235 && type <= 3237)
                                                        {
                                                          this.useStyle = 1;
                                                          this.useTurn = true;
                                                          this.useAnimation = 15;
                                                          this.useTime = 10;
                                                          this.autoReuse = true;
                                                          this.consumable = true;
                                                          this.createTile = 139;
                                                          this.placeStyle = 33 + type - 3235;
                                                          this.width = 24;
                                                          this.height = 24;
                                                          this.rare = 4;
                                                          this.value = 100000;
                                                          this.accessory = true;
                                                          this.canBePlacedInVanityRegardlessOfConditions = true;
                                                          return;
                                                        }
                                                        switch (type)
                                                        {
                                                          case 3238:
                                                            this.useStyle = 1;
                                                            this.useTurn = true;
                                                            this.useAnimation = 15;
                                                            this.useTime = 7;
                                                            this.autoReuse = true;
                                                            this.maxStack = 999;
                                                            this.consumable = true;
                                                            this.createWall = 186;
                                                            this.width = 12;
                                                            this.height = 12;
                                                            return;
                                                          case 3239:
                                                            this.useStyle = 1;
                                                            this.useTurn = true;
                                                            this.useAnimation = 15;
                                                            this.useTime = 10;
                                                            this.autoReuse = true;
                                                            this.maxStack = 999;
                                                            this.consumable = true;
                                                            this.createTile = 387;
                                                            this.width = 20;
                                                            this.height = 12;
                                                            return;
                                                          case 3240:
                                                            this.useStyle = 1;
                                                            this.useTurn = true;
                                                            this.useAnimation = 15;
                                                            this.useTime = 10;
                                                            this.autoReuse = true;
                                                            this.maxStack = 999;
                                                            this.consumable = true;
                                                            this.createTile = 388;
                                                            this.width = 18;
                                                            this.height = 26;
                                                            return;
                                                          case 3241:
                                                            this.width = 14;
                                                            this.height = 28;
                                                            this.rare = 1;
                                                            this.value = Item.sellPrice(gold: 3);
                                                            this.accessory = true;
                                                            this.balloonSlot = (sbyte) 12;
                                                            return;
                                                          case 3242:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.headSlot = 182;
                                                            return;
                                                          case 3243:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.bodySlot = 184;
                                                            return;
                                                          case 3244:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.legSlot = 124;
                                                            return;
                                                          case 3245:
                                                            this.width = 16;
                                                            this.height = 16;
                                                            this.value = Item.sellPrice(gold: 2);
                                                            this.useAnimation = 17;
                                                            this.useTime = 17;
                                                            this.useStyle = 1;
                                                            this.UseSound = SoundID.Item1;
                                                            this.noMelee = true;
                                                            this.shootSpeed = 1f;
                                                            this.damage = 11;
                                                            this.knockBack = 1.8f;
                                                            this.shoot = 21;
                                                            this.ranged = true;
                                                            this.rare = 2;
                                                            this.useAmmo = 154;
                                                            this.noUseGraphic = true;
                                                            this.expert = true;
                                                            return;
                                                          case 3246:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.bodySlot = 185;
                                                            return;
                                                          case 3247:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.legSlot = 125;
                                                            return;
                                                          case 3248:
                                                            this.width = 18;
                                                            this.height = 18;
                                                            this.value = Item.buyPrice(gold: 3);
                                                            this.vanity = true;
                                                            this.headSlot = 183;
                                                            return;
                                                          case 3249:
                                                            this.mana = 10;
                                                            this.damage = 50;
                                                            this.useStyle = 1;
                                                            this.shootSpeed = 10f;
                                                            this.shoot = 533;
                                                            this.buffType = 161;
                                                            this.width = 26;
                                                            this.height = 28;
                                                            this.UseSound = SoundID.Item113;
                                                            this.useAnimation = 36;
                                                            this.useTime = 36;
                                                            this.rare = 8;
                                                            this.noMelee = true;
                                                            this.knockBack = 2f;
                                                            this.value = this.eclipsePostPlanteraPrice;
                                                            this.summon = true;
                                                            return;
                                                          default:
                                                            if (type == 3250 || type == 3251 || type == 3252)
                                                            {
                                                              this.width = 20;
                                                              this.height = 22;
                                                              this.rare = 4;
                                                              this.value = Item.buyPrice(gold: 15);
                                                              this.accessory = true;
                                                              this.balloonSlot = (sbyte) (13 + type - 3250);
                                                              return;
                                                            }
                                                            if (type == 3253)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 390;
                                                              this.width = 12;
                                                              this.height = 30;
                                                              this.value = Item.buyPrice(gold: 2);
                                                              this.rare = 1;
                                                              this.glowMask = (short) 129;
                                                              return;
                                                            }
                                                            if (type >= 3254 && type <= 3257)
                                                            {
                                                              this.useStyle = 1;
                                                              this.useTurn = true;
                                                              this.useAnimation = 15;
                                                              this.useTime = 10;
                                                              this.autoReuse = true;
                                                              this.maxStack = 99;
                                                              this.consumable = true;
                                                              this.createTile = 391 + type - 3254;
                                                              this.width = 12;
                                                              this.height = 12;
                                                              return;
                                                            }
                                                            switch (type)
                                                            {
                                                              case 3258:
                                                                this.useStyle = 1;
                                                                this.useAnimation = 21;
                                                                this.useTime = 21;
                                                                this.autoReuse = true;
                                                                this.knockBack = 20f;
                                                                this.width = 36;
                                                                this.height = 36;
                                                                this.damage = 35;
                                                                this.scale = 1.1f;
                                                                this.UseSound = SoundID.Item1;
                                                                this.rare = 4;
                                                                this.value = Item.buyPrice(gold: 25);
                                                                this.melee = true;
                                                                this.crit = 15;
                                                                return;
                                                              case 3259:
                                                                this.width = 20;
                                                                this.height = 26;
                                                                this.maxStack = 99;
                                                                this.rare = 3;
                                                                this.value = Item.buyPrice(gold: 30);
                                                                this.UseSound = SoundID.Item3;
                                                                this.useStyle = 9;
                                                                this.useTurn = true;
                                                                this.useAnimation = 17;
                                                                this.useTime = 17;
                                                                this.consumable = true;
                                                                return;
                                                              case 3260:
                                                                this.useStyle = 4;
                                                                this.channel = true;
                                                                this.width = 34;
                                                                this.height = 34;
                                                                this.UseSound = SoundID.Item25;
                                                                this.useAnimation = 20;
                                                                this.useTime = 20;
                                                                this.rare = 8;
                                                                this.noMelee = true;
                                                                this.mountType = 10;
                                                                this.value = Item.sellPrice(gold: 5);
                                                                return;
                                                              case 3261:
                                                                this.width = 20;
                                                                this.height = 20;
                                                                this.maxStack = 999;
                                                                this.rare = 7;
                                                                this.value = Item.sellPrice(gold: 1);
                                                                this.useStyle = 1;
                                                                this.useTurn = true;
                                                                this.useAnimation = 15;
                                                                this.useTime = 10;
                                                                this.autoReuse = true;
                                                                this.consumable = true;
                                                                this.createTile = 239;
                                                                this.placeStyle = 21;
                                                                return;
                                                              default:
                                                                if (type == 3262 || type >= 3278 && type <= 3292 || type >= 3315 && type <= 3317)
                                                                {
                                                                  this.useStyle = 5;
                                                                  this.width = 24;
                                                                  this.height = 24;
                                                                  this.noUseGraphic = true;
                                                                  this.UseSound = SoundID.Item1;
                                                                  this.melee = true;
                                                                  this.channel = true;
                                                                  this.noMelee = true;
                                                                  this.shoot = 541 + type - 3278;
                                                                  this.useAnimation = 25;
                                                                  this.useTime = 25;
                                                                  this.shootSpeed = 16f;
                                                                  switch (type)
                                                                  {
                                                                    case 3262:
                                                                      this.knockBack = 3.25f;
                                                                      this.damage = 21;
                                                                      this.value = Item.buyPrice(gold: 5);
                                                                      this.rare = 2;
                                                                      this.shoot = 534;
                                                                      return;
                                                                    case 3278:
                                                                      this.knockBack = 2.5f;
                                                                      this.damage = 9;
                                                                      this.value = Item.sellPrice(silver: 1);
                                                                      this.rare = 0;
                                                                      return;
                                                                    case 3279:
                                                                      this.knockBack = 4.5f;
                                                                      this.damage = 16;
                                                                      this.value = Item.sellPrice(gold: 1);
                                                                      this.rare = 1;
                                                                      return;
                                                                    case 3280:
                                                                      this.knockBack = 4f;
                                                                      this.damage = 17;
                                                                      this.value = Item.sellPrice(gold: 1);
                                                                      this.rare = 1;
                                                                      return;
                                                                    case 3281:
                                                                      this.knockBack = 3.75f;
                                                                      this.damage = 18;
                                                                      this.value = Item.sellPrice(gold: 1, silver: 30);
                                                                      this.rare = 3;
                                                                      return;
                                                                    case 3282:
                                                                      this.knockBack = 4.3f;
                                                                      this.damage = 27;
                                                                      this.value = Item.sellPrice(gold: 1, silver: 80);
                                                                      this.rare = 3;
                                                                      return;
                                                                    case 3283:
                                                                      this.knockBack = 3.3f;
                                                                      this.damage = 38;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.rare = 4;
                                                                      return;
                                                                    case 3284:
                                                                      this.knockBack = 3.8f;
                                                                      this.damage = 54;
                                                                      this.value = Item.buyPrice(gold: 25);
                                                                      this.rare = 5;
                                                                      return;
                                                                    case 3285:
                                                                      this.knockBack = 3.5f;
                                                                      this.damage = 14;
                                                                      this.value = Item.sellPrice(silver: 50);
                                                                      this.rare = 1;
                                                                      return;
                                                                    case 3286:
                                                                      this.knockBack = 3.1f;
                                                                      this.damage = 60;
                                                                      this.value = Item.sellPrice(gold: 5);
                                                                      this.rare = 7;
                                                                      return;
                                                                    case 3289:
                                                                      this.knockBack = 2.8f;
                                                                      this.damage = 47;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.rare = 4;
                                                                      return;
                                                                    case 3290:
                                                                      this.knockBack = 4.5f;
                                                                      this.damage = 45;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.rare = 4;
                                                                      return;
                                                                    case 3291:
                                                                      this.knockBack = 4.3f;
                                                                      this.damage = 95;
                                                                      this.value = Item.sellPrice(gold: 11);
                                                                      this.rare = 8;
                                                                      this.crit += 10;
                                                                      return;
                                                                    case 3315:
                                                                      this.knockBack = 3.25f;
                                                                      this.damage = 35;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.rare = 3;
                                                                      this.shoot = 562;
                                                                      return;
                                                                    case 3316:
                                                                      this.knockBack = 3.8f;
                                                                      this.damage = 44;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.rare = 3;
                                                                      this.shoot = 563;
                                                                      return;
                                                                    case 3317:
                                                                      this.knockBack = 3.85f;
                                                                      this.damage = 22;
                                                                      this.value = this.dungeonPrice;
                                                                      this.rare = 3;
                                                                      this.shoot = 564;
                                                                      return;
                                                                    default:
                                                                      if (type == 3288 || type == 3287)
                                                                      {
                                                                        this.knockBack = 4.5f;
                                                                        this.damage = 70;
                                                                        this.rare = 9;
                                                                        this.value = Item.sellPrice(gold: 4);
                                                                        return;
                                                                      }
                                                                      if (type == 3292)
                                                                      {
                                                                        this.knockBack = 3.5f;
                                                                        this.damage = 115;
                                                                        this.value = this.eclipseMothronPrice;
                                                                        this.rare = 8;
                                                                        return;
                                                                      }
                                                                      this.knockBack = 4f;
                                                                      this.damage = 15;
                                                                      this.rare = 2;
                                                                      this.value = Item.sellPrice(gold: 1);
                                                                      return;
                                                                  }
                                                                }
                                                                else
                                                                {
                                                                  if (type == 3389)
                                                                  {
                                                                    this.useStyle = 5;
                                                                    this.width = 24;
                                                                    this.height = 24;
                                                                    this.noUseGraphic = true;
                                                                    this.UseSound = SoundID.Item1;
                                                                    this.melee = true;
                                                                    this.channel = true;
                                                                    this.noMelee = true;
                                                                    this.shoot = 603;
                                                                    this.useAnimation = 25;
                                                                    this.useTime = 25;
                                                                    this.shootSpeed = 16f;
                                                                    this.damage = 190;
                                                                    this.knockBack = 6.5f;
                                                                    this.value = Item.sellPrice(gold: 10);
                                                                    this.crit = 10;
                                                                    this.rare = 10;
                                                                    return;
                                                                  }
                                                                  if (type >= 3293 && type <= 3308)
                                                                  {
                                                                    this.width = 24;
                                                                    this.height = 24;
                                                                    this.rare = 1;
                                                                    this.value = Item.sellPrice(silver: 3);
                                                                    this.accessory = true;
                                                                    this.stringColor = type != 3307 ? (type != 3306 ? (type != 3308 ? (type != 3305 ? 1 + type - 3293 : 28) : 13) : 14) : 27;
                                                                    this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                    return;
                                                                  }
                                                                  if (type >= 3309 && type <= 3314)
                                                                  {
                                                                    this.width = 24;
                                                                    this.height = 24;
                                                                    this.rare = 2;
                                                                    this.value = Item.buyPrice(gold: 5);
                                                                    this.accessory = true;
                                                                    return;
                                                                  }
                                                                  switch (type)
                                                                  {
                                                                    case 3263:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = Item.buyPrice(gold: 3);
                                                                      this.vanity = true;
                                                                      this.headSlot = 184;
                                                                      return;
                                                                    case 3264:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = Item.buyPrice(gold: 3);
                                                                      this.vanity = true;
                                                                      this.bodySlot = 186;
                                                                      return;
                                                                    case 3265:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = Item.buyPrice(gold: 3);
                                                                      this.vanity = true;
                                                                      this.legSlot = 126;
                                                                      return;
                                                                    case 3266:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = 4500;
                                                                      this.headSlot = 185;
                                                                      this.defense = 4;
                                                                      return;
                                                                    case 3267:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = 4500;
                                                                      this.bodySlot = 187;
                                                                      this.defense = 5;
                                                                      return;
                                                                    case 3268:
                                                                      this.width = 18;
                                                                      this.height = 18;
                                                                      this.value = 4500;
                                                                      this.legSlot = (int) sbyte.MaxValue;
                                                                      this.defense = 4;
                                                                      return;
                                                                    case 3269:
                                                                      this.useStyle = 4;
                                                                      this.useAnimation = 20;
                                                                      this.useTime = 20;
                                                                      this.autoReuse = true;
                                                                      this.reuseDelay = 10;
                                                                      this.shootSpeed = 1f;
                                                                      this.knockBack = 2f;
                                                                      this.width = 16;
                                                                      this.height = 16;
                                                                      this.damage = 40;
                                                                      this.UseSound = (LegacySoundStyle) null;
                                                                      this.shoot = 535;
                                                                      this.mana = 15;
                                                                      this.rare = 4;
                                                                      this.value = Item.sellPrice(gold: 4);
                                                                      this.noMelee = true;
                                                                      this.noUseGraphic = true;
                                                                      this.magic = true;
                                                                      this.channel = true;
                                                                      return;
                                                                    case 3270:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 99;
                                                                      this.consumable = true;
                                                                      this.createTile = 395;
                                                                      this.width = 28;
                                                                      this.height = 28;
                                                                      return;
                                                                    case 3271:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 396;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3272:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 397;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3273:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 275;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3274:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 398;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3275:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 399;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3276:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 400;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3277:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 401;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3338:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 402;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3339:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 403;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3340:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 304;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3341:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 305;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3342:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 306;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3343:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 307;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3344:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 308;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3345:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 309;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3346:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 310;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3347:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 10;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createTile = 404;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    case 3348:
                                                                      this.useStyle = 1;
                                                                      this.useTurn = true;
                                                                      this.useAnimation = 15;
                                                                      this.useTime = 7;
                                                                      this.autoReuse = true;
                                                                      this.maxStack = 999;
                                                                      this.consumable = true;
                                                                      this.createWall = 311;
                                                                      this.width = 12;
                                                                      this.height = 12;
                                                                      return;
                                                                    default:
                                                                      if (type >= 3318 && type <= 3332)
                                                                      {
                                                                        this.maxStack = 999;
                                                                        this.consumable = true;
                                                                        this.width = 24;
                                                                        this.height = 24;
                                                                        this.rare = 1;
                                                                        if (type == 3320)
                                                                          this.rare = 2;
                                                                        if (type == 3321)
                                                                          this.rare = 2;
                                                                        if (type == 3322)
                                                                          this.rare = 3;
                                                                        if (type == 3323)
                                                                          this.rare = 3;
                                                                        if (type == 3324)
                                                                          this.rare = 4;
                                                                        if (type == 3325)
                                                                          this.rare = 5;
                                                                        if (type == 3326)
                                                                          this.rare = 5;
                                                                        if (type == 3327)
                                                                          this.rare = 5;
                                                                        if (type == 3328)
                                                                          this.rare = 6;
                                                                        if (type == 3329)
                                                                          this.rare = 7;
                                                                        if (type == 3330)
                                                                          this.rare = 7;
                                                                        if (type == 3331)
                                                                          this.rare = 8;
                                                                        if (type == 3332)
                                                                          this.rare = 8;
                                                                        this.expert = true;
                                                                        return;
                                                                      }
                                                                      switch (type)
                                                                      {
                                                                        case 3333:
                                                                          this.width = 22;
                                                                          this.height = 22;
                                                                          this.accessory = true;
                                                                          this.rare = 3;
                                                                          this.value = Item.sellPrice(gold: 2);
                                                                          this.backSlot = (sbyte) 9;
                                                                          this.expert = true;
                                                                          return;
                                                                        case 3334:
                                                                          this.width = 22;
                                                                          this.height = 22;
                                                                          this.accessory = true;
                                                                          this.rare = 4;
                                                                          this.value = Item.buyPrice(gold: 50);
                                                                          this.handOffSlot = (sbyte) 11;
                                                                          this.handOnSlot = (sbyte) 18;
                                                                          return;
                                                                        case 3335:
                                                                          this.maxStack = 99;
                                                                          this.consumable = true;
                                                                          this.width = 18;
                                                                          this.height = 18;
                                                                          this.useStyle = 4;
                                                                          this.useTime = 30;
                                                                          this.UseSound = SoundID.Item4;
                                                                          this.useAnimation = 30;
                                                                          this.rare = 4;
                                                                          this.value = Item.sellPrice(gold: 2);
                                                                          this.expert = true;
                                                                          return;
                                                                        case 3336:
                                                                          this.width = 22;
                                                                          this.height = 22;
                                                                          this.accessory = true;
                                                                          this.rare = 8;
                                                                          this.value = Item.sellPrice(gold: 4);
                                                                          this.expert = true;
                                                                          return;
                                                                        case 3337:
                                                                          this.width = 22;
                                                                          this.height = 22;
                                                                          this.accessory = true;
                                                                          this.rare = 8;
                                                                          this.value = Item.sellPrice(gold: 5);
                                                                          this.expert = true;
                                                                          return;
                                                                        case 3353:
                                                                          this.width = 36;
                                                                          this.height = 26;
                                                                          this.mountType = 11;
                                                                          this.rare = 6;
                                                                          this.value = Item.sellPrice(gold: 3);
                                                                          this.expert = true;
                                                                          return;
                                                                        default:
                                                                          if (type == 3355 || type == 3354 || type == 3356)
                                                                          {
                                                                            this.width = 20;
                                                                            this.height = 20;
                                                                            this.maxStack = 99;
                                                                            this.rare = 5;
                                                                            this.value = Item.sellPrice(silver: 50);
                                                                            this.expert = true;
                                                                            return;
                                                                          }
                                                                          if (type == 3357 || type == 3358 || type == 3359)
                                                                          {
                                                                            this.useStyle = 1;
                                                                            this.useTurn = true;
                                                                            this.useAnimation = 15;
                                                                            this.useTime = 10;
                                                                            this.autoReuse = true;
                                                                            this.maxStack = 99;
                                                                            this.consumable = true;
                                                                            this.createTile = 240;
                                                                            this.width = 30;
                                                                            this.height = 30;
                                                                            this.value = Item.sellPrice(gold: 1);
                                                                            this.placeStyle = 56 + type - 3357;
                                                                            this.rare = 1;
                                                                            return;
                                                                          }
                                                                          switch (type)
                                                                          {
                                                                            case 3360:
                                                                              this.tileWand = 620;
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.createTile = 383;
                                                                              this.width = 8;
                                                                              this.height = 10;
                                                                              this.rare = 1;
                                                                              this.value = Item.sellPrice(silver: 25);
                                                                              return;
                                                                            case 3361:
                                                                              this.tileWand = 620;
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.createTile = 384;
                                                                              this.width = 8;
                                                                              this.height = 10;
                                                                              this.rare = 1;
                                                                              this.value = Item.sellPrice(silver: 25);
                                                                              return;
                                                                            case 3362:
                                                                              this.width = 28;
                                                                              this.height = 20;
                                                                              this.bodySlot = 188;
                                                                              this.rare = 1;
                                                                              this.vanity = true;
                                                                              this.value = Item.buyPrice(gold: 25);
                                                                              return;
                                                                            case 3363:
                                                                              this.width = 28;
                                                                              this.height = 20;
                                                                              this.legSlot = 128;
                                                                              this.rare = 1;
                                                                              this.vanity = true;
                                                                              this.value = Item.buyPrice(gold: 25);
                                                                              return;
                                                                            case 3364:
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.maxStack = 99;
                                                                              this.consumable = true;
                                                                              this.createTile = 405;
                                                                              this.width = 28;
                                                                              this.height = 28;
                                                                              this.rare = 1;
                                                                              return;
                                                                            case 3365:
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.maxStack = 99;
                                                                              this.consumable = true;
                                                                              this.createTile = 406;
                                                                              this.width = 28;
                                                                              this.height = 28;
                                                                              this.rare = 1;
                                                                              return;
                                                                            case 3366:
                                                                              this.width = 24;
                                                                              this.height = 24;
                                                                              this.rare = 4;
                                                                              this.value = Item.buyPrice(gold: 50);
                                                                              this.accessory = true;
                                                                              return;
                                                                            case 3367:
                                                                              this.useStyle = 4;
                                                                              this.channel = true;
                                                                              this.width = 34;
                                                                              this.height = 34;
                                                                              this.UseSound = SoundID.Item25;
                                                                              this.useAnimation = 20;
                                                                              this.useTime = 20;
                                                                              this.rare = 8;
                                                                              this.noMelee = true;
                                                                              this.mountType = 12;
                                                                              this.value = Item.sellPrice(gold: 5);
                                                                              this.expert = true;
                                                                              return;
                                                                            case 3368:
                                                                              this.width = 14;
                                                                              this.height = 38;
                                                                              this.useAnimation = 25;
                                                                              this.useTime = 15;
                                                                              this.useStyle = 5;
                                                                              this.rare = 9;
                                                                              this.noUseGraphic = true;
                                                                              this.channel = true;
                                                                              this.noMelee = true;
                                                                              this.damage = 20;
                                                                              this.knockBack = 4f;
                                                                              this.autoReuse = false;
                                                                              this.noMelee = true;
                                                                              this.melee = true;
                                                                              this.shoot = 595;
                                                                              this.shootSpeed = 15f;
                                                                              this.value = Item.sellPrice(gold: 5);
                                                                              return;
                                                                            case 3369:
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.maxStack = 999;
                                                                              this.consumable = true;
                                                                              this.createTile = 209;
                                                                              this.placeStyle = 2;
                                                                              this.width = 12;
                                                                              this.height = 12;
                                                                              this.rare = 3;
                                                                              this.value = Item.buyPrice(gold: 25);
                                                                              return;
                                                                            case 3370:
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.consumable = true;
                                                                              this.createTile = 139;
                                                                              this.placeStyle = 36;
                                                                              this.width = 24;
                                                                              this.height = 24;
                                                                              this.rare = 4;
                                                                              this.value = 100000;
                                                                              this.accessory = true;
                                                                              this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                              return;
                                                                            case 3371:
                                                                              this.useStyle = 1;
                                                                              this.useTurn = true;
                                                                              this.useAnimation = 15;
                                                                              this.useTime = 10;
                                                                              this.autoReuse = true;
                                                                              this.consumable = true;
                                                                              this.createTile = 139;
                                                                              this.placeStyle = 37;
                                                                              this.width = 24;
                                                                              this.height = 24;
                                                                              this.rare = 4;
                                                                              this.value = 100000;
                                                                              this.accessory = true;
                                                                              this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                              return;
                                                                            default:
                                                                              if (type >= 3372 && type <= 3373)
                                                                              {
                                                                                this.width = 28;
                                                                                this.height = 20;
                                                                                this.headSlot = type + 186 - 3372;
                                                                                this.rare = 1;
                                                                                this.value = Item.sellPrice(silver: 75);
                                                                                this.vanity = true;
                                                                                return;
                                                                              }
                                                                              switch (type)
                                                                              {
                                                                                case 3374:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 2;
                                                                                  this.headSlot = 188;
                                                                                  this.rare = 1;
                                                                                  this.value = Item.sellPrice(silver: 30);
                                                                                  return;
                                                                                case 3375:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 4;
                                                                                  this.bodySlot = 189;
                                                                                  this.rare = 1;
                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                  return;
                                                                                case 3376:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 2;
                                                                                  this.legSlot = 129;
                                                                                  this.rare = 1;
                                                                                  this.value = Item.sellPrice(silver: 40);
                                                                                  return;
                                                                                case 3377:
                                                                                  this.mana = 7;
                                                                                  this.UseSound = SoundID.Item43;
                                                                                  this.useStyle = 5;
                                                                                  this.damage = 21;
                                                                                  this.useAnimation = 28;
                                                                                  this.useTime = 28;
                                                                                  this.width = 40;
                                                                                  this.height = 40;
                                                                                  this.shoot = 597;
                                                                                  this.shootSpeed = 9f;
                                                                                  this.knockBack = 4.75f;
                                                                                  this.magic = true;
                                                                                  this.autoReuse = true;
                                                                                  this.value = 20000;
                                                                                  this.rare = 1;
                                                                                  this.noMelee = true;
                                                                                  return;
                                                                                case 3378:
                                                                                  this.shoot = 598;
                                                                                  this.shootSpeed = 10f;
                                                                                  this.damage = 20;
                                                                                  this.knockBack = 5f;
                                                                                  this.ranged = true;
                                                                                  this.useStyle = 1;
                                                                                  this.UseSound = SoundID.Item1;
                                                                                  this.useAnimation = 25;
                                                                                  this.useTime = 25;
                                                                                  this.width = 30;
                                                                                  this.height = 30;
                                                                                  this.maxStack = 999;
                                                                                  this.consumable = true;
                                                                                  this.noUseGraphic = true;
                                                                                  this.noMelee = true;
                                                                                  this.autoReuse = true;
                                                                                  this.value = 50;
                                                                                  this.rare = 1;
                                                                                  return;
                                                                                case 3379:
                                                                                  this.autoReuse = true;
                                                                                  this.useStyle = 1;
                                                                                  this.shootSpeed = 10f;
                                                                                  this.shoot = 599;
                                                                                  this.damage = 14;
                                                                                  this.width = 18;
                                                                                  this.height = 20;
                                                                                  this.maxStack = 999;
                                                                                  this.consumable = true;
                                                                                  this.UseSound = SoundID.Item1;
                                                                                  this.useAnimation = 14;
                                                                                  this.useTime = 14;
                                                                                  this.noUseGraphic = true;
                                                                                  this.noMelee = true;
                                                                                  this.value = 50;
                                                                                  this.knockBack = 1.5f;
                                                                                  this.ranged = true;
                                                                                  this.rare = 1;
                                                                                  return;
                                                                                case 3380:
                                                                                  this.useStyle = 1;
                                                                                  this.useTurn = true;
                                                                                  this.useAnimation = 15;
                                                                                  this.useTime = 10;
                                                                                  this.autoReuse = true;
                                                                                  this.maxStack = 999;
                                                                                  this.consumable = true;
                                                                                  this.createTile = 407;
                                                                                  this.width = 12;
                                                                                  this.height = 12;
                                                                                  this.rare = 1;
                                                                                  return;
                                                                                case 3381:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 10;
                                                                                  this.headSlot = 189;
                                                                                  this.rare = 10;
                                                                                  this.value = Item.sellPrice(gold: 7);
                                                                                  return;
                                                                                case 3382:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 16;
                                                                                  this.bodySlot = 190;
                                                                                  this.rare = 10;
                                                                                  this.value = Item.sellPrice(gold: 7) * 2;
                                                                                  return;
                                                                                case 3383:
                                                                                  this.width = 18;
                                                                                  this.height = 18;
                                                                                  this.defense = 12;
                                                                                  this.legSlot = 130;
                                                                                  this.rare = 10;
                                                                                  this.value = (int) ((double) Item.sellPrice(gold: 7) * 1.5);
                                                                                  return;
                                                                                case 3384:
                                                                                  this.useStyle = 5;
                                                                                  this.useAnimation = 20;
                                                                                  this.useTime = 20;
                                                                                  this.shootSpeed = 24f;
                                                                                  this.knockBack = 2f;
                                                                                  this.width = 16;
                                                                                  this.height = 16;
                                                                                  this.UseSound = (LegacySoundStyle) null;
                                                                                  this.shoot = 600;
                                                                                  this.rare = 8;
                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                  this.noMelee = true;
                                                                                  this.noUseGraphic = true;
                                                                                  this.channel = true;
                                                                                  this.autoReuse = true;
                                                                                  return;
                                                                                default:
                                                                                  if (type >= 3385 && type <= 3388)
                                                                                  {
                                                                                    this.width = 20;
                                                                                    this.height = 20;
                                                                                    this.maxStack = 99;
                                                                                    this.value = 10000;
                                                                                    this.rare = -11;
                                                                                    this.placeStyle = type - 3385 + 8;
                                                                                    this.createTile = 227;
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.consumable = true;
                                                                                    return;
                                                                                  }
                                                                                  if (type >= 3390 && type <= 3452)
                                                                                  {
                                                                                    this.useStyle = 1;
                                                                                    this.useTurn = true;
                                                                                    this.useAnimation = 15;
                                                                                    this.useTime = 10;
                                                                                    this.autoReuse = true;
                                                                                    this.maxStack = 99;
                                                                                    this.consumable = true;
                                                                                    this.createTile = 91;
                                                                                    this.placeStyle = 207 + type - 3390;
                                                                                    this.width = 10;
                                                                                    this.height = 24;
                                                                                    this.value = 1000;
                                                                                    this.rare = 1;
                                                                                    return;
                                                                                  }
                                                                                  if (type >= 3453 && type <= 3455)
                                                                                  {
                                                                                    this.width = 12;
                                                                                    this.height = 12;
                                                                                    switch (type)
                                                                                    {
                                                                                      case 3453:
                                                                                        this.buffType = 179;
                                                                                        return;
                                                                                      case 3454:
                                                                                        this.buffType = 173;
                                                                                        return;
                                                                                      case 3455:
                                                                                        this.buffType = 176;
                                                                                        return;
                                                                                      default:
                                                                                        return;
                                                                                    }
                                                                                  }
                                                                                  else
                                                                                  {
                                                                                    if (type >= 3456 && type <= 3459)
                                                                                    {
                                                                                      this.width = 18;
                                                                                      this.height = 18;
                                                                                      this.maxStack = 999;
                                                                                      this.value = Item.sellPrice(silver: 20);
                                                                                      this.rare = 9;
                                                                                      return;
                                                                                    }
                                                                                    switch (type)
                                                                                    {
                                                                                      case 3460:
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 999;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 408;
                                                                                        this.width = 12;
                                                                                        this.height = 12;
                                                                                        this.rare = 10;
                                                                                        this.value = Item.sellPrice(gold: 1, silver: 20) / 4;
                                                                                        return;
                                                                                      case 3461:
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.maxStack = 999;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 409;
                                                                                        this.width = 12;
                                                                                        this.height = 12;
                                                                                        return;
                                                                                      case 3462:
                                                                                        this.SetDefaults3(2772);
                                                                                        type = 3462;
                                                                                        this.glowMask = (short) 174;
                                                                                        return;
                                                                                      case 3463:
                                                                                        this.SetDefaults3(2773);
                                                                                        type = 3463;
                                                                                        this.shoot = 610;
                                                                                        this.glowMask = (short) 175;
                                                                                        return;
                                                                                      case 3464:
                                                                                        this.SetDefaults3(2774);
                                                                                        type = 3464;
                                                                                        this.shoot = 609;
                                                                                        this.glowMask = (short) 176;
                                                                                        return;
                                                                                      case 3465:
                                                                                        this.SetDefaults3(2775);
                                                                                        type = 3465;
                                                                                        this.glowMask = (short) 177;
                                                                                        return;
                                                                                      case 3466:
                                                                                        this.SetDefaults3(2776);
                                                                                        type = 3466;
                                                                                        this.glowMask = (short) 178;
                                                                                        return;
                                                                                      case 3467:
                                                                                        this.width = 20;
                                                                                        this.height = 20;
                                                                                        this.maxStack = 999;
                                                                                        this.rare = 10;
                                                                                        this.value = Item.sellPrice(gold: 1, silver: 20);
                                                                                        this.useStyle = 1;
                                                                                        this.useTurn = true;
                                                                                        this.useAnimation = 15;
                                                                                        this.useTime = 10;
                                                                                        this.autoReuse = true;
                                                                                        this.consumable = true;
                                                                                        this.createTile = 239;
                                                                                        this.placeStyle = 22;
                                                                                        return;
                                                                                      default:
                                                                                        if (type >= 3468 && type <= 3471)
                                                                                        {
                                                                                          this.width = 22;
                                                                                          this.height = 20;
                                                                                          this.accessory = true;
                                                                                          this.value = Item.buyPrice(gold: 40);
                                                                                          this.rare = 10;
                                                                                          this.wingSlot = (sbyte) (29 + type - 3468);
                                                                                          return;
                                                                                        }
                                                                                        switch (type)
                                                                                        {
                                                                                          case 3472:
                                                                                            this.useStyle = 1;
                                                                                            this.useTurn = true;
                                                                                            this.useAnimation = 15;
                                                                                            this.useTime = 7;
                                                                                            this.autoReuse = true;
                                                                                            this.maxStack = 999;
                                                                                            this.consumable = true;
                                                                                            this.createWall = 224;
                                                                                            this.width = 12;
                                                                                            this.height = 12;
                                                                                            return;
                                                                                          case 3473:
                                                                                            this.useStyle = 5;
                                                                                            this.useAnimation = 20;
                                                                                            this.useTime = 20;
                                                                                            this.shootSpeed = 24f;
                                                                                            this.knockBack = 2f;
                                                                                            this.width = 16;
                                                                                            this.height = 16;
                                                                                            this.shoot = 611;
                                                                                            this.rare = 10;
                                                                                            this.value = Item.sellPrice(gold: 10);
                                                                                            this.noMelee = true;
                                                                                            this.noUseGraphic = true;
                                                                                            this.channel = true;
                                                                                            this.autoReuse = true;
                                                                                            this.melee = true;
                                                                                            this.damage = 105;
                                                                                            return;
                                                                                          case 3474:
                                                                                            this.mana = 10;
                                                                                            this.damage = 60;
                                                                                            this.useStyle = 1;
                                                                                            this.shootSpeed = 10f;
                                                                                            this.shoot = 613;
                                                                                            this.width = 26;
                                                                                            this.height = 28;
                                                                                            this.UseSound = SoundID.Item44;
                                                                                            this.useAnimation = 36;
                                                                                            this.useTime = 36;
                                                                                            this.rare = 10;
                                                                                            this.noMelee = true;
                                                                                            this.knockBack = 2f;
                                                                                            this.buffType = 182;
                                                                                            this.value = Item.sellPrice(gold: 10);
                                                                                            this.summon = true;
                                                                                            return;
                                                                                          case 3475:
                                                                                            this.useStyle = 5;
                                                                                            this.useAnimation = 20;
                                                                                            this.useTime = 20;
                                                                                            this.shootSpeed = 20f;
                                                                                            this.knockBack = 2f;
                                                                                            this.width = 20;
                                                                                            this.height = 12;
                                                                                            this.damage = 50;
                                                                                            this.UseSound = (LegacySoundStyle) null;
                                                                                            this.shoot = 615;
                                                                                            this.rare = 10;
                                                                                            this.value = Item.sellPrice(gold: 10);
                                                                                            this.noMelee = true;
                                                                                            this.noUseGraphic = true;
                                                                                            this.ranged = true;
                                                                                            this.channel = true;
                                                                                            this.glowMask = (short) 191;
                                                                                            this.useAmmo = AmmoID.Bullet;
                                                                                            this.autoReuse = true;
                                                                                            return;
                                                                                          case 3476:
                                                                                            this.mana = 30;
                                                                                            this.damage = 70;
                                                                                            this.useStyle = 5;
                                                                                            this.shootSpeed = 7f;
                                                                                            this.shoot = 617;
                                                                                            this.width = 26;
                                                                                            this.height = 28;
                                                                                            this.UseSound = SoundID.Item117;
                                                                                            this.useAnimation = 30;
                                                                                            this.useTime = 30;
                                                                                            this.autoReuse = true;
                                                                                            this.noMelee = true;
                                                                                            this.knockBack = 5f;
                                                                                            this.rare = 10;
                                                                                            this.value = Item.sellPrice(gold: 10);
                                                                                            this.magic = true;
                                                                                            this.glowMask = (short) 194;
                                                                                            this.holdStyle = 1;
                                                                                            return;
                                                                                          case 3477:
                                                                                            this.useStyle = 1;
                                                                                            this.shootSpeed = 9f;
                                                                                            this.rare = 3;
                                                                                            this.damage = 20;
                                                                                            this.shoot = 621;
                                                                                            this.width = 18;
                                                                                            this.height = 20;
                                                                                            this.maxStack = 999;
                                                                                            this.consumable = true;
                                                                                            this.knockBack = 3f;
                                                                                            this.UseSound = SoundID.Item1;
                                                                                            this.useAnimation = 15;
                                                                                            this.useTime = 15;
                                                                                            this.noUseGraphic = true;
                                                                                            this.noMelee = true;
                                                                                            this.value = 100;
                                                                                            return;
                                                                                          case 3478:
                                                                                            this.width = 18;
                                                                                            this.height = 18;
                                                                                            this.headSlot = 190;
                                                                                            this.value = 5000;
                                                                                            this.vanity = true;
                                                                                            return;
                                                                                          case 3479:
                                                                                            this.width = 18;
                                                                                            this.height = 18;
                                                                                            this.bodySlot = 191;
                                                                                            this.value = 5000;
                                                                                            this.vanity = true;
                                                                                            return;
                                                                                          default:
                                                                                            if (type >= 3522 && type <= 3525)
                                                                                            {
                                                                                              this.useTurn = true;
                                                                                              this.autoReuse = true;
                                                                                              this.useStyle = 1;
                                                                                              this.useAnimation = 28;
                                                                                              this.useTime = 7;
                                                                                              this.knockBack = 7f;
                                                                                              this.width = 42;
                                                                                              this.height = 42;
                                                                                              this.damage = 60;
                                                                                              this.axe = 30;
                                                                                              this.hammer = 100;
                                                                                              this.UseSound = SoundID.Item1;
                                                                                              this.rare = 10;
                                                                                              this.value = Item.sellPrice(gold: 5);
                                                                                              this.melee = true;
                                                                                              this.tileBoost += 4;
                                                                                              switch (type)
                                                                                              {
                                                                                                case 3522:
                                                                                                  return;
                                                                                                case 3523:
                                                                                                  this.glowMask = (short) 196;
                                                                                                  return;
                                                                                                case 3524:
                                                                                                  this.glowMask = (short) 197;
                                                                                                  return;
                                                                                                case 3525:
                                                                                                  this.glowMask = (short) 198;
                                                                                                  return;
                                                                                                default:
                                                                                                  return;
                                                                                              }
                                                                                            }
                                                                                            else
                                                                                            {
                                                                                              switch (type)
                                                                                              {
                                                                                                case 3349:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 18;
                                                                                                  this.useTime = 18;
                                                                                                  this.damage = 20;
                                                                                                  this.width = this.height = 32;
                                                                                                  this.knockBack = 4.25f;
                                                                                                  this.rare = 2;
                                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                                  return;
                                                                                                case 3350:
                                                                                                  this.useStyle = 5;
                                                                                                  this.useAnimation = 24;
                                                                                                  this.useTime = 9;
                                                                                                  this.width = 24;
                                                                                                  this.height = 14;
                                                                                                  this.shoot = 587;
                                                                                                  this.UseSound = (LegacySoundStyle) null;
                                                                                                  this.damage = 12;
                                                                                                  this.shootSpeed = 10f;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                                  this.knockBack = 1.25f;
                                                                                                  this.scale = 0.85f;
                                                                                                  this.rare = 2;
                                                                                                  this.ranged = true;
                                                                                                  this.crit = 7;
                                                                                                  return;
                                                                                                case 3351:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 15;
                                                                                                  this.damage = 16;
                                                                                                  this.width = this.height = 28;
                                                                                                  this.knockBack = 3.5f;
                                                                                                  this.rare = 2;
                                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                                  return;
                                                                                                case 3352:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.damage = 14;
                                                                                                  this.width = this.height = 32;
                                                                                                  this.knockBack = 5f;
                                                                                                  this.rare = 2;
                                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                                  return;
                                                                                                case 3480:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 25;
                                                                                                  this.useTime = 25;
                                                                                                  this.damage = 13;
                                                                                                  this.value = 10500;
                                                                                                  return;
                                                                                                case 3481:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 27;
                                                                                                  this.useTime = 21;
                                                                                                  this.scale = 1.275f;
                                                                                                  this.damage = 10;
                                                                                                  this.hammer = 59;
                                                                                                  this.value = 12000;
                                                                                                  return;
                                                                                                case 3482:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 17;
                                                                                                  this.axe = 12;
                                                                                                  this.useAnimation = 25;
                                                                                                  this.scale = 1.175f;
                                                                                                  this.damage = 8;
                                                                                                  this.value = 12000;
                                                                                                  return;
                                                                                                case 3483:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 13;
                                                                                                  this.useAnimation = 10;
                                                                                                  this.useTime = 10;
                                                                                                  this.knockBack = 5f;
                                                                                                  this.shoot = 945;
                                                                                                  this.scale = 0.975f;
                                                                                                  this.value = 10500;
                                                                                                  return;
                                                                                                case 3484:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 19;
                                                                                                  this.damage = 15;
                                                                                                  this.scale = 1.075f;
                                                                                                  this.value = 13500;
                                                                                                  return;
                                                                                                case 3485:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 15;
                                                                                                  this.pick = 59;
                                                                                                  this.useAnimation = 19;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.damage = 7;
                                                                                                  this.value = 15000;
                                                                                                  return;
                                                                                                case 3486:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 26;
                                                                                                  this.useTime = 26;
                                                                                                  this.damage = 10;
                                                                                                  this.value = 5250;
                                                                                                  return;
                                                                                                case 3487:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 28;
                                                                                                  this.useTime = 25;
                                                                                                  this.scale = 1.25f;
                                                                                                  this.damage = 9;
                                                                                                  this.hammer = 50;
                                                                                                  this.value = 6000;
                                                                                                  return;
                                                                                                case 3488:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 18;
                                                                                                  this.axe = 11;
                                                                                                  this.useAnimation = 26;
                                                                                                  this.scale = 1.15f;
                                                                                                  this.damage = 7;
                                                                                                  this.value = 6000;
                                                                                                  return;
                                                                                                case 3489:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 10;
                                                                                                  this.useAnimation = 11;
                                                                                                  this.useTime = 11;
                                                                                                  this.knockBack = 4f;
                                                                                                  this.shoot = 943;
                                                                                                  this.scale = 0.95f;
                                                                                                  this.value = 5250;
                                                                                                  return;
                                                                                                case 3490:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 20;
                                                                                                  this.damage = 12;
                                                                                                  this.scale *= 1.025f;
                                                                                                  this.value = 6750;
                                                                                                  return;
                                                                                                case 3491:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 19;
                                                                                                  this.pick = 50;
                                                                                                  this.useAnimation = 21;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 7500;
                                                                                                  return;
                                                                                                case 3492:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 27;
                                                                                                  this.useTime = 27;
                                                                                                  this.damage = 9;
                                                                                                  this.value = 2100;
                                                                                                  return;
                                                                                                case 3493:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 29;
                                                                                                  this.useTime = 19;
                                                                                                  this.scale = 1.225f;
                                                                                                  this.damage = 8;
                                                                                                  this.hammer = 43;
                                                                                                  this.value = 2400;
                                                                                                  return;
                                                                                                case 3494:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 19;
                                                                                                  this.axe = 10;
                                                                                                  this.useAnimation = 28;
                                                                                                  this.scale = 1.125f;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 2400;
                                                                                                  return;
                                                                                                case 3495:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 9;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.knockBack = 4f;
                                                                                                  this.shoot = 941;
                                                                                                  this.scale = 0.925f;
                                                                                                  this.value = 2100;
                                                                                                  return;
                                                                                                case 3496:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 21;
                                                                                                  this.damage = 11;
                                                                                                  this.value = 2700;
                                                                                                  return;
                                                                                                case 3497:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 12;
                                                                                                  this.pick = 43;
                                                                                                  this.useAnimation = 19;
                                                                                                  this.damage = 6;
                                                                                                  this.scale = 1.025f;
                                                                                                  this.value = 3000;
                                                                                                  return;
                                                                                                case 3498:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 28;
                                                                                                  this.useTime = 28;
                                                                                                  this.damage = 7;
                                                                                                  this.value = 525;
                                                                                                  return;
                                                                                                case 3499:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 31;
                                                                                                  this.useTime = 21;
                                                                                                  this.scale = 1.15f;
                                                                                                  this.damage = 6;
                                                                                                  this.hammer = 38;
                                                                                                  this.value = 600;
                                                                                                  return;
                                                                                                case 3500:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 20;
                                                                                                  this.axe = 8;
                                                                                                  this.useAnimation = 28;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.damage = 4;
                                                                                                  this.value = 600;
                                                                                                  return;
                                                                                                case 3501:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 7;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.knockBack = 4f;
                                                                                                  this.shoot = 939;
                                                                                                  this.scale = 0.85f;
                                                                                                  this.value = 525;
                                                                                                  return;
                                                                                                case 3502:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 22;
                                                                                                  this.damage = 9;
                                                                                                  this.value = 675;
                                                                                                  return;
                                                                                                case 3503:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 14;
                                                                                                  this.pick = 35;
                                                                                                  this.useAnimation = 21;
                                                                                                  this.damage = 5;
                                                                                                  this.scale = 0.95f;
                                                                                                  this.value = 750;
                                                                                                  return;
                                                                                                case 3504:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 29;
                                                                                                  this.useTime = 29;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 350;
                                                                                                  return;
                                                                                                case 3505:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 33;
                                                                                                  this.useTime = 23;
                                                                                                  this.scale = 1.1f;
                                                                                                  this.damage = 4;
                                                                                                  this.hammer = 35;
                                                                                                  this.tileBoost = -1;
                                                                                                  this.value = 400;
                                                                                                  return;
                                                                                                case 3506:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 21;
                                                                                                  this.axe = 7;
                                                                                                  this.useAnimation = 30;
                                                                                                  this.scale = 1f;
                                                                                                  this.damage = 3;
                                                                                                  this.tileBoost = -1;
                                                                                                  this.value = 400;
                                                                                                  return;
                                                                                                case 3507:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 5;
                                                                                                  this.useAnimation = 13;
                                                                                                  this.useTime = 13;
                                                                                                  this.knockBack = 4f;
                                                                                                  this.shoot = 938;
                                                                                                  this.scale = 0.8f;
                                                                                                  this.value = 350;
                                                                                                  return;
                                                                                                case 3508:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 23;
                                                                                                  this.damage = 8;
                                                                                                  this.value = 450;
                                                                                                  return;
                                                                                                case 3509:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 15;
                                                                                                  this.pick = 35;
                                                                                                  this.useAnimation = 23;
                                                                                                  this.damage = 4;
                                                                                                  this.scale = 0.9f;
                                                                                                  this.tileBoost = -1;
                                                                                                  this.value = 500;
                                                                                                  return;
                                                                                                case 3510:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 27;
                                                                                                  this.useTime = 27;
                                                                                                  this.damage = 9;
                                                                                                  this.value = 3500;
                                                                                                  return;
                                                                                                case 3511:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 29;
                                                                                                  this.useTime = 19;
                                                                                                  this.scale = 1.25f;
                                                                                                  this.damage = 9;
                                                                                                  this.hammer = 45;
                                                                                                  this.value = 4000;
                                                                                                  return;
                                                                                                case 3512:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 18;
                                                                                                  this.axe = 10;
                                                                                                  this.useAnimation = 26;
                                                                                                  this.scale = 1.15f;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 4000;
                                                                                                  return;
                                                                                                case 3513:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 9;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.knockBack = 4f;
                                                                                                  this.shoot = 942;
                                                                                                  this.scale = 0.95f;
                                                                                                  this.value = 3500;
                                                                                                  return;
                                                                                                case 3514:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 21;
                                                                                                  this.damage = 11;
                                                                                                  this.value = 4500;
                                                                                                  return;
                                                                                                case 3515:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 11;
                                                                                                  this.pick = 45;
                                                                                                  this.useAnimation = 19;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 5000;
                                                                                                  return;
                                                                                                case 3516:
                                                                                                  this.SetDefaults1(99);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 26;
                                                                                                  this.useTime = 26;
                                                                                                  this.damage = 11;
                                                                                                  this.value = 7000;
                                                                                                  return;
                                                                                                case 3517:
                                                                                                  this.SetDefaults1(7);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 28;
                                                                                                  this.useTime = 23;
                                                                                                  this.scale = 1.25f;
                                                                                                  this.damage = 9;
                                                                                                  this.hammer = 55;
                                                                                                  this.value = 8000;
                                                                                                  return;
                                                                                                case 3518:
                                                                                                  this.SetDefaults1(10);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 18;
                                                                                                  this.axe = 11;
                                                                                                  this.useAnimation = 26;
                                                                                                  this.scale = 1.15f;
                                                                                                  this.damage = 7;
                                                                                                  this.value = 8000;
                                                                                                  return;
                                                                                                case 3519:
                                                                                                  this.SetDefaults1(6);
                                                                                                  this.type = type;
                                                                                                  this.damage = 12;
                                                                                                  this.useAnimation = 11;
                                                                                                  this.useTime = 11;
                                                                                                  this.knockBack = 5f;
                                                                                                  this.shoot = 944;
                                                                                                  this.scale = 0.95f;
                                                                                                  this.value = 7000;
                                                                                                  return;
                                                                                                case 3520:
                                                                                                  this.SetDefaults1(4);
                                                                                                  this.type = type;
                                                                                                  this.useAnimation = 20;
                                                                                                  this.damage = 13;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.value = 9000;
                                                                                                  return;
                                                                                                case 3521:
                                                                                                  this.SetDefaults1(1);
                                                                                                  this.type = type;
                                                                                                  this.useTime = 17;
                                                                                                  this.pick = 55;
                                                                                                  this.useAnimation = 20;
                                                                                                  this.scale = 1.05f;
                                                                                                  this.damage = 6;
                                                                                                  this.value = 10000;
                                                                                                  return;
                                                                                                case 3526:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                                  this.rare = 4;
                                                                                                  return;
                                                                                                case 3527:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                                  this.rare = 4;
                                                                                                  return;
                                                                                                case 3528:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                                  this.rare = 4;
                                                                                                  return;
                                                                                                case 3529:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                                  this.rare = 4;
                                                                                                  return;
                                                                                                case 3530:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 2, silver: 50);
                                                                                                  this.rare = 4;
                                                                                                  return;
                                                                                                case 3531:
                                                                                                  this.mana = 10;
                                                                                                  this.damage = 40;
                                                                                                  this.useStyle = 1;
                                                                                                  this.shootSpeed = 10f;
                                                                                                  this.shoot = 625;
                                                                                                  this.width = 26;
                                                                                                  this.height = 28;
                                                                                                  this.UseSound = SoundID.Item44;
                                                                                                  this.useAnimation = 36;
                                                                                                  this.useTime = 36;
                                                                                                  this.rare = 10;
                                                                                                  this.noMelee = true;
                                                                                                  this.knockBack = 2f;
                                                                                                  this.buffType = 188;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.summon = true;
                                                                                                  return;
                                                                                                case 3533:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3534:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(silver: 75);
                                                                                                  this.rare = 2;
                                                                                                  return;
                                                                                                case 3535:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3536:
                                                                                                  this.width = 22;
                                                                                                  this.height = 32;
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 410;
                                                                                                  this.placeStyle = 0;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.buyPrice(1);
                                                                                                  return;
                                                                                                case 3537:
                                                                                                  this.width = 22;
                                                                                                  this.height = 32;
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 410;
                                                                                                  this.placeStyle = 1;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.buyPrice(1);
                                                                                                  return;
                                                                                                case 3538:
                                                                                                  this.width = 22;
                                                                                                  this.height = 32;
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 410;
                                                                                                  this.placeStyle = 2;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.buyPrice(1);
                                                                                                  return;
                                                                                                case 3539:
                                                                                                  this.width = 22;
                                                                                                  this.height = 32;
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 410;
                                                                                                  this.placeStyle = 3;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.buyPrice(1);
                                                                                                  return;
                                                                                                case 3540:
                                                                                                  this.useStyle = 5;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.shootSpeed = 20f;
                                                                                                  this.knockBack = 2f;
                                                                                                  this.width = 20;
                                                                                                  this.height = 12;
                                                                                                  this.damage = 50;
                                                                                                  this.UseSound = SoundID.Item5;
                                                                                                  this.shoot = 630;
                                                                                                  this.rare = 10;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.noMelee = true;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.ranged = true;
                                                                                                  this.channel = true;
                                                                                                  this.glowMask = (short) 200;
                                                                                                  this.useAmmo = AmmoID.Arrow;
                                                                                                  this.autoReuse = true;
                                                                                                  return;
                                                                                                case 3541:
                                                                                                  this.useStyle = 5;
                                                                                                  this.useAnimation = 10;
                                                                                                  this.useTime = 10;
                                                                                                  this.reuseDelay = 5;
                                                                                                  this.shootSpeed = 30f;
                                                                                                  this.knockBack = 0.0f;
                                                                                                  this.width = 16;
                                                                                                  this.height = 16;
                                                                                                  this.damage = 100;
                                                                                                  this.UseSound = (LegacySoundStyle) null;
                                                                                                  this.shoot = 633;
                                                                                                  this.mana = 12;
                                                                                                  this.rare = 10;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.noMelee = true;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.magic = true;
                                                                                                  this.channel = true;
                                                                                                  return;
                                                                                                case 3542:
                                                                                                  this.useStyle = 5;
                                                                                                  this.useAnimation = 12;
                                                                                                  this.useTime = 12;
                                                                                                  this.shootSpeed = 6f;
                                                                                                  this.knockBack = 0.0f;
                                                                                                  this.width = 16;
                                                                                                  this.height = 16;
                                                                                                  this.damage = 130;
                                                                                                  this.UseSound = SoundID.Item20;
                                                                                                  this.shoot = 634;
                                                                                                  this.mana = 12;
                                                                                                  this.rare = 10;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.noMelee = true;
                                                                                                  this.magic = true;
                                                                                                  this.autoReuse = true;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.glowMask = (short) 207;
                                                                                                  return;
                                                                                                case 3543:
                                                                                                  this.shoot = 636;
                                                                                                  this.shootSpeed = 10f;
                                                                                                  this.damage = 150;
                                                                                                  this.knockBack = 5f;
                                                                                                  this.melee = true;
                                                                                                  this.useStyle = 1;
                                                                                                  this.UseSound = SoundID.Item1;
                                                                                                  this.useAnimation = 16;
                                                                                                  this.useTime = 16;
                                                                                                  this.width = 30;
                                                                                                  this.height = 30;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.noMelee = true;
                                                                                                  this.autoReuse = true;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.rare = 10;
                                                                                                  return;
                                                                                                case 3544:
                                                                                                  this.UseSound = SoundID.Item3;
                                                                                                  this.healLife = 200;
                                                                                                  this.useStyle = 9;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 17;
                                                                                                  this.useTime = 17;
                                                                                                  this.maxStack = 30;
                                                                                                  this.consumable = true;
                                                                                                  this.potion = true;
                                                                                                  this.width = 14;
                                                                                                  this.height = 24;
                                                                                                  this.rare = 7;
                                                                                                  this.value = Item.sellPrice(silver: 30);
                                                                                                  return;
                                                                                                case 3545:
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 411;
                                                                                                  this.width = 28;
                                                                                                  this.height = 28;
                                                                                                  this.rare = 1;
                                                                                                  this.mech = true;
                                                                                                  this.value = Item.sellPrice(silver: 20);
                                                                                                  return;
                                                                                                case 3546:
                                                                                                  this.useStyle = 5;
                                                                                                  this.autoReuse = true;
                                                                                                  this.useAnimation = 30;
                                                                                                  this.useTime = 30;
                                                                                                  this.useAmmo = AmmoID.Rocket;
                                                                                                  this.width = 50;
                                                                                                  this.height = 20;
                                                                                                  this.shoot = 134;
                                                                                                  this.UseSound = SoundID.Item156;
                                                                                                  this.damage = 25;
                                                                                                  this.shootSpeed = 15f;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.buyPrice(gold: 80);
                                                                                                  this.knockBack = 4f;
                                                                                                  this.rare = 8;
                                                                                                  this.ranged = true;
                                                                                                  return;
                                                                                                case 3547:
                                                                                                  this.useStyle = 1;
                                                                                                  this.shootSpeed = 4f;
                                                                                                  this.shoot = 637;
                                                                                                  this.width = 8;
                                                                                                  this.height = 28;
                                                                                                  this.maxStack = 99;
                                                                                                  this.consumable = true;
                                                                                                  this.UseSound = SoundID.Item1;
                                                                                                  this.useAnimation = 40;
                                                                                                  this.useTime = 40;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.buyPrice(silver: 20);
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3548:
                                                                                                  this.useStyle = 5;
                                                                                                  this.shootSpeed = 6f;
                                                                                                  this.shoot = 588;
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.consumable = true;
                                                                                                  this.UseSound = SoundID.Item1;
                                                                                                  this.useAnimation = 20;
                                                                                                  this.useTime = 20;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.sellPrice(copper: 50);
                                                                                                  this.damage = 30;
                                                                                                  this.knockBack = 6f;
                                                                                                  this.rare = 2;
                                                                                                  this.ranged = true;
                                                                                                  return;
                                                                                                case 3549:
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 99;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 412;
                                                                                                  this.width = 28;
                                                                                                  this.height = 28;
                                                                                                  this.rare = 10;
                                                                                                  return;
                                                                                                case 3550:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3551:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3552:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3553:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(silver: 75);
                                                                                                  this.rare = 2;
                                                                                                  return;
                                                                                                case 3554:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(silver: 75);
                                                                                                  this.rare = 2;
                                                                                                  return;
                                                                                                case 3555:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(silver: 75);
                                                                                                  this.rare = 2;
                                                                                                  return;
                                                                                                case 3556:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3557:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3558:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3559:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 1;
                                                                                                  return;
                                                                                                case 3560:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = 10000;
                                                                                                  this.rare = 2;
                                                                                                  return;
                                                                                                case 3561:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3562:
                                                                                                  this.width = 20;
                                                                                                  this.height = 20;
                                                                                                  this.maxStack = 99;
                                                                                                  this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3563:
                                                                                                  this.useStyle = 1;
                                                                                                  this.autoReuse = true;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.width = 12;
                                                                                                  this.height = 12;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.makeNPC = (short) 538;
                                                                                                  return;
                                                                                                case 3564:
                                                                                                  this.useStyle = 1;
                                                                                                  this.autoReuse = true;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.width = 12;
                                                                                                  this.height = 12;
                                                                                                  this.makeNPC = (short) 539;
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3565:
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 99;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 413;
                                                                                                  this.width = 12;
                                                                                                  this.height = 12;
                                                                                                  return;
                                                                                                case 3566:
                                                                                                  this.useStyle = 1;
                                                                                                  this.useTurn = true;
                                                                                                  this.useAnimation = 15;
                                                                                                  this.useTime = 10;
                                                                                                  this.autoReuse = true;
                                                                                                  this.maxStack = 99;
                                                                                                  this.consumable = true;
                                                                                                  this.createTile = 414;
                                                                                                  this.width = 12;
                                                                                                  this.height = 12;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.rare = 3;
                                                                                                  return;
                                                                                                case 3567:
                                                                                                  this.shootSpeed = 2f;
                                                                                                  this.shoot = 638;
                                                                                                  this.damage = 20;
                                                                                                  this.width = 8;
                                                                                                  this.height = 8;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.ammo = AmmoID.Bullet;
                                                                                                  this.knockBack = 3f;
                                                                                                  this.value = 7;
                                                                                                  this.ranged = true;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.sellPrice(copper: 2);
                                                                                                  return;
                                                                                                case 3568:
                                                                                                  this.shootSpeed = 3f;
                                                                                                  this.shoot = 639;
                                                                                                  this.damage = 15;
                                                                                                  this.width = 10;
                                                                                                  this.height = 28;
                                                                                                  this.maxStack = 999;
                                                                                                  this.consumable = true;
                                                                                                  this.ammo = AmmoID.Arrow;
                                                                                                  this.knockBack = 3.5f;
                                                                                                  this.value = 5;
                                                                                                  this.ranged = true;
                                                                                                  this.rare = 9;
                                                                                                  this.value = Item.sellPrice(copper: 2);
                                                                                                  return;
                                                                                                case 3569:
                                                                                                  this.mana = 10;
                                                                                                  this.damage = 50;
                                                                                                  this.useStyle = 1;
                                                                                                  this.shootSpeed = 14f;
                                                                                                  this.shoot = 641;
                                                                                                  this.width = 18;
                                                                                                  this.height = 20;
                                                                                                  this.UseSound = SoundID.Item78;
                                                                                                  this.useAnimation = 30;
                                                                                                  this.useTime = 30;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.knockBack = 7.5f;
                                                                                                  this.rare = 10;
                                                                                                  this.summon = true;
                                                                                                  this.sentry = true;
                                                                                                  return;
                                                                                                case 3570:
                                                                                                  this.autoReuse = true;
                                                                                                  this.mana = 13;
                                                                                                  this.useStyle = 5;
                                                                                                  this.damage = 100;
                                                                                                  this.useAnimation = 10;
                                                                                                  this.useTime = 10;
                                                                                                  this.width = 40;
                                                                                                  this.height = 40;
                                                                                                  this.shoot = 645;
                                                                                                  this.shootSpeed = 10f;
                                                                                                  this.knockBack = 4.5f;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.magic = true;
                                                                                                  this.rare = 10;
                                                                                                  this.noMelee = true;
                                                                                                  this.UseSound = SoundID.Item88;
                                                                                                  return;
                                                                                                case 3571:
                                                                                                  this.mana = 10;
                                                                                                  this.damage = 80;
                                                                                                  this.useStyle = 1;
                                                                                                  this.shootSpeed = 14f;
                                                                                                  this.shoot = 643;
                                                                                                  this.width = 18;
                                                                                                  this.height = 20;
                                                                                                  this.UseSound = SoundID.Item78;
                                                                                                  this.useAnimation = 30;
                                                                                                  this.useTime = 30;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  this.knockBack = 7.5f;
                                                                                                  this.rare = 10;
                                                                                                  this.summon = true;
                                                                                                  this.sentry = true;
                                                                                                  return;
                                                                                                case 3572:
                                                                                                  this.noUseGraphic = true;
                                                                                                  this.damage = 0;
                                                                                                  this.useStyle = 5;
                                                                                                  this.shootSpeed = 18f;
                                                                                                  this.shoot = 646;
                                                                                                  this.width = 18;
                                                                                                  this.height = 28;
                                                                                                  this.UseSound = SoundID.Item1;
                                                                                                  this.useAnimation = 20;
                                                                                                  this.useTime = 20;
                                                                                                  this.rare = 10;
                                                                                                  this.noMelee = true;
                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                  return;
                                                                                                default:
                                                                                                  if (type >= 3573 && type <= 3576)
                                                                                                  {
                                                                                                    this.useStyle = 1;
                                                                                                    this.useTurn = true;
                                                                                                    this.useAnimation = 15;
                                                                                                    this.useTime = 10;
                                                                                                    this.autoReuse = true;
                                                                                                    this.maxStack = 999;
                                                                                                    this.consumable = true;
                                                                                                    this.createTile = 415 + type - 3573;
                                                                                                    this.width = 12;
                                                                                                    this.height = 12;
                                                                                                    return;
                                                                                                  }
                                                                                                  switch (type)
                                                                                                  {
                                                                                                    case 3577:
                                                                                                      this.channel = true;
                                                                                                      this.damage = 0;
                                                                                                      this.useStyle = 4;
                                                                                                      this.shoot = 650;
                                                                                                      this.width = 24;
                                                                                                      this.height = 24;
                                                                                                      this.UseSound = SoundID.Item8;
                                                                                                      this.useAnimation = 20;
                                                                                                      this.useTime = 20;
                                                                                                      this.rare = 10;
                                                                                                      this.noMelee = true;
                                                                                                      this.value = Item.sellPrice(gold: 10);
                                                                                                      this.buffType = 190;
                                                                                                      this.expert = true;
                                                                                                      return;
                                                                                                    case 3578:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.bodySlot = 192;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3579:
                                                                                                      this.width = 18;
                                                                                                      this.height = 14;
                                                                                                      this.legSlot = 132;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3580:
                                                                                                      this.width = 18;
                                                                                                      this.height = 14;
                                                                                                      this.wingSlot = (sbyte) 33;
                                                                                                      this.rare = 9;
                                                                                                      this.accessory = true;
                                                                                                      this.value = 400000;
                                                                                                      return;
                                                                                                    case 3581:
                                                                                                      this.width = 18;
                                                                                                      this.height = 14;
                                                                                                      this.rare = 9;
                                                                                                      this.vanity = true;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.accessory = true;
                                                                                                      this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                                                      return;
                                                                                                    case 3582:
                                                                                                      this.width = 24;
                                                                                                      this.height = 8;
                                                                                                      this.accessory = true;
                                                                                                      this.rare = 9;
                                                                                                      this.wingSlot = (sbyte) 34;
                                                                                                      this.value = 400000;
                                                                                                      return;
                                                                                                    case 3583:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.headSlot = 191;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3584:
                                                                                                      this.useStyle = 1;
                                                                                                      this.useTurn = true;
                                                                                                      this.useAnimation = 15;
                                                                                                      this.useTime = 7;
                                                                                                      this.autoReuse = true;
                                                                                                      this.maxStack = 999;
                                                                                                      this.consumable = true;
                                                                                                      this.createWall = 60;
                                                                                                      this.width = 12;
                                                                                                      this.height = 12;
                                                                                                      return;
                                                                                                    case 3585:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.headSlot = 192;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3586:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.bodySlot = 193;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3587:
                                                                                                      this.width = 18;
                                                                                                      this.height = 14;
                                                                                                      this.legSlot = 133;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3588:
                                                                                                      this.width = 24;
                                                                                                      this.height = 8;
                                                                                                      this.accessory = true;
                                                                                                      this.rare = 9;
                                                                                                      this.wingSlot = (sbyte) 35;
                                                                                                      this.value = 400000;
                                                                                                      return;
                                                                                                    case 3589:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.headSlot = 193;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3590:
                                                                                                      this.width = 28;
                                                                                                      this.height = 20;
                                                                                                      this.bodySlot = 194;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3591:
                                                                                                      this.width = 18;
                                                                                                      this.height = 14;
                                                                                                      this.legSlot = 134;
                                                                                                      this.rare = 9;
                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                      this.vanity = true;
                                                                                                      return;
                                                                                                    case 3592:
                                                                                                      this.width = 24;
                                                                                                      this.height = 8;
                                                                                                      this.accessory = true;
                                                                                                      this.rare = 9;
                                                                                                      this.wingSlot = (sbyte) 36;
                                                                                                      this.value = 400000;
                                                                                                      return;
                                                                                                    default:
                                                                                                      if (type >= 3593 && type <= 3594)
                                                                                                      {
                                                                                                        this.useStyle = 1;
                                                                                                        this.useTurn = true;
                                                                                                        this.useAnimation = 15;
                                                                                                        this.useTime = 10;
                                                                                                        this.autoReuse = true;
                                                                                                        this.maxStack = 99;
                                                                                                        this.consumable = true;
                                                                                                        this.createTile = 91;
                                                                                                        this.placeStyle = 270 + type - 3593;
                                                                                                        this.width = 10;
                                                                                                        this.height = 24;
                                                                                                        this.value = 1000;
                                                                                                        this.rare = 1;
                                                                                                        return;
                                                                                                      }
                                                                                                      switch (type)
                                                                                                      {
                                                                                                        case 3595:
                                                                                                          this.useStyle = 1;
                                                                                                          this.useTurn = true;
                                                                                                          this.useAnimation = 15;
                                                                                                          this.useTime = 10;
                                                                                                          this.autoReuse = true;
                                                                                                          this.maxStack = 99;
                                                                                                          this.consumable = true;
                                                                                                          this.createTile = 240;
                                                                                                          this.width = 30;
                                                                                                          this.height = 30;
                                                                                                          this.value = Item.sellPrice(gold: 1);
                                                                                                          this.placeStyle = 59;
                                                                                                          this.rare = 1;
                                                                                                          return;
                                                                                                        case 3596:
                                                                                                          this.useStyle = 1;
                                                                                                          this.useTurn = true;
                                                                                                          this.useAnimation = 15;
                                                                                                          this.useTime = 10;
                                                                                                          this.autoReuse = true;
                                                                                                          this.maxStack = 99;
                                                                                                          this.consumable = true;
                                                                                                          this.createTile = 242;
                                                                                                          this.width = 30;
                                                                                                          this.height = 30;
                                                                                                          this.value = Item.buyPrice(gold: 3);
                                                                                                          this.placeStyle = 36;
                                                                                                          return;
                                                                                                        case 3601:
                                                                                                          this.useStyle = 4;
                                                                                                          this.width = 22;
                                                                                                          this.height = 14;
                                                                                                          this.consumable = true;
                                                                                                          this.useAnimation = 45;
                                                                                                          this.useTime = 45;
                                                                                                          this.maxStack = 20;
                                                                                                          this.rare = 10;
                                                                                                          return;
                                                                                                        case 3602:
                                                                                                          this.createTile = 419;
                                                                                                          this.width = 16;
                                                                                                          this.height = 16;
                                                                                                          this.rare = 1;
                                                                                                          this.useStyle = 1;
                                                                                                          this.useTurn = true;
                                                                                                          this.useAnimation = 15;
                                                                                                          this.useTime = 10;
                                                                                                          this.autoReuse = true;
                                                                                                          this.maxStack = 999;
                                                                                                          this.consumable = true;
                                                                                                          this.mech = true;
                                                                                                          this.value = Item.buyPrice(silver: 10);
                                                                                                          return;
                                                                                                        default:
                                                                                                          if (type >= 3603 && type <= 3608)
                                                                                                          {
                                                                                                            this.createTile = 420;
                                                                                                            this.width = 16;
                                                                                                            this.height = 16;
                                                                                                            this.rare = 1;
                                                                                                            this.useStyle = 1;
                                                                                                            this.useTurn = true;
                                                                                                            this.useAnimation = 15;
                                                                                                            this.useTime = 10;
                                                                                                            this.autoReuse = true;
                                                                                                            this.maxStack = 999;
                                                                                                            this.consumable = true;
                                                                                                            this.placeStyle = type - 3603;
                                                                                                            this.mech = true;
                                                                                                            this.value = Item.buyPrice(gold: 2);
                                                                                                            return;
                                                                                                          }
                                                                                                          switch (type)
                                                                                                          {
                                                                                                            case 3609:
                                                                                                              this.createTile = 421;
                                                                                                              this.width = 16;
                                                                                                              this.height = 16;
                                                                                                              this.rare = 1;
                                                                                                              this.useStyle = 1;
                                                                                                              this.useTurn = true;
                                                                                                              this.useAnimation = 15;
                                                                                                              this.useTime = 10;
                                                                                                              this.autoReuse = true;
                                                                                                              this.maxStack = 999;
                                                                                                              this.consumable = true;
                                                                                                              this.value = Item.buyPrice(silver: 5);
                                                                                                              return;
                                                                                                            case 3610:
                                                                                                              this.createTile = 422;
                                                                                                              this.width = 16;
                                                                                                              this.height = 16;
                                                                                                              this.rare = 1;
                                                                                                              this.useStyle = 1;
                                                                                                              this.useTurn = true;
                                                                                                              this.useAnimation = 15;
                                                                                                              this.useTime = 10;
                                                                                                              this.autoReuse = true;
                                                                                                              this.maxStack = 999;
                                                                                                              this.consumable = true;
                                                                                                              this.value = Item.buyPrice(silver: 5);
                                                                                                              return;
                                                                                                            case 3611:
                                                                                                              this.useStyle = 5;
                                                                                                              this.useAnimation = 10;
                                                                                                              this.useTime = 10;
                                                                                                              this.width = 20;
                                                                                                              this.height = 20;
                                                                                                              this.shoot = 651;
                                                                                                              this.channel = true;
                                                                                                              this.shootSpeed = 10f;
                                                                                                              this.value = Item.sellPrice(gold: 4);
                                                                                                              this.rare = 2;
                                                                                                              this.UseSound = SoundID.Item64;
                                                                                                              this.mech = true;
                                                                                                              return;
                                                                                                            case 3612:
                                                                                                              this.useStyle = 1;
                                                                                                              this.useTurn = true;
                                                                                                              this.useAnimation = 15;
                                                                                                              this.useTime = 5;
                                                                                                              this.autoReuse = true;
                                                                                                              this.width = 24;
                                                                                                              this.height = 28;
                                                                                                              this.rare = 1;
                                                                                                              this.value = 20000;
                                                                                                              this.tileBoost = 20;
                                                                                                              this.mech = true;
                                                                                                              return;
                                                                                                            default:
                                                                                                              if (type >= 3613 && type <= 3615)
                                                                                                              {
                                                                                                                this.createTile = 423;
                                                                                                                this.width = 16;
                                                                                                                this.height = 16;
                                                                                                                this.rare = 1;
                                                                                                                this.useStyle = 1;
                                                                                                                this.useTurn = true;
                                                                                                                this.useAnimation = 15;
                                                                                                                this.useTime = 10;
                                                                                                                this.autoReuse = true;
                                                                                                                this.maxStack = 999;
                                                                                                                this.consumable = true;
                                                                                                                this.placeStyle = type - 3613;
                                                                                                                this.mech = true;
                                                                                                                return;
                                                                                                              }
                                                                                                              switch (type)
                                                                                                              {
                                                                                                                case 3616:
                                                                                                                  this.createTile = 424;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.mech = true;
                                                                                                                  this.value = Item.buyPrice(silver: 2);
                                                                                                                  return;
                                                                                                                case 3617:
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.createTile = 425;
                                                                                                                  this.width = 28;
                                                                                                                  this.height = 28;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3618:
                                                                                                                  this.createTile = 419;
                                                                                                                  this.placeStyle = 1;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.mech = true;
                                                                                                                  this.value = Item.buyPrice(silver: 10);
                                                                                                                  return;
                                                                                                                case 3619:
                                                                                                                  this.width = 24;
                                                                                                                  this.height = 28;
                                                                                                                  this.rare = 3;
                                                                                                                  this.value = Item.buyPrice(gold: 1);
                                                                                                                  this.accessory = true;
                                                                                                                  return;
                                                                                                                case 3620:
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 5;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.width = 24;
                                                                                                                  this.height = 28;
                                                                                                                  this.rare = 1;
                                                                                                                  this.value = 20000;
                                                                                                                  this.tileBoost = 20;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3621:
                                                                                                                  this.createTile = 426;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.value = Item.buyPrice(silver: 1);
                                                                                                                  return;
                                                                                                                case 3622:
                                                                                                                  this.createTile = 427;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.value = Item.buyPrice(silver: 1);
                                                                                                                  return;
                                                                                                                case 3623:
                                                                                                                  this.noUseGraphic = true;
                                                                                                                  this.damage = 0;
                                                                                                                  this.useStyle = 5;
                                                                                                                  this.shootSpeed = 16f;
                                                                                                                  this.shoot = 652;
                                                                                                                  this.width = 18;
                                                                                                                  this.height = 28;
                                                                                                                  this.UseSound = SoundID.Item1;
                                                                                                                  this.useAnimation = 20;
                                                                                                                  this.useTime = 20;
                                                                                                                  this.rare = 10;
                                                                                                                  this.noMelee = true;
                                                                                                                  this.value = Item.sellPrice(gold: 10);
                                                                                                                  return;
                                                                                                                case 3624:
                                                                                                                  this.width = 30;
                                                                                                                  this.height = 30;
                                                                                                                  this.accessory = true;
                                                                                                                  this.rare = 3;
                                                                                                                  this.value = Item.buyPrice(gold: 10);
                                                                                                                  return;
                                                                                                                case 3625:
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 5;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.width = 24;
                                                                                                                  this.height = 28;
                                                                                                                  this.rare = 1;
                                                                                                                  this.value = Item.buyPrice(gold: 12);
                                                                                                                  this.tileBoost = 20;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3626:
                                                                                                                  this.createTile = 428;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.placeStyle = 3;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3627:
                                                                                                                  this.width = 18;
                                                                                                                  this.height = 18;
                                                                                                                  this.headSlot = 194;
                                                                                                                  this.value = Item.buyPrice(gold: 1);
                                                                                                                  this.vanity = true;
                                                                                                                  return;
                                                                                                                case 3628:
                                                                                                                  this.channel = true;
                                                                                                                  this.damage = 0;
                                                                                                                  this.useStyle = 4;
                                                                                                                  this.shoot = 653;
                                                                                                                  this.width = 24;
                                                                                                                  this.height = 24;
                                                                                                                  this.UseSound = SoundID.Item8;
                                                                                                                  this.useAnimation = 20;
                                                                                                                  this.useTime = 20;
                                                                                                                  this.rare = 1;
                                                                                                                  this.noMelee = true;
                                                                                                                  this.value = Item.buyPrice(5);
                                                                                                                  this.buffType = 191;
                                                                                                                  return;
                                                                                                                case 3629:
                                                                                                                  this.createTile = 429;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 2;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.mech = true;
                                                                                                                  this.value = Item.buyPrice(gold: 5);
                                                                                                                  return;
                                                                                                                case 3630:
                                                                                                                  this.createTile = 428;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.placeStyle = 0;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3631:
                                                                                                                  this.createTile = 428;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.placeStyle = 2;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                case 3632:
                                                                                                                  this.createTile = 428;
                                                                                                                  this.width = 16;
                                                                                                                  this.height = 16;
                                                                                                                  this.rare = 1;
                                                                                                                  this.useStyle = 1;
                                                                                                                  this.useTurn = true;
                                                                                                                  this.useAnimation = 15;
                                                                                                                  this.useTime = 10;
                                                                                                                  this.autoReuse = true;
                                                                                                                  this.maxStack = 999;
                                                                                                                  this.consumable = true;
                                                                                                                  this.placeStyle = 1;
                                                                                                                  this.mech = true;
                                                                                                                  return;
                                                                                                                default:
                                                                                                                  if (type >= 3633 && type <= 3637)
                                                                                                                  {
                                                                                                                    this.createTile = 430 + (type - 3633);
                                                                                                                    this.width = 16;
                                                                                                                    this.height = 16;
                                                                                                                    this.rare = 1;
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.value = Item.buyPrice(silver: 1);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3638 && type <= 3642)
                                                                                                                  {
                                                                                                                    this.createTile = 435 + (type - 3638);
                                                                                                                    this.width = 16;
                                                                                                                    this.height = 16;
                                                                                                                    this.rare = 1;
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.value = Item.buyPrice(silver: 1);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3643)
                                                                                                                  {
                                                                                                                    this.width = 20;
                                                                                                                    this.height = 20;
                                                                                                                    this.rare = 1;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3644 && type <= 3650)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 99;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 440;
                                                                                                                    this.placeStyle = type - 3644;
                                                                                                                    this.width = 22;
                                                                                                                    this.height = 22;
                                                                                                                    this.value = Item.sellPrice(silver: 1);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3651 && type <= 3662)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 99;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 105;
                                                                                                                    this.width = 20;
                                                                                                                    this.height = 20;
                                                                                                                    this.value = 300;
                                                                                                                    this.placeStyle = 51 + type - 3651;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3663)
                                                                                                                  {
                                                                                                                    this.createTile = 419;
                                                                                                                    this.width = 16;
                                                                                                                    this.height = 16;
                                                                                                                    this.rare = 1;
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.mech = true;
                                                                                                                    this.placeStyle = 2;
                                                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3664)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 209;
                                                                                                                    this.placeStyle = 3;
                                                                                                                    this.width = 12;
                                                                                                                    this.height = 12;
                                                                                                                    this.rare = 3;
                                                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3665 && type <= 3706)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 99;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 441;
                                                                                                                    this.placeStyle = type - 3665 + (type > 3666).ToInt() + (type > 3667).ToInt() * 3 + (type > 3683).ToInt() * 5 + (type > 3691).ToInt() + (type > 3692).ToInt() + (type > 3693).ToInt();
                                                                                                                    this.width = 26;
                                                                                                                    this.height = 22;
                                                                                                                    this.value = 500;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3707)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 442;
                                                                                                                    this.width = 12;
                                                                                                                    this.height = 12;
                                                                                                                    this.placeStyle = 0;
                                                                                                                    this.mech = true;
                                                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                                                    this.mech = true;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3708 && type <= 3720)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 99;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 105;
                                                                                                                    this.width = 20;
                                                                                                                    this.height = 20;
                                                                                                                    this.value = 300;
                                                                                                                    this.placeStyle = 63 + type - 3708;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3721)
                                                                                                                  {
                                                                                                                    this.width = 26;
                                                                                                                    this.height = 30;
                                                                                                                    this.maxStack = 1;
                                                                                                                    this.value = Item.sellPrice(gold: 3);
                                                                                                                    this.rare = 3;
                                                                                                                    this.accessory = true;
                                                                                                                    this.backSlot = (sbyte) 10;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3722)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 443;
                                                                                                                    this.width = 20;
                                                                                                                    this.height = 12;
                                                                                                                    this.value = 10000;
                                                                                                                    this.mech = true;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3723 && type <= 3724)
                                                                                                                  {
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.createTile = 215;
                                                                                                                    this.placeStyle = 6 + type - 3723;
                                                                                                                    this.width = 12;
                                                                                                                    this.height = 12;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3725)
                                                                                                                  {
                                                                                                                    this.createTile = 445;
                                                                                                                    this.width = 16;
                                                                                                                    this.height = 16;
                                                                                                                    this.rare = 1;
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.mech = true;
                                                                                                                    this.value = Item.buyPrice(silver: 2);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type >= 3726 && type <= 3729)
                                                                                                                  {
                                                                                                                    this.createTile = 423;
                                                                                                                    this.width = 16;
                                                                                                                    this.height = 16;
                                                                                                                    this.rare = 1;
                                                                                                                    this.useStyle = 1;
                                                                                                                    this.useTurn = true;
                                                                                                                    this.useAnimation = 15;
                                                                                                                    this.useTime = 10;
                                                                                                                    this.autoReuse = true;
                                                                                                                    this.maxStack = 999;
                                                                                                                    this.consumable = true;
                                                                                                                    this.placeStyle = type - 3726 + 3;
                                                                                                                    this.mech = true;
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  if (type == 3730 || type == 3731)
                                                                                                                  {
                                                                                                                    this.width = 20;
                                                                                                                    this.height = 22;
                                                                                                                    this.rare = 1;
                                                                                                                    this.value = Item.buyPrice(gold: 2);
                                                                                                                    this.accessory = true;
                                                                                                                    this.vanity = true;
                                                                                                                    this.balloonSlot = (sbyte) (16 + type - 3730);
                                                                                                                    return;
                                                                                                                  }
                                                                                                                  switch (type)
                                                                                                                  {
                                                                                                                    case 3732:
                                                                                                                      this.width = 18;
                                                                                                                      this.height = 18;
                                                                                                                      this.headSlot = 195;
                                                                                                                      this.value = Item.buyPrice(gold: 1);
                                                                                                                      this.vanity = true;
                                                                                                                      return;
                                                                                                                    case 3733:
                                                                                                                      this.width = 18;
                                                                                                                      this.height = 18;
                                                                                                                      this.headSlot = 196;
                                                                                                                      this.value = Item.buyPrice(gold: 3);
                                                                                                                      this.vanity = true;
                                                                                                                      return;
                                                                                                                    case 3734:
                                                                                                                      this.width = 28;
                                                                                                                      this.height = 20;
                                                                                                                      this.bodySlot = 195;
                                                                                                                      this.value = Item.buyPrice(gold: 3);
                                                                                                                      this.vanity = true;
                                                                                                                      return;
                                                                                                                    case 3735:
                                                                                                                      this.width = 18;
                                                                                                                      this.height = 14;
                                                                                                                      this.legSlot = 138;
                                                                                                                      this.value = Item.buyPrice(gold: 3);
                                                                                                                      this.vanity = true;
                                                                                                                      return;
                                                                                                                    default:
                                                                                                                      if (type >= 3736 && type <= 3738)
                                                                                                                      {
                                                                                                                        this.createTile = 446 + (type - 3736);
                                                                                                                        this.width = 16;
                                                                                                                        this.height = 16;
                                                                                                                        this.useStyle = 1;
                                                                                                                        this.useTurn = true;
                                                                                                                        this.useAnimation = 15;
                                                                                                                        this.useTime = 10;
                                                                                                                        this.autoReuse = true;
                                                                                                                        this.maxStack = 999;
                                                                                                                        this.consumable = true;
                                                                                                                        this.value = Item.buyPrice(silver: 1);
                                                                                                                        return;
                                                                                                                      }
                                                                                                                      if (type >= 3739 && type <= 3741)
                                                                                                                      {
                                                                                                                        this.createTile = 449 + (type - 3739);
                                                                                                                        this.width = 16;
                                                                                                                        this.height = 16;
                                                                                                                        this.useStyle = 1;
                                                                                                                        this.useTurn = true;
                                                                                                                        this.useAnimation = 15;
                                                                                                                        this.useTime = 10;
                                                                                                                        this.autoReuse = true;
                                                                                                                        this.maxStack = 999;
                                                                                                                        this.consumable = true;
                                                                                                                        this.value = Item.buyPrice(copper: 50);
                                                                                                                        this.tileBoost += 3;
                                                                                                                        return;
                                                                                                                      }
                                                                                                                      if (type == 3742)
                                                                                                                      {
                                                                                                                        this.useStyle = 1;
                                                                                                                        this.useTurn = true;
                                                                                                                        this.useAnimation = 15;
                                                                                                                        this.useTime = 10;
                                                                                                                        this.autoReuse = true;
                                                                                                                        this.maxStack = 99;
                                                                                                                        this.consumable = true;
                                                                                                                        this.createTile = 452;
                                                                                                                        this.width = 26;
                                                                                                                        this.height = 20;
                                                                                                                        this.value = Item.buyPrice(gold: 5);
                                                                                                                        this.rare = 1;
                                                                                                                        return;
                                                                                                                      }
                                                                                                                      if (type >= 3743 && type <= 3745)
                                                                                                                      {
                                                                                                                        this.createTile = 453;
                                                                                                                        this.placeStyle = type - 3743;
                                                                                                                        if (3744 == type)
                                                                                                                          this.placeStyle = 0;
                                                                                                                        if (3745 == type)
                                                                                                                          this.placeStyle = 2;
                                                                                                                        if (3743 == type)
                                                                                                                          this.placeStyle = 4;
                                                                                                                        this.useStyle = 1;
                                                                                                                        this.useTurn = true;
                                                                                                                        this.useAnimation = 15;
                                                                                                                        this.useTime = 10;
                                                                                                                        this.autoReuse = true;
                                                                                                                        this.maxStack = 99;
                                                                                                                        this.consumable = true;
                                                                                                                        this.width = 12;
                                                                                                                        this.height = 30;
                                                                                                                        this.value = Item.buyPrice(silver: 10);
                                                                                                                        return;
                                                                                                                      }
                                                                                                                      switch (type)
                                                                                                                      {
                                                                                                                        case 3746:
                                                                                                                          this.createTile = 454;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 99;
                                                                                                                          this.consumable = true;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 30;
                                                                                                                          this.value = Item.buyPrice(gold: 1);
                                                                                                                          return;
                                                                                                                        case 3747:
                                                                                                                          this.createTile = 455;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 99;
                                                                                                                          this.consumable = true;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 30;
                                                                                                                          this.value = Item.buyPrice(gold: 20);
                                                                                                                          this.rare = 3;
                                                                                                                          return;
                                                                                                                        case 3748:
                                                                                                                          this.createTile = 456;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 99;
                                                                                                                          this.consumable = true;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 30;
                                                                                                                          this.value = Item.buyPrice(silver: 20);
                                                                                                                          return;
                                                                                                                        case 3749:
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 99;
                                                                                                                          this.consumable = true;
                                                                                                                          this.createTile = 457;
                                                                                                                          this.width = 26;
                                                                                                                          this.height = 20;
                                                                                                                          this.value = Item.buyPrice(silver: 20);
                                                                                                                          this.rare = 1;
                                                                                                                          return;
                                                                                                                        case 3750:
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          this.createTile = 621;
                                                                                                                          this.width = 22;
                                                                                                                          this.height = 22;
                                                                                                                          this.value = Item.sellPrice(silver: 50);
                                                                                                                          this.rare = 3;
                                                                                                                          return;
                                                                                                                        case 3751:
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 7;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          this.createWall = 225;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 12;
                                                                                                                          return;
                                                                                                                        case 3752:
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 7;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          this.createWall = 226;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 12;
                                                                                                                          return;
                                                                                                                        case 3753:
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 7;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          this.createWall = 227;
                                                                                                                          this.width = 12;
                                                                                                                          this.height = 12;
                                                                                                                          return;
                                                                                                                        case 3754:
                                                                                                                          this.createTile = 458;
                                                                                                                          this.width = 16;
                                                                                                                          this.height = 16;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          this.value = Item.buyPrice(copper: 5);
                                                                                                                          return;
                                                                                                                        case 3755:
                                                                                                                          this.createTile = 459;
                                                                                                                          this.width = 16;
                                                                                                                          this.height = 16;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          return;
                                                                                                                        case 3756:
                                                                                                                          this.createTile = 460;
                                                                                                                          this.width = 16;
                                                                                                                          this.height = 16;
                                                                                                                          this.useStyle = 1;
                                                                                                                          this.useTurn = true;
                                                                                                                          this.useAnimation = 15;
                                                                                                                          this.useTime = 10;
                                                                                                                          this.autoReuse = true;
                                                                                                                          this.maxStack = 999;
                                                                                                                          this.consumable = true;
                                                                                                                          return;
                                                                                                                        case 3757:
                                                                                                                          this.width = 18;
                                                                                                                          this.height = 18;
                                                                                                                          this.headSlot = 197;
                                                                                                                          this.value = Item.sellPrice(silver: 30);
                                                                                                                          this.vanity = true;
                                                                                                                          this.rare = 9;
                                                                                                                          return;
                                                                                                                        case 3758:
                                                                                                                          this.width = 28;
                                                                                                                          this.height = 20;
                                                                                                                          this.bodySlot = 196;
                                                                                                                          this.value = Item.sellPrice(silver: 30);
                                                                                                                          this.vanity = true;
                                                                                                                          this.rare = 9;
                                                                                                                          return;
                                                                                                                        case 3759:
                                                                                                                          this.width = 18;
                                                                                                                          this.height = 14;
                                                                                                                          this.legSlot = 139;
                                                                                                                          this.value = Item.sellPrice(silver: 30);
                                                                                                                          this.vanity = true;
                                                                                                                          this.rare = 9;
                                                                                                                          return;
                                                                                                                        default:
                                                                                                                          if (type >= 3760 && type <= 3762)
                                                                                                                          {
                                                                                                                            this.useStyle = 1;
                                                                                                                            this.useTurn = true;
                                                                                                                            this.useAnimation = 15;
                                                                                                                            this.useTime = 7;
                                                                                                                            this.autoReuse = true;
                                                                                                                            this.maxStack = 999;
                                                                                                                            this.consumable = true;
                                                                                                                            this.createWall = 228 + (type - 3760);
                                                                                                                            this.width = 12;
                                                                                                                            this.height = 12;
                                                                                                                            return;
                                                                                                                          }
                                                                                                                          if (type == 3763)
                                                                                                                          {
                                                                                                                            this.width = 18;
                                                                                                                            this.height = 18;
                                                                                                                            this.headSlot = 198;
                                                                                                                            this.value = Item.sellPrice(gold: 1);
                                                                                                                            this.vanity = true;
                                                                                                                            this.rare = 9;
                                                                                                                            return;
                                                                                                                          }
                                                                                                                          if (type >= 3764 && type <= 3769)
                                                                                                                          {
                                                                                                                            this.SetDefaults(198);
                                                                                                                            this.type = type;
                                                                                                                            this.damage = 42;
                                                                                                                            this.useTime = 20;
                                                                                                                            this.useAnimation = 20;
                                                                                                                            this.scale = 1.15f;
                                                                                                                            this.autoReuse = true;
                                                                                                                            this.useTurn = true;
                                                                                                                            this.rare = 4;
                                                                                                                            this.value = Item.sellPrice(gold: 1);
                                                                                                                            return;
                                                                                                                          }
                                                                                                                          switch (type)
                                                                                                                          {
                                                                                                                            case 3770:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 14;
                                                                                                                              this.legSlot = 140;
                                                                                                                              this.value = Item.sellPrice(gold: 1);
                                                                                                                              this.vanity = true;
                                                                                                                              this.rare = 4;
                                                                                                                              return;
                                                                                                                            case 3771:
                                                                                                                              this.useStyle = 4;
                                                                                                                              this.channel = true;
                                                                                                                              this.width = 34;
                                                                                                                              this.height = 34;
                                                                                                                              this.UseSound = SoundID.Item25;
                                                                                                                              this.useAnimation = 20;
                                                                                                                              this.useTime = 20;
                                                                                                                              this.rare = 8;
                                                                                                                              this.noMelee = true;
                                                                                                                              this.mountType = 14;
                                                                                                                              this.value = Item.sellPrice(gold: 5);
                                                                                                                              return;
                                                                                                                            case 3772:
                                                                                                                              this.useStyle = 1;
                                                                                                                              this.useTurn = true;
                                                                                                                              this.autoReuse = true;
                                                                                                                              this.useAnimation = 18;
                                                                                                                              this.useTime = 18;
                                                                                                                              this.width = 28;
                                                                                                                              this.height = 28;
                                                                                                                              this.damage = 14;
                                                                                                                              this.knockBack = 4.5f;
                                                                                                                              this.UseSound = SoundID.Item1;
                                                                                                                              this.scale = 1f;
                                                                                                                              this.melee = true;
                                                                                                                              this.value = Item.sellPrice(silver: 10);
                                                                                                                              this.rare = 2;
                                                                                                                              return;
                                                                                                                            case 3773:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.headSlot = 199;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3774:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.bodySlot = 197;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3775:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.legSlot = 141;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3776:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.defense = 6;
                                                                                                                              this.headSlot = 200;
                                                                                                                              this.rare = 5;
                                                                                                                              this.value = 250000;
                                                                                                                              return;
                                                                                                                            case 3777:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.defense = 12;
                                                                                                                              this.bodySlot = 198;
                                                                                                                              this.rare = 5;
                                                                                                                              this.value = 200000;
                                                                                                                              return;
                                                                                                                            case 3778:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.defense = 8;
                                                                                                                              this.legSlot = 142;
                                                                                                                              this.rare = 5;
                                                                                                                              this.value = 150000;
                                                                                                                              return;
                                                                                                                            case 3779:
                                                                                                                              this.mana = 14;
                                                                                                                              this.damage = 85;
                                                                                                                              this.useStyle = 5;
                                                                                                                              this.shootSpeed = 3f;
                                                                                                                              this.shoot = 659;
                                                                                                                              this.width = 26;
                                                                                                                              this.height = 28;
                                                                                                                              this.UseSound = SoundID.Item117;
                                                                                                                              this.useAnimation = 22;
                                                                                                                              this.useTime = 22;
                                                                                                                              this.autoReuse = true;
                                                                                                                              this.noMelee = true;
                                                                                                                              this.knockBack = 5f;
                                                                                                                              this.rare = 4;
                                                                                                                              this.value = Item.sellPrice(gold: 1);
                                                                                                                              this.magic = true;
                                                                                                                              this.glowMask = (short) 218;
                                                                                                                              return;
                                                                                                                            case 3780:
                                                                                                                              this.useStyle = 1;
                                                                                                                              this.useTurn = true;
                                                                                                                              this.useAnimation = 15;
                                                                                                                              this.useTime = 10;
                                                                                                                              this.autoReuse = true;
                                                                                                                              this.maxStack = 99;
                                                                                                                              this.consumable = true;
                                                                                                                              this.createTile = 91;
                                                                                                                              this.placeStyle = 272;
                                                                                                                              this.width = 10;
                                                                                                                              this.height = 24;
                                                                                                                              this.value = 1000;
                                                                                                                              this.rare = 1;
                                                                                                                              return;
                                                                                                                            case 3781:
                                                                                                                              this.width = 24;
                                                                                                                              this.height = 28;
                                                                                                                              this.rare = 3;
                                                                                                                              this.value = 100000;
                                                                                                                              this.accessory = true;
                                                                                                                              return;
                                                                                                                            case 3782:
                                                                                                                              this.useStyle = 1;
                                                                                                                              this.useTurn = true;
                                                                                                                              this.useAnimation = 15;
                                                                                                                              this.useTime = 10;
                                                                                                                              this.autoReuse = true;
                                                                                                                              this.maxStack = 999;
                                                                                                                              this.consumable = true;
                                                                                                                              this.createTile = 461;
                                                                                                                              this.width = 24;
                                                                                                                              this.height = 24;
                                                                                                                              this.value = Item.sellPrice(copper: 40);
                                                                                                                              return;
                                                                                                                            case 3783:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.maxStack = 999;
                                                                                                                              this.value = 50000;
                                                                                                                              this.rare = 5;
                                                                                                                              return;
                                                                                                                            case 3784:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.legSlot = 143;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3785:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.bodySlot = 199;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3786:
                                                                                                                              this.width = 18;
                                                                                                                              this.height = 18;
                                                                                                                              this.headSlot = 201;
                                                                                                                              this.rare = 3;
                                                                                                                              this.vanity = true;
                                                                                                                              this.value = Item.sellPrice(silver: 50);
                                                                                                                              return;
                                                                                                                            case 3787:
                                                                                                                              this.useStyle = 5;
                                                                                                                              this.useAnimation = 12;
                                                                                                                              this.useTime = 4;
                                                                                                                              this.reuseDelay = this.useAnimation + 6;
                                                                                                                              this.shootSpeed = 14f;
                                                                                                                              this.knockBack = 6f;
                                                                                                                              this.width = 16;
                                                                                                                              this.height = 16;
                                                                                                                              this.damage = 38;
                                                                                                                              this.UseSound = SoundID.Item9;
                                                                                                                              this.crit = 20;
                                                                                                                              this.shoot = 660;
                                                                                                                              this.mana = 17;
                                                                                                                              this.rare = 4;
                                                                                                                              this.value = 300000;
                                                                                                                              this.noMelee = true;
                                                                                                                              this.magic = true;
                                                                                                                              this.autoReuse = true;
                                                                                                                              return;
                                                                                                                            case 3788:
                                                                                                                              this.knockBack = 6.5f;
                                                                                                                              this.useStyle = 5;
                                                                                                                              this.useAnimation = 45;
                                                                                                                              this.useTime = 45;
                                                                                                                              this.width = 50;
                                                                                                                              this.height = 14;
                                                                                                                              this.shoot = 10;
                                                                                                                              this.useAmmo = AmmoID.Bullet;
                                                                                                                              this.UseSound = SoundID.Item36;
                                                                                                                              this.damage = 28;
                                                                                                                              this.shootSpeed = 7f;
                                                                                                                              this.noMelee = true;
                                                                                                                              this.value = 250000;
                                                                                                                              this.rare = 4;
                                                                                                                              this.ranged = true;
                                                                                                                              return;
                                                                                                                            default:
                                                                                                                              if (type >= 3789 && type <= 3793)
                                                                                                                              {
                                                                                                                                this.useStyle = 1;
                                                                                                                                this.useTurn = true;
                                                                                                                                this.useAnimation = 15;
                                                                                                                                this.useTime = 10;
                                                                                                                                this.autoReuse = true;
                                                                                                                                this.maxStack = 99;
                                                                                                                                this.consumable = true;
                                                                                                                                this.createTile = 91;
                                                                                                                                this.placeStyle = 273 + type - 3789;
                                                                                                                                this.width = 10;
                                                                                                                                this.height = 24;
                                                                                                                                this.value = 1000;
                                                                                                                                this.rare = 1;
                                                                                                                                return;
                                                                                                                              }
                                                                                                                              switch (type)
                                                                                                                              {
                                                                                                                                case 3794:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.maxStack = 999;
                                                                                                                                  this.value = Item.sellPrice(silver: 1);
                                                                                                                                  this.rare = 1;
                                                                                                                                  return;
                                                                                                                                case 3795:
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.maxStack = 99;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 462;
                                                                                                                                  this.width = 26;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.value = Item.sellPrice(silver: 50);
                                                                                                                                  this.rare = 3;
                                                                                                                                  return;
                                                                                                                                case 3796:
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 139;
                                                                                                                                  this.placeStyle = 38;
                                                                                                                                  this.width = 24;
                                                                                                                                  this.height = 24;
                                                                                                                                  this.rare = 4;
                                                                                                                                  this.value = 100000;
                                                                                                                                  this.accessory = true;
                                                                                                                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                                                                                  return;
                                                                                                                                case 3797:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.headSlot = 203;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 7;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3798:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.bodySlot = 200;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 15;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3799:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.legSlot = 144;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 10;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3800:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.headSlot = 204;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 13;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3801:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.bodySlot = 201;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 27;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3802:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.legSlot = 145;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 18;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3803:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.headSlot = 205;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 7;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3804:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.bodySlot = 202;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 17;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3805:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.legSlot = 146;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 12;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3806:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.headSlot = 206;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 8;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3807:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.bodySlot = 203;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 22;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3808:
                                                                                                                                  this.width = 18;
                                                                                                                                  this.height = 18;
                                                                                                                                  this.legSlot = 148;
                                                                                                                                  this.rare = 8;
                                                                                                                                  this.defense = 16;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  return;
                                                                                                                                case 3809:
                                                                                                                                  this.width = 22;
                                                                                                                                  this.height = 22;
                                                                                                                                  this.accessory = true;
                                                                                                                                  this.rare = 5;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  this.neckSlot = (sbyte) 9;
                                                                                                                                  return;
                                                                                                                                case 3810:
                                                                                                                                  this.width = 22;
                                                                                                                                  this.height = 22;
                                                                                                                                  this.accessory = true;
                                                                                                                                  this.rare = 5;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  this.shieldSlot = (sbyte) 6;
                                                                                                                                  return;
                                                                                                                                case 3811:
                                                                                                                                  this.width = 22;
                                                                                                                                  this.height = 22;
                                                                                                                                  this.accessory = true;
                                                                                                                                  this.rare = 5;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  this.handOnSlot = (sbyte) 19;
                                                                                                                                  return;
                                                                                                                                case 3812:
                                                                                                                                  this.width = 22;
                                                                                                                                  this.height = 22;
                                                                                                                                  this.accessory = true;
                                                                                                                                  this.rare = 5;
                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                  this.waistSlot = (sbyte) 12;
                                                                                                                                  return;
                                                                                                                                case 3813:
                                                                                                                                  this.rare = 3;
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.maxStack = 99;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 463;
                                                                                                                                  this.width = 12;
                                                                                                                                  this.height = 12;
                                                                                                                                  this.value = 100000;
                                                                                                                                  this.glowMask = (short) 244;
                                                                                                                                  return;
                                                                                                                                case 3814:
                                                                                                                                  this.rare = 1;
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.maxStack = 999;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 464;
                                                                                                                                  this.width = 12;
                                                                                                                                  this.height = 12;
                                                                                                                                  this.value = 100000;
                                                                                                                                  return;
                                                                                                                                case 3815:
                                                                                                                                  this.rare = 1;
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.maxStack = 999;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 465;
                                                                                                                                  this.width = 12;
                                                                                                                                  this.height = 12;
                                                                                                                                  this.value = 100000;
                                                                                                                                  return;
                                                                                                                                case 3816:
                                                                                                                                  this.rare = 3;
                                                                                                                                  this.useStyle = 1;
                                                                                                                                  this.useTurn = true;
                                                                                                                                  this.useAnimation = 15;
                                                                                                                                  this.useTime = 10;
                                                                                                                                  this.autoReuse = true;
                                                                                                                                  this.maxStack = 999;
                                                                                                                                  this.consumable = true;
                                                                                                                                  this.createTile = 466;
                                                                                                                                  this.width = 12;
                                                                                                                                  this.height = 12;
                                                                                                                                  this.value = Item.buyPrice(gold: 1);
                                                                                                                                  return;
                                                                                                                                case 3817:
                                                                                                                                  this.width = 12;
                                                                                                                                  this.height = 12;
                                                                                                                                  this.maxStack = 999;
                                                                                                                                  this.value = 0;
                                                                                                                                  this.rare = 3;
                                                                                                                                  return;
                                                                                                                                default:
                                                                                                                                  if (type == 3818 || type == 3819 || type == 3820 || type == 3824 || type == 3825 || type == 3826 || type == 3829 || type == 3830 || type == 3831 || type == 3832 || type == 3833 || type == 3834)
                                                                                                                                  {
                                                                                                                                    this.width = 18;
                                                                                                                                    this.height = 20;
                                                                                                                                    this.UseSound = SoundID.DD2_DefenseTowerSpawn;
                                                                                                                                    this.useStyle = 1;
                                                                                                                                    this.useAnimation = 30;
                                                                                                                                    this.useTime = 30;
                                                                                                                                    this.shootSpeed = 1f;
                                                                                                                                    this.noMelee = true;
                                                                                                                                    this.value = Item.sellPrice(gold: 1);
                                                                                                                                    this.rare = 3;
                                                                                                                                    this.shoot = 663;
                                                                                                                                    this.summon = true;
                                                                                                                                    this.damage = 17;
                                                                                                                                    this.knockBack = 3f;
                                                                                                                                    this.mana = 5;
                                                                                                                                    this.DD2Summon = true;
                                                                                                                                    this.sentry = true;
                                                                                                                                    switch (type)
                                                                                                                                    {
                                                                                                                                      case 3819:
                                                                                                                                        this.shoot = 665;
                                                                                                                                        this.damage = 42;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.mana = 10;
                                                                                                                                        this.value = Item.sellPrice(gold: 5);
                                                                                                                                        return;
                                                                                                                                      case 3820:
                                                                                                                                        this.shoot = 667;
                                                                                                                                        this.damage = 88;
                                                                                                                                        this.rare = 8;
                                                                                                                                        this.mana = 15;
                                                                                                                                        this.value = Item.sellPrice(gold: 15);
                                                                                                                                        return;
                                                                                                                                      case 3821:
                                                                                                                                        return;
                                                                                                                                      case 3822:
                                                                                                                                        return;
                                                                                                                                      case 3823:
                                                                                                                                        return;
                                                                                                                                      case 3824:
                                                                                                                                        this.shoot = 677;
                                                                                                                                        this.damage = 27;
                                                                                                                                        this.knockBack = 4.5f;
                                                                                                                                        return;
                                                                                                                                      case 3825:
                                                                                                                                        this.shoot = 678;
                                                                                                                                        this.damage = 67;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.mana = 10;
                                                                                                                                        this.knockBack = 4.5f;
                                                                                                                                        this.value = Item.sellPrice(gold: 5);
                                                                                                                                        return;
                                                                                                                                      case 3826:
                                                                                                                                        this.shoot = 679;
                                                                                                                                        this.damage = 140;
                                                                                                                                        this.rare = 8;
                                                                                                                                        this.mana = 15;
                                                                                                                                        this.knockBack = 4.5f;
                                                                                                                                        this.value = Item.sellPrice(gold: 15);
                                                                                                                                        return;
                                                                                                                                      case 3827:
                                                                                                                                        return;
                                                                                                                                      case 3828:
                                                                                                                                        return;
                                                                                                                                      case 3829:
                                                                                                                                        this.shoot = 688;
                                                                                                                                        this.damage = 4;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        return;
                                                                                                                                      case 3830:
                                                                                                                                        this.shoot = 689;
                                                                                                                                        this.damage = 11;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.mana = 10;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        this.value = Item.sellPrice(gold: 5);
                                                                                                                                        return;
                                                                                                                                      case 3831:
                                                                                                                                        this.shoot = 690;
                                                                                                                                        this.damage = 34;
                                                                                                                                        this.rare = 8;
                                                                                                                                        this.mana = 15;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        this.value = Item.sellPrice(gold: 15);
                                                                                                                                        return;
                                                                                                                                      case 3832:
                                                                                                                                        this.shoot = 691;
                                                                                                                                        this.damage = 24;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        return;
                                                                                                                                      case 3833:
                                                                                                                                        this.shoot = 692;
                                                                                                                                        this.damage = 59;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.mana = 10;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        this.value = Item.sellPrice(gold: 5);
                                                                                                                                        return;
                                                                                                                                      case 3834:
                                                                                                                                        this.shoot = 693;
                                                                                                                                        this.damage = 126;
                                                                                                                                        this.rare = 8;
                                                                                                                                        this.mana = 15;
                                                                                                                                        this.knockBack = 0.0f;
                                                                                                                                        this.value = Item.sellPrice(gold: 15);
                                                                                                                                        return;
                                                                                                                                      default:
                                                                                                                                        return;
                                                                                                                                    }
                                                                                                                                  }
                                                                                                                                  else
                                                                                                                                  {
                                                                                                                                    switch (type)
                                                                                                                                    {
                                                                                                                                      case 3821:
                                                                                                                                        this.shootSpeed = 6.5f;
                                                                                                                                        this.shoot = 669;
                                                                                                                                        this.width = 20;
                                                                                                                                        this.height = 20;
                                                                                                                                        this.maxStack = 1;
                                                                                                                                        this.UseSound = SoundID.Item1;
                                                                                                                                        this.useStyle = 5;
                                                                                                                                        this.useAnimation = 40;
                                                                                                                                        this.useTime = 40;
                                                                                                                                        this.noUseGraphic = true;
                                                                                                                                        this.noMelee = true;
                                                                                                                                        this.value = Item.sellPrice(silver: 1);
                                                                                                                                        this.damage = 20;
                                                                                                                                        this.knockBack = 7f;
                                                                                                                                        this.ranged = true;
                                                                                                                                        this.rare = 1;
                                                                                                                                        this.useAmmo = 353;
                                                                                                                                        return;
                                                                                                                                      case 3822:
                                                                                                                                        this.width = 12;
                                                                                                                                        this.height = 12;
                                                                                                                                        this.maxStack = 999;
                                                                                                                                        this.value = 0;
                                                                                                                                        return;
                                                                                                                                      case 3823:
                                                                                                                                        this.UseSound = SoundID.Item1;
                                                                                                                                        this.useStyle = 1;
                                                                                                                                        this.damage = 85;
                                                                                                                                        this.useAnimation = 25;
                                                                                                                                        this.useTime = 25;
                                                                                                                                        this.width = 34;
                                                                                                                                        this.height = 34;
                                                                                                                                        this.scale = 1.15f;
                                                                                                                                        this.knockBack = 6.5f;
                                                                                                                                        this.melee = true;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.value = Item.sellPrice(gold: 1);
                                                                                                                                        this.autoReuse = true;
                                                                                                                                        this.flame = true;
                                                                                                                                        this.useTurn = true;
                                                                                                                                        return;
                                                                                                                                      case 3828:
                                                                                                                                        this.rare = 3;
                                                                                                                                        this.maxStack = 99;
                                                                                                                                        this.consumable = true;
                                                                                                                                        this.width = 22;
                                                                                                                                        this.height = 18;
                                                                                                                                        this.value = Item.buyPrice(silver: 25);
                                                                                                                                        return;
                                                                                                                                      case 3835:
                                                                                                                                        this.useStyle = 5;
                                                                                                                                        this.useAnimation = 30;
                                                                                                                                        this.useTime = 30;
                                                                                                                                        this.shootSpeed = 24f;
                                                                                                                                        this.knockBack = 7f;
                                                                                                                                        this.width = 16;
                                                                                                                                        this.height = 16;
                                                                                                                                        this.UseSound = SoundID.DD2_MonkStaffSwing;
                                                                                                                                        this.shoot = 697;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.value = Item.sellPrice(gold: 1);
                                                                                                                                        this.noMelee = true;
                                                                                                                                        this.noUseGraphic = true;
                                                                                                                                        this.channel = true;
                                                                                                                                        this.autoReuse = true;
                                                                                                                                        this.melee = true;
                                                                                                                                        this.damage = 40;
                                                                                                                                        return;
                                                                                                                                      case 3836:
                                                                                                                                        this.useStyle = 5;
                                                                                                                                        this.useAnimation = 27;
                                                                                                                                        this.useTime = 27;
                                                                                                                                        this.shootSpeed = 42f;
                                                                                                                                        this.knockBack = 7f;
                                                                                                                                        this.width = 16;
                                                                                                                                        this.height = 16;
                                                                                                                                        this.UseSound = SoundID.DD2_GhastlyGlaivePierce;
                                                                                                                                        this.shoot = 699;
                                                                                                                                        this.rare = 5;
                                                                                                                                        this.value = Item.sellPrice(gold: 1);
                                                                                                                                        this.noMelee = true;
                                                                                                                                        this.noUseGraphic = true;
                                                                                                                                        this.channel = true;
                                                                                                                                        this.melee = true;
                                                                                                                                        this.damage = 45;
                                                                                                                                        return;
                                                                                                                                      default:
                                                                                                                                        if (type >= 3837 && type <= 3846)
                                                                                                                                        {
                                                                                                                                          this.useStyle = 1;
                                                                                                                                          this.useTurn = true;
                                                                                                                                          this.useAnimation = 15;
                                                                                                                                          this.useTime = 10;
                                                                                                                                          this.autoReuse = true;
                                                                                                                                          this.maxStack = 99;
                                                                                                                                          this.consumable = true;
                                                                                                                                          this.createTile = 91;
                                                                                                                                          this.placeStyle = 278 + type - 3837;
                                                                                                                                          this.width = 10;
                                                                                                                                          this.height = 24;
                                                                                                                                          this.value = 1000;
                                                                                                                                          this.rare = 1;
                                                                                                                                          return;
                                                                                                                                        }
                                                                                                                                        if (type == 3855 || type == 3856 || type == 3857)
                                                                                                                                        {
                                                                                                                                          this.damage = 0;
                                                                                                                                          this.useStyle = 1;
                                                                                                                                          this.width = 16;
                                                                                                                                          this.height = 30;
                                                                                                                                          this.UseSound = SoundID.Item2;
                                                                                                                                          this.useAnimation = 20;
                                                                                                                                          this.useTime = 20;
                                                                                                                                          this.rare = 3;
                                                                                                                                          this.noMelee = true;
                                                                                                                                          this.value = Item.sellPrice(gold: 2);
                                                                                                                                          this.buffType = 200;
                                                                                                                                          this.shoot = 703;
                                                                                                                                          if (type != 3856)
                                                                                                                                          {
                                                                                                                                            if (type != 3857)
                                                                                                                                              return;
                                                                                                                                            this.buffType = 202;
                                                                                                                                            this.shoot = 701;
                                                                                                                                            return;
                                                                                                                                          }
                                                                                                                                          this.buffType = 201;
                                                                                                                                          this.shoot = 702;
                                                                                                                                          return;
                                                                                                                                        }
                                                                                                                                        switch (type)
                                                                                                                                        {
                                                                                                                                          case 3827:
                                                                                                                                            this.rare = 8;
                                                                                                                                            this.UseSound = SoundID.DD2_SonicBoomBladeSlash;
                                                                                                                                            this.useStyle = 1;
                                                                                                                                            this.damage = 90;
                                                                                                                                            this.useAnimation = 25;
                                                                                                                                            this.useTime = 25;
                                                                                                                                            this.width = 30;
                                                                                                                                            this.height = 30;
                                                                                                                                            this.knockBack = 5.5f;
                                                                                                                                            this.melee = true;
                                                                                                                                            this.value = Item.sellPrice(gold: 5);
                                                                                                                                            this.autoReuse = true;
                                                                                                                                            this.useTurn = false;
                                                                                                                                            this.glowMask = (short) 227;
                                                                                                                                            this.shoot = 684;
                                                                                                                                            this.shootSpeed = 17f;
                                                                                                                                            return;
                                                                                                                                          case 3852:
                                                                                                                                            this.useStyle = 5;
                                                                                                                                            this.useAnimation = 25;
                                                                                                                                            this.useTime = 3;
                                                                                                                                            this.shootSpeed = 11f;
                                                                                                                                            this.knockBack = 9f;
                                                                                                                                            this.width = 16;
                                                                                                                                            this.height = 16;
                                                                                                                                            this.damage = 32;
                                                                                                                                            this.UseSound = SoundID.DD2_BookStaffCast;
                                                                                                                                            this.shoot = 712;
                                                                                                                                            this.mana = 20;
                                                                                                                                            this.rare = 5;
                                                                                                                                            this.value = Item.sellPrice(gold: 1);
                                                                                                                                            this.noMelee = true;
                                                                                                                                            this.magic = true;
                                                                                                                                            this.autoReuse = true;
                                                                                                                                            return;
                                                                                                                                          case 3854:
                                                                                                                                            this.useStyle = 5;
                                                                                                                                            this.useAnimation = 18;
                                                                                                                                            this.useTime = 18;
                                                                                                                                            this.shootSpeed = 20f;
                                                                                                                                            this.knockBack = 2f;
                                                                                                                                            this.width = 20;
                                                                                                                                            this.height = 12;
                                                                                                                                            this.damage = 32;
                                                                                                                                            this.UseSound = SoundID.Item5;
                                                                                                                                            this.shoot = 705;
                                                                                                                                            this.rare = 5;
                                                                                                                                            this.value = Item.sellPrice(gold: 1);
                                                                                                                                            this.noMelee = true;
                                                                                                                                            this.noUseGraphic = true;
                                                                                                                                            this.ranged = true;
                                                                                                                                            this.channel = true;
                                                                                                                                            this.useAmmo = AmmoID.Arrow;
                                                                                                                                            this.autoReuse = true;
                                                                                                                                            return;
                                                                                                                                          case 3858:
                                                                                                                                            this.useStyle = 5;
                                                                                                                                            this.useAnimation = 30;
                                                                                                                                            this.useTime = 30;
                                                                                                                                            this.shootSpeed = 24f;
                                                                                                                                            this.knockBack = 5f;
                                                                                                                                            this.width = 16;
                                                                                                                                            this.height = 16;
                                                                                                                                            this.UseSound = SoundID.DD2_SkyDragonsFurySwing;
                                                                                                                                            this.shoot = 707;
                                                                                                                                            this.rare = 8;
                                                                                                                                            this.value = Item.sellPrice(gold: 5);
                                                                                                                                            this.noMelee = true;
                                                                                                                                            this.noUseGraphic = true;
                                                                                                                                            this.channel = true;
                                                                                                                                            this.autoReuse = true;
                                                                                                                                            this.melee = true;
                                                                                                                                            this.damage = 70;
                                                                                                                                            return;
                                                                                                                                          case 3859:
                                                                                                                                            this.autoReuse = true;
                                                                                                                                            this.useStyle = 5;
                                                                                                                                            this.useAnimation = 30;
                                                                                                                                            this.useTime = 30;
                                                                                                                                            this.width = 14;
                                                                                                                                            this.height = 32;
                                                                                                                                            this.shoot = 495;
                                                                                                                                            this.useAmmo = AmmoID.Arrow;
                                                                                                                                            this.UseSound = SoundID.Item102;
                                                                                                                                            this.damage = 55;
                                                                                                                                            this.shootSpeed = 11f;
                                                                                                                                            this.knockBack = 4.5f;
                                                                                                                                            this.rare = 8;
                                                                                                                                            this.crit = 3;
                                                                                                                                            this.noMelee = true;
                                                                                                                                            this.value = Item.sellPrice(gold: 5);
                                                                                                                                            this.ranged = true;
                                                                                                                                            this.glowMask = (short) 234;
                                                                                                                                            return;
                                                                                                                                          default:
                                                                                                                                            if (type == 3860 || type == 3862 || type == 3861)
                                                                                                                                            {
                                                                                                                                              this.maxStack = 999;
                                                                                                                                              this.consumable = true;
                                                                                                                                              this.width = 24;
                                                                                                                                              this.height = 24;
                                                                                                                                              this.rare = 1;
                                                                                                                                              if (type == 3860)
                                                                                                                                                this.rare = 8;
                                                                                                                                              if (type == 3862)
                                                                                                                                                this.rare = 3;
                                                                                                                                              if (type == 3861)
                                                                                                                                                this.rare = 5;
                                                                                                                                              this.expert = true;
                                                                                                                                              return;
                                                                                                                                            }
                                                                                                                                            if (type >= 3863 && type <= 3865)
                                                                                                                                            {
                                                                                                                                              this.width = 28;
                                                                                                                                              this.height = 20;
                                                                                                                                              this.rare = 1;
                                                                                                                                              this.vanity = true;
                                                                                                                                              this.value = Item.sellPrice(silver: 75);
                                                                                                                                              switch (type)
                                                                                                                                              {
                                                                                                                                                case 3863:
                                                                                                                                                  this.headSlot = 207;
                                                                                                                                                  return;
                                                                                                                                                case 3864:
                                                                                                                                                  this.headSlot = 208;
                                                                                                                                                  return;
                                                                                                                                                case 3865:
                                                                                                                                                  this.headSlot = 209;
                                                                                                                                                  return;
                                                                                                                                                default:
                                                                                                                                                  return;
                                                                                                                                              }
                                                                                                                                            }
                                                                                                                                            else
                                                                                                                                            {
                                                                                                                                              if (type == 3866 || type == 3867 || type == 3868)
                                                                                                                                              {
                                                                                                                                                this.useStyle = 1;
                                                                                                                                                this.useTurn = true;
                                                                                                                                                this.useAnimation = 15;
                                                                                                                                                this.useTime = 10;
                                                                                                                                                this.autoReuse = true;
                                                                                                                                                this.maxStack = 99;
                                                                                                                                                this.consumable = true;
                                                                                                                                                this.createTile = 240;
                                                                                                                                                this.width = 30;
                                                                                                                                                this.height = 30;
                                                                                                                                                this.value = Item.sellPrice(gold: 1);
                                                                                                                                                this.placeStyle = 60;
                                                                                                                                                if (type == 3866)
                                                                                                                                                  this.placeStyle = 61;
                                                                                                                                                if (type == 3868)
                                                                                                                                                  this.placeStyle = 62;
                                                                                                                                                this.rare = 1;
                                                                                                                                                return;
                                                                                                                                              }
                                                                                                                                              switch (type)
                                                                                                                                              {
                                                                                                                                                case 3869:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 139;
                                                                                                                                                  this.placeStyle = 39;
                                                                                                                                                  this.width = 24;
                                                                                                                                                  this.height = 24;
                                                                                                                                                  this.rare = 4;
                                                                                                                                                  this.value = 100000;
                                                                                                                                                  this.accessory = true;
                                                                                                                                                  this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                                                                                                  return;
                                                                                                                                                case 3870:
                                                                                                                                                  this.useStyle = 5;
                                                                                                                                                  this.useAnimation = 20;
                                                                                                                                                  this.useTime = 20;
                                                                                                                                                  this.reuseDelay = 10;
                                                                                                                                                  this.shootSpeed = 14f;
                                                                                                                                                  this.knockBack = 7f;
                                                                                                                                                  this.width = 16;
                                                                                                                                                  this.height = 16;
                                                                                                                                                  this.damage = 65;
                                                                                                                                                  this.UseSound = SoundID.DD2_BetsysWrathShot;
                                                                                                                                                  this.shoot = 711;
                                                                                                                                                  this.mana = 14;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.value = Item.sellPrice(gold: 5);
                                                                                                                                                  this.noMelee = true;
                                                                                                                                                  this.magic = true;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.glowMask = (short) 238;
                                                                                                                                                  return;
                                                                                                                                                case 3871:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 20;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.headSlot = 210;
                                                                                                                                                  return;
                                                                                                                                                case 3872:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 24;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.bodySlot = 204;
                                                                                                                                                  return;
                                                                                                                                                case 3873:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 24;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.legSlot = 152;
                                                                                                                                                  return;
                                                                                                                                                case 3874:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 7;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.headSlot = 211;
                                                                                                                                                  return;
                                                                                                                                                case 3875:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 21;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.bodySlot = 205;
                                                                                                                                                  return;
                                                                                                                                                case 3876:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 14;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.legSlot = 153;
                                                                                                                                                  return;
                                                                                                                                                case 3877:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 8;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.headSlot = 212;
                                                                                                                                                  return;
                                                                                                                                                case 3878:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 24;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.bodySlot = 206;
                                                                                                                                                  return;
                                                                                                                                                case 3879:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 16;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.legSlot = 154;
                                                                                                                                                  return;
                                                                                                                                                case 3880:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 10;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.headSlot = 213;
                                                                                                                                                  return;
                                                                                                                                                case 3881:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 26;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.bodySlot = 207;
                                                                                                                                                  return;
                                                                                                                                                case 3882:
                                                                                                                                                  this.width = 18;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.defense = 18;
                                                                                                                                                  this.value = Item.sellPrice(gold: 3);
                                                                                                                                                  this.legSlot = 156;
                                                                                                                                                  return;
                                                                                                                                                case 3883:
                                                                                                                                                  this.width = 22;
                                                                                                                                                  this.height = 20;
                                                                                                                                                  this.accessory = true;
                                                                                                                                                  this.value = Item.buyPrice(gold: 40);
                                                                                                                                                  this.rare = 8;
                                                                                                                                                  this.wingSlot = (sbyte) 37;
                                                                                                                                                  return;
                                                                                                                                                case 3884:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 467;
                                                                                                                                                  this.width = 26;
                                                                                                                                                  this.height = 22;
                                                                                                                                                  this.value = 500;
                                                                                                                                                  this.placeStyle = 0;
                                                                                                                                                  return;
                                                                                                                                                case 3885:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 467;
                                                                                                                                                  this.width = 26;
                                                                                                                                                  this.height = 22;
                                                                                                                                                  this.value = Item.buyPrice(gold: 10);
                                                                                                                                                  this.placeStyle = 1;
                                                                                                                                                  return;
                                                                                                                                                case 3886:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 468;
                                                                                                                                                  this.width = 26;
                                                                                                                                                  this.height = 22;
                                                                                                                                                  this.value = 500;
                                                                                                                                                  this.placeStyle = 0;
                                                                                                                                                  return;
                                                                                                                                                case 3887:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 468;
                                                                                                                                                  this.width = 26;
                                                                                                                                                  this.height = 22;
                                                                                                                                                  this.value = 500;
                                                                                                                                                  this.placeStyle = 1;
                                                                                                                                                  return;
                                                                                                                                                case 3888:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 10;
                                                                                                                                                  this.width = 14;
                                                                                                                                                  this.height = 28;
                                                                                                                                                  this.value = 200;
                                                                                                                                                  this.placeStyle = 36;
                                                                                                                                                  return;
                                                                                                                                                case 3889:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 15;
                                                                                                                                                  this.width = 12;
                                                                                                                                                  this.height = 30;
                                                                                                                                                  this.placeStyle = 36;
                                                                                                                                                  this.value = 150;
                                                                                                                                                  return;
                                                                                                                                                case 3890:
                                                                                                                                                  this.noWet = true;
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 33;
                                                                                                                                                  this.width = 8;
                                                                                                                                                  this.height = 18;
                                                                                                                                                  this.value = Item.sellPrice(copper: 60);
                                                                                                                                                  this.placeStyle = 30;
                                                                                                                                                  return;
                                                                                                                                                case 3891:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 999;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 42;
                                                                                                                                                  this.width = 12;
                                                                                                                                                  this.height = 28;
                                                                                                                                                  this.placeStyle = 37;
                                                                                                                                                  this.value = 150;
                                                                                                                                                  return;
                                                                                                                                                case 3892:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 93;
                                                                                                                                                  this.width = 10;
                                                                                                                                                  this.height = 24;
                                                                                                                                                  this.value = 500;
                                                                                                                                                  this.placeStyle = 31;
                                                                                                                                                  return;
                                                                                                                                                case 3893:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 100;
                                                                                                                                                  this.width = 20;
                                                                                                                                                  this.height = 20;
                                                                                                                                                  this.value = 1500;
                                                                                                                                                  this.placeStyle = 31;
                                                                                                                                                  return;
                                                                                                                                                case 3894:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 34;
                                                                                                                                                  this.width = 26;
                                                                                                                                                  this.height = 26;
                                                                                                                                                  this.value = 3000;
                                                                                                                                                  this.placeStyle = 37;
                                                                                                                                                  return;
                                                                                                                                                case 3895:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 90;
                                                                                                                                                  this.width = 20;
                                                                                                                                                  this.height = 20;
                                                                                                                                                  this.value = 300;
                                                                                                                                                  this.placeStyle = 31;
                                                                                                                                                  return;
                                                                                                                                                case 3896:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.createTile = 172;
                                                                                                                                                  this.width = 20;
                                                                                                                                                  this.height = 20;
                                                                                                                                                  this.value = 300;
                                                                                                                                                  this.placeStyle = 32;
                                                                                                                                                  return;
                                                                                                                                                case 3897:
                                                                                                                                                  this.useStyle = 1;
                                                                                                                                                  this.useTurn = true;
                                                                                                                                                  this.useAnimation = 15;
                                                                                                                                                  this.useTime = 10;
                                                                                                                                                  this.maxStack = 99;
                                                                                                                                                  this.consumable = true;
                                                                                                                                                  this.autoReuse = true;
                                                                                                                                                  this.createTile = 79;
                                                                                                                                                  this.width = 28;
                                                                                                                                                  this.height = 20;
                                                                                                                                                  this.value = 2000;
                                                                                                                                                  this.placeStyle = 31;
                                                                                                                                                  return;
                                                                                                                                                default:
                                                                                                                                                  if (type >= 3898 && type <= 3902)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 99;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 104;
                                                                                                                                                    this.width = 20;
                                                                                                                                                    this.height = 20;
                                                                                                                                                    this.value = 300;
                                                                                                                                                    this.placeStyle = 28 + type - 3898;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  if (type >= 3903 && type <= 3908)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 999;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 19;
                                                                                                                                                    this.width = 8;
                                                                                                                                                    this.height = 10;
                                                                                                                                                    this.placeStyle = 30 + type - 3903;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  if (type == 3909)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 99;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 18;
                                                                                                                                                    this.width = 28;
                                                                                                                                                    this.height = 14;
                                                                                                                                                    this.value = 150;
                                                                                                                                                    this.placeStyle = 31;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  if (type == 3910)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 99;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 18;
                                                                                                                                                    this.width = 28;
                                                                                                                                                    this.height = 14;
                                                                                                                                                    this.value = Item.buyPrice(gold: 10);
                                                                                                                                                    this.placeStyle = 32;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  if (type >= 3911 && type <= 3914)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 99;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 88;
                                                                                                                                                    this.width = 20;
                                                                                                                                                    this.height = 20;
                                                                                                                                                    this.value = 300;
                                                                                                                                                    this.placeStyle = 28 + type - 3911;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  if (type >= 3915 && type <= 3916)
                                                                                                                                                  {
                                                                                                                                                    this.useStyle = 1;
                                                                                                                                                    this.useTurn = true;
                                                                                                                                                    this.useAnimation = 15;
                                                                                                                                                    this.useTime = 10;
                                                                                                                                                    this.autoReuse = true;
                                                                                                                                                    this.maxStack = 99;
                                                                                                                                                    this.consumable = true;
                                                                                                                                                    this.createTile = 87;
                                                                                                                                                    this.width = 20;
                                                                                                                                                    this.height = 20;
                                                                                                                                                    this.value = 300;
                                                                                                                                                    this.placeStyle = 30 + type - 3915;
                                                                                                                                                    return;
                                                                                                                                                  }
                                                                                                                                                  switch (type)
                                                                                                                                                  {
                                                                                                                                                    case 3917:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 101;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3918:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 89;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3919:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 89;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 34;
                                                                                                                                                      return;
                                                                                                                                                    case 3920:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 469;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 0;
                                                                                                                                                      return;
                                                                                                                                                    case 3921:
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.headSlot = 214;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3922:
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.bodySlot = 208;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3923:
                                                                                                                                                      this.width = 18;
                                                                                                                                                      this.height = 14;
                                                                                                                                                      this.legSlot = 158;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3924:
                                                                                                                                                      this.width = 24;
                                                                                                                                                      this.height = 8;
                                                                                                                                                      this.accessory = true;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.wingSlot = (sbyte) 38;
                                                                                                                                                      this.value = 400000;
                                                                                                                                                      return;
                                                                                                                                                    case 3925:
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.headSlot = 215;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3926:
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.bodySlot = 209;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3927:
                                                                                                                                                      this.width = 18;
                                                                                                                                                      this.height = 14;
                                                                                                                                                      this.legSlot = 159;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3928:
                                                                                                                                                      this.width = 24;
                                                                                                                                                      this.height = 8;
                                                                                                                                                      this.accessory = true;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.wingSlot = (sbyte) 39;
                                                                                                                                                      this.value = 400000;
                                                                                                                                                      return;
                                                                                                                                                    case 3929:
                                                                                                                                                      this.width = 18;
                                                                                                                                                      this.height = 14;
                                                                                                                                                      this.rare = 9;
                                                                                                                                                      this.vanity = true;
                                                                                                                                                      this.value = Item.sellPrice(gold: 5);
                                                                                                                                                      this.accessory = true;
                                                                                                                                                      this.canBePlacedInVanityRegardlessOfConditions = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3930:
                                                                                                                                                      this.useStyle = 5;
                                                                                                                                                      this.useAnimation = 6;
                                                                                                                                                      this.useTime = 6;
                                                                                                                                                      this.shootSpeed = 17f;
                                                                                                                                                      this.knockBack = 10f;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      this.damage = 40;
                                                                                                                                                      this.UseSound = (LegacySoundStyle) null;
                                                                                                                                                      this.shoot = 714;
                                                                                                                                                      this.rare = 10;
                                                                                                                                                      this.value = Item.sellPrice(gold: 10);
                                                                                                                                                      this.noMelee = true;
                                                                                                                                                      this.noUseGraphic = true;
                                                                                                                                                      this.ranged = true;
                                                                                                                                                      this.channel = true;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.useAmmo = AmmoID.Rocket;
                                                                                                                                                      return;
                                                                                                                                                    case 3931:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 90;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3932:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.createTile = 79;
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 2000;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3933:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 101;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3934:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 88;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3935:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 100;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 1500;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3936:
                                                                                                                                                      this.noWet = true;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 33;
                                                                                                                                                      this.width = 8;
                                                                                                                                                      this.height = 18;
                                                                                                                                                      this.value = Item.sellPrice(copper: 60);
                                                                                                                                                      this.placeStyle = 31;
                                                                                                                                                      return;
                                                                                                                                                    case 3937:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 15;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 30;
                                                                                                                                                      this.placeStyle = 37;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      return;
                                                                                                                                                    case 3938:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 34;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 26;
                                                                                                                                                      this.value = 3000;
                                                                                                                                                      this.placeStyle = 38;
                                                                                                                                                      return;
                                                                                                                                                    case 3939:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 467;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 22;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 2;
                                                                                                                                                      return;
                                                                                                                                                    case 3940:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 104;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3941:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 10;
                                                                                                                                                      this.width = 14;
                                                                                                                                                      this.height = 28;
                                                                                                                                                      this.value = 200;
                                                                                                                                                      this.placeStyle = 37;
                                                                                                                                                      return;
                                                                                                                                                    case 3942:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 93;
                                                                                                                                                      this.width = 10;
                                                                                                                                                      this.height = 24;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3943:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 42;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 28;
                                                                                                                                                      this.placeStyle = 38;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      return;
                                                                                                                                                    case 3944:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 87;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3945:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 19;
                                                                                                                                                      this.width = 8;
                                                                                                                                                      this.height = 10;
                                                                                                                                                      this.placeStyle = 36;
                                                                                                                                                      return;
                                                                                                                                                    case 3946:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 172;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3947:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 89;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 35;
                                                                                                                                                      return;
                                                                                                                                                    case 3948:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 469;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 1;
                                                                                                                                                      return;
                                                                                                                                                    case 3949:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 18;
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 14;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3950:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 468;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 22;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 2;
                                                                                                                                                      return;
                                                                                                                                                    case 3951:
                                                                                                                                                      this.createTile = 472;
                                                                                                                                                      this.width = 16;
                                                                                                                                                      this.height = 16;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3952:
                                                                                                                                                      this.createWall = 231;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 7;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      return;
                                                                                                                                                    case 3953:
                                                                                                                                                      this.createTile = 473;
                                                                                                                                                      this.width = 16;
                                                                                                                                                      this.height = 16;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3954:
                                                                                                                                                      this.createWall = 232;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 7;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      return;
                                                                                                                                                    case 3955:
                                                                                                                                                      this.createTile = 474;
                                                                                                                                                      this.width = 16;
                                                                                                                                                      this.height = 16;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3956:
                                                                                                                                                      this.createWall = 233;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 7;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      return;
                                                                                                                                                    case 3957:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 19;
                                                                                                                                                      this.width = 8;
                                                                                                                                                      this.height = 10;
                                                                                                                                                      this.placeStyle = 37;
                                                                                                                                                      return;
                                                                                                                                                    case 3958:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 90;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3959:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.createTile = 79;
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 2000;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3960:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 101;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 34;
                                                                                                                                                      return;
                                                                                                                                                    case 3961:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 100;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 1500;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3962:
                                                                                                                                                      this.noWet = true;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 33;
                                                                                                                                                      this.width = 8;
                                                                                                                                                      this.height = 18;
                                                                                                                                                      this.value = Item.sellPrice(copper: 60);
                                                                                                                                                      this.placeStyle = 32;
                                                                                                                                                      return;
                                                                                                                                                    case 3963:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 15;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 30;
                                                                                                                                                      this.placeStyle = 38;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      return;
                                                                                                                                                    case 3964:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 34;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 26;
                                                                                                                                                      this.value = 3000;
                                                                                                                                                      this.placeStyle = 39;
                                                                                                                                                      return;
                                                                                                                                                    case 3965:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 467;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 22;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 3;
                                                                                                                                                      return;
                                                                                                                                                    case 3966:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 104;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 34;
                                                                                                                                                      return;
                                                                                                                                                    case 3967:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 10;
                                                                                                                                                      this.width = 14;
                                                                                                                                                      this.height = 28;
                                                                                                                                                      this.value = 200;
                                                                                                                                                      this.placeStyle = 38;
                                                                                                                                                      return;
                                                                                                                                                    case 3968:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 88;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3969:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 93;
                                                                                                                                                      this.width = 10;
                                                                                                                                                      this.height = 24;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3970:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 42;
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 28;
                                                                                                                                                      this.placeStyle = 39;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      return;
                                                                                                                                                    case 3971:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 87;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 33;
                                                                                                                                                      return;
                                                                                                                                                    case 3972:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 172;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 34;
                                                                                                                                                      return;
                                                                                                                                                    case 3973:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 89;
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 36;
                                                                                                                                                      return;
                                                                                                                                                    case 3974:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 469;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.value = 300;
                                                                                                                                                      this.placeStyle = 2;
                                                                                                                                                      return;
                                                                                                                                                    case 3975:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 18;
                                                                                                                                                      this.width = 28;
                                                                                                                                                      this.height = 14;
                                                                                                                                                      this.value = 150;
                                                                                                                                                      this.placeStyle = 34;
                                                                                                                                                      return;
                                                                                                                                                    case 3976:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 468;
                                                                                                                                                      this.width = 26;
                                                                                                                                                      this.height = 22;
                                                                                                                                                      this.value = 500;
                                                                                                                                                      this.placeStyle = 3;
                                                                                                                                                      return;
                                                                                                                                                    case 3977:
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.useTurn = true;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 10;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.maxStack = 999;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      this.createTile = 269;
                                                                                                                                                      this.width = 22;
                                                                                                                                                      this.height = 32;
                                                                                                                                                      this.createTile = 475;
                                                                                                                                                      return;
                                                                                                                                                    case 3978:
                                                                                                                                                      this.width = 20;
                                                                                                                                                      this.height = 20;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.value = Item.sellPrice(gold: 1, silver: 50);
                                                                                                                                                      this.rare = 3;
                                                                                                                                                      return;
                                                                                                                                                    case 3979:
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      this.rare = 1;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.value = Item.sellPrice(silver: 10);
                                                                                                                                                      this.createTile = 376;
                                                                                                                                                      this.placeStyle = 9;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 15;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3980:
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      this.rare = 2;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.value = Item.sellPrice(silver: 50);
                                                                                                                                                      this.createTile = 376;
                                                                                                                                                      this.placeStyle = 10;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 15;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    case 3981:
                                                                                                                                                      this.width = 12;
                                                                                                                                                      this.height = 12;
                                                                                                                                                      this.rare = 3;
                                                                                                                                                      this.maxStack = 99;
                                                                                                                                                      this.value = Item.sellPrice(gold: 2);
                                                                                                                                                      this.createTile = 376;
                                                                                                                                                      this.placeStyle = 11;
                                                                                                                                                      this.useAnimation = 15;
                                                                                                                                                      this.useTime = 15;
                                                                                                                                                      this.autoReuse = true;
                                                                                                                                                      this.useStyle = 1;
                                                                                                                                                      this.consumable = true;
                                                                                                                                                      return;
                                                                                                                                                    default:
                                                                                                                                                      if (type >= 3982 && type <= 3987)
                                                                                                                                                      {
                                                                                                                                                        this.width = 12;
                                                                                                                                                        this.height = 12;
                                                                                                                                                        this.rare = 2;
                                                                                                                                                        this.maxStack = 99;
                                                                                                                                                        this.createTile = 376;
                                                                                                                                                        this.placeStyle = 12 + type - 3982;
                                                                                                                                                        this.useAnimation = 15;
                                                                                                                                                        this.useTime = 15;
                                                                                                                                                        this.autoReuse = true;
                                                                                                                                                        this.useStyle = 1;
                                                                                                                                                        this.consumable = true;
                                                                                                                                                        this.value = Item.sellPrice(gold: 1);
                                                                                                                                                        return;
                                                                                                                                                      }
                                                                                                                                                      if (type == 3988)
                                                                                                                                                      {
                                                                                                                                                        this.useStyle = 1;
                                                                                                                                                        this.useTurn = true;
                                                                                                                                                        this.useAnimation = 15;
                                                                                                                                                        this.useTime = 10;
                                                                                                                                                        this.autoReuse = true;
                                                                                                                                                        this.maxStack = 99;
                                                                                                                                                        this.consumable = true;
                                                                                                                                                        this.createTile = 467;
                                                                                                                                                        this.width = 26;
                                                                                                                                                        this.height = 22;
                                                                                                                                                        this.value = 500;
                                                                                                                                                        this.placeStyle = 4;
                                                                                                                                                        return;
                                                                                                                                                      }
                                                                                                                                                      if (type != 3989)
                                                                                                                                                        return;
                                                                                                                                                      this.DefaultToGolfBall(721);
                                                                                                                                                      return;
                                                                                                                                                  }
                                                                                                                                              }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                  }
                                                                                                                              }
                                                                                                                          }
                                                                                                                      }
                                                                                                                  }
                                                                                                              }
                                                                                                          }
                                                                                                      }
                                                                                                  }
                                                                                              }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                  }
                                                                              }
                                                                          }
                                                                      }
                                                                  }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                              }
                                          }
                                        }
                                      }
                                  }
                              }
                          }
                      }
                  }
              }
          }
      }
    }

    private void DefaultToGolfBall(int projid)
    {
      this.shoot = projid;
      this.useStyle = 1;
      this.shootSpeed = 12f;
      this.width = 18;
      this.height = 20;
      this.maxStack = 1;
      this.UseSound = SoundID.Item1;
      this.useAnimation = 15;
      this.useTime = 15;
      this.noUseGraphic = true;
      this.noMelee = true;
      this.value = 0;
      this.accessory = true;
      this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
      this.canBePlacedInVanityRegardlessOfConditions = true;
    }

    public void SetDefaults5(int type)
    {
      switch (type)
      {
        case 3990:
          this.DefaultToAccessory(36, 28);
          this.shoeSlot = (sbyte) 18;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 2));
          break;
        case 3991:
          this.DefaultToAccessory(30, 42);
          this.faceSlot = (sbyte) 9;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 10));
          break;
        case 3992:
          this.defense = 7;
          this.DefaultToAccessory(20, 40);
          this.handOnSlot = (sbyte) 20;
          this.handOffSlot = (sbyte) 12;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 15));
          break;
        case 3993:
          this.DefaultToAccessory(34, 30);
          this.shoeSlot = (sbyte) 19;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 10));
          break;
        case 3994:
          this.DefaultToAccessory(newheight: 30);
          this.shoeSlot = (sbyte) 20;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 2));
          break;
        case 3995:
          this.DefaultToAccessory(34, 32);
          this.handOnSlot = (sbyte) 21;
          this.handOffSlot = (sbyte) 13;
          this.shoeSlot = (sbyte) 20;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 5));
          break;
        case 3996:
          this.DefaultToAccessory(28, 30);
          this.handOnSlot = (sbyte) 21;
          this.handOffSlot = (sbyte) 13;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 2));
          break;
        case 3997:
          this.defense = 6;
          this.DefaultToAccessory(36, 38);
          this.shieldSlot = (sbyte) 7;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 10));
          break;
        case 3998:
          this.defense = 7;
          this.DefaultToAccessory(36, 40);
          this.shieldSlot = (sbyte) 8;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 15));
          break;
        case 3999:
          this.DefaultToAccessory(22, 32);
          this.faceSlot = (sbyte) 10;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 2, silver: 50));
          break;
        case 4000:
          this.DefaultToAccessory(28, 32);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 4));
          break;
        case 4001:
          this.DefaultToAccessory(26, 36);
          this.backSlot = (sbyte) 14;
          this.frontSlot = (sbyte) 5;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 3));
          break;
        case 4002:
          this.DefaultToAccessory(34, 36);
          this.backSlot = (sbyte) 15;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 7, silver: 50));
          break;
        case 4003:
          this.DefaultToAccessory(30, 34);
          this.faceSlot = (sbyte) 11;
          this.SetShopValues(ItemRarityColor.LightPurple6, Item.sellPrice(gold: 5));
          break;
        case 4004:
          this.DefaultToAccessory(30, 32);
          this.faceSlot = (sbyte) 13;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 3));
          break;
        case 4005:
          this.DefaultToAccessory(30, 30);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 15));
          break;
        case 4006:
          this.DefaultToAccessory(36, 38);
          this.backSlot = (sbyte) 16;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 15));
          break;
        case 4007:
          this.DefaultToAccessory(26, 30);
          this.neckSlot = (sbyte) 10;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 3));
          break;
        case 4008:
          this.defense = 4;
          this.DefaultToHeadgear(24, 22, 216);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 2));
          break;
        case 4038:
          this.DefaultToAccessory(28, 34);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 7, silver: 50));
          break;
        case 4039:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4040:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 476;
          this.width = 12;
          this.height = 12;
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4041:
        case 4042:
        case 4043:
        case 4044:
        case 4045:
        case 4046:
        case 4047:
        case 4048:
        case 4241:
          this.DefaultToPlacableTile((ushort) 3, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 5));
          this.autoReuse = false;
          this.useTime = this.useAnimation;
          break;
        case 4049:
          this.DefaultToLawnMower(20, 20);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4050:
          this.DefaultToPlacableTile((ushort) 478, 0);
          break;
        case 4051:
          this.DefaultToPlacableTile((ushort) 479, 0);
          break;
        case 4052:
          this.DefaultToPlacableWall((ushort) 234);
          break;
        case 4053:
          this.DefaultToPlacableWall((ushort) 235);
          break;
        case 4054:
          this.DefaultToPlacableTile((ushort) 480, 0);
          this.width = 22;
          this.height = 32;
          this.rare = 3;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4055:
          this.DefaultToAccessory(34, 30);
          this.shoeSlot = (sbyte) 21;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4056:
          this.DefaultToAccessory(30, 30);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4057:
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 1));
          this.DefaultToGuitar();
          break;
        case 4058:
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 10));
          this.DefaultToBow(17, 11f);
          this.SetWeaponValues(8, 5f);
          break;
        case 4059:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 30));
          this.SetWeaponValues(8, 4f);
          this.melee = true;
          this.autoReuse = true;
          this.useTurn = true;
          this.useTime = 14;
          this.useAnimation = 18;
          this.useStyle = 1;
          this.pick = 55;
          this.UseSound = SoundID.Item1;
          break;
        case 4060:
          this.width = 42;
          this.height = 20;
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 50));
          this.DefaultToRangedWeapon(728, AmmoID.FallenStar, 12, 20f, true);
          this.SetWeaponValues(70, 5f);
          break;
        case 4061:
          this.DefaultToSpear(730, 3.5f, 28);
          this.SetWeaponValues(12, 6f);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 30));
          break;
        case 4062:
          this.DefaultToStaff(731, 8f, 17, 5);
          this.SetWeaponValues(12, 2f);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 30));
          break;
        case 4063:
          this.DefaultToPlacableTile((ushort) 486, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4064:
          this.DefaultToPlacableTile((ushort) 487, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(copper: 80));
          break;
        case 4065:
          this.DefaultToPlacableTile((ushort) 487, 1);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 1));
          break;
        case 4066:
          this.DefaultToMount(15);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 50));
          break;
        case 4067:
          this.DefaultToMount(16);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4068:
          this.DefaultToCapturedCritter((short) 583);
          this.rare = 1;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4069:
          this.DefaultToCapturedCritter((short) 584);
          this.rare = 1;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4070:
          this.DefaultToCapturedCritter((short) 585);
          this.rare = 1;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4071:
        case 4072:
        case 4073:
          this.DefaultToSeaShelll();
          break;
        case 4074:
          this.DefaultToPlacableTile((ushort) 489, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 20));
          break;
        case 4075:
          this.DefaultToPlacableTile((ushort) 490, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 10));
          break;
        case 4076:
          this.rare = 3;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 491;
          this.width = 12;
          this.height = 12;
          this.value = 100000;
          break;
        case 4077:
          this.DefaultToMusicBox(43);
          break;
        case 4078:
          this.DefaultToMusicBox(41);
          break;
        case 4079:
          this.DefaultToMusicBox(42);
          break;
        case 4080:
          this.DefaultToMusicBox(44);
          break;
        case 4081:
          this.DefaultToMusicBox(45);
          break;
        case 4082:
          this.DefaultToMusicBox(40);
          break;
        case 4083:
        case 4084:
        case 4085:
        case 4086:
        case 4087:
        case 4088:
          this.DefaultToPlacableTile((ushort) 493, type - 4083);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 20));
          break;
        case 4089:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 494;
          this.width = 12;
          this.height = 12;
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4090:
          this.DefaultToPlacableTile((ushort) 495, 0);
          this.SetShopValues(ItemRarityColor.White0, 0);
          break;
        case 4091:
          this.DefaultToPlacableTile((ushort) 496, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 1));
          break;
        case 4092:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4093:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4094:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 1));
          break;
        case 4095:
          this.maxStack = 1;
          this.consumable = false;
          this.width = 18;
          this.height = 18;
          this.useStyle = 4;
          this.useTime = 10;
          this.UseSound = SoundID.Item128;
          this.useAnimation = 10;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4096:
        case 4097:
        case 4098:
        case 4099:
        case 4100:
        case 4101:
        case 4102:
        case 4103:
        case 4104:
        case 4105:
        case 4106:
        case 4107:
        case 4108:
        case 4109:
        case 4110:
        case 4111:
        case 4112:
        case 4113:
        case 4114:
        case 4115:
        case 4116:
        case 4117:
        case 4118:
        case 4119:
        case 4120:
        case 4121:
        case 4122:
        case 4123:
        case 4124:
        case 4125:
        case 4126:
          this.DefaultToPlacableTile((ushort) 497, type - 4096);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4127:
          this.DefaultToPlacableTile((ushort) 497, type - 4096);
          this.maxStack = 99;
          this.value = 100000;
          break;
        case 4128:
          this.width = 18;
          this.height = 18;
          this.headSlot = 217;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4129:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 210;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4130:
          this.width = 18;
          this.height = 18;
          this.legSlot = 180;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4131:
          this.useStyle = 1;
          this.shootSpeed = 4f;
          this.shoot = 734;
          this.width = 26;
          this.height = 24;
          this.UseSound = SoundID.Item130;
          this.useAnimation = 28;
          this.useTime = 28;
          this.rare = 3;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4132:
          this.width = 18;
          this.height = 18;
          this.headSlot = 218;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4133:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 211;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4134:
          this.width = 18;
          this.height = 18;
          this.legSlot = 184;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4135:
          this.width = 18;
          this.height = 18;
          this.headSlot = 219;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4136:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 212;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4137:
          this.width = 18;
          this.height = 18;
          this.legSlot = 185;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4138:
          this.width = 18;
          this.height = 18;
          this.headSlot = 220;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4139:
          this.DefaultToPlacableTile((ushort) 498, 0);
          this.SetShopValues(ItemRarityColor.White0, 0);
          break;
        case 4140:
          this.DefaultToPlacableWall((ushort) 236);
          this.SetShopValues(ItemRarityColor.White0, 0);
          break;
        case 4141:
          this.DefaultToPlacableTile((ushort) 497, 32);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4142:
          this.DefaultToPlacableTile((ushort) 499, 0);
          this.maxStack = 99;
          this.SetShopValues(ItemRarityColor.White0, 100000);
          break;
        case 4143:
          this.width = 12;
          this.height = 12;
          break;
        case 4144:
          this.width = 14;
          this.height = 38;
          this.useAnimation = 25;
          this.useTime = 15;
          this.useStyle = 5;
          this.rare = 2;
          this.noUseGraphic = true;
          this.channel = true;
          this.noMelee = true;
          this.damage = 17;
          this.knockBack = 3f;
          this.autoReuse = false;
          this.noMelee = true;
          this.melee = true;
          this.shoot = 735;
          this.shootSpeed = 15f;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4145:
          this.DefaultToPlacableTile((ushort) 90, 34);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4146:
          this.DefaultToPlacableTile((ushort) 79, 34);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4147:
          this.DefaultToPlacableTile((ushort) 101, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4148:
          this.DefaultToPlacableTile((ushort) 88, 34);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4149:
          this.DefaultToPlacableTile((ushort) 100, 34);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4150:
          this.DefaultToPlacableTile((ushort) 33, 33);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4151:
          this.DefaultToPlacableTile((ushort) 15, 39);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4152:
          this.DefaultToPlacableTile((ushort) 34, 40);
          this.SetShopValues(ItemRarityColor.White0, 3000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4153:
          this.DefaultToPlacableTile((ushort) 467, 5);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4154:
          this.DefaultToPlacableTile((ushort) 104, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4155:
          this.DefaultToPlacableTile((ushort) 10, 39);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4156:
          this.DefaultToPlacableTile((ushort) 93, 34);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4157:
          this.DefaultToPlacableTile((ushort) 42, 40);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4158:
          this.DefaultToPlacableTile((ushort) 87, 34);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4159:
          this.DefaultToPlacableTile((ushort) 19, 38);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4160:
          this.DefaultToPlacableTile((ushort) 172, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4161:
          this.DefaultToPlacableTile((ushort) 89, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4162:
          this.DefaultToPlacableTile((ushort) 469, 3);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4163:
          this.DefaultToPlacableTile((ushort) 18, 35);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4164:
          this.DefaultToPlacableTile((ushort) 468, 5);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4165:
          this.DefaultToPlacableTile((ushort) 497, 33);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4166:
          this.DefaultToPlacableTile((ushort) 90, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4167:
          this.DefaultToPlacableTile((ushort) 79, 35);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4168:
          this.DefaultToPlacableTile((ushort) 101, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4169:
          this.DefaultToPlacableTile((ushort) 88, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4170:
          this.DefaultToPlacableTile((ushort) 100, 35);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4171:
          this.DefaultToPlacableTile((ushort) 33, 34);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4172:
          this.DefaultToPlacableTile((ushort) 15, 40);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4173:
          this.DefaultToPlacableTile((ushort) 34, 41);
          this.SetShopValues(ItemRarityColor.White0, 3000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4174:
          this.DefaultToPlacableTile((ushort) 467, 6);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4175:
          this.DefaultToPlacableTile((ushort) 104, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4176:
          this.DefaultToPlacableTile((ushort) 10, 40);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4177:
          this.DefaultToPlacableTile((ushort) 93, 35);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4178:
          this.DefaultToPlacableTile((ushort) 42, 41);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4179:
          this.DefaultToPlacableTile((ushort) 87, 35);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4180:
          this.DefaultToPlacableTile((ushort) 19, 39);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4181:
          this.DefaultToPlacableTile((ushort) 172, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4182:
          this.DefaultToPlacableTile((ushort) 89, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4183:
          this.DefaultToPlacableTile((ushort) 469, 4);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4184:
          this.DefaultToPlacableTile((ushort) 18, 36);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4185:
          this.DefaultToPlacableTile((ushort) 468, 6);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4186:
          this.DefaultToPlacableTile((ushort) 497, 34);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4187:
          this.DefaultToPlacableTile((ushort) 90, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4188:
          this.DefaultToPlacableTile((ushort) 79, 36);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4189:
          this.DefaultToPlacableTile((ushort) 101, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4190:
          this.DefaultToPlacableTile((ushort) 88, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4191:
          this.DefaultToPlacableTile((ushort) 100, 36);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4192:
          this.DefaultToPlacableTile((ushort) 33, 35);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4193:
          this.DefaultToPlacableTile((ushort) 15, 41);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4194:
          this.DefaultToPlacableTile((ushort) 34, 42);
          this.SetShopValues(ItemRarityColor.White0, 3000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4195:
          this.DefaultToPlacableTile((ushort) 467, 7);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4196:
          this.DefaultToPlacableTile((ushort) 104, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4197:
          this.DefaultToPlacableTile((ushort) 10, 41);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4198:
          this.DefaultToPlacableTile((ushort) 93, 36);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4199:
          this.DefaultToPlacableTile((ushort) 42, 42);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4200:
          this.DefaultToPlacableTile((ushort) 87, 36);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4201:
          this.DefaultToPlacableTile((ushort) 19, 40);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4202:
          this.DefaultToPlacableTile((ushort) 172, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4203:
          this.DefaultToPlacableTile((ushort) 89, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4204:
          this.DefaultToPlacableTile((ushort) 469, 5);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4205:
          this.DefaultToPlacableTile((ushort) 18, 37);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4206:
          this.DefaultToPlacableTile((ushort) 468, 7);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4207:
          this.DefaultToPlacableTile((ushort) 497, 35);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4208:
          this.DefaultToPlacableTile((ushort) 90, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4209:
          this.DefaultToPlacableTile((ushort) 79, 37);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4210:
          this.DefaultToPlacableTile((ushort) 101, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4211:
          this.DefaultToPlacableTile((ushort) 88, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4212:
          this.DefaultToPlacableTile((ushort) 100, 37);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4213:
          this.DefaultToPlacableTile((ushort) 33, 36);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4214:
          this.DefaultToPlacableTile((ushort) 15, 42);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4215:
          this.DefaultToPlacableTile((ushort) 34, 43);
          this.SetShopValues(ItemRarityColor.White0, 3000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4216:
          this.DefaultToPlacableTile((ushort) 467, 8);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4217:
          this.DefaultToPlacableTile((ushort) 104, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4218:
          this.DefaultToPlacableTile((ushort) 10, 42);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4219:
          this.DefaultToPlacableTile((ushort) 93, 37);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4220:
          this.DefaultToPlacableTile((ushort) 42, 43);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4221:
          this.DefaultToPlacableTile((ushort) 87, 37);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4222:
          this.DefaultToPlacableTile((ushort) 19, 41);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4223:
          this.DefaultToPlacableTile((ushort) 172, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4224:
          this.DefaultToPlacableTile((ushort) 89, 40);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4225:
          this.DefaultToPlacableTile((ushort) 469, 6);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4226:
          this.DefaultToPlacableTile((ushort) 18, 38);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4227:
          this.DefaultToPlacableTile((ushort) 468, 8);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4228:
          this.DefaultToPlacableTile((ushort) 497, 36);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4229:
          this.DefaultToPlacableTile((ushort) 500, 0);
          break;
        case 4230:
          this.DefaultToPlacableTile((ushort) 501, 0);
          break;
        case 4231:
          this.DefaultToPlacableTile((ushort) 502, 0);
          break;
        case 4232:
          this.DefaultToPlacableTile((ushort) 503, 0);
          break;
        case 4233:
          this.DefaultToPlacableWall((ushort) 237);
          break;
        case 4234:
          this.DefaultToPlacableWall((ushort) 238);
          break;
        case 4235:
          this.DefaultToPlacableWall((ushort) 239);
          break;
        case 4236:
          this.DefaultToPlacableWall((ushort) 240);
          break;
        case 4237:
          this.DefaultToMusicBox(46);
          break;
        case 4238:
          this.DefaultToPlacableTile((ushort) 481, 0);
          break;
        case 4239:
          this.DefaultToPlacableTile((ushort) 482, 0);
          break;
        case 4240:
          this.DefaultToPlacableTile((ushort) 483, 0);
          break;
        case 4242:
          this.DefaultToGolfBall(739);
          break;
        case 4243:
          this.DefaultToGolfBall(740);
          break;
        case 4244:
          this.DefaultToGolfBall(741);
          break;
        case 4245:
          this.DefaultToGolfBall(742);
          break;
        case 4246:
          this.DefaultToGolfBall(743);
          break;
        case 4247:
          this.DefaultToGolfBall(744);
          break;
        case 4248:
          this.DefaultToGolfBall(745);
          break;
        case 4249:
          this.DefaultToGolfBall(746);
          break;
        case 4250:
          this.DefaultToGolfBall(747);
          break;
        case 4251:
          this.DefaultToGolfBall(748);
          break;
        case 4252:
          this.DefaultToGolfBall(749);
          break;
        case 4253:
          this.DefaultToGolfBall(750);
          break;
        case 4254:
          this.DefaultToGolfBall(751);
          break;
        case 4255:
          this.DefaultToGolfBall(752);
          break;
        case 4256:
          this.defense = 3;
          this.width = 18;
          this.height = 14;
          this.bodySlot = 213;
          this.value = Item.sellPrice(silver: 50) * 6;
          this.rare = 2;
          break;
        case 4257:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 12.5f;
          this.shoot = 753;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 4258:
          this.useStyle = 1;
          this.useAnimation = 25;
          this.knockBack = 3f;
          this.width = 40;
          this.height = 40;
          this.damage = 21;
          this.scale = 1f;
          this.UseSound = SoundID.Item15;
          this.rare = 1;
          this.value = 27000;
          this.melee = true;
          break;
        case 4259:
          this.SetDefaults(198);
          this.type = type;
          this.damage = 42;
          this.useTime = 20;
          this.useAnimation = 20;
          this.scale = 1.15f;
          this.autoReuse = true;
          this.useTurn = true;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4260:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 7;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createWall = 241;
          this.width = 12;
          this.height = 12;
          this.value = Item.sellPrice(silver: 5);
          break;
        case 4261:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 135;
          this.width = 12;
          this.height = 12;
          this.placeStyle = 7;
          this.mech = true;
          this.value = 5000;
          break;
        case 4262:
          this.useTurn = true;
          this.width = 20;
          this.height = 20;
          this.useStyle = 5;
          this.useTime = 90;
          this.UseSound = SoundID.Item151;
          this.useAnimation = 90;
          this.rare = 1;
          this.value = 50000;
          this.shoot = 754;
          break;
        case 4263:
          this.useTurn = true;
          this.width = 20;
          this.height = 20;
          this.useStyle = 4;
          this.useTime = 90;
          this.UseSound = SoundID.Item6;
          this.useAnimation = 90;
          this.rare = 1;
          this.value = 50000;
          break;
        case 4264:
          this.useStyle = 4;
          this.channel = true;
          this.width = 34;
          this.height = 34;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.mountType = 17;
          this.value = Item.sellPrice(gold: 10);
          break;
        case 4265:
          this.DefaultToPlacableTile((ushort) 467, 9);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(gold: 3));
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4266:
          this.DefaultToPlacableTile((ushort) 468, 9);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4267:
          this.DefaultToPlacableTile((ushort) 467, 10);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4268:
          this.DefaultToPlacableTile((ushort) 468, 10);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4269:
          this.mana = 10;
          this.damage = 35;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 755;
          this.buffType = 213;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item113;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 4;
          this.noMelee = true;
          this.knockBack = 8f;
          this.value = Item.sellPrice(gold: 5);
          this.summon = true;
          break;
        case 4270:
          this.mana = 20;
          this.damage = 29;
          this.useStyle = 4;
          this.shootSpeed = 32f;
          this.shoot = 756;
          this.width = 26;
          this.height = 28;
          this.useAnimation = 21;
          this.useTime = 7;
          this.rare = 4;
          this.noMelee = true;
          this.knockBack = 1f;
          this.value = Item.sellPrice(gold: 4);
          this.magic = true;
          this.autoReuse = true;
          break;
        case 4271:
          this.useStyle = 4;
          this.width = 22;
          this.height = 14;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.maxStack = 20;
          this.rare = 2;
          break;
        case 4272:
          this.noMelee = true;
          this.useStyle = 5;
          this.useAnimation = 40;
          this.useTime = 40;
          this.knockBack = 6.5f;
          this.width = 30;
          this.height = 10;
          this.damage = 55;
          this.scale = 1.1f;
          this.noUseGraphic = true;
          this.shoot = 757;
          this.shootSpeed = 15.9f;
          this.UseSound = SoundID.Item1;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 4);
          this.melee = true;
          this.channel = true;
          break;
        case 4273:
          this.mana = 10;
          this.damage = 11;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 758;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item44;
          this.useAnimation = 36;
          this.useTime = 36;
          this.noMelee = true;
          this.knockBack = 5f;
          this.buffType = 214;
          this.value = Item.sellPrice(gold: 1);
          this.rare = 3;
          this.summon = true;
          break;
        case 4274:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.noUseGraphic = true;
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.makeNPC = (short) 592;
          break;
        case 4275:
          this.width = 18;
          this.height = 18;
          this.headSlot = 221;
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.vanity = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 505;
          this.width = 12;
          this.height = 12;
          break;
        case 4276:
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 506;
          this.width = 20;
          this.height = 20;
          break;
        case 4277:
          this.DefaultToPlacableTile((ushort) 507, 0);
          break;
        case 4278:
          this.DefaultToPlacableTile((ushort) 508, 0);
          break;
        case 4279:
          this.DefaultToPlacableWall((ushort) 242);
          break;
        case 4280:
          this.DefaultToPlacableWall((ushort) 243);
          break;
        case 4281:
          this.mana = 10;
          this.damage = 7;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 759;
          this.buffType = 216;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item113;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 1;
          this.noMelee = true;
          this.knockBack = 4f;
          this.value = Item.sellPrice(gold: 1);
          this.summon = true;
          break;
        case 4298:
          this.DefaultToPlacableTile((ushort) 90, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4299:
          this.DefaultToPlacableTile((ushort) 79, 38);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4300:
          this.DefaultToPlacableTile((ushort) 101, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4301:
          this.DefaultToPlacableTile((ushort) 88, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4302:
          this.DefaultToPlacableTile((ushort) 100, 38);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4303:
          this.DefaultToPlacableTile((ushort) 33, 37);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4304:
          this.DefaultToPlacableTile((ushort) 15, 43);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4305:
          this.DefaultToPlacableTile((ushort) 34, 44);
          this.SetShopValues(ItemRarityColor.White0, 3000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4306:
          this.DefaultToPlacableTile((ushort) 104, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4307:
          this.DefaultToPlacableTile((ushort) 10, 43);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4308:
          this.DefaultToPlacableTile((ushort) 93, 38);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4309:
          this.DefaultToPlacableTile((ushort) 42, 44);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4310:
          this.DefaultToPlacableTile((ushort) 87, 38);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4311:
          this.DefaultToPlacableTile((ushort) 19, 42);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4312:
          this.DefaultToPlacableTile((ushort) 172, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4313:
          this.DefaultToPlacableTile((ushort) 89, 41);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4314:
          this.DefaultToPlacableTile((ushort) 469, 7);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4315:
          this.DefaultToPlacableTile((ushort) 18, 39);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4316:
          this.DefaultToPlacableTile((ushort) 497, 37);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4317:
          this.SetShopValues(ItemRarityColor.LightRed4, Item.sellPrice(gold: 2));
          this.SetWeaponValues(30, 7f);
          this.melee = true;
          this.autoReuse = true;
          this.useTime = 11;
          this.useAnimation = 27;
          this.useStyle = 1;
          this.hammer = 80;
          this.axe = 30;
          this.UseSound = SoundID.Item1;
          this.width = 20;
          this.height = 20;
          break;
        case 4318:
          this.DefaultToPlacableTile((ushort) 509, 0);
          this.width = 22;
          this.height = 32;
          this.rare = 9;
          this.value = Item.sellPrice(gold: 25);
          break;
        case 4319:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 510;
          this.width = 28;
          this.height = 28;
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 20));
          break;
        case 4320:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 511;
          this.width = 28;
          this.height = 28;
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 20));
          break;
        case 4321:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 214;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 5);
          break;
        case 4322:
          this.width = 18;
          this.height = 18;
          this.legSlot = 188;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 5);
          break;
        case 4323:
          this.width = 18;
          this.height = 18;
          this.headSlot = 222;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 50);
          break;
        case 4324:
          this.width = 18;
          this.height = 14;
          this.bodySlot = 215;
          this.value = Item.buyPrice(gold: 50);
          this.rare = 3;
          this.vanity = true;
          break;
        case 4325:
          this.useStyle = 1;
          this.useAnimation = 8;
          this.useTime = 8;
          this.width = 24;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.shoot = 760;
          this.fishingPole = 25;
          this.shootSpeed = 15f;
          this.rare = 2;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4326:
          this.DefaultToPlacableTile((ushort) 520, 0);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4327:
        case 4328:
        case 4329:
        case 4330:
        case 4331:
        case 4332:
          this.DefaultToPlacableTile((ushort) (type - 4327 + 521), 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4333:
          this.DefaultToPlacableTile((ushort) 527, 0);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4334:
        case 4335:
        case 4336:
        case 4337:
        case 4338:
        case 4339:
          this.DefaultToCapturedCritter((short) (type - 4334 + 595));
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.width = 20;
          this.height = 20;
          this.bait = 20;
          break;
        case 4340:
          this.DefaultToCapturedCritter((short) 601);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.width = 20;
          this.height = 20;
          this.bait = 50;
          break;
        case 4341:
          this.DefaultToAccessory(30, 30);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4342:
          this.DefaultToPlacableTile((ushort) 105, 78);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 60));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4343:
          this.width = 22;
          this.height = 16;
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.DefaultToThrownWeapon(761, 17, 5f);
          this.SetWeaponValues(4, 2f);
          break;
        case 4344:
          this.width = 22;
          this.height = 16;
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.DefaultToThrownWeapon(762, 17, 5f);
          this.SetWeaponValues(4, 2f);
          break;
        case 4345:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 5));
          this.maxStack = 99;
          this.width = 12;
          this.height = 12;
          break;
        case 4346:
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 5));
          this.width = 30;
          this.height = 30;
          break;
        case 4347:
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 17));
          this.DefaultToMagicWeapon(876, 37, 15f);
          this.mana = 16;
          this.width = 40;
          this.height = 40;
          this.knockBack = 6f;
          this.scale = 0.75f;
          this.damage = 42;
          this.UseSound = SoundID.Item158;
          break;
        case 4348:
          this.SetShopValues(ItemRarityColor.Pink5, Item.buyPrice(gold: 50));
          this.DefaultToMagicWeapon(876, 37, 15f);
          this.mana = 16;
          this.width = 40;
          this.height = 40;
          this.knockBack = 6f;
          this.scale = 0.75f;
          this.damage = 100;
          this.UseSound = SoundID.Item158;
          break;
        case 4349:
        case 4350:
        case 4351:
        case 4352:
        case 4353:
          this.DefaultToPlacableTile(179 + type - 4349);
          break;
        case 4354:
          this.DefaultToPlacableTile((ushort) 381, 0);
          break;
        case 4355:
          this.DefaultToPlacableTile((ushort) 531, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 60));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4356:
          this.DefaultToMusicBox(47);
          break;
        case 4357:
          this.DefaultToMusicBox(48);
          break;
        case 4358:
          this.DefaultToMusicBox(49);
          break;
        case 4359:
          this.DefaultToCapturedCritter((short) 602);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 7, copper: 50));
          this.width = 20;
          this.height = 20;
          break;
        case 4360:
          this.DefaultToPlacableTile((ushort) 105, 77);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 60));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4361:
          this.DefaultToCapturedCritter((short) 604);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.width = 20;
          this.height = 20;
          this.bait = 17;
          break;
        case 4362:
          this.DefaultToCapturedCritter((short) 605);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.width = 20;
          this.height = 20;
          this.bait = 50;
          break;
        case 4363:
          this.DefaultToCapturedCritter((short) 606);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 5));
          this.width = 12;
          this.height = 12;
          this.bait = 22;
          break;
        case 4364:
          this.DefaultToPlacableTile((ushort) 532, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4365:
          this.DefaultToVanitypet(764, 217);
          this.SetShopValues(ItemRarityColor.Pink5, Item.buyPrice(1));
          break;
        case 4366:
          this.DefaultToVanitypet(765, 218);
          break;
        case 4367:
        case 4368:
        case 4369:
        case 4370:
        case 4371:
          this.DefaultTokite(type - 4367 + 766);
          break;
        case 4372:
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 1));
          this.DefaultToGuitar();
          break;
        case 4373:
          this.DefaultToCapturedCritter((short) 607);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 7, copper: 50));
          this.width = 12;
          this.height = 12;
          break;
        case 4374:
          this.DefaultToCapturedCritter((short) 608);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 7, copper: 50));
          this.width = 12;
          this.height = 12;
          break;
        case 4375:
          this.DefaultToCapturedCritter((short) 610);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.width = 12;
          this.height = 12;
          break;
        case 4376:
          this.DefaultToPlacableTile((ushort) 533, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4377:
          this.DefaultToPlacableTile((ushort) 534, 0);
          this.rare = 1;
          break;
        case 4378:
          this.DefaultToPlacableTile((ushort) 536, 0);
          this.rare = 1;
          break;
        case 4379:
          this.DefaultTokite(771);
          break;
        case 4380:
          this.DefaultToPlacableTile((ushort) 538, 0);
          this.maxStack = 99;
          break;
        case 4381:
          this.DefaultToBow(19, 9f, true);
          this.SetWeaponValues(14, 3f);
          this.value = Item.sellPrice(gold: 1);
          this.rare = 3;
          break;
        case 4382:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.UseSound = SoundID.Item92;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          this.rare = 2;
          break;
        case 4383:
          this.DefaultToTorch(16);
          break;
        case 4384:
          this.DefaultToTorch(17, true);
          break;
        case 4385:
          this.DefaultToTorch(18);
          break;
        case 4386:
          this.DefaultToTorch(19);
          break;
        case 4387:
          this.DefaultToTorch(20);
          break;
        case 4388:
          this.DefaultToTorch(21);
          break;
        case 4389:
          this.DefaultToPlacableTile((ushort) 539, 0);
          this.rare = 1;
          break;
        case 4390:
          this.DefaultToPlacableTile((ushort) 484, 0);
          break;
        case 4391:
          this.DefaultToPlacableTile((ushort) 162, 0);
          break;
        case 4392:
          this.DefaultToPlacableTile((ushort) 541, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 10));
          break;
        case 4393:
        case 4394:
          this.DefaultToQuestFish();
          break;
        case 4395:
          this.DefaultToCapturedCritter((short) 611);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.width = 12;
          this.height = 12;
          break;
        case 4396:
          this.DefaultToPlacableTile((ushort) 542, 0);
          this.maxStack = 99;
          break;
        case 4397:
          this.DefaultToPlacableTile((ushort) 105, 76);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 60));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4398:
          this.DefaultToPlacableTile((ushort) 543, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          this.value = Item.sellPrice(silver: 20);
          break;
        case 4399:
          this.DefaultToPlacableTile((ushort) 544, 0);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.maxStack = 99;
          break;
        case 4400:
          this.useStyle = 1;
          this.shootSpeed = 7f;
          this.shoot = 772;
          this.width = 22;
          this.height = 22;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.noUseGraphic = true;
          this.useTime = 15;
          this.rare = 2;
          this.value = Item.sellPrice(silver: 5);
          this.consumable = true;
          this.maxStack = 999;
          break;
        case 4401:
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 7, copper: 50));
          this.maxStack = 999;
          this.width = 26;
          this.height = 26;
          break;
        case 4402:
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(gold: 1));
          this.maxStack = 999;
          this.width = 26;
          this.height = 26;
          break;
        case 4404:
          this.DefaultToAccessory(20, 12);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(gold: 1));
          this.canBePlacedInVanityRegardlessOfConditions = true;
          break;
        case 4405:
        case 4406:
        case 4407:
        case 4408:
          this.DefaultToPlacableTile((ushort) 376, 18 + type - 4405);
          this.SetShopValues(ItemRarityColor.Green2, Item.sellPrice(gold: 1));
          this.maxStack = 99;
          break;
        case 4409:
          this.DefaultToAccessory(28);
          this.faceSlot = (sbyte) 14;
          this.SetShopValues(ItemRarityColor.Pink5, Item.buyPrice(gold: 10));
          break;
        case 4410:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 1));
          this.maxStack = 99;
          this.width = 32;
          this.height = 22;
          break;
        case 4412:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          this.maxStack = 999;
          this.width = 22;
          this.height = 22;
          break;
        case 4413:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 5));
          this.maxStack = 999;
          this.width = 22;
          this.height = 22;
          break;
        case 4414:
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 25));
          this.maxStack = 999;
          this.width = 22;
          this.height = 22;
          break;
        case 4415:
          this.DefaultToPlacableTile((ushort) 10, 44);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 40));
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4416:
          this.DefaultToPlacableTile((ushort) 19, 43);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4417:
          this.DefaultToPlacableTile((ushort) 207, 9);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 4));
          this.width = 8;
          this.height = 10;
          break;
        case 4418:
          this.DefaultToCapturedCritter((short) 612);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 10));
          this.width = 20;
          this.height = 20;
          this.bait = 17;
          break;
        case 4419:
          this.DefaultToCapturedCritter((short) 613);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.width = 20;
          this.height = 20;
          this.bait = 50;
          break;
        case 4420:
          this.DefaultToPlacableTile((ushort) 545, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(gold: 5));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4421:
          this.DefaultToMusicBox(50);
          break;
        case 4422:
          this.DefaultToPlacableTile((ushort) 546, 0);
          break;
        case 4423:
          this.useStyle = 1;
          this.shootSpeed = 5f;
          this.shoot = 773;
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.UseSound = SoundID.Item1;
          this.consumable = true;
          this.useAnimation = 25;
          this.noUseGraphic = true;
          this.useTime = 25;
          this.value = Item.sellPrice(silver: 3);
          this.rare = 1;
          break;
        case 4424:
          this.DefaultToPlacableWall((ushort) 245);
          break;
        case 4425:
          this.DefaultToVanitypet(774, 219);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 1));
          break;
        case 4426:
          this.DefaultToMount(18);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4427:
          this.DefaultToMount(19);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 50));
          break;
        case 4428:
          this.DefaultToMount(20);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4429:
          this.DefaultToMount(21);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 50));
          break;
        case 4430:
          this.DefaultToPlacableTile((ushort) 547, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4431:
          this.DefaultToPlacableTile((ushort) 547, 1);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4432:
          this.DefaultToPlacableTile((ushort) 547, 2);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4433:
          this.DefaultToPlacableTile((ushort) 547, 3);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4434:
          this.DefaultToPlacableTile((ushort) 547, 4);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4435:
          this.DefaultToPlacableTile((ushort) 548, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4436:
          this.DefaultToPlacableTile((ushort) 548, 1);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4437:
          this.DefaultToPlacableTile((ushort) 548, 2);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4438:
          this.DefaultToPlacableTile((ushort) 548, 3);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4439:
          this.DefaultToPlacableTile((ushort) 548, 4);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4440:
          this.DefaultToPlacableTile((ushort) 548, 5);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4441:
          this.DefaultToPlacableTile((ushort) 548, 6);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4442:
          this.useStyle = 1;
          this.useAnimation = 8;
          this.useTime = 8;
          this.width = 24;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.shoot = 775;
          this.fishingPole = 25;
          this.shootSpeed = 15f;
          this.rare = 1;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4443:
          this.DefaultToMount(22);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4444:
          this.useStyle = 4;
          this.channel = true;
          this.width = 34;
          this.height = 34;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.mountType = 23;
          this.value = Item.sellPrice(gold: 5);
          this.expert = true;
          break;
        case 4445:
          this.damage = 50;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.buyPrice(silver: 7, copper: 50);
          this.ranged = true;
          break;
        case 4446:
          this.damage = 50;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.buyPrice(silver: 15);
          this.ranged = true;
          break;
        case 4447:
          this.damage = 40;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.sellPrice(silver: 10);
          this.ranged = true;
          break;
        case 4448:
          this.damage = 40;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.sellPrice(silver: 10);
          this.ranged = true;
          break;
        case 4449:
          this.damage = 40;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.sellPrice(silver: 10);
          this.ranged = true;
          break;
        case 4450:
          this.DefaultToMount(24);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4451:
          this.DefaultToMount(25);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4452:
          this.DefaultToMount(26);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4453:
          this.DefaultToMount(27);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4454:
          this.DefaultToMount(28);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4455:
          this.DefaultToMount(29);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4456:
          this.DefaultToMount(30);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4457:
          this.damage = 75;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.buyPrice(silver: 5);
          this.ranged = true;
          break;
        case 4458:
          this.damage = 75;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.buyPrice(silver: 10);
          this.ranged = true;
          break;
        case 4459:
          this.damage = 40;
          this.width = 20;
          this.height = 14;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Rocket;
          this.knockBack = 4f;
          this.value = Item.buyPrice(silver: 50);
          this.ranged = true;
          break;
        case 4460:
          this.tileWand = 169;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.createTile = 552;
          this.width = 8;
          this.height = 10;
          this.rare = 1;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4461:
          this.DefaultToPlacableTile((ushort) 550, 0);
          this.maxStack = 99;
          break;
        case 4462:
          this.DefaultToPlacableTile((ushort) 551, 0);
          this.maxStack = 99;
          break;
        case 4463:
          this.autoReuse = false;
          this.useStyle = 13;
          this.useAnimation = 21;
          this.useTime = 7;
          this.reuseDelay = 14;
          this.width = 50;
          this.height = 18;
          this.shoot = 802;
          this.UseSound = SoundID.Item1;
          this.damage = 15;
          this.shootSpeed = 2.4f;
          this.noMelee = true;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 30));
          this.melee = true;
          this.knockBack = 0.5f;
          this.noUseGraphic = true;
          break;
        case 4464:
          this.DefaultToCapturedCritter((short) 616);
          this.value = Item.sellPrice(silver: 10);
          break;
        case 4465:
          this.DefaultToCapturedCritter((short) 617);
          this.value = Item.sellPrice(silver: 10);
          break;
        case 4466:
          this.DefaultToPlacableTile((ushort) 105, 79);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 60));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4467:
          this.DefaultToMount(31);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4468:
          this.DefaultToMount(32);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 4));
          break;
        case 4469:
          this.DefaultToMount(33);
          this.SetShopValues(ItemRarityColor.StrongRed10, Item.sellPrice(gold: 10));
          break;
        case 4470:
          this.DefaultToMount(34);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4471:
          this.DefaultToMount(35);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4472:
          this.DefaultToMount(36);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4473:
          this.DefaultToPlacableTile((ushort) 553, 0);
          this.maxStack = 99;
          break;
        case 4474:
          this.DefaultToPlacableTile((ushort) 554, 0);
          this.maxStack = 99;
          break;
        case 4475:
          this.DefaultToPlacableTile((ushort) 555, 0);
          this.maxStack = 99;
          break;
        case 4476:
          this.DefaultToPlacableTile((ushort) 556, 0);
          this.maxStack = 99;
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          break;
        case 4477:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 257;
          this.buffTime = 10800;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4478:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 257;
          this.buffTime = 18000;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 5));
          break;
        case 4479:
          this.UseSound = SoundID.Item3;
          this.useStyle = 9;
          this.useTurn = true;
          this.useAnimation = 17;
          this.useTime = 17;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.buffType = 257;
          this.buffTime = 36000;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 25));
          break;
        case 4480:
          this.DefaultToCapturedCritter((short) 626);
          this.value = Item.sellPrice(silver: 15);
          break;
        case 4481:
          this.DefaultToPlacableTile((ushort) 558, 0);
          this.maxStack = 99;
          break;
        case 4482:
          this.DefaultToCapturedCritter((short) 627);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          break;
        case 4483:
          this.DefaultToPlacableTile((ushort) 559, 0);
          this.value = Item.sellPrice(gold: 10);
          this.rare = 3;
          this.maxStack = 99;
          break;
        case 4484:
        case 4485:
          this.mech = true;
          this.noWet = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 144;
          this.placeStyle = type - 4484 + 3;
          this.width = 10;
          this.height = 12;
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(gold: 2));
          break;
        case 4486:
        case 4487:
        case 4488:
        case 4489:
        case 4490:
        case 4491:
        case 4492:
        case 4493:
        case 4494:
        case 4495:
        case 4496:
        case 4497:
        case 4498:
        case 4499:
        case 4500:
        case 4501:
        case 4502:
        case 4503:
          this.DefaultToPlacableWall((ushort) (246 + type - 4486));
          break;
        case 4504:
        case 4505:
          this.DefaultToPlacableWall((ushort) (264 + type - 4504));
          this.value = 250;
          break;
        case 4506:
        case 4507:
          this.DefaultToPlacableWall((ushort) (266 + type - 4506));
          break;
        case 4508:
          this.DefaultToPlacableWall((ushort) (268 + type - 4508));
          this.value = 250;
          break;
        case 4509:
        case 4510:
        case 4511:
          this.DefaultToPlacableWall((ushort) (269 + type - 4509));
          break;
        case 4512:
          this.DefaultToPlacableWall((ushort) 274);
          break;
        case 4513:
        case 4514:
        case 4515:
        case 4516:
        case 4517:
        case 4518:
        case 4519:
        case 4520:
        case 4521:
        case 4522:
        case 4523:
        case 4524:
        case 4525:
        case 4526:
        case 4527:
        case 4528:
        case 4529:
        case 4530:
        case 4531:
        case 4532:
        case 4533:
        case 4534:
        case 4535:
        case 4536:
        case 4537:
        case 4538:
        case 4539:
        case 4540:
          this.DefaultToPlacableWall((ushort) (276 + type - 4513));
          break;
        case 4541:
        case 4542:
        case 4543:
        case 4544:
        case 4545:
        case 4546:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 288 + (type - 4541);
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          this.rare = 1;
          break;
        case 4547:
          this.DefaultToPlacableTile((ushort) 563, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(copper: 20));
          break;
        case 4548:
          this.DefaultToPlacableWall((ushort) 313);
          break;
        case 4549:
          this.width = 18;
          this.height = 18;
          this.headSlot = 223;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4550:
          this.DefaultToVanitypet(825, 262);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(1));
          break;
        case 4551:
          this.DefaultToVanitypet(821, 261);
          break;
        case 4552:
          this.DefaultToPlacableTile((ushort) 565, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 4));
          break;
        case 4553:
          this.DefaultToPlacableTile((ushort) 564, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4554:
          this.DefaultToPlacableTile((ushort) 561, 0);
          break;
        case 4555:
          this.width = 18;
          this.height = 18;
          this.headSlot = 227;
          this.rare = 0;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4556:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 216;
          this.rare = 0;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4557:
          this.width = 18;
          this.height = 18;
          this.legSlot = 190;
          this.rare = 0;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4558:
          this.width = 18;
          this.height = 18;
          this.headSlot = 228;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 2);
          break;
        case 4559:
          this.width = 18;
          this.height = 18;
          this.headSlot = 229;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 2);
          break;
        case 4560:
          this.width = 18;
          this.height = 18;
          this.headSlot = 224;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4561:
          this.width = 18;
          this.height = 18;
          this.headSlot = 225;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4562:
          this.width = 18;
          this.height = 18;
          this.headSlot = 226;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4563:
          this.DefaultToAccessory(18, 18);
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          this.canBePlacedInVanityRegardlessOfConditions = true;
          break;
        case 4564:
          this.DefaultToPlacableTile((ushort) 562, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 1));
          break;
        case 4565:
          this.DefaultToPlacableWall((ushort) 312);
          break;
        case 4566:
          this.DefaultToPlacableTile((ushort) 90, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4567:
          this.DefaultToPlacableTile((ushort) 79, 39);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 28;
          this.height = 20;
          break;
        case 4568:
          this.DefaultToPlacableTile((ushort) 101, 40);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4569:
          this.DefaultToPlacableTile((ushort) 88, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4570:
          this.DefaultToPlacableTile((ushort) 100, 39);
          this.SetShopValues(ItemRarityColor.White0, 1500);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4571:
          this.DefaultToPlacableTile((ushort) 33, 38);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.maxStack = 99;
          this.width = 8;
          this.height = 18;
          this.value = Item.sellPrice(copper: 60);
          this.noWet = true;
          break;
        case 4572:
          this.DefaultToPlacableTile((ushort) 15, 44);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 30;
          break;
        case 4573:
          this.DefaultToPlacableTile((ushort) 34, 45);
          this.SetShopValues(ItemRarityColor.White0, 2000);
          this.maxStack = 99;
          this.width = 26;
          this.height = 26;
          break;
        case 4574:
          this.DefaultToPlacableTile((ushort) 467, 11);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4575:
          this.DefaultToPlacableTile((ushort) 104, 40);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4576:
          this.DefaultToPlacableTile((ushort) 10, 45);
          this.SetShopValues(ItemRarityColor.White0, 200);
          this.maxStack = 99;
          this.width = 14;
          this.height = 28;
          break;
        case 4577:
          this.DefaultToPlacableTile((ushort) 93, 39);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 10;
          this.height = 24;
          break;
        case 4578:
          this.DefaultToPlacableTile((ushort) 42, 45);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 12;
          this.height = 28;
          break;
        case 4579:
          this.DefaultToPlacableTile((ushort) 87, 39);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4580:
          this.DefaultToPlacableTile((ushort) 19, 44);
          this.SetShopValues(ItemRarityColor.White0, 0);
          this.width = 8;
          this.height = 10;
          break;
        case 4581:
          this.DefaultToPlacableTile((ushort) 172, 40);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4582:
          this.DefaultToPlacableTile((ushort) 89, 42);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4583:
          this.DefaultToPlacableTile((ushort) 469, 8);
          this.SetShopValues(ItemRarityColor.White0, 300);
          this.maxStack = 99;
          this.width = 26;
          this.height = 20;
          break;
        case 4584:
          this.DefaultToPlacableTile((ushort) 18, 40);
          this.SetShopValues(ItemRarityColor.White0, 150);
          this.maxStack = 99;
          this.width = 28;
          this.height = 14;
          break;
        case 4585:
          this.DefaultToPlacableTile((ushort) 468, 11);
          this.SetShopValues(ItemRarityColor.White0, 500);
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4586:
          this.DefaultToPlacableTile((ushort) 497, 38);
          this.maxStack = 99;
          this.value = 150;
          break;
        case 4587:
        case 4588:
        case 4589:
        case 4590:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 10));
          break;
        case 4591:
        case 4592:
        case 4593:
        case 4594:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 10));
          break;
        case 4595:
        case 4596:
        case 4597:
        case 4598:
          this.DefaultToGolfClub(20, 20);
          this.SetShopValues(ItemRarityColor.LightRed4, Item.buyPrice(gold: 25));
          break;
        case 4599:
        case 4600:
        case 4601:
          this.DefaultToPlacableTile((ushort) 560, type - 4599);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 1));
          this.maxStack = 99;
          break;
        case 4602:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 294;
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          this.rare = 1;
          break;
        case 4603:
          this.DefaultToVanitypet(815, 258);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(1));
          break;
        case 4604:
          this.DefaultToVanitypet(816, 259);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(1));
          break;
        case 4605:
          this.DefaultToVanitypet(817, 260);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(1));
          break;
        case 4606:
          this.DefaultToMusicBox(51);
          break;
        case 4607:
          this.mana = 10;
          this.damage = 33;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 831;
          this.buffType = 263;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item113;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 8;
          this.noMelee = true;
          this.knockBack = 4f;
          this.value = Item.sellPrice(gold: 20);
          this.summon = true;
          break;
        case 4608:
          this.useStyle = 1;
          this.shootSpeed = 7f;
          this.shoot = 820;
          this.width = 18;
          this.height = 20;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 19;
          this.useTime = 19;
          this.noMelee = true;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 5));
          break;
        case 4609:
          this.DefaultToPlacableTile((ushort) 567, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 1));
          break;
        case 4610:
          this.DefaultTokite(822);
          break;
        case 4611:
          this.DefaultTokite(823);
          break;
        case 4612:
          this.DefaultTokite(824);
          break;
        case 4613:
          this.DefaultTokite(826);
          break;
        case 4626:
        case 4627:
        case 4628:
        case 4629:
        case 4630:
        case 4631:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 63 + (type - 4626);
          break;
        case 4632:
        case 4633:
        case 4634:
        case 4635:
        case 4636:
        case 4637:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 37 + (type - 4632);
          break;
        case 4638:
        case 4639:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 245;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 10);
          this.placeStyle = 7 + (type - 4638);
          break;
        case 4640:
          this.DefaultToPlacableTile((ushort) 67, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4641:
          this.DefaultToPlacableTile((ushort) 66, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4642:
          this.DefaultToPlacableTile((ushort) 63, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4643:
          this.DefaultToPlacableTile((ushort) 65, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4644:
          this.DefaultToPlacableTile((ushort) 64, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4645:
          this.DefaultToPlacableTile((ushort) 68, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4646:
          this.DefaultToPlacableTile((ushort) 566, 0);
          this.SetShopValues(ItemRarityColor.White0, Item.sellPrice(silver: 1));
          break;
        case 4647:
          this.DefaultToPlacableWall((ushort) 314);
          break;
        case 4648:
        case 4649:
        case 4650:
        case 4651:
          this.DefaultTokite(827 + (type - 4648));
          break;
        case 4652:
          this.width = 18;
          this.height = 18;
          this.headSlot = 230;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4653:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 217;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4654:
          this.width = 18;
          this.height = 18;
          this.legSlot = 191;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4655:
          this.DefaultToPlacableTile((ushort) 568, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4656:
          this.DefaultToPlacableTile((ushort) 569, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4657:
          this.DefaultToPlacableTile((ushort) 570, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          break;
        case 4658:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 43;
          break;
        case 4659:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 245;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 9;
          break;
        case 4660:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 69;
          break;
        case 4661:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 246;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 19;
          break;
        case 4662:
        case 4663:
        case 4778:
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.value = Item.sellPrice(gold: 1, silver: 50);
          this.rare = 3;
          break;
        case 4664:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 218;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 20);
          break;
        case 4665:
          this.width = 18;
          this.height = 18;
          this.legSlot = 193;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 20);
          break;
        case 4666:
          this.width = 18;
          this.height = 18;
          this.headSlot = 232;
          this.rare = 3;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 15);
          break;
        case 4667:
          this.DefaultToPlacableWall((ushort) 315);
          break;
        case 4668:
          this.paint = (byte) 31;
          this.width = 24;
          this.height = 24;
          this.value = Item.buyPrice(silver: 2);
          this.maxStack = 999;
          break;
        case 4669:
          this.DefaultTokite(838);
          break;
        case 4670:
          this.DefaultTokite(839);
          break;
        case 4671:
          this.DefaultTokite(840);
          break;
        case 4672:
          this.DefaultToWhip(841, 14, 0.5f, 4f);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 15));
          break;
        case 4673:
          this.autoReuse = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 12;
          this.useTime = 12;
          this.width = 16;
          this.height = 16;
          this.scale = 1f;
          this.value = Item.buyPrice(silver: 50);
          break;
        case 4674:
          this.DefaultTokite(843);
          break;
        case 4675:
          this.DefaultTokite(844);
          break;
        case 4676:
          this.DefaultTokite(845);
          this.value = Item.buyPrice(gold: 2);
          break;
        case 4677:
          this.DefaultTokite(846);
          break;
        case 4678:
          this.DefaultToWhip(847, 55, 2f, 4f);
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 4, silver: 60));
          break;
        case 4679:
          this.DefaultToWhip(848, 180, 11f, 4f, 45);
          this.SetShopValues(ItemRarityColor.Yellow8, Item.sellPrice(gold: 6));
          this.crit = 10;
          break;
        case 4680:
          this.DefaultToWhip(849, 100, 3f, 4f);
          this.SetShopValues(ItemRarityColor.Yellow8, Item.sellPrice(gold: 10));
          break;
        case 4681:
          this.DefaultTokite(850);
          this.value = Item.buyPrice(gold: 2);
          break;
        case 4682:
          this.width = 20;
          this.height = 24;
          this.DefaultToThrownWeapon(851, 25, 4f);
          this.value = Item.buyPrice(silver: 1);
          this.ranged = false;
          this.noUseGraphic = true;
          break;
        case 4683:
          this.DefaultTokite(852);
          break;
        case 4684:
          this.DefaultTokite(853);
          break;
        case 4685:
          this.width = 18;
          this.height = 18;
          this.headSlot = 231;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4686:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 219;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4687:
        case 4688:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 295 + (type - 4687);
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          this.rare = 1;
          break;
        case 4689:
        case 4690:
        case 4691:
        case 4692:
        case 4693:
        case 4694:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 215;
          this.placeStyle = 8 + type - 4689;
          this.width = 12;
          this.height = 12;
          break;
        case 4695:
        case 4696:
        case 4697:
        case 4698:
        case 4699:
        case 4700:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 572;
          this.placeStyle = type - 4695;
          this.width = 12;
          this.height = 28;
          if (type >= 4695 && type <= 4697)
          {
            this.value = 1000;
            break;
          }
          this.value = 40000;
          break;
        case 4701:
          this.DefaultToVanitypet(854, 264);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 50));
          break;
        case 4702:
          this.width = 20;
          this.height = 24;
          this.DefaultToThrownWeapon(855, 25, 4f);
          this.value = Item.buyPrice(silver: 1);
          this.ranged = false;
          this.noUseGraphic = true;
          break;
        case 4703:
          this.DefaultToRangedWeapon(14, AmmoID.Bullet, 45, 7f);
          this.knockBack = 6.5f;
          this.width = 50;
          this.height = 14;
          this.UseSound = SoundID.Item36;
          this.damage = 24;
          this.value = Item.buyPrice(gold: 35);
          this.rare = 3;
          break;
        case 4704:
          this.width = 18;
          this.height = 18;
          this.headSlot = 233;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4705:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 220;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4706:
          this.width = 18;
          this.height = 18;
          this.legSlot = 197;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4707:
          this.width = 44;
          this.height = 44;
          this.rare = 2;
          this.value = Item.buyPrice(gold: 10);
          this.holdStyle = 2;
          this.useStyle = 3;
          this.useAnimation = 22;
          this.useTime = 22;
          this.damage = 15;
          this.knockBack = 5f;
          this.UseSound = SoundID.Item1;
          this.melee = true;
          break;
        case 4708:
          this.width = 18;
          this.height = 18;
          this.headSlot = 234;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4709:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 221;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 10);
          break;
        case 4710:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 999;
          this.consumable = true;
          this.createTile = 573;
          this.width = 28;
          this.height = 28;
          break;
        case 4711:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 22;
          this.useTime = 14;
          this.autoReuse = true;
          this.width = 24;
          this.height = 28;
          this.damage = 12;
          this.UseSound = SoundID.Item1;
          this.knockBack = 3.5f;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 10);
          this.melee = true;
          break;
        case 4712:
          this.DefaultToPlacableTile((ushort) 467, 12);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 25));
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4713:
          this.DefaultToPlacableTile((ushort) 468, 12);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 5));
          this.maxStack = 99;
          this.width = 26;
          this.height = 22;
          break;
        case 4714:
          this.width = 14;
          this.height = 20;
          this.maxStack = 99;
          this.rare = 8;
          break;
        case 4715:
          this.SetShopValues(ItemRarityColor.Pink5, Item.buyPrice(gold: 50));
          this.DefaultToGuitar();
          this.useAnimation = this.useTime = 12;
          this.useTime /= 2;
          this.shoot = 856;
          this.damage = 75;
          this.magic = true;
          this.shootSpeed = 1f;
          this.crit = 20;
          this.mana = 12;
          this.noMelee = true;
          break;
        case 4716:
          this.useStyle = 4;
          this.channel = true;
          this.width = 34;
          this.height = 34;
          this.UseSound = SoundID.Item43;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.mountType = 37;
          this.value = Item.buyPrice(gold: 20);
          break;
        case 4717:
        case 4718:
        case 4719:
        case 4720:
        case 4721:
          this.DefaultToPlacableTile(574 + type - 4717);
          break;
        case 4722:
          this.useStyle = 5;
          this.width = 24;
          this.height = 24;
          this.noUseGraphic = true;
          this.UseSound = SoundID.Item1;
          this.autoReuse = true;
          this.melee = true;
          this.channel = true;
          this.noMelee = true;
          this.shoot = 857;
          this.useAnimation = 35;
          this.useTime = this.useAnimation / 5;
          this.shootSpeed = 16f;
          this.damage = 190;
          this.knockBack = 6.5f;
          this.value = Item.sellPrice(gold: 20);
          this.crit = 10;
          this.rare = 10;
          this.glowMask = (short) 271;
          break;
        case 4723:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 70;
          break;
        case 4724:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 71;
          break;
        case 4725:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 242;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 44;
          break;
        case 4726:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 245;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 10;
          break;
        case 4727:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 245;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 11;
          break;
        case 4728:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 245;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 12;
          break;
        case 4729:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 246;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(silver: 20);
          this.placeStyle = 20;
          break;
        case 4730:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 40;
          this.value = 400000;
          break;
        case 4731:
          this.DefaultToPlacableTile((ushort) 497, 39);
          this.maxStack = 99;
          this.value = 150;
          this.rare = 8;
          break;
        case 4732:
          this.width = 18;
          this.height = 18;
          this.headSlot = 235;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4733:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 222;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4734:
          this.width = 18;
          this.height = 18;
          this.legSlot = 203;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4735:
          this.DefaultToVanitypet(858, 266);
          this.value = Item.buyPrice(gold: 50);
          break;
        case 4736:
          this.DefaultToVanitypet(859, 267);
          this.value = Item.buyPrice(gold: 30);
          break;
        case 4737:
          this.DefaultToVanitypet(860, 268);
          break;
        case 4738:
          this.width = 18;
          this.height = 18;
          this.headSlot = 236;
          this.rare = 2;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4739:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 223;
          this.rare = 2;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4740:
          this.width = 18;
          this.height = 18;
          this.headSlot = 237;
          this.rare = 2;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4741:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 224;
          this.rare = 2;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4742:
          this.width = 18;
          this.height = 18;
          this.legSlot = 205;
          this.rare = 2;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4743:
          this.useStyle = 1;
          this.shootSpeed = 11f;
          this.shoot = 861;
          this.damage = 0;
          this.width = 10;
          this.height = 10;
          this.maxStack = 1;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.noMelee = true;
          this.value = 20;
          break;
        case 4744:
          this.DefaultToAccessory(26, 36);
          this.backSlot = (sbyte) 24;
          this.frontSlot = (sbyte) 8;
          this.SetShopValues(ItemRarityColor.Pink5, Item.sellPrice(gold: 3));
          this.vanity = true;
          break;
        case 4745:
          this.DefaultToMount(38);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 2));
          break;
        case 4746:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 41;
          this.value = 400000;
          break;
        case 4747:
          this.width = 18;
          this.height = 18;
          this.headSlot = 238;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4748:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 225;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4749:
          this.width = 18;
          this.height = 18;
          this.legSlot = 208;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4750:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 42;
          this.value = 400000;
          break;
        case 4751:
          this.width = 18;
          this.height = 18;
          this.headSlot = 239;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4752:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 226;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4753:
          this.width = 18;
          this.height = 18;
          this.legSlot = 209;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4754:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 43;
          this.value = 400000;
          break;
        case 4755:
          this.width = 18;
          this.height = 18;
          this.headSlot = 240;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4756:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 227;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4757:
          this.width = 18;
          this.height = 18;
          this.legSlot = 210;
          this.rare = 9;
          this.vanity = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4758:
          this.mana = 10;
          this.damage = 6;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 864;
          this.buffType = 271;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item113;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 5;
          this.noMelee = true;
          this.knockBack = 0.0f;
          this.value = Item.sellPrice(gold: 1);
          this.summon = true;
          break;
        case 4759:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 11.5f;
          this.shoot = 865;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 1;
          this.noMelee = true;
          this.value = 20000;
          break;
        case 4760:
          this.damage = 60;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 866;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 5;
          this.noMelee = true;
          this.value = Item.buyPrice(gold: 35);
          this.melee = true;
          this.noUseGraphic = true;
          break;
        case 4761:
          this.width = 12;
          this.height = 12;
          this.headSlot = 241;
          this.rare = 3;
          this.vanity = true;
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 579;
          break;
        case 4762:
          this.width = 24;
          this.height = 24;
          this.accessory = true;
          this.vanity = true;
          this.rare = 1;
          this.value = Item.buyPrice(gold: 10);
          this.canBePlacedInVanityRegardlessOfConditions = true;
          break;
        case 4763:
          this.DefaultToMount(39);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 50));
          break;
        case 4764:
          this.noMelee = true;
          this.useStyle = 1;
          this.shootSpeed = 10.5f;
          this.shoot = 867;
          this.damage = 14;
          this.knockBack = 7f;
          this.width = 14;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.rare = 1;
          this.value = 30000;
          this.melee = true;
          break;
        case 4765:
        case 4766:
          this.DefaultToThrownWeapon(type - 4765 + 868, 20, 8f);
          this.UseSound = SoundID.Item106;
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 3));
          break;
        case 4767:
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 5));
          this.width = 30;
          this.height = 30;
          break;
        case 4768:
          this.width = 18;
          this.height = 18;
          this.headSlot = 242;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4769:
          this.DefaultToAccessory(18, 18);
          this.backSlot = (sbyte) 25;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4770:
          this.width = 18;
          this.height = 18;
          this.headSlot = 243;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4771:
          this.DefaultToAccessory(18, 18);
          this.backSlot = (sbyte) 26;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4772:
          this.width = 18;
          this.height = 18;
          this.headSlot = 244;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4773:
          this.DefaultToAccessory(18, 18);
          this.backSlot = (sbyte) 27;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4774:
          this.width = 18;
          this.height = 18;
          this.headSlot = 245;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.sellPrice(silver: 50);
          break;
        case 4775:
          this.DefaultToAccessory(18, 18);
          this.backSlot = (sbyte) 28;
          this.rare = 1;
          this.vanity = true;
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4776:
          this.color = new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
          this.useStyle = 1;
          this.shootSpeed = 6f;
          this.shoot = 870;
          this.width = 12;
          this.height = 12;
          this.maxStack = 999;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noMelee = true;
          this.rare = 1;
          this.value = Item.buyPrice(copper: 75);
          this.holdStyle = 1;
          break;
        case 4777:
          this.DefaultToVanitypet(875, 274);
          this.value = Item.buyPrice(gold: 50);
          break;
        case 4779:
          this.width = 18;
          this.height = 18;
          this.headSlot = 250;
          this.rare = 1;
          this.vanity = true;
          break;
        case 4780:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 228;
          this.rare = 1;
          this.vanity = true;
          break;
        case 4781:
          this.width = 18;
          this.height = 18;
          this.legSlot = 211;
          this.rare = 1;
          this.vanity = true;
          break;
        case 4782:
          this.maxStack = 999;
          this.consumable = true;
          this.width = 24;
          this.height = 24;
          this.rare = 6;
          this.expert = true;
          break;
        case 4783:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.rare = 1;
          this.placeStyle = 72;
          break;
        case 4784:
          this.width = 18;
          this.height = 18;
          this.headSlot = 251;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 75);
          this.vanity = true;
          break;
        case 4785:
        case 4786:
        case 4787:
          this.useStyle = 4;
          this.channel = true;
          this.width = 34;
          this.height = 34;
          this.UseSound = SoundID.Item76;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.mountType = 40 + (type - 4785);
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4788:
          this.DefaultToSpear(877, 3.5f, 24);
          this.SetWeaponValues(56, 12f);
          this.SetShopValues(ItemRarityColor.LightRed4, Item.buyPrice(gold: 6));
          this.channel = true;
          break;
        case 4789:
          this.DefaultToSpear(878, 3.5f, 24);
          this.SetWeaponValues(108, 14f);
          this.SetShopValues(ItemRarityColor.Yellow8, Item.sellPrice(gold: 10));
          this.channel = true;
          break;
        case 4790:
          this.DefaultToSpear(879, 3.5f, 24);
          this.SetWeaponValues(78, 13f);
          this.SetShopValues(ItemRarityColor.Pink5, 230000);
          this.channel = true;
          break;
        case 4791:
          this.useStyle = 4;
          this.channel = true;
          this.width = 10;
          this.height = 32;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.mountType = 43;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4792:
        case 4793:
        case 4794:
        case 4795:
        case 4796:
          this.useStyle = 4;
          this.channel = true;
          this.width = 10;
          this.height = 32;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = -13;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.mountType = 44 + type - 4792;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4797:
        case 4798:
        case 4799:
        case 4800:
        case 4801:
        case 4802:
        case 4803:
        case 4804:
        case 4805:
        case 4806:
        case 4807:
        case 4808:
        case 4809:
        case 4810:
        case 4811:
        case 4812:
        case 4813:
        case 4814:
        case 4815:
        case 4816:
        case 4817:
          this.DefaultToVanitypet(881 + type - 4797, 284 + type - 4797);
          this.value = Item.buyPrice(gold: 25);
          this.rare = -13;
          break;
        case 4818:
          this.noMelee = true;
          this.useStyle = 1;
          this.shootSpeed = 8.5f;
          this.shoot = 902;
          this.damage = 25;
          this.knockBack = 3.5f;
          this.width = 14;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.rare = 2;
          this.value = Item.sellPrice(silver: 50);
          this.melee = true;
          break;
        case 4819:
          this.useTurn = true;
          this.width = 20;
          this.height = 20;
          this.useStyle = 4;
          this.useTime = 90;
          this.UseSound = SoundID.Item6;
          this.useAnimation = 90;
          this.SetShopValues(ItemRarityColor.LightRed4, Item.buyPrice(gold: 5));
          break;
        case 4820:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 12;
          this.useTime = 5;
          this.width = 20;
          this.height = 20;
          this.autoReuse = true;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 10);
          this.tileBoost += 2;
          break;
        case 4821:
          this.useTurn = true;
          this.useStyle = 1;
          this.useAnimation = 21;
          this.width = 24;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.value = Item.sellPrice(gold: 5);
          this.autoReuse = true;
          this.rare = 3;
          this.scale = 0.85f;
          break;
        case 4822:
          this.DefaultToAccessory(34, 30);
          this.shoeSlot = (sbyte) 22;
          this.SetShopValues(ItemRarityColor.Orange3, Item.sellPrice(gold: 2));
          this.vanity = true;
          break;
        case 4823:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 44;
          this.value = Item.buyPrice(gold: 40);
          break;
        case 4824:
        case 4825:
        case 4826:
        case 4827:
          this.useStyle = 1;
          this.shootSpeed = 5f;
          this.shoot = 903 + (type - 4824);
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.UseSound = SoundID.Item1;
          this.consumable = true;
          this.useAnimation = 25;
          this.noUseGraphic = true;
          this.useTime = 25;
          this.value = Item.sellPrice(silver: 5);
          this.rare = 1;
          break;
        case 4828:
          this.useStyle = 4;
          this.channel = true;
          this.width = 10;
          this.height = 32;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.mountType = 49;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4829:
        case 4830:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.UseSound = SoundID.Item92;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 5));
          break;
        case 4831:
        case 4832:
        case 4833:
        case 4834:
        case 4835:
        case 4836:
        case 4837:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.noUseGraphic = true;
          this.value = Item.sellPrice(silver: 10);
          this.makeNPC = (short) (639 + (type - 4831));
          break;
        case 4838:
        case 4839:
        case 4840:
        case 4841:
        case 4842:
        case 4843:
        case 4844:
          this.useStyle = 1;
          this.autoReuse = true;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.maxStack = 999;
          this.consumable = true;
          this.width = 12;
          this.height = 12;
          this.noUseGraphic = true;
          this.value = Item.sellPrice(silver: 10);
          this.makeNPC = (short) (646 + (type - 4838));
          break;
        case 4845:
          this.DefaultToCapturedCritter((short) 653);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 20));
          this.width = 12;
          this.height = 12;
          this.bait = 15;
          break;
        case 4846:
          this.DefaultToPlacableTile((ushort) 580, 0);
          this.maxStack = 99;
          break;
        case 4847:
          this.DefaultToCapturedCritter((short) 654);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 20));
          this.width = 12;
          this.height = 12;
          this.bait = 25;
          break;
        case 4848:
          this.DefaultToPlacableTile((ushort) 581, 0);
          this.maxStack = 99;
          break;
        case 4849:
          this.DefaultToCapturedCritter((short) 655);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 50));
          this.width = 12;
          this.height = 12;
          this.bait = 35;
          break;
        case 4850:
          this.DefaultToPlacableTile((ushort) 582, 0);
          this.maxStack = 99;
          break;
        case 4851:
          this.DefaultToPlacableTile((ushort) 590, 0);
          this.value = Item.sellPrice(silver: 7, copper: 50);
          break;
        case 4852:
          this.DefaultToPlacableTile((ushort) 590, 1);
          this.value = Item.sellPrice(silver: 3, copper: 75);
          break;
        case 4853:
          this.DefaultToPlacableTile((ushort) 590, 2);
          this.value = Item.sellPrice(silver: 11, copper: 25);
          break;
        case 4854:
          this.DefaultToPlacableTile((ushort) 590, 3);
          this.value = Item.sellPrice(silver: 15);
          break;
        case 4855:
          this.DefaultToPlacableTile((ushort) 590, 4);
          this.value = Item.sellPrice(silver: 22, copper: 50);
          break;
        case 4856:
          this.DefaultToPlacableTile((ushort) 590, 5);
          this.value = Item.sellPrice(silver: 30);
          break;
        case 4857:
          this.DefaultToPlacableTile((ushort) 590, 6);
          this.value = Item.sellPrice(silver: 30);
          break;
        case 4858:
        case 4859:
        case 4860:
        case 4861:
        case 4862:
        case 4863:
        case 4864:
        case 4865:
        case 4866:
          this.DefaultToPlacableTile((ushort) 591, type - 4858);
          this.value = Item.sellPrice(silver: 25);
          break;
        case 4867:
          this.DefaultToPlacableTile((ushort) 592, 0);
          this.value = Item.sellPrice(silver: 25);
          break;
        case 4868:
        case 4869:
          this.DefaultToPlacableTile(593 + (type - 4868));
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4870:
          this.UseSound = SoundID.Item6;
          this.useStyle = 6;
          this.useTurn = true;
          this.useTime = this.useAnimation = 30;
          this.maxStack = 30;
          this.consumable = true;
          this.width = 14;
          this.height = 24;
          this.value = 1000;
          this.rare = 1;
          break;
        case 4871:
          this.DefaultToPlacableTile((ushort) 595, 0);
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4872:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 12;
          this.useTime = 5;
          this.width = 20;
          this.height = 20;
          this.autoReuse = true;
          this.rare = 7;
          this.value = Item.sellPrice(gold: 10);
          this.tileBoost += 2;
          break;
        case 4873:
          this.width = 18;
          this.height = 18;
          this.defense = 1;
          this.headSlot = 254;
          this.rare = 5;
          this.value = 250000;
          break;
        case 4874:
          this.DefaultToAccessory(34, 30);
          this.shoeSlot = (sbyte) 23;
          this.SetShopValues(ItemRarityColor.Lime7, Item.sellPrice(gold: 12));
          this.canBePlacedInVanityRegardlessOfConditions = true;
          break;
        case 4875:
          this.DefaultToPlacableTile((ushort) 597, 1);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4876:
          this.DefaultToPlacableTile((ushort) 597, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4877:
        case 4878:
          this.DefaultToPlacableTile((ushort) 376, 22 + type - 4877);
          this.SetShopValues(ItemRarityColor.Green2, Item.sellPrice(gold: 1));
          this.maxStack = 99;
          break;
        case 4879:
          this.width = 12;
          this.height = 12;
          this.rare = 2;
          this.maxStack = 99;
          this.value = Item.buyPrice(gold: 2);
          break;
        case 4880:
          this.DefaultToPlacableTile((ushort) 598, 0);
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          this.value = Item.sellPrice(silver: 20);
          break;
        case 4881:
          this.DefaultToAccessory(34, 30);
          this.SetShopValues(ItemRarityColor.Lime7, Item.sellPrice(gold: 2));
          break;
        case 4882:
        case 4883:
        case 4884:
        case 4885:
        case 4886:
        case 4887:
        case 4888:
        case 4889:
        case 4890:
        case 4891:
        case 4892:
        case 4893:
        case 4894:
        case 4895:
          this.DefaultToPlacableTile(599 + (type - 4882));
          this.maxStack = 99;
          break;
        case 4896:
          this.width = 18;
          this.height = 18;
          this.defense = 24;
          this.headSlot = (int) byte.MaxValue;
          this.rare = 5;
          this.value = 250000;
          break;
        case 4897:
          this.width = 18;
          this.height = 18;
          this.defense = 9;
          this.headSlot = 256;
          this.rare = 5;
          this.value = 250000;
          break;
        case 4898:
          this.width = 18;
          this.height = 18;
          this.defense = 5;
          this.headSlot = 257;
          this.rare = 5;
          this.value = 250000;
          break;
        case 4899:
          this.width = 18;
          this.height = 18;
          this.defense = 1;
          this.headSlot = 258;
          this.rare = 5;
          this.value = 250000;
          break;
        case 4900:
          this.width = 18;
          this.height = 18;
          this.defense = 15;
          this.bodySlot = 229;
          this.rare = 5;
          this.value = 200000;
          break;
        case 4901:
          this.width = 18;
          this.height = 18;
          this.defense = 11;
          this.legSlot = 212;
          this.rare = 5;
          this.value = 150000;
          break;
        case 4902:
          this.DefaultToPlacableTile((ushort) 548, 7);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 3));
          break;
        case 4903:
          this.DefaultToPlacableTile((ushort) 548, 8);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 3));
          break;
        case 4904:
          this.DefaultToPlacableTile((ushort) 613, 0);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 3));
          break;
        case 4905:
          this.DefaultToPlacableTile((ushort) 613, 1);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 3));
          break;
        case 4906:
          this.DefaultToPlacableTile((ushort) 614, 0);
          this.SetShopValues(ItemRarityColor.Orange3, Item.buyPrice(gold: 3));
          break;
        case 4907:
          this.DefaultToPlacableTile((ushort) 615, 0);
          this.value = Item.buyPrice(gold: 3);
          break;
        case 4908:
        case 4909:
          this.useStyle = 1;
          this.shootSpeed = 5f;
          this.shoot = 910 + (type - 4908);
          this.width = 20;
          this.height = 20;
          this.maxStack = 99;
          this.UseSound = SoundID.Item1;
          this.consumable = true;
          this.useAnimation = 25;
          this.noUseGraphic = true;
          this.useTime = 25;
          this.value = Item.sellPrice(silver: 1);
          this.rare = 1;
          break;
        case 4910:
          this.useStyle = 4;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.UseSound = SoundID.Item92;
          this.width = 28;
          this.height = 28;
          this.maxStack = 20;
          this.SetShopValues(ItemRarityColor.Green2, Item.buyPrice(gold: 5));
          break;
        case 4911:
          this.DefaultToWhip(912, 50, 1.5f, 4f);
          this.SetShopValues(ItemRarityColor.LightRed4, Item.sellPrice(gold: 4));
          break;
        case 4912:
          this.DefaultToWhip(913, 40, 2f, 4f);
          this.SetShopValues(ItemRarityColor.LightRed4, Item.sellPrice(gold: 3));
          break;
        case 4913:
          this.DefaultToWhip(914, 18, 1f, 4f);
          this.SetShopValues(ItemRarityColor.Orange3, Item.sellPrice(gold: 1));
          break;
        case 4914:
          this.DefaultToWhip(915, 165, 4f, 4f);
          this.SetShopValues(ItemRarityColor.Yellow8, Item.sellPrice(gold: 5));
          break;
        case 4915:
          this.shootSpeed = 4.5f;
          this.shoot = 14;
          this.damage = 9;
          this.width = 8;
          this.height = 8;
          this.maxStack = 999;
          this.consumable = true;
          this.ammo = AmmoID.Bullet;
          this.knockBack = 4f;
          this.value = 18;
          this.ranged = true;
          break;
        case 4916:
          this.DefaultToPlacableTile((ushort) 597, 2);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4917:
          this.DefaultToPlacableTile((ushort) 597, 3);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4918:
          this.DefaultToPlacableTile((ushort) 597, 4);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4919:
          this.DefaultToPlacableTile((ushort) 597, 5);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4920:
          this.DefaultToPlacableTile((ushort) 597, 6);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4921:
          this.DefaultToPlacableTile((ushort) 597, 7);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 10));
          break;
        case 4922:
          this.DefaultToPlacableTile((ushort) 207, 8);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 4));
          this.width = 8;
          this.height = 10;
          break;
        case 4923:
          this.width = 14;
          this.height = 38;
          this.rare = 8;
          this.noUseGraphic = true;
          this.channel = true;
          this.noMelee = true;
          this.damage = 70;
          this.knockBack = 4f;
          this.autoReuse = false;
          this.noMelee = true;
          this.melee = true;
          this.shoot = 927;
          this.shootSpeed = 15f;
          this.value = Item.sellPrice(gold: 5);
          this.useStyle = 13;
          this.useAnimation = 18;
          this.useTime = 6;
          break;
        case 4924:
        case 4925:
        case 4926:
        case 4927:
        case 4928:
        case 4929:
        case 4930:
        case 4931:
        case 4932:
        case 4933:
        case 4934:
        case 4935:
        case 4936:
        case 4937:
        case 4938:
        case 4939:
        case 4940:
        case 4941:
        case 4942:
        case 4943:
        case 4944:
        case 4945:
        case 4946:
        case 4947:
        case 4948:
        case 4949:
        case 4950:
          this.DefaultToPlacableTile((ushort) 617, type - 4924);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 5));
          this.rare = -13;
          this.maxStack = 99;
          break;
        case 4951:
          this.DefaultToPlacableTile((ushort) 597, 8);
          this.SetShopValues(ItemRarityColor.Cyan9, Item.buyPrice(1));
          break;
        case 4952:
          this.autoReuse = true;
          this.useStyle = 14;
          this.holdStyle = 6;
          this.scale = 0.7f;
          this.useAnimation = 36;
          this.useTime = 2;
          this.width = 36;
          this.height = 22;
          this.shoot = 931;
          this.mana = 26;
          this.UseSound = SoundID.Item82;
          this.knockBack = 2.5f;
          this.damage = 50;
          this.shootSpeed = 17f;
          this.noMelee = true;
          this.rare = 8;
          this.magic = true;
          this.value = Item.sellPrice(gold: 5);
          this.flame = true;
          break;
        case 4953:
          this.useStyle = 5;
          this.autoReuse = true;
          this.useAnimation = 30;
          this.useTime = 2;
          this.width = 50;
          this.height = 18;
          this.shoot = 1;
          this.useAmmo = AmmoID.Arrow;
          this.UseSound = SoundID.Item5;
          this.damage = 50;
          this.shootSpeed = 10f;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 5);
          this.ranged = true;
          this.rare = 8;
          this.knockBack = 2f;
          break;
        case 4954:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 9;
          this.wingSlot = (sbyte) 45;
          this.value = Item.sellPrice(gold: 10);
          this.expert = true;
          break;
        case 4955:
          this.width = 18;
          this.height = 18;
          this.headSlot = 259;
          this.value = Item.buyPrice(gold: 15);
          this.rare = 5;
          this.vanity = true;
          break;
        case 4956:
          this.useStyle = 1;
          this.width = 24;
          this.height = 24;
          this.UseSound = SoundID.Item169;
          this.autoReuse = true;
          this.melee = true;
          this.melee = true;
          this.shoot = 933;
          this.useAnimation = 30;
          this.useTime = this.useAnimation / 3;
          this.shootSpeed = 16f;
          this.damage = 190;
          this.knockBack = 6.5f;
          this.value = Item.sellPrice(gold: 20);
          this.crit = 10;
          this.rare = 10;
          this.noUseGraphic = true;
          this.noMelee = true;
          break;
        case 4957:
          this.maxStack = 999;
          this.consumable = true;
          this.width = 24;
          this.height = 24;
          this.rare = 6;
          this.expert = true;
          break;
        case 4958:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 240;
          this.width = 30;
          this.height = 30;
          this.value = Item.sellPrice(gold: 1);
          this.rare = 1;
          this.placeStyle = 73;
          break;
        case 4959:
          this.width = 18;
          this.height = 18;
          this.headSlot = 260;
          this.rare = 1;
          this.value = Item.sellPrice(silver: 75);
          this.vanity = true;
          break;
        case 4960:
          this.DefaultToVanitypet(934, 317);
          this.value = Item.buyPrice(gold: 25);
          this.rare = -13;
          break;
        case 4961:
          this.DefaultToCapturedCritter((short) 661);
          this.SetShopValues(ItemRarityColor.Orange3, Item.sellPrice(gold: 5));
          this.width = 12;
          this.height = 12;
          break;
        case 4962:
          this.DefaultToPlacableTile((ushort) 618, 0);
          break;
        case 4963:
          this.DefaultToPlacableTile((ushort) 619, 0);
          this.maxStack = 99;
          break;
        case 4964:
          this.DefaultToPlacableTile((ushort) 620, 0);
          this.maxStack = 99;
          break;
        case 4965:
        case 4966:
        case 4967:
        case 4968:
        case 4969:
        case 4970:
        case 4971:
        case 4972:
        case 4973:
        case 4974:
        case 4975:
        case 4976:
        case 4977:
          this.useStyle = 1;
          this.useTurn = true;
          this.useAnimation = 15;
          this.useTime = 10;
          this.autoReuse = true;
          this.maxStack = 99;
          this.consumable = true;
          this.createTile = 91;
          this.placeStyle = 297 + (type - 4965);
          this.width = 10;
          this.height = 24;
          this.value = 1000;
          this.rare = 1;
          break;
        case 4978:
          this.width = 24;
          this.height = 8;
          this.accessory = true;
          this.rare = 0;
          this.wingSlot = (sbyte) 46;
          this.value = 2000;
          break;
        case 4979:
          this.DefaultToMusicBox(52);
          break;
        case 4980:
          this.noUseGraphic = true;
          this.damage = 0;
          this.knockBack = 7f;
          this.useStyle = 5;
          this.shootSpeed = 4f;
          this.shoot = 935;
          this.width = 18;
          this.height = 28;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 5;
          this.noMelee = true;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4981:
          this.useStyle = 4;
          this.channel = true;
          this.width = 10;
          this.height = 32;
          this.UseSound = SoundID.Item25;
          this.useAnimation = 20;
          this.useTime = 20;
          this.rare = 8;
          this.noMelee = true;
          this.noUseGraphic = true;
          this.mountType = 50;
          this.value = Item.sellPrice(gold: 5);
          break;
        case 4982:
          this.width = 18;
          this.height = 18;
          this.defense = 12;
          this.headSlot = 261;
          this.rare = 5;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4983:
          this.width = 18;
          this.height = 18;
          this.defense = 14;
          this.bodySlot = 230;
          this.rare = 5;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4984:
          this.width = 18;
          this.height = 18;
          this.defense = 10;
          this.legSlot = 213;
          this.rare = 5;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 4985:
          this.DefaultToMusicBox(53);
          break;
        case 4986:
          this.useStyle = 1;
          this.shootSpeed = 9f;
          this.shoot = 936;
          this.width = 18;
          this.height = 20;
          this.maxStack = 99;
          this.consumable = true;
          this.UseSound = SoundID.Item1;
          this.useAnimation = 15;
          this.useTime = 15;
          this.noUseGraphic = true;
          this.noMelee = true;
          this.value = 200;
          break;
        case 4987:
          this.width = 16;
          this.height = 24;
          this.accessory = true;
          this.rare = 6;
          this.value = Item.sellPrice(gold: 5);
          this.expert = true;
          break;
        case 4988:
          this.useStyle = 4;
          this.width = 20;
          this.height = 20;
          this.consumable = true;
          this.useAnimation = 45;
          this.useTime = 45;
          this.maxStack = 20;
          this.rare = 6;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4989:
          this.width = 22;
          this.height = 22;
          this.accessory = true;
          this.rare = 1;
          this.value = Item.sellPrice(gold: 10);
          this.expert = true;
          break;
        case 4990:
          this.DefaultToMusicBox(54);
          break;
        case 4991:
          this.DefaultToMusicBox(55);
          break;
        case 4992:
          this.DefaultToMusicBox(56);
          break;
        case 4993:
          this.DefaultToPlacableTile((ushort) 89, 43);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 50));
          this.maxStack = 99;
          this.width = 20;
          this.height = 20;
          this.rare = 9;
          break;
        case 4994:
          this.width = 18;
          this.height = 14;
          this.headSlot = 262;
          this.rare = 2;
          this.value = Item.buyPrice(gold: 10);
          this.vanity = true;
          break;
        case 4995:
          this.width = 18;
          this.height = 14;
          this.headSlot = 263;
          this.rare = 2;
          this.value = Item.buyPrice(gold: 10);
          this.vanity = true;
          break;
        case 4996:
          this.width = 18;
          this.height = 14;
          this.headSlot = 264;
          this.rare = 2;
          this.value = Item.buyPrice(gold: 10);
          this.vanity = true;
          break;
        case 4997:
          this.width = 18;
          this.height = 14;
          this.vanity = true;
          this.bodySlot = 231;
          this.value = Item.buyPrice(gold: 10);
          this.rare = 2;
          break;
        case 4998:
          this.width = 18;
          this.height = 14;
          this.vanity = true;
          this.bodySlot = 232;
          this.value = Item.buyPrice(gold: 10);
          this.rare = 2;
          break;
        case 4999:
          this.width = 18;
          this.height = 14;
          this.vanity = true;
          this.bodySlot = 233;
          this.value = Item.buyPrice(gold: 10);
          this.rare = 2;
          break;
        case 5000:
          this.DefaultToAccessory(34, 30);
          this.shoeSlot = (sbyte) 24;
          this.SetShopValues(ItemRarityColor.Lime7, Item.sellPrice(gold: 15));
          this.canBePlacedInVanityRegardlessOfConditions = true;
          break;
        case 5001:
          this.width = 18;
          this.height = 14;
          this.defense = 3;
          this.legSlot = 217;
          this.value = Item.buyPrice(gold: 10);
          this.rare = 2;
          break;
        case 5002:
        case 5003:
          this.DefaultToPlacableTile((ushort) 376, 24 + type - 5002);
          this.SetShopValues(ItemRarityColor.Green2, Item.sellPrice(gold: 1));
          this.maxStack = 99;
          break;
        case 5004:
          this.width = 18;
          this.height = 14;
          this.headSlot = 265;
          this.rare = 9;
          this.value = Item.sellPrice(silver: 30);
          this.vanity = true;
          break;
        case 5005:
          this.mana = 10;
          this.damage = 90;
          this.useStyle = 1;
          this.shootSpeed = 10f;
          this.shoot = 946;
          this.buffType = 322;
          this.width = 26;
          this.height = 28;
          this.UseSound = SoundID.Item113;
          this.useAnimation = 36;
          this.useTime = 36;
          this.rare = 5;
          this.noMelee = true;
          this.knockBack = 4f;
          this.value = Item.sellPrice(gold: 20);
          this.summon = true;
          break;
        case 5006:
          this.DefaultToMusicBox(57);
          break;
        case 5007:
          this.width = 18;
          this.height = 18;
          this.bodySlot = 234;
          this.rare = 2;
          this.value = Item.sellPrice(silver: 20);
          this.vanity = true;
          break;
        case 5008:
          this.DefaultToPlacableTile((ushort) 622, 0);
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(silver: 2));
          break;
        case 5010:
          this.DefaultToAccessory(34, 30);
          this.waistSlot = (sbyte) 16;
          this.SetShopValues(ItemRarityColor.Blue1, Item.sellPrice(gold: 5));
          break;
        case 5011:
        case 5012:
          this.noMelee = true;
          this.useStyle = 5;
          this.useAnimation = 45;
          this.useTime = 45;
          this.knockBack = 4.6f;
          this.width = 28;
          this.height = 28;
          this.damage = 9;
          this.scale = 1f;
          this.noUseGraphic = true;
          this.shoot = 947;
          if (type == 5012)
            this.shoot = 948;
          this.shootSpeed = 11f;
          this.UseSound = SoundID.Item1;
          this.rare = 1;
          this.value = Item.sellPrice(gold: 2);
          this.melee = true;
          this.channel = true;
          break;
        case 5014:
          this.DefaultToMusicBox(58);
          break;
        case 5015:
          this.DefaultToMusicBox(59);
          break;
        case 5016:
          this.DefaultToMusicBox(60);
          break;
        case 5017:
          this.DefaultToMusicBox(61);
          break;
        case 5018:
          this.DefaultToMusicBox(62);
          break;
        case 5019:
          this.DefaultToMusicBox(63);
          break;
        case 5020:
          this.DefaultToMusicBox(64);
          break;
        case 5021:
          this.DefaultToMusicBox(65);
          break;
        case 5022:
          this.DefaultToMusicBox(66);
          break;
        case 5023:
          this.DefaultToMusicBox(67);
          break;
        case 5024:
          this.DefaultToMusicBox(68);
          break;
        case 5025:
          this.DefaultToMusicBox(69);
          break;
        case 5026:
          this.DefaultToMusicBox(70);
          break;
        case 5027:
          this.DefaultToMusicBox(71);
          break;
        case 5028:
          this.DefaultToMusicBox(72);
          break;
        case 5029:
          this.DefaultToMusicBox(73);
          break;
        case 5030:
          this.DefaultToMusicBox(74);
          break;
        case 5031:
          this.DefaultToMusicBox(75);
          break;
        case 5032:
          this.DefaultToMusicBox(76);
          break;
        case 5033:
          this.DefaultToMusicBox(77);
          break;
        case 5034:
          this.DefaultToMusicBox(78);
          break;
        case 5035:
          this.DefaultToMusicBox(79);
          break;
        case 5036:
          this.DefaultToMusicBox(80);
          break;
        case 5037:
          this.DefaultToMusicBox(81);
          break;
        case 5038:
          this.DefaultToMusicBox(82);
          break;
        case 5039:
          this.DefaultToMusicBox(83);
          break;
        case 5040:
          this.DefaultToMusicBox(84);
          break;
        case 5043:
          this.maxStack = 99;
          this.consumable = true;
          this.width = 18;
          this.height = 18;
          this.useStyle = 4;
          this.useTime = 30;
          this.UseSound = SoundID.Item4;
          this.useAnimation = 30;
          this.rare = 4;
          this.value = Item.sellPrice(gold: 2);
          break;
        case 5044:
          this.DefaultToMusicBox(85);
          break;
      }
    }

    private void DefaultToWhip(
      int projectileId,
      int dmg,
      float kb,
      float shootspeed,
      int animationTotalTime = 30)
    {
      this.autoReuse = false;
      this.useStyle = 1;
      this.useAnimation = animationTotalTime;
      this.useTime = animationTotalTime;
      this.width = 18;
      this.height = 18;
      this.shoot = projectileId;
      this.UseSound = SoundID.Item152;
      this.noMelee = true;
      this.summon = true;
      this.noUseGraphic = true;
      this.damage = dmg;
      this.knockBack = kb;
      this.shootSpeed = shootspeed;
    }

    public void DefaultTokite(int projId)
    {
      this.width = 20;
      this.height = 28;
      this.DefaultToThrownWeapon(projId, 30, 2f);
      this.consumable = false;
      this.ranged = false;
      this.noUseGraphic = true;
      this.maxStack = 1;
      this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
    }

    public void DefaultToVanitypet(int projId, int buffID)
    {
      this.damage = 0;
      this.useStyle = 1;
      this.width = 16;
      this.height = 30;
      this.UseSound = SoundID.Item2;
      this.useAnimation = 20;
      this.useTime = 20;
      this.rare = 3;
      this.noMelee = true;
      this.value = Item.sellPrice(gold: 2);
      this.buffType = buffID;
      this.shoot = projId;
    }

    public bool IsACoin
    {
      get
      {
        switch (this.type)
        {
          case 71:
          case 72:
          case 73:
          case 74:
            return true;
          default:
            return false;
        }
      }
    }

    public static bool IsAGolfingItem(Item item)
    {
      if (ProjectileID.Sets.IsAGolfBall[item.shoot])
        return true;
      int type = item.type;
      switch (type)
      {
        case 4039:
        case 4092:
        case 4093:
        case 4094:
        case 4095:
          return true;
        default:
          if ((uint) (type - 4587) > 11U)
            return false;
          goto case 4039;
      }
    }

    private void DefaultToSeaShelll()
    {
      this.useStyle = 1;
      this.autoReuse = true;
      this.useAnimation = 15;
      this.useTime = 10;
      this.maxStack = 999;
      this.consumable = true;
      this.createTile = 324;
      this.width = 22;
      this.height = 22;
      switch (this.type)
      {
        case 2626:
          this.placeStyle = 1;
          this.value = Item.sellPrice(silver: 10);
          break;
        case 4071:
          this.placeStyle = 4;
          this.value = Item.sellPrice(gold: 1);
          break;
        case 4072:
          this.placeStyle = 2;
          this.value = Item.sellPrice(silver: 20);
          break;
        case 4073:
          this.placeStyle = 3;
          this.value = Item.sellPrice(silver: 20);
          break;
        default:
          this.value = Item.sellPrice(silver: 5);
          break;
      }
    }

    private void DefaultToCapturedCritter(short npcIdToSpawnOnUse)
    {
      this.useStyle = 1;
      this.autoReuse = true;
      this.useTurn = true;
      this.useAnimation = 15;
      this.useTime = 10;
      this.maxStack = 999;
      this.consumable = true;
      this.width = 12;
      this.height = 12;
      this.noUseGraphic = true;
      this.makeNPC = npcIdToSpawnOnUse;
    }

    private void DefaultToStaff(
      int projType,
      float pushForwardSpeed,
      int singleShotTime,
      int manaPerShot)
    {
      this.DefaultToMagicWeapon(projType, singleShotTime, pushForwardSpeed, true);
      this.mana = manaPerShot;
      this.width = 40;
      this.height = 40;
      this.UseSound = SoundID.Item43;
    }

    private void DefaultToSpear(int projType, float pushForwardSpeed, int animationTime)
    {
      this.useStyle = 5;
      this.useAnimation = 31;
      this.useTime = 31;
      this.shootSpeed = pushForwardSpeed;
      this.width = 32;
      this.height = 32;
      this.UseSound = SoundID.Item1;
      this.shoot = projType;
      this.noMelee = true;
      this.noUseGraphic = true;
      this.melee = true;
      this.useAnimation = this.useTime = animationTime;
    }

    private void SetFoodDefaults(int type)
    {
      switch (type)
      {
        case 353:
          this.DefaultToFood(22, 22, 25, 7200, true);
          this.SetShopValues(ItemRarityColor.White0, 100);
          this.maxStack = 99;
          this.holdStyle = 1;
          this.ammo = 353;
          this.notAmmo = true;
          break;
        case 357:
          this.DefaultToFood(22, 22, 206, 28800, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 967:
          this.DefaultToFood(12, 12, 26, 3600);
          this.SetShopValues(ItemRarityColor.White0, Item.buyPrice(silver: 1));
          this.useStyle = 9;
          break;
        case 969:
          this.DefaultToFood(12, 12, 26, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 2));
          this.useStyle = 9;
          break;
        case 1787:
          this.DefaultToFood(22, 22, 206, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 10));
          break;
        case 1911:
          this.DefaultToFood(22, 22, 207, 14400, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 10));
          break;
        case 1912:
          this.DefaultToHealingPotion(22, 22, 80);
          this.SetShopValues(ItemRarityColor.Blue1, 40);
          break;
        case 1919:
          this.DefaultToFood(22, 22, 207, 14400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 25));
          break;
        case 1920:
          this.DefaultToFood(22, 22, 207, 14400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 25));
          break;
        case 2266:
          this.DefaultToFood(22, 22, 25, 14400, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 5));
          break;
        case 2267:
          this.DefaultToFood(22, 22, 206, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 30));
          break;
        case 2268:
          this.DefaultToFood(22, 22, 206, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 50));
          break;
        case 2425:
          this.DefaultToFood(22, 22, 26, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 25));
          break;
        case 2426:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 75));
          break;
        case 2427:
          this.DefaultToFood(22, 22, 206, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 25));
          break;
        case 3195:
          this.DefaultToFood(22, 22, 206, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 3532:
          this.DefaultToFood(22, 22, 207, 86400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 5));
          break;
        case 4009:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4011:
          this.DefaultToFood(22, 22, 207, 57600);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4012:
          this.DefaultToFood(22, 22, 206, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4013:
          this.DefaultToFood(22, 22, 207, 86400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 5));
          break;
        case 4014:
          this.DefaultToFood(22, 22, 26, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4015:
          this.DefaultToFood(22, 22, 207, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4016:
          this.DefaultToFood(22, 22, 206, 50400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4017:
          this.DefaultToFood(22, 22, 206, 72000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4018:
          this.DefaultToFood(22, 22, 206, 57600, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4019:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4020:
          this.DefaultToFood(22, 22, 206, 50400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4021:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4022:
          this.DefaultToFood(22, 22, 207, 172800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 50));
          break;
        case 4023:
          this.DefaultToFood(22, 22, 206, 57600);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4024:
          this.DefaultToFood(22, 22, 26, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4025:
          this.DefaultToFood(22, 22, 206, 72000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4026:
          this.DefaultToFood(22, 22, 206, 50400, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4027:
          this.DefaultToFood(22, 22, 207, 57600, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4028:
          this.DefaultToFood(22, 22, 206, 57600);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4029:
          this.DefaultToFood(22, 22, 207, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4030:
          this.DefaultToFood(22, 22, 26, 64800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1, silver: 50));
          break;
        case 4031:
          this.DefaultToFood(22, 22, 26, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4032:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4033:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4034:
          this.DefaultToFood(22, 22, 207, 14400);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(silver: 50));
          break;
        case 4035:
          this.DefaultToFood(22, 22, 206, 64800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2, silver: 50));
          break;
        case 4036:
          this.DefaultToFood(22, 22, 207, 28800);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4037:
          this.DefaultToFood(22, 22, 207, 57600);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 4282:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4283:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4284:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4285:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4286:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4287:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4288:
          this.DefaultToFood(22, 22, 206, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4289:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4290:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4291:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4292:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4293:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4294:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4295:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4296:
          this.DefaultToFood(22, 22, 26, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4297:
          this.DefaultToFood(22, 22, 206, 18000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4403:
          this.DefaultToFood(22, 22, 206, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4411:
          this.DefaultToFood(22, 22, 26, 36000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4614:
          this.DefaultToFood(22, 22, 26, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4615:
          this.DefaultToFood(22, 22, 207, 57600, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 4));
          break;
        case 4616:
          this.DefaultToFood(22, 22, 26, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4617:
          this.DefaultToFood(22, 22, 26, 54000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4618:
          this.DefaultToFood(22, 22, 26, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 4619:
          this.DefaultToFood(22, 22, 26, 72000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4620:
          this.DefaultToFood(22, 22, 26, 72000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4621:
          this.DefaultToFood(22, 22, 26, 72000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4622:
          this.DefaultToFood(22, 22, 26, 72000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4623:
          this.DefaultToFood(22, 22, 206, 72000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4624:
          this.DefaultToFood(22, 22, 26, 54000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 2));
          break;
        case 4625:
          this.DefaultToFood(22, 22, 26, 90000);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 3));
          break;
        case 5009:
          this.DefaultToFood(22, 22, 26, 18000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(copper: 20));
          break;
        case 5041:
          this.DefaultToFood(22, 22, 26, 54000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
        case 5042:
          this.DefaultToFood(22, 22, 206, 36000, true);
          this.SetShopValues(ItemRarityColor.Blue1, Item.buyPrice(gold: 1));
          break;
      }
      float num = 0.0f;
      this.rare = (int) ((double) ((this.buffType != 207 ? (this.buffType != 206 ? num + 3f : num + 8f) : num + 12f) + (float) (this.buffTime / 14400)) / 4.0);
    }

    private void DefaultToMount(int mount)
    {
      this.width = 36;
      this.height = 26;
      this.mountType = mount;
    }

    private void DefaultToPlacableWall(ushort wallToPlace)
    {
      this.useStyle = 1;
      this.useTurn = true;
      this.useAnimation = 15;
      this.useTime = 7;
      this.autoReuse = true;
      this.maxStack = 999;
      this.consumable = true;
      this.createWall = (int) wallToPlace;
      this.width = 12;
      this.height = 12;
    }

    private void SetWeaponValues(int dmg, float knockback, int bonusCritChance = 0)
    {
      this.damage = dmg;
      this.knockBack = knockback;
      this.crit = bonusCritChance;
    }

    private void DefaultToBow(int singleShotTime, float shotVelocity, bool hasAutoReuse = false)
    {
      this.DefaultToRangedWeapon(1, AmmoID.Arrow, singleShotTime, shotVelocity, hasAutoReuse);
      this.width = 14;
      this.height = 30;
      this.UseSound = SoundID.Item5;
    }

    private void DefaultToMagicWeapon(
      int projType,
      int singleShotTime,
      float shotVelocity,
      bool hasAutoReuse = false)
    {
      this.autoReuse = hasAutoReuse;
      this.useStyle = 5;
      this.useAnimation = singleShotTime;
      this.useTime = singleShotTime;
      this.shoot = projType;
      this.shootSpeed = shotVelocity;
      this.noMelee = true;
      this.magic = true;
    }

    private void DefaultToRangedWeapon(
      int baseProjType,
      int ammoID,
      int singleShotTime,
      float shotVelocity,
      bool hasAutoReuse = false)
    {
      this.autoReuse = hasAutoReuse;
      this.useStyle = 5;
      this.useAnimation = singleShotTime;
      this.useTime = singleShotTime;
      this.shoot = baseProjType;
      this.useAmmo = ammoID;
      this.shootSpeed = shotVelocity;
      this.noMelee = true;
      this.ranged = true;
    }

    private void DefaultToThrownWeapon(
      int baseProjType,
      int singleShotTime,
      float shotVelocity,
      bool hasAutoReuse = false)
    {
      this.autoReuse = hasAutoReuse;
      this.useStyle = 1;
      this.useAnimation = singleShotTime;
      this.useTime = singleShotTime;
      this.shoot = baseProjType;
      this.shootSpeed = shotVelocity;
      this.noMelee = true;
      this.ranged = true;
      this.consumable = true;
      this.maxStack = 999;
    }

    private void DefaultToTorch(int tileStyleToPlace, bool allowWaterPlacement = false)
    {
      this.flame = true;
      this.noWet = !allowWaterPlacement;
      this.holdStyle = 1;
      this.autoReuse = true;
      this.maxStack = 999;
      this.consumable = true;
      this.createTile = 4;
      this.placeStyle = tileStyleToPlace;
      this.width = 10;
      this.height = 12;
      this.value = 60;
      this.useStyle = 1;
      this.useTurn = true;
      this.useAnimation = 15;
      this.useTime = 10;
    }

    private void DefaultToPlacableTile(int tileIDToPlace, int tileStyleToPlace = 0) => this.DefaultToPlacableTile((ushort) tileIDToPlace, tileStyleToPlace);

    private void DefaultToPlacableTile(ushort tileIDToPlace, int tileStyleToPlace = 0)
    {
      this.createTile = (int) tileIDToPlace;
      this.placeStyle = tileStyleToPlace;
      this.width = 14;
      this.height = 14;
      this.useStyle = 1;
      this.useAnimation = 15;
      this.useTime = 10;
      this.maxStack = 999;
      this.useTurn = true;
      this.autoReuse = true;
      this.consumable = true;
    }

    private void DefaultToGolfClub(int newwidth, int newheight)
    {
      this.width = newwidth;
      this.height = newheight;
      this.channel = true;
      this.useStyle = 8;
      this.holdStyle = 4;
      this.shootSpeed = 6f;
      this.shoot = 722;
      this.UseSound = (LegacySoundStyle) null;
      this.useAnimation = this.useTime = 12;
      this.noMelee = true;
    }

    private void DefaultToLawnMower(int newwidth, int newheight)
    {
      this.width = newwidth;
      this.height = newheight;
      this.holdStyle = 1;
      this.useStyle = 11;
      this.useAnimation = 30;
      this.useTime = 10;
      this.UseSound = SoundID.Item23;
      this.autoReuse = true;
    }

    private void DefaultToFood(
      int newwidth,
      int newheight,
      int foodbuff,
      int foodbuffduration,
      bool useGulpSound = false,
      int animationTime = 17)
    {
      this.UseSound = !useGulpSound ? SoundID.Item2 : SoundID.Item3;
      this.useStyle = !useGulpSound ? 2 : 9;
      this.useTurn = true;
      this.useAnimation = this.useTime = animationTime;
      this.maxStack = 30;
      this.consumable = true;
      this.width = newwidth;
      this.height = newheight;
      this.buffType = foodbuff;
      this.buffTime = foodbuffduration;
      this.rare = 1;
      this.value = Item.buyPrice(silver: 20);
    }

    private void DefaultToHealingPotion(
      int newwidth,
      int newheight,
      int healingAmount,
      int animationTime = 17)
    {
      this.UseSound = SoundID.Item3;
      this.useStyle = 9;
      this.useTurn = true;
      this.useAnimation = this.useTime = animationTime;
      this.maxStack = 30;
      this.consumable = true;
      this.width = newwidth;
      this.height = newheight;
      this.rare = 1;
      this.value = Item.buyPrice(silver: 20);
      this.potion = true;
      this.healLife = healingAmount;
    }

    private void SetShopValues(ItemRarityColor rarity, int coinValue)
    {
      this.rare = (int) rarity;
      this.value = coinValue;
    }

    private void DefaultToHeadgear(int newwidth, int newheight, int helmetArtID)
    {
      this.width = newwidth;
      this.height = newheight;
      this.headSlot = helmetArtID;
    }

    private void DefaultToAccessory(int newwidth = 24, int newheight = 24)
    {
      this.width = newwidth;
      this.height = newheight;
      this.accessory = true;
    }

    private void DefaultToGuitar(int newwidth = 24, int newheight = 24)
    {
      this.width = newwidth;
      this.height = newheight;
      this.autoReuse = true;
      this.holdStyle = 5;
      this.useStyle = 12;
      this.useAnimation = this.useTime = 12;
    }

    private void DefaultToMusicBox(int style)
    {
      this.useStyle = 1;
      this.useTurn = true;
      this.useAnimation = 15;
      this.useTime = 10;
      this.autoReuse = true;
      this.consumable = true;
      this.createTile = 139;
      this.placeStyle = style;
      this.width = 24;
      this.height = 24;
      this.rare = 4;
      this.value = 100000;
      this.accessory = true;
      this.canBePlacedInVanityRegardlessOfConditions = true;
    }

    public void SetDefaults(int Type = 0) => this.SetDefaults(Type, false);

    public void SetDefaults(int Type, bool noMatCheck = false)
    {
      if (Type < 0)
      {
        this.netDefaults(Type);
      }
      else
      {
        this.playerIndexTheItemIsReservedFor = Main.netMode == 1 || Main.netMode == 2 ? (int) byte.MaxValue : Main.myPlayer;
        this.ResetStats(Type);
        if (this.type >= 5045)
          this.type = 0;
        if (this.type == 0)
        {
          this.netID = 0;
          this.stack = 0;
        }
        else if (ItemID.Sets.IsFood[this.type])
          this.SetFoodDefaults(this.type);
        else if (this.type <= 1000)
          this.SetDefaults1(this.type);
        else if (this.type <= 2001)
          this.SetDefaults2(this.type);
        else if (this.type <= 3000)
          this.SetDefaults3(this.type);
        else if (this.type <= 3989)
          this.SetDefaults4(this.type);
        else
          this.SetDefaults5(this.type);
        this.dye = (byte) GameShaders.Armor.GetShaderIdFromItemId(this.type);
        if (this.hairDye != (short) 0)
          this.hairDye = GameShaders.Hair.GetShaderIdFromItemId(this.type);
        if (this.type == 2015)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 2016)
          this.value = Item.sellPrice(silver: 7, copper: 50);
        if (this.type == 2017)
          this.value = Item.sellPrice(silver: 7, copper: 50);
        if (this.type == 2019)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 2018)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 3563)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 261)
          this.value = Item.sellPrice(silver: 7, copper: 50);
        if (this.type == 2205)
          this.value = Item.sellPrice(silver: 12, copper: 50);
        if (this.type == 2123)
          this.value = Item.sellPrice(silver: 7, copper: 50);
        if (this.type == 2122)
          this.value = Item.sellPrice(silver: 7, copper: 50);
        if (this.type == 2003)
          this.value = Item.sellPrice(silver: 10);
        if (this.type == 2156)
          this.value = Item.sellPrice(silver: 15);
        if (this.type == 2157)
          this.value = Item.sellPrice(silver: 15);
        if (this.type == 2121)
          this.value = Item.sellPrice(silver: 15);
        if (this.type == 1992)
          this.value = Item.sellPrice(silver: 3);
        if (this.type == 2004)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 2002)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 2740)
          this.value = Item.sellPrice(silver: 2, copper: 50);
        if (this.type == 2006)
          this.value = Item.sellPrice(silver: 10);
        if (this.type == 3191)
          this.value = Item.sellPrice(silver: 20);
        if (this.type == 3192)
          this.value = Item.sellPrice(silver: 2, copper: 50);
        if (this.type == 3193)
          this.value = Item.sellPrice(silver: 5);
        if (this.type == 3194)
          this.value = Item.sellPrice(silver: 10);
        if (this.type == 2007)
          this.value = Item.sellPrice(silver: 50);
        if (this.type == 2673)
          this.value = Item.sellPrice(gold: 10);
        if (this.bait > 0)
        {
          if (this.bait >= 50)
            this.rare = 3;
          else if (this.bait >= 30)
            this.rare = 2;
          else if (this.bait >= 15)
            this.rare = 1;
        }
        if (this.type >= 1994 && this.type <= 2001)
        {
          int num = this.type - 1994;
          if (num == 0)
            this.value = Item.sellPrice(silver: 5);
          if (num == 4)
            this.value = Item.sellPrice(silver: 10);
          if (num == 6)
            this.value = Item.sellPrice(silver: 15);
          if (num == 3)
            this.value = Item.sellPrice(silver: 20);
          if (num == 7)
            this.value = Item.sellPrice(silver: 30);
          if (num == 2)
            this.value = Item.sellPrice(silver: 40);
          if (num == 1)
            this.value = Item.sellPrice(silver: 75);
          if (num == 5)
            this.value = Item.sellPrice(gold: 1);
        }
        if (this.type == 2663 || this.type == 1720 || this.type == 2137 || this.type == 2155 || this.type == 2151 || this.type == 1704 || this.type == 2143 || this.type == 1710 || this.type == 2238 || this.type == 2133 || this.type == 2147 || this.type == 2405 || this.type == 1716 || this.type == 1705)
          this.value = Item.sellPrice(gold: 2);
        if (Main.projHook[this.shoot])
        {
          this.useStyle = 0;
          this.useTime = 0;
          this.useAnimation = 0;
        }
        if (ItemID.Sets.IsDrill[this.type] || ItemID.Sets.IsChainsaw[this.type])
        {
          this.useTime = (int) ((double) this.useTime * 0.6);
          if (this.useTime < 1)
            this.useTime = 1;
          this.useAnimation = (int) ((double) this.useAnimation * 0.6);
          if (this.useAnimation < 1)
            this.useAnimation = 1;
          --this.tileBoost;
        }
        if (ItemID.Sets.IsFood[this.type])
          this.holdStyle = 1;
        if (this.type >= 1803 && this.type <= 1807)
          this.SetDefaults(1533 + this.type - 1803);
        if (this.dye > (byte) 0)
          this.maxStack = 99;
        if (this.createTile == 19)
          this.maxStack = 999;
        this.netID = this.type;
        if (!noMatCheck)
          this.material = ItemID.Sets.IsAMaterial[this.type];
        this.RebuildTooltip();
        if (this.type <= 0 || this.type >= 5045 || !ItemID.Sets.Deprecated[this.type])
          return;
        this.netID = 0;
        this.type = 0;
        this.stack = 0;
      }
    }

    public void ResetStats(int Type)
    {
      this.tooltipContext = -1;
      this.BestiaryNotes = (string) null;
      this.sentry = false;
      this.canBePlacedInVanityRegardlessOfConditions = false;
      this.DD2Summon = false;
      this.shopSpecialCurrency = -1;
      this.shopCustomPrice = new int?();
      this.expert = false;
      this.isAShopItem = false;
      this.expertOnly = false;
      this.instanced = false;
      this.questItem = false;
      this.fishingPole = 0;
      this.bait = 0;
      this.hairDye = (short) -1;
      this.makeNPC = (short) 0;
      this.dye = (byte) 0;
      this.paint = (byte) 0;
      this.tileWand = -1;
      this.notAmmo = false;
      this.netID = 0;
      this.prefix = (byte) 0;
      this.crit = 0;
      this.mech = false;
      this.flame = false;
      this.reuseDelay = 0;
      this.melee = false;
      this.magic = false;
      this.ranged = false;
      this.summon = false;
      this.placeStyle = 0;
      this.buffTime = 0;
      this.buffType = 0;
      this.mountType = -1;
      this.cartTrack = false;
      this.material = false;
      this.noWet = false;
      this.vanity = false;
      this.mana = 0;
      this.wet = false;
      this.wetCount = (byte) 0;
      this.lavaWet = false;
      this.channel = false;
      this.manaIncrease = 0;
      this.timeSinceTheItemHasBeenReservedForSomeone = 0;
      this.noMelee = false;
      this.noUseGraphic = false;
      this.lifeRegen = 0;
      this.shootSpeed = 0.0f;
      this.active = true;
      this.alpha = 0;
      this.ammo = AmmoID.None;
      this.useAmmo = AmmoID.None;
      this.autoReuse = false;
      this.accessory = false;
      this.axe = 0;
      this.healMana = 0;
      this.bodySlot = -1;
      this.legSlot = -1;
      this.headSlot = -1;
      this.potion = false;
      this.color = new Color();
      this.glowMask = (short) -1;
      this.consumable = false;
      this.createTile = -1;
      this.createWall = -1;
      this.damage = -1;
      this.defense = 0;
      this.hammer = 0;
      this.healLife = 0;
      this.holdStyle = 0;
      this.knockBack = 0.0f;
      this.maxStack = 1;
      this.pick = 0;
      this.rare = 0;
      this.scale = 1f;
      this.shoot = 0;
      this.stack = 1;
      this.ToolTip = (ItemTooltip) null;
      this.tileBoost = 0;
      this.useStyle = 0;
      this.UseSound = (LegacySoundStyle) null;
      this.useTime = 100;
      this.useAnimation = 100;
      this.value = 0;
      this.useTurn = false;
      this.buy = false;
      this.handOnSlot = (sbyte) -1;
      this.handOffSlot = (sbyte) -1;
      this.backSlot = (sbyte) -1;
      this.frontSlot = (sbyte) -1;
      this.shoeSlot = (sbyte) -1;
      this.waistSlot = (sbyte) -1;
      this.wingSlot = (sbyte) -1;
      this.shieldSlot = (sbyte) -1;
      this.neckSlot = (sbyte) -1;
      this.faceSlot = (sbyte) -1;
      this.balloonSlot = (sbyte) -1;
      this.uniqueStack = false;
      this.favorited = false;
      this.type = Type;
    }

    public Color GetAlpha(Color newColor)
    {
      int type = this.type;
      if (type <= 1572)
      {
        if (type <= 549)
        {
          if (type <= 184)
          {
            if (type <= 58)
            {
              if (type == 51)
                return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 0);
              if (type == 58)
                goto label_64;
              else
                goto label_92;
            }
            else if (type != 75)
            {
              if ((uint) (type - 119) > 3U)
              {
                if (type == 184)
                  goto label_64;
                else
                  goto label_92;
              }
            }
            else
              goto label_59;
          }
          else if (type <= 501)
          {
            if ((uint) (type - 198) <= 5U)
              return Color.White;
            if ((uint) (type - 217) > 3U)
            {
              if (type == 501)
                return new Color(200, 200, 200, 50);
              goto label_92;
            }
          }
          else
          {
            if (type == 502)
              return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 150);
            if ((uint) (type - 520) <= 2U || (uint) (type - 547) <= 2U)
              goto label_63;
            else
              goto label_92;
          }
          return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue);
        }
        if (type <= 1306)
        {
          if (type <= 757)
          {
            if (type != 575)
            {
              if (type == 757)
                goto label_62;
              else
                goto label_92;
            }
            else
              goto label_63;
          }
          else
          {
            if (type == 787)
              return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 175);
            if (type == 1260)
              return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 175);
            if (type == 1306)
              goto label_62;
            else
              goto label_92;
          }
        }
        else
        {
          if (type <= 1507)
          {
            if (type != 1332)
            {
              if (type != 1446 && (uint) (type - 1506) > 1U)
                goto label_92;
            }
            else
              goto label_63;
          }
          else
          {
            if (type == 1508)
              return new Color(200, 200, 200, 0);
            if ((uint) (type - 1543) > 2U)
            {
              if (type == 1572)
                return new Color(200, 200, (int) byte.MaxValue, 125);
              goto label_92;
            }
          }
          return new Color((int) newColor.R, (int) newColor.G, (int) newColor.B, (int) Main.gFade);
        }
      }
      else
      {
        if (type <= 3522)
        {
          if (type <= 2786)
          {
            if (type <= 1826)
            {
              if ((uint) (type - 1734) > 1U)
              {
                if (type == 1826)
                  return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 200);
                goto label_92;
              }
              else
                goto label_64;
            }
            else if ((uint) (type - 1867) > 1U)
            {
              if ((uint) (type - 2763) > 2U && (uint) (type - 2782) > 4U)
                goto label_92;
            }
            else
              goto label_64;
          }
          else if (type <= 3332)
          {
            if (type != 3065)
            {
              if (type == 3191)
                return new Color(250, 250, 250, 200);
              if ((uint) (type - 3318) <= 14U)
                goto label_56;
              else
                goto label_92;
            }
            else
              goto label_58;
          }
          else if ((uint) (type - 3453) > 2U)
          {
            if ((uint) (type - 3456) > 3U)
            {
              if (type != 3522)
                goto label_92;
            }
            else
              goto label_62;
          }
          else
            goto label_63;
          return new Color(250, 250, 250, (int) byte.MaxValue - this.alpha);
        }
        if (type <= 4354)
        {
          if (type <= 3858)
          {
            if (type != 3580)
            {
              if (type == 3822)
                return Color.Lerp(Color.White, newColor, 0.5f) * (float) (((double) byte.MaxValue - (double) this.alpha) / (double) byte.MaxValue);
              if (type == 3858)
                goto label_59;
              else
                goto label_92;
            }
            else
              goto label_63;
          }
          else if ((uint) (type - 3860) > 2U)
          {
            if (type == 4143)
              return Color.Lerp(Color.White, newColor, 0.0f) * (float) (((double) byte.MaxValue - (double) this.alpha) / (double) byte.MaxValue);
            if (type != 4354)
              goto label_92;
          }
          else
            goto label_56;
        }
        else if (type <= 4782)
        {
          if ((uint) (type - 4377) > 1U && type != 4389)
          {
            if (type == 4782)
              goto label_56;
            else
              goto label_92;
          }
        }
        else if (type != 4956)
        {
          if (type != 4957)
          {
            if (type == 5043)
              return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, (int) newColor.A - this.alpha);
            goto label_92;
          }
          else
            goto label_56;
        }
        else
          goto label_58;
        Color color = new Color();
        switch (this.type)
        {
          case 4377:
            color = new Color(50, (int) byte.MaxValue, 50, 200);
            break;
          case 4378:
            color = new Color(50, 200, (int) byte.MaxValue, (int) byte.MaxValue);
            break;
          case 4389:
            color = new Color((int) byte.MaxValue, 50, 125, 200);
            break;
          default:
            color = new Color((int) byte.MaxValue, 150, 150, 200);
            break;
        }
        if ((int) newColor.R > (int) color.R)
          color.R = newColor.R;
        if ((int) newColor.G > (int) color.G)
          color.G = newColor.G;
        if ((int) newColor.B > (int) color.B)
          color.B = newColor.B;
        if ((int) newColor.A > (int) color.A)
          color.A = newColor.A;
        return color;
label_56:
        return Color.Lerp(newColor, Color.White, 0.4f);
label_58:
        return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, (int) newColor.A - this.alpha);
      }
label_59:
      return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue);
label_62:
      return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 200);
label_63:
      return new Color((int) byte.MaxValue, (int) byte.MaxValue, (int) byte.MaxValue, 50);
label_64:
      return new Color(200, 200, 200, 200);
label_92:
      float num1 = (float) ((int) byte.MaxValue - this.alpha) / (float) byte.MaxValue;
      int r = (int) ((double) newColor.R * (double) num1);
      int num2 = (int) ((double) newColor.G * (double) num1);
      int num3 = (int) ((double) newColor.B * (double) num1);
      int num4 = (int) newColor.A - this.alpha;
      if (num4 < 0)
        num4 = 0;
      if (num4 > (int) byte.MaxValue)
        num4 = (int) byte.MaxValue;
      int g = num2;
      int b = num3;
      int a = num4;
      return new Color(r, g, b, a);
    }

    public Color GetColor(Color newColor)
    {
      int r = (int) this.color.R - ((int) byte.MaxValue - (int) newColor.R);
      int g = (int) this.color.G - ((int) byte.MaxValue - (int) newColor.G);
      int b = (int) this.color.B - ((int) byte.MaxValue - (int) newColor.B);
      int a = (int) this.color.A - ((int) byte.MaxValue - (int) newColor.A);
      if (r < 0)
        r = 0;
      if (r > (int) byte.MaxValue)
        r = (int) byte.MaxValue;
      if (g < 0)
        g = 0;
      if (g > (int) byte.MaxValue)
        g = (int) byte.MaxValue;
      if (b < 0)
        b = 0;
      if (b > (int) byte.MaxValue)
        b = (int) byte.MaxValue;
      if (a < 0)
        a = 0;
      if (a > (int) byte.MaxValue)
        a = (int) byte.MaxValue;
      return new Color(r, g, b, a);
    }

    public static bool MechSpawn(float x, float y, int type)
    {
      int num1 = 0;
      int num2 = 0;
      int num3 = 0;
      for (int index = 0; index < 200; ++index)
      {
        if (Main.item[index].active && Main.item[index].type == type)
        {
          ++num1;
          Vector2 vector2 = new Vector2(x, y);
          double num4 = (double) Main.item[index].position.X - (double) vector2.X;
          float num5 = Main.item[index].position.Y - vector2.Y;
          double num6 = Math.Sqrt(num4 * num4 + (double) num5 * (double) num5);
          if (num6 < 300.0)
            ++num2;
          if (num6 < 800.0)
            ++num3;
        }
      }
      return num2 < 3 && num3 < 6 && num1 < 10;
    }

    public static int buyPrice(int platinum = 0, int gold = 0, int silver = 0, int copper = 0) => copper + silver * 100 + gold * 100 * 100 + platinum * 100 * 100 * 100;

    public static int sellPrice(int platinum = 0, int gold = 0, int silver = 0, int copper = 0) => (copper + silver * 100 + gold * 100 * 100 + platinum * 100 * 100 * 100) * 5;

    public void UpdateItem(int i)
    {
      if (Main.timeItemSlotCannotBeReusedFor[i] > 0)
      {
        if (Main.netMode == 2)
        {
          --Main.timeItemSlotCannotBeReusedFor[i];
          return;
        }
        Main.timeItemSlotCannotBeReusedFor[i] = 0;
      }
      if (!this.active)
        return;
      if (this.instanced)
      {
        if (Main.netMode == 2)
        {
          this.active = false;
          return;
        }
        this.keepTime = 6000;
        this.ownTime = 0;
        this.noGrabDelay = 0;
        this.playerIndexTheItemIsReservedFor = Main.myPlayer;
      }
      if (Main.netMode == 0)
        this.playerIndexTheItemIsReservedFor = Main.myPlayer;
      float gravity = 0.1f;
      float maxFallSpeed = 7f;
      if (Main.netMode == 1)
      {
        int index1 = (int) ((double) this.position.X + (double) (this.width / 2)) / 16;
        int index2 = (int) ((double) this.position.Y + (double) (this.height / 2)) / 16;
        if (index1 >= 0 && index2 >= 0 && index1 < Main.maxTilesX && index2 < Main.maxTilesY && Main.tile[index1, index2] == null)
        {
          gravity = 0.0f;
          this.velocity.X = 0.0f;
          this.velocity.Y = 0.0f;
        }
      }
      if (this.honeyWet)
      {
        gravity = 0.05f;
        maxFallSpeed = 3f;
      }
      else if (this.wet)
      {
        maxFallSpeed = 5f;
        gravity = 0.08f;
      }
      if (this.ownTime > 0)
        --this.ownTime;
      else
        this.ownIgnore = -1;
      if (this.keepTime > 0)
        --this.keepTime;
      Vector2 wetVelocity = this.velocity * 0.5f;
      if (!this.beingGrabbed)
      {
        this.TryCombiningIntoNearbyItems(i);
        if (Main.netMode != 2 && Main.expertMode && this.playerIndexTheItemIsReservedFor == Main.myPlayer && this.type >= 71 && this.type <= 74)
          this.GetPickedUpByMonsters(i);
        this.MoveInWorld(gravity, maxFallSpeed, ref wetVelocity);
        if (this.lavaWet)
          this.CheckLavaDeath(i);
        this.DespawnIfMeetingConditions(i);
      }
      else
        this.beingGrabbed = false;
      this.UpdateItem_VisualEffects();
      if (this.timeSinceItemSpawned < 2147483547)
        this.timeSinceItemSpawned += ItemID.Sets.ItemSpawnDecaySpeed[this.type];
      if (Main.netMode == 2 && this.playerIndexTheItemIsReservedFor != Main.myPlayer)
      {
        ++this.timeSinceTheItemHasBeenReservedForSomeone;
        if (this.timeSinceTheItemHasBeenReservedForSomeone >= 300)
        {
          this.timeSinceTheItemHasBeenReservedForSomeone = 0;
          NetMessage.SendData(39, this.playerIndexTheItemIsReservedFor, number: i);
        }
      }
      if (this.wet)
        this.position = this.position + wetVelocity;
      else
        this.position = this.position + this.velocity;
      if (this.noGrabDelay <= 0)
        return;
      --this.noGrabDelay;
    }

    private void DespawnIfMeetingConditions(int i)
    {
      if (this.type == 75 && Main.dayTime)
      {
        for (int index = 0; index < 10; ++index)
          Dust.NewDust(this.position, this.width, this.height, 15, this.velocity.X, this.velocity.Y, 150, Scale: 1.2f);
        for (int index = 0; index < 3; ++index)
          Gore.NewGore(this.position, new Vector2(this.velocity.X, this.velocity.Y), Main.rand.Next(16, 18));
        this.active = false;
        this.type = 0;
        this.stack = 0;
        if (Main.netMode == 2)
          NetMessage.SendData(21, number: i);
      }
      if (this.type == 4143 && this.timeSinceItemSpawned > 300)
      {
        for (int index = 0; index < 20; ++index)
          Dust.NewDust(this.position, this.width, this.height, 15, this.velocity.X, this.velocity.Y, 150, Color.Lerp(Color.CornflowerBlue, Color.Indigo, Main.rand.NextFloat()), 1.2f);
        this.active = false;
        this.type = 0;
        this.stack = 0;
        if (Main.netMode == 2)
          NetMessage.SendData(21, number: i);
      }
      if (this.type != 3822 || DD2Event.Ongoing)
        return;
      int num = Main.rand.Next(18, 24);
      for (int index1 = 0; index1 < num; ++index1)
      {
        int index2 = Dust.NewDust(this.Center, 0, 0, 61, Scale: 1.7f);
        Main.dust[index2].velocity *= 8f;
        --Main.dust[index2].velocity.Y;
        Main.dust[index2].position = Vector2.Lerp(Main.dust[index2].position, this.Center, 0.5f);
        Main.dust[index2].noGravity = true;
        Main.dust[index2].noLight = true;
      }
      this.active = false;
      this.type = 0;
      this.stack = 0;
      if (Main.netMode != 2)
        return;
      NetMessage.SendData(21, number: i);
    }

    public void TryCombiningIntoNearbyItems(int i)
    {
      bool flag = true;
      switch (this.type)
      {
        case 71:
        case 72:
        case 73:
        case 74:
          flag = false;
          break;
      }
      if (ItemID.Sets.NebulaPickup[this.type])
        flag = false;
      if (!(this.playerIndexTheItemIsReservedFor == Main.myPlayer & flag))
        return;
      this.CombineWithNearbyItems(i);
    }

    private void CheckLavaDeath(int i)
    {
      if (this.type == 267)
      {
        if (Main.netMode == 1)
          return;
        this.active = false;
        this.type = 0;
        this.stack = 0;
        for (int number = 0; number < 200; ++number)
        {
          if (Main.npc[number].active && Main.npc[number].type == 22)
          {
            if (Main.netMode == 2)
              NetMessage.SendData(28, number: number, number2: 9999f, number3: 10f, number4: ((float) -Main.npc[number].direction));
            Main.npc[number].StrikeNPCNoInteraction(9999, 10f, -Main.npc[number].direction);
            NPC.SpawnWOF(this.position);
          }
        }
        NetMessage.SendData(21, number: i);
      }
      else
      {
        if (this.playerIndexTheItemIsReservedFor != Main.myPlayer || this.type == 312 || this.type == 318 || this.type == 173 || this.type == 174 || this.type == 4422 || this.type == 175 || this.type == 2701 || this.rare != 0)
          return;
        this.active = false;
        this.type = 0;
        this.stack = 0;
        if (Main.netMode == 0)
          return;
        NetMessage.SendData(21, number: i);
      }
    }

    private void MoveInWorld(float gravity, float maxFallSpeed, ref Vector2 wetVelocity)
    {
      if (ItemID.Sets.ItemNoGravity[this.type])
      {
        this.velocity.X *= 0.95f;
        if ((double) this.velocity.X < 0.1 && (double) this.velocity.X > -0.1)
          this.velocity.X = 0.0f;
        this.velocity.Y *= 0.95f;
        if ((double) this.velocity.Y < 0.1 && (double) this.velocity.Y > -0.1)
          this.velocity.Y = 0.0f;
      }
      else
      {
        this.velocity.Y += gravity;
        if ((double) this.velocity.Y > (double) maxFallSpeed)
          this.velocity.Y = maxFallSpeed;
        this.velocity.X *= 0.95f;
        if ((double) this.velocity.X < 0.1 && (double) this.velocity.X > -0.1)
          this.velocity.X = 0.0f;
      }
      bool flag = Collision.LavaCollision(this.position, this.width, this.height);
      if (flag)
        this.lavaWet = true;
      int num = Collision.WetCollision(this.position, this.width, this.height) ? 1 : 0;
      if (Collision.honey)
        this.honeyWet = true;
      if (num != 0)
      {
        if (!this.wet)
        {
          if (this.wetCount == (byte) 0)
          {
            this.wetCount = (byte) 20;
            if (!flag)
            {
              if (this.honeyWet)
              {
                for (int index1 = 0; index1 < 5; ++index1)
                {
                  int index2 = Dust.NewDust(new Vector2(this.position.X - 6f, (float) ((double) this.position.Y + (double) (this.height / 2) - 8.0)), this.width + 12, 24, 152);
                  --Main.dust[index2].velocity.Y;
                  Main.dust[index2].velocity.X *= 2.5f;
                  Main.dust[index2].scale = 1.3f;
                  Main.dust[index2].alpha = 100;
                  Main.dust[index2].noGravity = true;
                }
                SoundEngine.PlaySound(19, (int) this.position.X, (int) this.position.Y);
              }
              else
              {
                for (int index3 = 0; index3 < 10; ++index3)
                {
                  int index4 = Dust.NewDust(new Vector2(this.position.X - 6f, (float) ((double) this.position.Y + (double) (this.height / 2) - 8.0)), this.width + 12, 24, Dust.dustWater());
                  Main.dust[index4].velocity.Y -= 4f;
                  Main.dust[index4].velocity.X *= 2.5f;
                  Main.dust[index4].scale *= 0.8f;
                  Main.dust[index4].alpha = 100;
                  Main.dust[index4].noGravity = true;
                }
                SoundEngine.PlaySound(19, (int) this.position.X, (int) this.position.Y);
              }
            }
            else
            {
              for (int index5 = 0; index5 < 5; ++index5)
              {
                int index6 = Dust.NewDust(new Vector2(this.position.X - 6f, (float) ((double) this.position.Y + (double) (this.height / 2) - 8.0)), this.width + 12, 24, 35);
                Main.dust[index6].velocity.Y -= 1.5f;
                Main.dust[index6].velocity.X *= 2.5f;
                Main.dust[index6].scale = 1.3f;
                Main.dust[index6].alpha = 100;
                Main.dust[index6].noGravity = true;
              }
              SoundEngine.PlaySound(19, (int) this.position.X, (int) this.position.Y);
            }
          }
          this.wet = true;
        }
      }
      else if (this.wet)
      {
        this.wet = false;
        int wetCount = (int) this.wetCount;
      }
      if (!this.wet)
      {
        this.lavaWet = false;
        this.honeyWet = false;
      }
      if (this.wetCount > (byte) 0)
        --this.wetCount;
      if (this.wet)
      {
        if (this.wet)
        {
          Vector2 velocity = this.velocity;
          this.velocity = Collision.TileCollision(this.position, this.velocity, this.width, this.height);
          if ((double) this.velocity.X != (double) velocity.X)
            wetVelocity.X = this.velocity.X;
          if ((double) this.velocity.Y != (double) velocity.Y)
            wetVelocity.Y = this.velocity.Y;
        }
      }
      else
        this.velocity = Collision.TileCollision(this.position, this.velocity, this.width, this.height);
      Vector4 vector4 = Collision.SlopeCollision(this.position, this.velocity, this.width, this.height, gravity);
      this.position.X = vector4.X;
      this.position.Y = vector4.Y;
      this.velocity.X = vector4.Z;
      this.velocity.Y = vector4.W;
      Collision.StepConveyorBelt((Entity) this, 1f);
    }

    private void GetPickedUpByMonsters(int i)
    {
      Rectangle rectangle1 = new Rectangle((int) this.position.X, (int) this.position.Y, this.width, this.height);
      for (int index1 = 0; index1 < 200; ++index1)
      {
        if (Main.npc[index1].active && Main.npc[index1].lifeMax > 5 && !Main.npc[index1].friendly && !Main.npc[index1].immortal && !Main.npc[index1].dontTakeDamage && !NPCID.Sets.CantTakeLunchMoney[Main.npc[index1].type])
        {
          float stack = (float) this.stack;
          float num1 = 1f;
          if (this.type == 72)
            num1 = 100f;
          if (this.type == 73)
            num1 = 10000f;
          if (this.type == 74)
            num1 = 1000000f;
          float num2 = stack * num1;
          float extraValue = (float) Main.npc[index1].extraValue;
          int index2 = Main.npc[index1].realLife;
          if (index2 >= 0 && Main.npc[index2].active)
            extraValue = (float) Main.npc[index2].extraValue;
          else
            index2 = -1;
          if ((double) extraValue < (double) num2 && (double) extraValue + (double) num2 < 999000000.0)
          {
            Rectangle rectangle2 = new Rectangle((int) Main.npc[index1].position.X, (int) Main.npc[index1].position.Y, Main.npc[index1].width, Main.npc[index1].height);
            if (rectangle1.Intersects(rectangle2))
            {
              float num3 = (float) Main.rand.Next(50, 76) * 0.01f;
              if (this.type == 71)
                num3 += (float) Main.rand.Next(51) * 0.01f;
              if (this.type == 72)
                num3 += (float) Main.rand.Next(26) * 0.01f;
              if ((double) num3 > 1.0)
                num3 = 1f;
              int num4 = (int) ((double) this.stack * (double) num3);
              if (num4 < 1)
                num4 = 1;
              if (num4 > this.stack)
                num4 = this.stack;
              this.stack -= num4;
              int num5 = (int) ((double) num4 * (double) num1);
              int number = index1;
              if (index2 >= 0)
                number = index2;
              Main.npc[number].extraValue += num5;
              if (Main.netMode == 0)
                Main.npc[number].moneyPing(this.position);
              else
                NetMessage.SendData(92, number: number, number2: ((float) num5), number3: this.position.X, number4: this.position.Y);
              if (this.stack <= 0)
              {
                this.SetDefaults();
                this.active = false;
              }
              NetMessage.SendData(21, number: i);
            }
          }
        }
      }
    }

    private void CombineWithNearbyItems(int myItemIndex)
    {
      if (!this.CanCombineStackInWorld() || this.stack >= this.maxStack)
        return;
      for (int number = myItemIndex + 1; number < 400; ++number)
      {
        Item obj = Main.item[number];
        if (obj.active && obj.type == this.type && obj.stack > 0 && obj.playerIndexTheItemIsReservedFor == this.playerIndexTheItemIsReservedFor)
        {
          double num1 = (double) Math.Abs((float) ((double) this.position.X + (double) (this.width / 2) - ((double) obj.position.X + (double) (obj.width / 2)))) + (double) Math.Abs((float) ((double) this.position.Y + (double) (this.height / 2) - ((double) obj.position.Y + (double) (obj.height / 2))));
          int num2 = 30;
          if ((double) Item.numberOfNewItems > 40.0)
            num2 *= 2;
          if ((double) Item.numberOfNewItems > 80.0)
            num2 *= 2;
          if ((double) Item.numberOfNewItems > 120.0)
            num2 *= 2;
          if ((double) Item.numberOfNewItems > 160.0)
            num2 *= 2;
          if ((double) Item.numberOfNewItems > 200.0)
            num2 *= 2;
          if ((double) Item.numberOfNewItems > 240.0)
            num2 *= 2;
          double num3 = (double) num2;
          if (num1 < num3)
          {
            this.position = (this.position + obj.position) / 2f;
            this.velocity = (this.velocity + obj.velocity) / 2f;
            int num4 = obj.stack;
            if (num4 > this.maxStack - this.stack)
              num4 = this.maxStack - this.stack;
            obj.stack -= num4;
            this.stack += num4;
            if (obj.stack <= 0)
            {
              obj.SetDefaults();
              obj.active = false;
            }
            if (Main.netMode != 0 && this.playerIndexTheItemIsReservedFor == Main.myPlayer)
            {
              NetMessage.SendData(21, number: myItemIndex);
              NetMessage.SendData(21, number: number);
            }
          }
        }
      }
    }

    public bool CanCombineStackInWorld()
    {
      if (this.type == 75)
        return false;
      return this.createTile >= 0 || this.createWall > 0 || this.ammo > 0 && !this.notAmmo || this.consumable || this.type >= 205 && this.type <= 207 || this.type == 1128 || this.type == 530 || this.dye > (byte) 0 || this.paint > (byte) 0 || this.material;
    }

    private void UpdateItem_VisualEffects()
    {
      if (this.type == 5043)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (float) (((double) Main.essScale + 0.5) / 2.0);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.25f * num, 0.25f * num, 0.25f * num);
      }
      else if (this.type == 3191)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (float) (((double) Main.essScale + 0.5) / 2.0);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.3f * num, 0.1f * num, 0.25f * num);
      }
      else if (this.type == 520 || this.type == 3454)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.5f * num, 0.1f * num, 0.25f * num);
      }
      else if (this.type == 521 || this.type == 3455)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.25f * num, 0.1f * num, 0.5f * num);
      }
      else if (this.type == 547 || this.type == 3453)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.5f * num, 0.3f * num, 0.05f * num);
      }
      else if (this.type == 548)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.1f * num, 0.1f * num, 0.6f * num);
      }
      else if (this.type == 575)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.1f * num, 0.3f * num, 0.5f * num);
      }
      else if (this.type == 549)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * Main.essScale;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.1f * num, 0.5f * num, 0.2f * num);
      }
      else if (this.type == 58 || this.type == 1734 || this.type == 1867)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (Main.essScale * 0.5f);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.5f * num, 0.1f * num, 0.1f * num);
      }
      else if (this.type == 184 || this.type == 1735 || this.type == 1868 || this.type == 4143)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (Main.essScale * 0.5f);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.1f * num, 0.1f * num, 0.5f * num);
      }
      else if (this.type == 522)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (Main.essScale * 0.2f);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.5f * num, 1f * num, 0.1f * num);
      }
      else if (this.type == 1332)
      {
        float num = (float) Main.rand.Next(90, 111) * 0.01f * (Main.essScale * 0.2f);
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f * num, 1f * num, 0.1f * num);
      }
      else if (this.type == 3456)
        Lighting.AddLight(this.Center, new Vector3(0.2f, 0.4f, 0.5f) * Main.essScale);
      else if (this.type == 3457)
        Lighting.AddLight(this.Center, new Vector3(0.4f, 0.2f, 0.5f) * Main.essScale);
      else if (this.type == 3458)
        Lighting.AddLight(this.Center, new Vector3(0.5f, 0.4f, 0.2f) * Main.essScale);
      else if (this.type == 3459)
        Lighting.AddLight(this.Center, new Vector3(0.2f, 0.2f, 0.5f) * Main.essScale);
      else if (this.type == 501)
      {
        if (Main.rand.Next(6) != 0)
          return;
        int index = Dust.NewDust(this.position, this.width, this.height, 55, Alpha: 200, newColor: this.color);
        Main.dust[index].velocity *= 0.3f;
        Main.dust[index].scale *= 0.5f;
      }
      else if (this.type == 3822)
        Lighting.AddLight(this.Center, 0.1f, 0.3f, 0.1f);
      else if (this.type == 1970)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.0f, 0.75f);
      else if (this.type == 1972)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.0f, 0.0f, 0.75f);
      else if (this.type == 1971)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.75f, 0.0f);
      else if (this.type == 1973)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.0f, 0.75f, 0.0f);
      else if (this.type == 1974)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.0f, 0.0f);
      else if (this.type == 1975)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.75f, 0.75f);
      else if (this.type == 1976)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.375f, 0.0f);
      else if (this.type == 2679)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.6f, 0.0f, 0.6f);
      else if (this.type == 2687)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.0f, 0.0f, 0.6f);
      else if (this.type == 2689)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.6f, 0.6f, 0.0f);
      else if (this.type == 2683)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.0f, 0.6f, 0.0f);
      else if (this.type == 2685)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.6f, 0.0f, 0.0f);
      else if (this.type == 2681)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.6f, 0.6f, 0.6f);
      else if (this.type == 2677)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.6f, 0.375f, 0.0f);
      else if (this.type == 105)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f, 0.95f, 0.8f);
      }
      else if (this.type == 2701)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.7f, 0.65f, 0.55f);
      else if (this.createTile == 4)
      {
        int placeStyle = this.placeStyle;
        if ((this.wet || !ItemID.Sets.Torches[this.type]) && !ItemID.Sets.WaterTorches[this.type])
          return;
        Lighting.AddLight(this.Center, placeStyle);
      }
      else if (this.type == 3114)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f, 0.0f, 1f);
      }
      else if (this.type == 1245)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f, 0.5f, 0.0f);
      }
      else if (this.type == 433)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), (float) (0.5 * (double) Main.demonTorch + 1.0 * (1.0 - (double) Main.demonTorch)), 0.3f, (float) (1.0 * (double) Main.demonTorch + 0.5 * (1.0 - (double) Main.demonTorch)));
      }
      else if (this.type == 523)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.85f, 1.2f, 0.7f);
      else if (this.type == 974)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.75f, 0.85f, 1.4f);
      }
      else if (this.type == 1333)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1.25f, 1.25f, 0.7f);
      else if (this.type == 4383)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1.4f, 0.85f, 0.55f);
      }
      else if (this.type == 4384)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.25f, 1.3f, 0.8f);
      else if (this.type == 3045)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), (float) Main.DiscoR / (float) byte.MaxValue, (float) Main.DiscoG / (float) byte.MaxValue, (float) Main.DiscoB / (float) byte.MaxValue);
      else if (this.type == 3004)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.95f, 0.65f, 1.3f);
      else if (this.type == 2274)
      {
        float r = 0.75f;
        float g = 1.35f;
        float b = 1.5f;
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), r, g, b);
      }
      else if (this.type >= 427 && this.type <= 432)
      {
        if (this.wet)
          return;
        float r = 0.0f;
        float g = 0.0f;
        float b = 0.0f;
        int num = this.type - 426;
        if (num == 1)
        {
          r = 0.1f;
          g = 0.2f;
          b = 1.1f;
        }
        if (num == 2)
        {
          r = 1f;
          g = 0.1f;
          b = 0.1f;
        }
        if (num == 3)
        {
          r = 0.0f;
          g = 1f;
          b = 0.1f;
        }
        if (num == 4)
        {
          r = 0.9f;
          g = 0.0f;
          b = 0.9f;
        }
        if (num == 5)
        {
          r = 1.3f;
          g = 1.3f;
          b = 1.3f;
        }
        if (num == 6)
        {
          r = 0.9f;
          g = 0.9f;
          b = 0.0f;
        }
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), r, g, b);
      }
      else if (this.type == 2777 || this.type == 2778 || this.type == 2779 || this.type == 2780 || this.type == 2781 || this.type == 2760 || this.type == 2761 || this.type == 2762 || this.type == 3524)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.4f, 0.16f, 0.36f);
      else if (this.type == 2772 || this.type == 2773 || this.type == 2774 || this.type == 2775 || this.type == 2776 || this.type == 2757 || this.type == 2758 || this.type == 2759 || this.type == 3523)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.0f, 0.36f, 0.4f);
      else if (this.type == 2782 || this.type == 2783 || this.type == 2784 || this.type == 2785 || this.type == 2786 || this.type == 2763 || this.type == 2764 || this.type == 2765 || this.type == 3522)
        Lighting.AddLight((int) (((double) this.position.X + (double) (this.width / 2)) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.5f, 0.25f, 0.05f);
      else if (this.type == 3462 || this.type == 3463 || this.type == 3464 || this.type == 3465 || this.type == 3466 || this.type == 3381 || this.type == 3382 || this.type == 3383 || this.type == 3525)
        Lighting.AddLight(this.Center, 0.3f, 0.3f, 0.2f);
      else if (this.type == 41)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f, 0.75f, 0.55f);
      }
      else if (this.type == 988)
      {
        if (this.wet)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.35f, 0.65f, 1f);
      }
      else if (this.type == 282)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.7f, 1f, 0.8f);
      else if (this.type == 286)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.7f, 0.8f, 1f);
      else if (this.type == 3112)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1f, 0.6f, 0.85f);
      else if (this.type == 4776)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.7f, 0.0f, 1f);
      else if (this.type == 3002)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 1.05f, 0.95f, 0.55f);
      else if (this.type == 331)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.55f, 0.75f, 0.6f);
      else if (this.type == 183)
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.15f, 0.45f, 0.9f);
      else if (this.type == 75)
      {
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.8f, 0.7f, 0.1f);
        if (this.timeSinceItemSpawned % 12 != 0)
          return;
        Dust dust = Dust.NewDustPerfect(this.Center + new Vector2(0.0f, (float) this.height * 0.2f) + Main.rand.NextVector2CircularEdge((float) this.width, (float) this.height * 0.6f) * (float) (0.300000011920929 + (double) Main.rand.NextFloat() * 0.5), 228, new Vector2?(new Vector2(0.0f, (float) (-(double) Main.rand.NextFloat() * 0.300000011920929 - 1.5))), (int) sbyte.MaxValue);
        dust.scale = 0.5f;
        dust.fadeIn = 1.1f;
        dust.noGravity = true;
        dust.noLight = true;
      }
      else
      {
        if ((this.type < 3318 || this.type > 3332) && this.type != 3860 && this.type != 3862 && this.type != 3861 && this.type != 4782 && this.type != 4957)
          return;
        Lighting.AddLight((int) (((double) this.position.X + (double) this.width) / 16.0), (int) (((double) this.position.Y + (double) (this.height / 2)) / 16.0), 0.4f, 0.4f, 0.4f);
        if (this.timeSinceItemSpawned % 12 != 0)
          return;
        Dust dust = Dust.NewDustPerfect(this.Center + new Vector2(0.0f, (float) this.height * -0.1f) + Main.rand.NextVector2CircularEdge((float) this.width * 0.6f, (float) this.height * 0.6f) * (float) (0.300000011920929 + (double) Main.rand.NextFloat() * 0.5), 279, new Vector2?(new Vector2(0.0f, (float) (-(double) Main.rand.NextFloat() * 0.300000011920929 - 1.5))), (int) sbyte.MaxValue);
        dust.scale = 0.5f;
        dust.fadeIn = 1.1f;
        dust.noGravity = true;
        dust.noLight = true;
        dust.alpha = 0;
      }
    }

    public static Rectangle GetDrawHitbox(int type, Player user)
    {
      Main.instance.LoadItem(type);
      if (ItemID.Sets.IsFood[type])
        return TextureAssets.Item[type].Frame(verticalFrames: 3, frameY: 1);
      switch (type)
      {
        case 75:
          return TextureAssets.Item[type].Frame(verticalFrames: 8);
        case 520:
        case 521:
        case 547:
        case 548:
        case 549:
        case 575:
        case 3453:
        case 3454:
        case 3455:
        case 3580:
        case 3581:
        case 4068:
        case 4069:
        case 4070:
          return TextureAssets.Item[type].Frame(verticalFrames: 4);
        default:
          return TextureAssets.Item[type].Frame();
      }
    }

    public static int NewItem(
      Vector2 pos,
      Vector2 randomBox,
      int Type,
      int Stack = 1,
      bool noBroadcast = false,
      int prefixGiven = 0,
      bool noGrabDelay = false,
      bool reverseLookup = false)
    {
      return Item.NewItem((int) pos.X, (int) pos.Y, (int) randomBox.X, (int) randomBox.Y, Type, Stack, noBroadcast, prefixGiven, noGrabDelay, reverseLookup);
    }

    public static int NewItem(
      Vector2 pos,
      int Width,
      int Height,
      int Type,
      int Stack = 1,
      bool noBroadcast = false,
      int prefixGiven = 0,
      bool noGrabDelay = false,
      bool reverseLookup = false)
    {
      return Item.NewItem((int) pos.X, (int) pos.Y, Width, Height, Type, Stack, noBroadcast, prefixGiven, noGrabDelay, reverseLookup);
    }

    public static int NewItem(
      int X,
      int Y,
      int Width,
      int Height,
      int Type,
      int Stack = 1,
      bool noBroadcast = false,
      int pfix = 0,
      bool noGrabDelay = false,
      bool reverseLookup = false)
    {
      if (WorldGen.gen)
        return 0;
      if (Main.rand == null)
        Main.rand = new UnifiedRandom();
      if (Main.halloween)
      {
        if (Type == 58)
          Type = 1734;
        if (Type == 184)
          Type = 1735;
      }
      if (Main.xMas)
      {
        if (Type == 58)
          Type = 1867;
        if (Type == 184)
          Type = 1868;
      }
      if (Type > 0 && Item.cachedItemSpawnsByType[Type] != -1)
      {
        Item.cachedItemSpawnsByType[Type] += Stack;
        return 400;
      }
      Main.item[400] = new Item();
      int index = 400;
      if (Main.netMode != 1)
        index = Item.PickAnItemSlotToSpawnItemOn(reverseLookup, index);
      Main.timeItemSlotCannotBeReusedFor[index] = 0;
      Main.item[index] = new Item();
      Item obj1 = Main.item[index];
      obj1.SetDefaults(Type);
      obj1.Prefix(pfix);
      obj1.stack = Stack;
      obj1.position.X = (float) (X + Width / 2 - obj1.width / 2);
      obj1.position.Y = (float) (Y + Height / 2 - obj1.height / 2);
      obj1.wet = Collision.WetCollision(obj1.position, obj1.width, obj1.height);
      obj1.velocity.X = (float) Main.rand.Next(-30, 31) * 0.1f;
      obj1.velocity.Y = (float) Main.rand.Next(-40, -15) * 0.1f;
      if (Type == 859 || Type == 4743)
      {
        Item obj2 = obj1;
        obj2.velocity = obj2.velocity * 0.0f;
      }
      if (Type == 520 || Type == 521 || obj1.type >= 0 && ItemID.Sets.NebulaPickup[obj1.type])
      {
        obj1.velocity.X = (float) Main.rand.Next(-30, 31) * 0.1f;
        obj1.velocity.Y = (float) Main.rand.Next(-30, 31) * 0.1f;
      }
      obj1.active = true;
      obj1.timeSinceItemSpawned = ItemID.Sets.NewItemSpawnPriority[obj1.type];
      ++Item.numberOfNewItems;
      if (ItemSlot.Options.HighlightNewItems && obj1.type >= 0 && !ItemID.Sets.NeverAppearsAsNewInInventory[obj1.type])
        obj1.newAndShiny = true;
      if (Main.netMode == 2 && !noBroadcast)
        NetMessage.SendData(21, number: index, number2: ((float) noGrabDelay.ToInt()));
      else if (Main.netMode == 0)
        obj1.playerIndexTheItemIsReservedFor = Main.myPlayer;
      return index;
    }

    private static int PickAnItemSlotToSpawnItemOn(bool reverseLookup, int nextItem)
    {
      int num1 = 0;
      int num2 = 400;
      int num3 = 1;
      if (reverseLookup)
      {
        num1 = 399;
        num2 = -1;
        num3 = -1;
      }
      bool flag = false;
      for (int index = num1; index != num2; index += num3)
      {
        if (!Main.item[index].active && Main.timeItemSlotCannotBeReusedFor[index] == 0)
        {
          nextItem = index;
          flag = true;
          break;
        }
      }
      if (!flag)
      {
        int num4 = 0;
        for (int index = 0; index < 400; ++index)
        {
          if (Main.timeItemSlotCannotBeReusedFor[index] == 0 && !Main.item[index].instanced && Main.item[index].timeSinceItemSpawned > num4)
          {
            num4 = Main.item[index].timeSinceItemSpawned;
            nextItem = index;
            flag = true;
          }
        }
        if (!flag)
        {
          for (int index = 0; index < 400; ++index)
          {
            if (Main.item[index].timeSinceItemSpawned - Main.timeItemSlotCannotBeReusedFor[index] > num4)
            {
              num4 = Main.item[index].timeSinceItemSpawned - Main.timeItemSlotCannotBeReusedFor[index];
              nextItem = index;
            }
          }
        }
      }
      return nextItem;
    }

    public void FindOwner(int whoAmI)
    {
      if (this.keepTime > 0)
        return;
      int itemIsReservedFor = this.playerIndexTheItemIsReservedFor;
      this.playerIndexTheItemIsReservedFor = (int) byte.MaxValue;
      bool flag = true;
      if (this.type == 267 && this.ownIgnore != -1)
        flag = false;
      if (flag)
      {
        float num1 = (float) NPC.sWidth;
        for (int index = 0; index < (int) byte.MaxValue; ++index)
        {
          if (this.ownIgnore != index)
          {
            Player player = Main.player[index];
            if (player.active)
            {
              Player.ItemSpaceStatus status = player.ItemSpace(Main.item[whoAmI]);
              if (player.CanPullItem(Main.item[whoAmI], status))
              {
                float num2 = Math.Abs(player.position.X + (float) (player.width / 2) - this.position.X - (float) (this.width / 2)) + Math.Abs(player.position.Y + (float) (player.height / 2) - this.position.Y - (float) this.height);
                if (player.manaMagnet && (this.type == 184 || this.type == 1735 || this.type == 1868))
                  num2 -= (float) Item.manaGrabRange;
                if (player.lifeMagnet && (this.type == 58 || this.type == 1734 || this.type == 1867))
                  num2 -= (float) Item.lifeGrabRange;
                if (this.type == 4143)
                  num2 -= (float) Item.manaGrabRange;
                if ((double) num1 > (double) num2)
                {
                  num1 = num2;
                  this.playerIndexTheItemIsReservedFor = index;
                }
              }
            }
          }
        }
      }
      if (this.playerIndexTheItemIsReservedFor == itemIsReservedFor || (itemIsReservedFor != Main.myPlayer || Main.netMode != 1) && (itemIsReservedFor != (int) byte.MaxValue || Main.netMode != 2) && (itemIsReservedFor == (int) byte.MaxValue || Main.player[itemIsReservedFor].active))
        return;
      NetMessage.SendData(21, number: whoAmI);
      if (!this.active)
        return;
      NetMessage.SendData(22, number: whoAmI);
    }

    public Item Clone() => (Item) this.MemberwiseClone();

    public Item DeepClone() => (Item) this.MemberwiseClone();

    public bool IsTheSameAs(Item compareItem) => this.netID == compareItem.netID && this.type == compareItem.type;

    public bool IsNotTheSameAs(Item compareItem) => this.netID != compareItem.netID || this.stack != compareItem.stack || (int) this.prefix != (int) compareItem.prefix;

    public void SetNameOverride(string name) => this._nameOverride = name;

    public void ClearNameOverride() => this._nameOverride = (string) null;

    public bool IsAir => this.type <= 0 || this.stack <= 0;

    public void TurnToAir()
    {
      this.type = 0;
      this.stack = 0;
      this.netID = 0;
      this.dye = (byte) 0;
      this.shoot = 0;
      this.mountType = -1;
    }

    public void OnPurchase(Item item)
    {
      if (!item.shopCustomPrice.HasValue)
        return;
      item.shopSpecialCurrency = -1;
      item.shopCustomPrice = new int?();
    }

    public int GetStoreValue() => this.shopCustomPrice.HasValue ? this.shopCustomPrice.Value : this.value;

    public void Serialize(BinaryWriter writer, ItemSerializationContext context)
    {
      if (context != ItemSerializationContext.SavingAndLoading)
        return;
      writer.Write(this.netID);
      writer.Write(this.stack);
      writer.Write(this.prefix);
    }

    public void DeserializeFrom(BinaryReader reader, ItemSerializationContext context)
    {
      if (context == ItemSerializationContext.SavingAndLoading)
      {
        this.netDefaults(reader.ReadInt32());
        this.stack = reader.ReadInt32();
        this.Prefix((int) reader.ReadByte());
      }
      if (this.type < 5045)
        return;
      this.TurnToAir();
    }

    public bool IsCurrency => this.type >= 71 && this.type <= 74 || CustomCurrencyManager.IsCustomCurrency(this);

    public void Refresh()
    {
      bool favorited = this.favorited;
      int stack = this.stack;
      int netId = this.netID;
      int prefix = (int) this.prefix;
      this.netDefaults(netId);
      this.Prefix(prefix);
      this.stack = stack;
      this.favorited = favorited;
    }

    public bool CanBeQuickUsed
    {
      get
      {
        if (this.IsAir)
          return false;
        bool? nullable = ItemID.Sets.CanBeQuickusedOnGamepad[this.type];
        if (nullable.HasValue)
          return nullable.Value;
        return this.healLife > 0 || this.healMana > 0 || this.buffType > 0 && this.buffTime > 0;
      }
    }
  }
}
